' $linesize:132
' $title: 'CNFG-SUB.BAS 17.4, Copyright 1987-92 by D. Thomas Mack'
'  Copyright 1991 by D. Thomas Mack, all rights reserved.
'  Name ...............: CNFG-SUB.BAS
'  First Released .....: June 21, 1992
'  Subsequent Releases.: 
'  Copyright ..........: 1987-92
'  Purpose.............: The Remote Bulletin Board System for the IBM PC,
'                        RBBS-PC, configuration program -- CONFIG.BAS
'                        utilizes a lot of menus and string space.
'                        These are incorporated within CNFG-SUB.BAS as a
'                        seperately callable subroutines in order to free
'                        up as much code as possible within the 64K code
'                        segment used by CONFIG.BAS.
'  Parameters..........: Most parameters are passed via a COMMON statement.
'
' Subroutine  Line      Function of Subroutine
'    Name    Number
' ALLCAPS    61212+     Captialize a string
' ANSIDECODE 62040+     Convert ANSI strings into english text expressions
' ANYINTEGER 61450      Prompt for any integer
' ANYNUMBER  61400      Prompt for any number
' ASKRO      61100      Ask a question on a specific row
' ASKUPOS    61300      Ask for identifying field in USERS record
' BRKFNAME   61830      Break file name in drive/path, prefix, extension
' CHKFMSDIR  61700      Check FMS directory for valid structure
' CHKPERSDIR 61755      Check Personal directory format
' CHKRANDOM  61751      Checks FMS/Pers read Randomly
' CNFGINIT   60385      Initialize CONFIG's constants
' COLORCODE  62040+     Convert response into ANSI-meaningful strings
' DISPLAY    12190      Display the CONFIG menu pages
' FINDFILE   61600      Determine whether a file exists
' FINDLAST   61850      Find last occurence of a character in a string
' GETANSI    62000      Prompt for ANSI colors to be used
' GETASCII   61810      Get any character by character or ascii value
' GETCOLOR   61950      Process request for setting color
' GETINIT    61110      Get answers that are integers
' GETNUMYN   61150      Get TRUE/FALSE answer to a YES/NO question
' GETYESNO   61200      Ask a question with a "yes" or "no" response
' HANDERR    61775+     Handle error checking for FMS directories
' MMINTEGER  61500      Prompt for integer with min and a max
' NETTYPE    60382      Prompt for supported network types
' REMOVE     61800      Remove characters from a string
' SECURE     61860      Allow commands and their security level to be changed
' SELMODEM   62100      Select modem to set modem strings
' SETSCRSCHK 61754      Sets up screen for check of FMS directory
' TRIMTRAIL  61840      Remove trailing characters from a string
'
'  $INCLUDE: 'CNFG-VAR.BAS'
'
'  $SUBTITLE: 'DISPLAY - subroutine to display CONFIG's menus'
'  $PAGE
'
'  SUBROUTINE NAME    --  DISPLAY
'
'  INPUT PARAMETERS   --  PARAMETER        DESCRIPTION
'                         ZIX = 0           DISPLAY THE CHOICE OF MENUS
'                         ZIX = -1          RE-READ THE INPUT (INVALID REQUEST)
'                         ZIX > 0           DISPLAY THE APPROPRIATE PAGE
'
'  OUTPUT PARAMETERS  --  ZHJ$              OPTION SELECTED
'                         ZIPage            MENU PAGE CONTAINING OPTION
'                         ZILookUp          INDEX (1 TO 20) OF OPTION SELECTED
'
'  SUBROUTINE PURPOSE --  TO DISPLAY CONFIG'S MENUS AND REQUEST OPTION
'
      SUB DISPLAY STATIC
'
' *  DISPLAY CONFIG'S MAIN FUNCTION KEY MENU
'
      IF ZIX > 0 THEN _
         GOTO 12320
      IF ZIX = -1 THEN _
         GOTO 12590
12190 COLOR ZFG,ZBG
      CLS
      ZDisplayedPageNumber = 0
      I! = FRE(ZC$)
      COLOR 0,7,0
      LOCATE 4,4
      PRINT " RBBS-PC/CDor "+ ZConfigVersion$ + _
            " CONFIGURATION PROGRAM " + " FILE: " + ZConfigFileName$ + " "
      COLOR ZFG,ZBG
      LOCATE 1,1,0
      PRINT "Copyright (c) 1983-1991 Tom Mack"
      LOCATE 2,1,0
      PRINT "39 Cranbury Dr, Trumbull, CT. 06611";
      IF ZConferenceMode THEN _
         GOSUB 24970
      LOCATE  5,1
      PRINT "   F1            Global RBBS-PC Parameters (part 1)
      PRINT "   F2            Global RBBS-PC Parameters (part 2)
      PRINT "   F3            Global RBBS-PC Parameters (part 3)
      PRINT "   F4            RBBS-PC System Files (part 1)
      PRINT "   F5            RBBS-PC System Files (part 2)
      PRINT "   F6            Parameters for RBBS-PC's 'Doors'
      PRINT "   F7            Parameters for RBBS-PC's Security (part 1)
      PRINT "   F8            Parameters for RBBS-PC's Security (part 2)
      PRINT "   F9            Parameters for multiple RBBS-PC's
      PRINT "  F10            RBBS-PC utilities
      PRINT "  Shift-F1       RBBS-PC File Management Faciliites"
      PRINT "  Shift-F2       RBBS-PC Communications Parameters (part 1)
      PRINT "  Shift-F3       RBBS-PC Communications Parameters (part 2)
      PRINT "  Shift-F4       Parameters for RBBS-PC NET-MAIL
      PRINT "  Shift-F5       New users parameters"
      PRINT "  Shift-F6       Library Sub-System"
      PRINT "  Shift-F7       RBBS-PC Color parameters"
      PRINT "  Shift-F8       Global RBBS-PC Parameters (part 4)"
      XX$ = "Press END to terminate or Function Key to select page "
      GOSUB 50345
      LOCATE ,,1
12310 GOSUB 22160
12320 IF ZIX THEN _            'ZIX    Key    Where to branch to
         ON ZIX GOTO 12360, _  ' 1       F1 - Global Parameters (Part 1)
                    12370, _  ' 2       F2 - Global Parameters (Part 2)
                    12380, _  ' 3       F3 - Global Parameters (Part 3)
                    12390, _  ' 4       F4 - RBBS-PC System Files (Part 1)
                    12400, _  ' 5       F5 - RBBS-PC System Files (Part 2)
                    12410, _  ' 6       F6 - RBBS-PC "doors"
                    12420, _  ' 7       F7 - RBBS-PC security parms. (Part 1)
                    12466, _  ' 8       F8 - RBBS-PC security parms. (Part 2)
                    12470, _  ' 9       F9 - Multiple RBBS-PC parameters
                    12480, _  '10      F10 - RBBS-PC's utilities
                    12490, _  '11 Shift-F1 - RBBS-PC File Manager
                    12500, _  '12 Shift-F2 - RBBS-PC comm. parameters (Part 1)
                    12505, _  '13 Shift-F3 - RBBS-PC comm. parameters (Part 2)
                    12510, _  '14 Shift-F4 - RBBS-PC Net Mail
                    12520, _  '15 Shift-F5 - New user parameters
                    12530, _  '16 Shift-F6 - Library parameters
                    12540, _  '17 Shift-F7 - RBBS-PC Color parameters
                    12550, _  '18 Shift-F8 - Global Parameters (Part 4)
                    12340, _  '19     PgUp - Go to previous page
                    12330, _  '20     PgDn - Go to next page
                    12630, _  '21      End - Terminate CONFIG
                    12350     '22    Enter - Re-display current page
      GOTO 12310
'
' *  COMMON ROUTINE TO HANDLE UNDEFINED OPTIONS
'
12325 ZIX = ZIPage
      GOTO 12320
'
' *  COMMON ROUTINE TO HANDLE PAGE UP OF DISPLAYS
'
12330 IF (ZDisplayedPageNumber + 1 ) > 18 THEN _
         GOTO 12190
      ZIX = ZDisplayedPageNumber + 1
      GOTO 12320
'
' *  COMMON ROUTINE TO HANDLE PAGE DOWN OF DISPLAYS
'
12340 IF (ZDisplayedPageNumber - 1) < 1 THEN _
         GOTO 12190
      ZIX = ZDisplayedPageNumber - 1
      GOTO 12320
'
' *  RETURN TO PRIMARY MENU SELECTION DISPLAY
'
12350 GOSUB 60380
      GOTO 12310
'
' *  COMMON CONFIGURATION PROGRAM MENU AND PAGE DISPLAY
'
12360 ZDisplayedPageNumber = 1
      GOSUB 24800
      LOCATE  3,1
      PRINT " 1. SYSOP's Public First Name -------------------- " + ZSysopFirstName$
      PRINT " 2. SYSOP's Public Last Name --------------------- " + ZSysopLastName$
      PRINT " 3. ";STRING$(45,45)
      PRINT " 4. SYSOP's office hours -------------------------"STR$(ZStartOfficeHours);" to"STR$(ZEndOfficeHours)
      PRINT " 5. Page SYSOP using printer's bell -------------- " + ZM11$
      PRINT " 6. Go off-line whenever a DISK FULL occurs ------ " ; FNYESNO$(ZDiskFullGoOffline)
      PRINT " 7. Prompt bell default is ----------------------- " + ZPromptBell$
      PRINT " 8. Maximum time per session (in minutes) --------"STR$(ZMinutesPerSession!)
      PRINT " 9. Maximum minutes per day ----------------------";STR$(ZMaxPerDay)
      PRINT "10. Factor to extend session time for uploads ----" + STR$(ZUploadTimeFactor!)
      PRINT "11. # Months of inactivity before user deleted ---"STR$(ZActMnthsB4Deleting)
      PRINT "12. Name of RBBS-PC shown initially is ----------- " + ZRBBSName$
      PRINT "13. ";STRING$(45,45)
      PRINT "14. ";STRING$(45,45)
      PRINT "15. Default extension for Batch Files ------------ " + ZDefaultBatchExt$
      PRINT "16. Your CONFIG.SYS contains 'DEVICE=ANSI.SYS'---- " + FNYESNO$(ZDOSANSI)
      IF ZSmartText THEN _
         SmartText$ = STR$(ZSmartText) _
      ELSE SmartText$ = ZNonePicked$
      PRINT "17. Control character for SMART TEXT -------------" + SmartText$
      PRINT "18. File with automatic operator page parameters - " ; ZAutoPageDef$
      X = INSTR("ANS",ZLogonMailLevel$)
      IF X < 1 THEN _
         X = 1
      X$ = MID$("OLD & NEWNEW ONLY NONE",9*X-8,9)
      IF X$ = "NONE" THEN _
         X$ = ZNonePicked$
      PRINT "19. Personal mail notification level at logon is - " + X$
      PRINT "20. Seconds to wait for caller's ANSI detect -----" + STR$(ZTestANSITime)
      GOTO 12580
12370 ZDisplayedPageNumber = 2
      GOSUB 24800
      LOCATE  3,1
      PRINT "21. Remind users of messages that they left ------ " + FNYESNO$(ZMessageReminder)
      PRINT "22. 'Who's On' command shows Offline Callers? ---- " + FNYESNO$(ZShowAllWhosOn)
      PRINT "23. Remind users of their user preferences? ------ " + FNYESNO$(ZRemindProfile)
      PRINT "24. Enable download of new files at logon -------- " + FNYESNO$(ZNewFilesCheck)
      PRINT "25. Default user page length is ------------------" + STR$(ZPageLength)
      PRINT "26. Maximum number of lines allowed per message --" + STR$(ZMaxMessageLines)
      PRINT "27. Is system 'welcome' interruptable? ----------- " + FNYESNO$(ZWelcomeInterruptable)
      PRINT "28. Are system bulletins to be 'optional'? ------- " + FNYESNO$(ZBulletinsOptional)
      PRINT "29. ";STRING$(45,45)
      PRINT "30. Symbols to use for SYSOP commands ------------ " + ZSysopCommands$
      PRINT "31. Symbols to use for MAIN menu commands -------- " + ZMainCommands$
      PRINT "32. Symbols to use for FILE menu commands -------- " + ZFileCommands$
      PRINT "33. Symbols to use for UTILITIES menu commands --- " + ZUtilCommands$
      PRINT "34. Symbols to use for global commands ----------- " + ZGlobalCommands$
      PRINT "35. Show section in command prompt --------------- " + FNYESNO$(ZShowSection)
      PRINT "36. Show commands in command prompt -------------- " + FNYESNO$(ZCommandsInPrompt)
      PRINT "37. Restrict valid commands to current section --- " + FNYESNO$(ZRestrictValidCmds)
      PRINT "38. Is system 'news' interruptable? -------------- " + FNYESNO$(ZNewsInterruptable)
      PRINT "39. Log to CALLERS.TXT file ---------------------- " + FNYESNO$(ZUseCallersTxt)
      PRINT "40. # of lines for extended file descriptions ----" + STR$(ZMaxExtendedLines)
      GOTO 12580
12380 ZDisplayedPageNumber = 3
      GOSUB 24800
      LOCATE  3,1
      PRINT "41. Field used to identify users ----------------- " + ZHashID$
      PRINT "42. Field used to distinguish users with same ID-- " + ZIndivID$
      PRINT "43. Start position identifying personal downloads-"  + STR$(ZPersonalBegin)
      PRINT "44. Field length to identify personal downloads --"  + STR$(ZPersonalLen)
      PRINT "45. Prompt for first part of personal identifier - " + ZFirstNamePrompt$
      PRINT "46. Prompt for last part of personal identifier -- " + ZLastNamePrompt$
      PRINT "47. Enforce upload/download ratios --------------- " + FNYESNO$(ZEnforceUploadDownloadRatios)
      PRINT "48. RESTRICT users by SUBSCRIPTION date ---------- " + FNYESNO$(ZRestrictByDate)
      PRINT "49. Security level when SUBSCRIPTION expires -----"  + STR$(ZExpiredSecurity)
      PRINT "50. Days before expiration to warn callers -------"  + STR$(ZDaysToWarn)
      PRINT "51. Default # days in SUBSCRIPTION PERIOD --------"  + STR$(ZDaysInSubscriptionPeriod)
      PRINT "52. Turn printer off after each recycle ---------- " + FNYESNO$(ZTurnPrinterOff)
      PRINT "53. Inhibit 'Thanks For Calling' Message --------- " + FNYESNO$(ZDontShowLogOff)
      PRINT "54. BUFFER SIZE used when displaying text files --" + STR$(ZBufferSize)
      PRINT "55. Stack space to be made available -------------" + STR$(ZSizeOfStack)
      PRINT "56. ";STRING$(45,45)
      PRINT "57. Ask users their (What is your ...) ----------- " + ZUserLocation$
      PRINT "58. ";STRING$(45,45)
      PRINT "59. BUFFER SIZE for writes on internal protocols -" + STR$(ZWriteBufDef)
      PRINT "60. ";STRING$(45,45)
      GOTO 12580
12390 ZDisplayedPageNumber = 4
      GOSUB 24800
      LOCATE  3,1
      PRINT "61. Drive and file describing 'bulletins' is ----- " + ZDriveForBulletins$ + ZBulletinMenu$
      PRINT "62. Number of active 'bulletins' -----------------" + STR$(ZActiveBulletins)
      PRINT "63. Prefix used to name bulletin files is -------- " + ZBulletinPrefix$
      PRINT "64. Drive and path (optional) for 'help' files --- " + ZHelpPath$
      PRINT "65. Prefix used to name three major 'help' files - " + ZHelpFilePrefix$
      PRINT "66. Extension for help files of individual cmds -- " + ZHelpExtension$
      PRINT "67. HELP file when callers CATEGORIZE uploads ---- " + ZUpCatHelp$
      PRINT "68. Name of 'newuser' file shown to new users ---- " + ZNewUserFile$
      PRINT "69. Name of 'welcome' file shown at logon -------- " + ZWelcomeFile$
      PRINT "70. The SYSOP's command menu is named ------------ " + ZMenu$(1)
      PRINT "71. The MAIN system menu is named ---------------- " + ZMenu$(2)
      PRINT "72. The file subsystem menu is named ------------- " + ZMenu$(3)
      PRINT "73. The utilities subsystem menu is named -------- " + ZMenu$(4)
      PRINT "74. Menu that lists available conferences is ----- " + ZConferenceMenu$
      PRINT "75. Menu that lists questionnaires available is -- " + ZAnsMenu$
      PRINT "76. Drive/path for optional questionnaires ------- " + ZQuesPath$
      PRINT "77. File with main SYSOP-supplied user interface - " + ZMainPUI$
      PRINT "78. Allow menus to pause in the middle ----------- " + FNYESNO$(ZDisplayOptions1)
      PRINT "79. Drive/path where macro files are stored ------ " + ZMacroDrvPath$
      IF ZMacroExtension$ = "" THEN _
         X$ = ZNonePicked$ _
      ELSE X$ = ZMacroExtension$
      PRINT "80. Extension of macro files --------------------- " ; X$
      GOTO 12580
12400 ZDisplayedPageNumber = 5
      GOSUB 24800
      LOCATE  3,1
      PRINT " 81. File containing invalid user names ----------- " + ZTrashCanFile$
      PRINT " 82. Name questionnaire required of ALL callers --- " + ZRequireQuestionnaire$
      PRINT " 83. Name of 'pre-log' file ----------------------- " + ZPreLog$
      PRINT " 84. Name of questionnaire required of new users -- " + ZNewUserQuestionnaire$
      PRINT " 85. Name of 'epi-log' questionnaire -------------- " + ZEpilog$
      PRINT " 86. System file containing messages is named ----- " + ZMainMessageFile$
      PRINT " 87. System file for recording users is named ----- " + ZMainUserFile$
      PRINT " 88. System file for comments to SYSOP is named --- " + ZCommentsFile$
      PRINT " 89. Record comments as private messages ---------- " ; FNYESNO$(ZCommentsAsMessages)
      PRINT " 90. System file for 'callers' is named ----------- " + ZCallersFile$
      PRINT " 91. Extended logging to 'callers' file ----------- " ; FNYESNO$(ZExtendedLogging)
      PRINT " 92. ";STRING$(45,45)
      PRINT " 93. File controlling scan for mail waiting ------- " + ZConfMailList$
      PRINT " 94. Max # of work variables in ques/macros -------"  ; STR$(ZMaxWorkVar)
      IF ZCallersLst$ = "" THEN _
         X$ = ZNonePicked$ _
      ELSE X$ = ZCallersLst$
      PRINT " 95. List of callers files for each node stored in  " ; X$
      PRINT " 96. Seconds to display copyright of RBBS ---------"  ; STR$(ZCopyrightSecs)
      PRINT " 97. Prevent callers from quoting in a reply ------ " ; FNYESNO$(ZNoQuoting)
      PRINT " 98. Omit User's Name from UPLOADLG.DEF ----------- " ; FNYESNO$(ZOmitFromLog)
      PRINT " 99. Add User's Name to Upload Dir ---------------- " ; FNYESNO$(ZAddNameToDir)
      IF ZShowXferTime > 0 THEN ZShowXferTime = 0
      PRINT "100. Show Transfer Time when Listing Files -------- " ; FNYESNO$(ZShowXferTime)
      GOTO 12580
12410 ZDisplayedPageNumber = 6
      GOSUB 24800
      LOCATE  3,1
      PRINT "101. Is the 'door' subystem available? ------------ " ; FNYESNO$(ZDoorsAvailable)
      PRINT "102. The 'door' subsystem menu is named ----------- " + ZMenu$(5)
      PRINT "103. File built dynamically to open a 'door' ------ " + ZRCTTYBat$
      PRINT "104. When a 'door' closes, re-invoke RBBS-PC via -- " + ZRBBSBat$
      PRINT "105. Drive/path to look for COMMAND.COM on -------- " + ZDiskForDOS$
      PRINT "106. Use the Dos 'CTTY' command to redirect I/O --- " ; FNYESNO$(ZRedirectIOMethod)
      PRINT "107. Door Program to check users at logon --------- " ; ZRegistrationProgram$
      PRINT "108. Logon door required of new users & security <="  ; STR$(ZMaxRegSec)
      PRINT "109. Name of control file for doors --------------- " ; ZDoorsDef$
      GOTO 12580
12420 ZDisplayedPageNumber = 7
      GOSUB 24800
      LOCATE  3,1
      PRINT "121. Pseudonym to sign on remotely as the SYSOP ---- " + ZMN1$+ " " +ZMN2$
      PRINT "122. ESC key logs SYSOP on locally without password- " ;
      IF ZEscapeInsecure = 0 THEN
         X$ = "NO"
      ELSEIF ZEscapeInsecure = 1 THEN
         X$ = "YES"
      ELSEIF ZEscapeInsecure = 2 THEN
         X$ = "YES/TURBO"
      END IF
      PRINT X$
      PRINT "123. Minimum security level to log on RBBS-PC ------" + STR$(ZMinimumLogonSecurity)
      PRINT "124. Default security level for new callers --------" + STR$(ZDefaultSecurityLevel)
      PRINT "125. Security level for SYSOP ----------------------" + STR$(ZSysopSecurityLevel)
      PRINT "126. Minimum security level to see SYSOP's menu ----" + STR$(ZSysopMenuSecurityLevel)
      PRINT "127. Minimum security to leave extended description-" + STR$(ZAskExtendedDesc)
      PRINT "128. Max # security violations before disconnect ---" + STR$(ZMaximumViolations)
      ZM22$ = STR$(ZSysopFunction(1))
      ZIX = ZSysopFunction(1)
      FOR I = 2 TO ZNumSysop
        IF ZIX <> ZSysopFunction(I) THEN _
           ZM22$ = "(Variable)" : _
           GOTO 12430
      NEXT
12430 PRINT "129. Security level for SYSOP functions ------------" + ZM22$
      ZM23$ = STR$(ZMainFunction(1))
      ZIX = ZMainFunction(1)
      FOR I = 2 TO ZNumMain
        IF ZIX<>ZMainFunction(I) THEN _
           ZM23$ = "(Variable)" : _
           GOTO 12440
      NEXT
12440 PRINT "130. Security level for main menu functions --------" + ZM23$
      ZM24$ = STR$(ZFilesFunction(1))
      ZIX = ZFilesFunction(1)
      FOR I = 2 TO ZNumFiles
        IF ZIX<>ZFilesFunction(I) THEN _
           ZM24$ = "(Variable)" : _
           GOTO 12450
      NEXT
12450 PRINT "131. Security level for file menu functions --------" + ZM24$
      ZM25$ = STR$(ZUtilityFunction(1))
      ZIX = ZUtilityFunction(1)
      FOR I = 2 TO ZNumUtility
        IF ZIX<>ZUtilityFunction(I) THEN _
           ZM25$ = "(Variable)" : _
           GOTO 12460
      NEXT
12460 PRINT "132. Security level for utilities menu functions ---" + ZM25$
      ZM26$ = STR$(ZGlobalFunction(1))
      ZIX = ZGlobalFunction(1)
      FOR I = 1 TO ZNumGlobal
        IF ZIX<>ZGlobalFunction(I) THEN _
           ZM26$ = "(Variable)" : _
           GOTO 12465
      NEXT
12465 PRINT "133. Security level for GLOBAL commands ------------" + ZM26$
      PRINT "134. Max # of password changes in a session --------" + STR$(ZMaximumPasswordChanges)
      PRINT "135. Minimum security for temp. password changes ---" + STR$(ZMinimumSecurityForTempPassword)
      PRINT "136. Minimum security to overwrite on uploads ------" + STR$(ZOverWriteSecurityLevel)
      PRINT "137. User's security exempted from 'packing' -------" + STR$(ZSecLvlExemptFrmPurging)
      PRINT "138. Default security to read new PRIVATE messages -"  + STR$(ZPrivateReadSec)
      PRINT "139. Default security to read new PUBLIC messages --"  + STR$(ZPublicReadSec)
      PRINT "140. Minimum security to change msg.'s security ----"  + STR$(ZSecChangeMsg)
      GOTO 12580
12466 ZDisplayedPageNumber = 8
      GOSUB 24800
      LOCATE  3,1
      PRINT "141. Reformat FILE_ID.DIZ Text for Upload Desc ---- " ; FNYESNO$(ZReFormatDiz)
      PRINT "142. Drive/path where personal files stored ------- " ; ZPersonalDrvPath$
      PRINT "143. Name of Personal Directory ------------------- " + ZPersonalDir$
      PRINT "144. Print Origin Line in NETMAIL messages -------- " + FNYESNO$(ZPrintOrigin)
      PRINT "145. Files with download security are listed in --- " + ZFileSecFile$
      PRINT "146. File name with privileged group passwords is - " + ZPasswordFile$
      PRINT "147. Concatenate multi-file ASCII downloads ------- " + FNYESNO$(ZPersonalConCat)
      PRINT "148. Min SECURITY to CATEGORIZE uploads -----------" + STR$(ZSLCategorizeUploads)
      PRINT "149. Min security level to view new uploads -------" + STR$(ZMinSecToView)
      PRINT "150. Security level exempt from 'epi-log' file ----" + STR$(ZSecurityExemptFromEpilog)
      PRINT "151. Min. security to 'AUTO ADD' conference user -- " + ZAutoAddSecurity$
      PRINT "152. Min. security for old caller to turbo logon --" + STR$(ZAllowCallerTurbo)
      PRINT "153. Min. security to describe an existing file ---" + STR$(ZAddDirSecurity)
      PRINT "154. Help file to display for a security violation- " + ZSecVioHlp$
      TimeLock$ = MID$("<none> DOORS  DOWNLDSBOTH   ",ZTimeLock*7+1,7)
      PRINT "155. Time lock on DOORS and DOWNLOADS ------------- "; TimeLock$
      PRINT "156. Min. sec level exempt from auto-update of sec-" ; ZAutoUpgradeSec
      PRINT "157. Min security to READ & KILL all messages -----" ; ZSecKillAny
      PRINT "158. Do not display lines in msgs beginning with -- "; ZScreenOutMsg$
      PRINT "159. Min. sec level to do personal uploads --------" ; ZMinSecPersUpld
      PRINT "160. Let messages have multiple recipients -------- " ; FNYESNO$(ZEnableCC)
      GOTO 12580
12470 ZDisplayedPageNumber = 9
      GOSUB 30040
      ZMaxMsgFileSizeFrmDef! = HighestMessageRecord
      ZMaxAllowedMsgsFrmDef  = MaximumNumberOfMsgs
      GOSUB 24800
      LOCATE  3,1
      PRINT "161. Maximum number of concurrent RBBS-PC's  -------" + STR$(ZMaximumNumberOfNodes)
      MT$ = "single RBBS-PC copy "
      IF ZMaximumNumberOfNodes <> 1 THEN _
         MT$ = "concurrent RBBS-PC's" : _
         ZSubroutineParameter = 2 : _
         IF ZNetWorkType < 0 OR ZNetWorkType > 7 THEN _
            ZSubroutineParameter = 1 : _
            CALL NETTYPE : _
         ELSE CALL NETTYPE
      IF ZNetWorkType = 6 THEN _
         MT$ = "NETBIOS             "
      PRINT "162. Environment running " + MT$ + " ------ " + ZNetWorkType$
      PRINT "163. Use Extended CONFMAIL.DEF file(s) ------------- " + FNYESNO$(ZExtendedConfMail)
      ZFile$ = ZMainMessageFile$
      GOSUB 30180
      ZMaxMsgFileSizeFrmDef! = UG
      IF ZConferenceMode <> 1 THEN _
         X$ = "MAIN" _
      ELSE X$ = ZConfName$
      PRINT "164. Number of records in " ;X$;" User File ";STRING$(15-LEN(X$),"-");STR$(ZMaxUsrFileSizeFrmDef)
      IF ZMainMessageFile$ = ZMainMsg$ THEN _
         X$ = "MAIN" _
      ELSE X$ = ZConfName$
      PRINT "165. Number of records in " ;X$;" Message File ";STRING$(12-LEN(X$),"-");STR$(ZMaxMsgFileSizeFrmDef!)
      PRINT "166. Maximum number of messages allowed ------------" ; STR$(ZMaxAllowedMsgsFrmDef)
      PRINT "167. Conference File Maintenance."
      IF ZDefaultExtension$ = "" THEN _
         X$ = ZNonePicked$ _
      ELSE X$ = ZDefaultExtension$
      PRINT "168. Default extension for compressed files -------- " ; X$
      PRINT "169. Additional extensions for compressed files ---- " ; ZCompressedExt$
      PRINT "170. Message file GROWS in size as messages added -- " ; FNYESNO$(ZMessagesCanGrow)
      PRINT "171. Name (prefix only) of distribution lists menu - " ; ZDistriHelp$
      PRINT "172. Drive/path where distribution lists stored ---- " ; ZDistriPath$
      PRINT "173. Msg sec can be (U=public,R=private,P=password)- " ; ZMsgSecCats$
      IF ZShowTimesDownloaded > 0 THEN ZShowTimesDownloaded = 0
      PRINT "174. Show Times Downloaded when Listing FIles ------ " ; FNYESNO$(ZShowTimesDownloaded)
      IF ZUpdateOnLine = 1 THEN
         ZUpdateOnLine = -1
      END IF
      PRINT "175. Update Times Downloaded while Caller OnLine --- " ; FNYESNO$(ZUpdateOnLine)
      PRINT "176. Allow SmartText in Messages ------------------- " ; FNYESNO$(ZSmartTextInMsgs)
      PRINT "177. Write Fido-style netmail messages ------------- " ; FNYESNO$(ZNetMailSystem)
      IF ZNetMailPath$ = "" THEN
         X$ = ZNonePicked$
      ELSE
         X$ = ZNetMailPath$
      END IF
      PRINT "178. NETMAIL subdirectory -------------------------- " ; X$
      PRINT "179. Set NetMail Attributes"
      IF ZNetMailAddr$ = "" THEN
         X$ = ZNonePicked$
      ELSE
         X$ = ZNetMailAddr$
      END IF
      PRINT "180. NETMAIL Address ------------------------------- " ; X$
      GOTO 12580
12480 ZDisplayedPageNumber = 10
      GOSUB 24800
      RB = 0
      LOCATE  3,1
      PRINT "181. Pack " + ZMainMessageFile$ + " file.
      PRINT "182. Rebuild " + ZMainUserFile$ + " file.
      PRINT "183. Print " + ZMainMessageFile$ + " 'header' records.
      PRINT "184. Renumber messages in " + ZMainMessageFile$ + " file.
      PRINT "185. Repair messages in " + ZMainMessageFile$ + " file.
      PRINT "186. Make all users answer required questionnaire."
      PRINT "187. Check FMS directory structure."
      PRINT "188. Check Personal Download directory structure."
      PRINT "189. Set most critical parameters."
      PRINT "190. Set parameters new to RBBS-PC " + ZConfigVersion$
      PRINT "191. Reset active printers for all nodes."
      PRINT "192. Make user pref. on hilighting match color graphics."
      PRINT "193. Make all users reselect all preferences."
      PRINT "194. Make all users reselect graphics preference."
      PRINT "195. Make all users reselect protocol preference."
      PRINT "196. Make all users graphics preference AutoDetect."
      GOTO 12580
12490 ZDisplayedPageNumber = 11
      GOSUB 24800
      LOCATE  3,1
      PRINT "201. Drive available for uploading files to ------- " + ZDriveForUploads$ + ":"
      PRINT "202. File name of Upload Directory  --------------- " + ZUploadDirectory$
      PRINT "203. Drive/path where Upload Directory stored ----- " + ZUploadPath$
      PRINT "204. Drive(s) available for Downloading ----------- " + ZDriveForDownloads$
      PRINT "205. Allow File Attaches to Messages -------------- " ; FNYESNO$(ZAllowFileAttach)
      PRINT "206. Path to Store Message File Attaches ---------- " + ZFileAttachPath$
      PRINT "207. Path to Store Deleted Message File Attaches -- " + ZFileAttachHoldPath$
      PRINT "208. List, change, add, delete sub-directories."
      PRINT "209. Extension for file directories --------------- " + ZDirectoryExtension$
      X$ = ZAltDirExtension$
      IF ZAltDirExtension$ = "" OR _
         ZAltDirExtension$ = "<none>" THEN _
         X$ = ZNonePicked$
      PRINT "210. Alternate extension for directory files ------ " + X$
      PRINT "211. Name (prefix) of directory of directories ---- " + ZDirectoryPrefix$
      PRINT "212. Omit directory of directories in N)ew cmnd. -- " + ZOmitMainDirectory$
      X$ = ZAlwaysStrewTo$
      IF ZAlwaysStrewTo$ = "" OR _
         ZAlwaysStrewTo$ = "<none>" THEN _
         X$ = "NO"
      PRINT "213. Copy all upload descriptions to -------------- " + X$
      A$ = ZFMSDirectory$
      IF ZFMSDirectory$ = "" THEN _
         A$ = ZNonePicked$
      PRINT "214. Name of master File Management System dir is - " + A$
      PRINT "215. Limit file searches to master FMS dir only --- " ; FNYESNO$(ZLimitSearchToFMS)
      PRINT "216. Default category code for uploads ------------ " + ZDefaultCategoryCode$
      PRINT "217. File containing valid directory categories --- " + ZDirCategoryFile$
      X$ = ZMasterDirectoryName$
      IF ZMasterDirectoryName$ = "" THEN _
         X$ = "NO"
      PRINT "218. Limit search for 'ALL' dirs to directory ----- " + X$
      PRINT "219. Max length of description of uploaded file ---" + STR$(ZMaxDescLen)
      PRINT "220. Drive/path(optional) for directory files ----- " + ZDirectoryPath$
      GOTO 12580
12500 ZDisplayedPageNumber = 12
      GOSUB 24800
      LOCATE 3,1
      PRINT "221. Communications port to be used by RBBS-PC ---- " + ZComPort$
      PRINT "222. # of seconds to wait for modem to initialize -" + STR$(ZModemInitWaitTime)
      PRINT "223. Seconds to wait before issuing modem commands-" + STR$(ZModemCommandDelayTime)
      PRINT "224. Number of rings to wait before answering -----" + STR$(ZRequiredRings);
      IF INSTR(ZUserInitCommand$, "S0=255") > 0 THEN _
         PRINT " RING BACK";
      PRINT
      PRINT "225. Set the modem commands"
      PRINT "226. ";STRING$(45,45)
      PRINT "227. Issue modem commands between rings ----------- " ; FNYESNO$(ZCommandBetweenRings)
      PRINT "228. BPS rate to initially open modem at ---------- " + ZModemInitBaud$
      X$ = STR$(ZWaitBeforeDisconnect) + " seconds"
      IF ZWaitBeforeDisconnect = 0 THEN _
         X$ = "NO"
      PRINT "229. Log off user who are idle for ----------------" + X$
      PRINT "230. ";STRING$(45,45)
      PRINT "231. Initialize modem firmware for RBBS-PC."
      PRINT "232. # seconds to wait after dropping DTR ---------"  + STR$(ZDTRDropDelay)
      IF ZProtoDef$ = "" THEN _
         X$ = ZNonePicked$ _
      ELSE X$ = ZProtoDef$
      PRINT "233. File with PROTOCOL definitions --------------- " ; X$
      PRINT "234. ";STRING$(45,45)
      PRINT "235. Require non-ascii protocol for BASIC files --- " ; FNYESNO$(ZRequireNonASCII)
      X$ = STR$(ZRecycleWait) + " minutes"
      IF ZRecycleWait = 0 THEN _
         X$ = "<Don't recycle>"
      PRINT "236. Recycle if no calls are received within ------" + X$
      PRINT "237. Leave modem at initial baud ------------------ " + FNYESNO$(ZKeepInitBaud)
      GOTO 12580
12505 ZDisplayedPageNumber = 13
      GOSUB 24800
      LOCATE 3,1
      PRINT "241. Restore initial parms. after change to N/8/1 - " + FNYESNO$(ZSwitchBack)
      PRINT "242. Minimum BPS rate required of new callers -----"  + STR$(ZMinNewCallerBaud!)
      PRINT "243. Minimum BPS rate required of old callers -----"  + STR$(ZMinOldCallerBaud!)
      PRINT "244. Modem flow control uses Clear-to-Send (CTS)--- " + ZRTS$
      PRINT "245. Modem flow control uses XON/XOFF ------------- " + FNYESNO$(ZXOnXOff)
      PRINT "246. Seconds to wait for carrier after answering --"  + STR$(ZMaxCarrierWait)
      PRINT "247. String to Identify CALLER ID NUMBER ---------- " + ZCallerIDNumStr$
      PRINT "248. String to Identify CALLER ID NAME ------------ " + ZCallerIDNamStr$
      PRINT "249. String to Identify CALLER ID BLOCKED --------- " + ZCallerIDBlockStr$
      PRINT "250. Allow Blocked CALLER ID Numbers Access ------- " + FNYESNO$(ZNoBlocking)
      PRINT "251. Use CALLER ID NAME for Logon ----------------- " + FNYESNO$(ZUseCallerIDName)
      PRINT "252. Minimum Security to UL PUBLIC File Attach ----" + STR$(ZPublicAttachSecLevel)
      PRINT "253. Minimum Security to UL PRIVATE File Attach ---" + STR$(ZPrivateAttachSecLevel)
      GOTO 12580
12510 ZDisplayedPageNumber = 14
      GOSUB 24800
      LOCATE 3,1
      IF ZTimeToDropToDOS < 1 THEN _
         TimeToDropToDOS$ = ZNonePicked$ _
      ELSE TimeToDropToDOS$ = STRING$(4 - (LEN(STR$(ZTimeToDropToDOS)) - 1),"0") + MID$(STR$(ZTimeToDropToDOS),2)
12512 PRINT "261. Time of day to exit to DOS ------------------- " + TimeToDropToDOS$
      PRINT "262. Net mail to invoke is ------------------------ " + ZNetMail$
      X$ = ZHostEchoOn$
      IF ZHostEchoOn$ = "" THEN _
         X$ = ZNonePicked$
      PRINT "263. Command for intermediate host to ECHO -------- " + X$
      X$ = ZHostEchoOff$
      IF ZHostEchoOff$ = "" THEN _
         X$ = ZNonePicked$
      PRINT "264. Command for intermediate host NOT to ECHO ---- " + X$
      X = INSTR("ICR",ZDefaultEchoer$)
      X$ = MID$("Intermediate hostCaller's softwareRBBS-PC",1 + 17 * (X - 1),17)
      PRINT "265. Who echos what a remote caller types? -------- " + X$
      X$ = ZDefaultLineAck$
      IF ZDefaultLineAck$ = "" THEN _
         X$ = ZNonePicked$
      PRINT "266. String to acknowlege line in ASCII upload ---- "+ X$
      PRINT "267. Name of sorted file list used in up/download - "; ZFastFileList$
      PRINT "268. Name of locator file used in up/download ----- "; ZFastFileLocator$
      PRINT "269. FMS lines to display before pause ------------";
      IF ZFMSBreakPoint = 0 THEN
         PRINT " <no pause>"
      ELSE
         PRINT ZFMSBreakPoint
      END IF
      PRINT "270. View Conference Mail Display ----------------- " ;
      IF ZShowConfName = 0 THEN
         X$ = ZNonePicked$
      ELSEIF ZShowConfName = 1 THEN
         X$ = "Conf Name"
      ELSEIF ZShowConfName = 2 THEN
         X$ = "File Name"
      ELSEIF ZShowConfName = 3 THEN
         X$ = "Both Names"
      END IF
      PRINT X$
      GOTO 12580
12520 ZDisplayedPageNumber = 15
      GOSUB 24800
      LOCATE  3,1
      PRINT "281. Let new users set their preferences ---------- " ; FNYESNO$(ZNewUserSetsDefaults)
      PRINT "282. Skip Mail check at Log on -------------------- " ; FNYESNO$(ZSkipMailCheck)
      PRINT "283. Skip Conference Mail Check at Log on --------- " ; FNYESNO$(ZSkipConfCheck)
      PRINT "284. ";STRING$(45,45)
      PRINT "285. ";STRING$(45,45)
      PRINT "286. ";STRING$(45,45)
      PRINT "287. ";STRING$(45,45)
      PRINT "288. ";STRING$(45,45)
      PRINT "289. ";STRING$(45,45)
      PRINT "290. Add new users to USERS file ------------------ " ; FNYESNO$(ZRememberNewUsers)
      PRINT "291. Let new users on even when USERS file full --- " ; FNYESNO$(ZSurviveNoUserRoom)
      PRINT "292. Default max number of minutes can Bank -------" ; STR$(ZMaxBank)
      IF ZPrinterNumber > 3 OR ZPrinterNumber < 1 THEN
         X$ = ZNonePicked$
      ELSE
         X$ = "LPT" + LTRIM$(STR$(ZPrinterNumber))
      END IF
      PRINT "293. Default Printer for Logging ------------------ ";X$
      GOTO 12580
12530 ZDisplayedPageNumber = 16
      GOSUB 24800
      LOCATE  3,1
      X$ = ZLibraryDrive$
      IF ZLibraryDrive$ = "" THEN _
         X$ = ZNonePicked$
      PRINT "301. Drive/Path for Internode Chat swap file------- " + X$
      IF ZNetMailUserLst$ = "" THEN
         X$ = ZNonePicked$
      ELSE
         X$ = ZNetMailUserLst$
      END IF
      PRINT "302. NETMAIL User List ---------------------------- " + X$
      PRINT "303. Drive/Path/Filename of Language File --------- " + ZLanguageFile$
      PRINT "304. Drive/Path for V)iew feature ----------------- " + ZLibraryWorkDiskPath$
      IF ZLocalNetMailUserLst$ = "" THEN
         X$ = ZNonePicked$
      ELSE
         X$ = ZLocalNetMailUserLst$
      END IF
      PRINT "305. LOCAL NETMAIL User List ---------------------- " + X$
      IF ZViewDropFile$ = "N" THEN
         X$ = ZNonePicked$
      ELSEIF ZViewDropFile$ = "D" THEN
         X$ = "DORINFOx.DEF"
      ELSEIF ZViewDropFile$ = "S" THEN
         X$ = "DOOR.SYS"
      ELSEIF ZViewDropFile$ = "P" THEN
         X$ = "PCBOARD.SYS"
      ELSEIF ZViewDropFile$ = "U" THEN
         X$ = "USERINFO.DAT"
      END IF
      PRINT "306. Door Drop File to Create when VIEWING -------- " + X$
      IF ZChatLogPath$ = "" THEN
         X$ = ZNonePicked$
      ELSE
         X$ = ZChatLogPath$
      END IF
      PRINT "307. Drive/Path of Chat Log Files ----------------- " + X$
      IF ZInternetMsgTo$ = "" THEN
         X$ = "Original Name"
      ELSE
         X$ = ZInternetMsgTo$
      END IF
      PRINT "308. Send Internet FIDO style messages to --------- " + X$
      PRINT "309. Name of RIP ICON File for Download ----------- " + ZRIPIconFile$
      PRINT "310. ";STRING$(45,45)
12531 PRINT "311. ";STRING$(45,45)
      PRINT "312. ";STRING$(45,45)
      PRINT "313. ";STRING$(45,45)
      GOTO 12580
12540 ZDisplayedPageNumber = 17
      GOSUB 24800
      LOCATE  3,1
      X$ = ZEmphasizeOnDef$
      IF ZEmphasizeOnDef$ = "" THEN _
         X$ = ZNonePicked$
      PRINT "321. String to turn ON Graphic Emphasis ----------- " + X$
      X$ = ZEmphasizeOffDef$
      IF ZEmphasizeOffDef$ = "" THEN _
         X$ = ZNonePicked$
      PRINT "322. String to restore normal text (Emphasis OFF) - " + X$
      PRINT "323. FileName Color in Directory Listings --------- " + ZFG1Def$
      PRINT "324. FileSize Color in Directory Listings --------- " + ZFG2Def$
      PRINT "325. FileDate Color in Directory Listings --------- " + ZFG3Def$
      PRINT "326. Description Color in Directory Listings ------ " + ZFG4Def$
      PRINT "327. ";STRING$(45,45)
      PRINT "328. Default Local Display Page Length ------------" + STR$(ZLocalPageLength)
      PRINT "329. Extended Description in Directory Listings --- " + ZFG5Def$
      X$ = ZSysopColor$
      IF ZSysopColor$ = "" THEN
         X$ = ZNonePicked$
      END IF
      PRINT "330. Sysop's Color for special menus -------------- " + X$
      PRINT "331. Clear the screen while listing files --------- "; FNYESNO$(ZDisplayOptions2)
      PRINT "332. Show Menu when ENTER pressed at Command Prompt "; FNYESNO$(ZDisplayOptions3)
      GOTO 12580
12550 ZDisplayedPageNumber = 18
      GOSUB 24800
      LOCATE 3,1
      PRINT "341. Allow Comments in Subboards/Conferences ------ "; FNYESNO$(ZBBSOptions1)
      PRINT "342. Clear Screen before ALL Menus and Screens ---- "; FNYESNO$(ZBBSOptions2)
      PRINT "343. Pause Screen after ALL Bulletins ------------- "; FNYESNO$(ZBBSOptions3)
      PRINT "344. Leave modem ON hook after logoff ------------- "; FNYESNO$(ZBBSOptions4)
      PRINT "345. Allow 8-N-1 calls only ----------------------- "; FNYESNO$(ZBBSOptions5)
      PRINT "346. Log internode chats -------------------------- "; FNYESNO$(ZBBSOptions6)
      PRINT "347. Log Off only for too many Sec Violations ----- "; FNYESNO$(ZBBSOptions7)
      PRINT "348. Prompt to Kill personal Mail after reading --- "; FNYESNO$(ZBBSOptions8)
      PRINT "349. Suspend TIME while reading messages ---------- "; FNYESNO$(ZBBSOptions9)
      PRINT "350. Suspend TIME while reading bulletins --------- "; FNYESNO$(ZBBSOptions10)
      PRINT "351. Clear Screen before display of each message -- "; FNYESNO$(ZBBSOptions11)
      PRINT "352. Suppress GIF dimensions in upload description- "; FNYESNO$(ZBBSOptions12)
      PRINT "353. Set Options New Users can select"
      PRINT "354. Set New Users default options"
      PRINT "355. Set New Users default Graphics"
      PRINT "356. Default New User Protocol -------------------- "; ZDefaultNewUserProto$
      PRINT "357. Blank the Screen while idle ------------------ "; FNYESNO$(ZBBSOptions13)
      PRINT "358. Log Local Callers ---------------------------- "; FNYESNO$(ZBBSOptions14)
      PRINT "359. Carry user's record over when joining SubBoard "; FNYESNO$(ZBBSOptions15)
      PRINT "360. Reset user's registration date when expired -- "; FNYESNO$(ZRegReset)
12580 IF PreDisplay THEN _
         PreDisplay = ZFalse : _
         GOTO 12622
      GOSUB 24890
12590 GOSUB 22160
12592 IF ZIX THEN _            'ZIX       Key    Where to branch to
         ON ZIX GOTO 12360, _  ' 1       F1 - Global Parameters (Part 1)
                    12370, _  ' 2       F2 - Global Parameters (Part 2)
                    12380, _  ' 3       F3 - Global Parameters (Part 3)
                    12390, _  ' 4       F4 - RBBS-PC System Files (Part 1)
                    12400, _  ' 5       F5 - RBBS-PC System Files (Part 2)
                    12410, _  ' 6       F6 - RBBS-PC "doors"
                    12420, _  ' 7       F7 - RBBS-PC security parms. (Part 1)
                    12466, _  ' 8       F8 - RBBS-PC security parms. (Part 2)
                    12470, _  ' 9       F9 - Multiple RBBS-PC parameters
                    12480, _  '10      F10 - RBBS-PC's utilities
                    12490, _  '11 Shift-F1 - RBBS-PC File Manager
                    12500, _  '12 Shift-F2 - RBBS-PC comm. parameters (Part 1)
                    12505, _  '13 Shift-F3 - RBBS-PC comm. parameters (Part 2)
                    12510, _  '14 Shift-F4 - RBBS-PC Net Mail
                    12520, _  '15 Shift-F5 - New user parameters
                    12530, _  '16 Shift-F6 - Library parameters
                    12540, _  '17 Shift-F7 - RBBS-PC Color parameters
                    12550, _  '18 Shift-F8 - Global Parameters (Part 4)
                    12340, _  '19     PgUp - Go to previous page
                    12330, _  '20     PgDn - Go to next page
                    12630, _  '21      End - Terminate CONFIG
                    12620     '22 Enter - Option selected followed by "enter"
      GOTO 12590
12620 GOSUB 50340
      IF VAL(ZHJ$) < 1 OR VAL(ZHJ$) > 360 THEN _
         GOTO 12580
      ZIPage = INT((VAL(ZHJ$) - 1) / 20)
      IF ZDisplayedPageNumber <> ZIPage+1 THEN _
         PreDisplay = ZTrue : _
         ZIX = ZIPage+1 : _
         GOTO 12592
12622 ZILookUp = VAL(ZHJ$) - (20 * ZIPage)
      ZIPage = ZIPage + 1
      IF ZILookUp < 1 THEN _
         ZILookUp = 20 : _
         ZIPage = ZIPage - 1
12630 EXIT SUB
'
' * COMMON SUBROUTINE TO HANDLE THE FUNCTION KEYS, SCROLL BETWEEN CONFIG'S
' * PAGES OF OPTIONS, AND USER'S SELECTING A NUMERIC 4-CHARACTER OPTION.
'
22160 I! = FRE(ZC$)
      ZIX = 0
      IF ZKStacked$ = "" THEN _
         GOTO 22161
      X = INSTR(ZKStacked$,CHR$(13))
      IF X > 0 THEN _
         ZIX = 22 : _
         ZHJ$ = LEFT$(ZKStacked$,X-1) : _
         ZKStacked$ = RIGHT$(ZKStacked$,LEN(ZKStacked$)-X) : _
         ZOption$ = ZHJ$ : _
         RETURN
      Y$ = CHR$(0) + "D"
      IF ZKStacked$ = "END" THEN _
         Y$ = CHR$(0) + "O"
      ZKStacked$ = ""
      GOTO 22240
22161 Y$ = INKEY$
      IF LEN(Y$) < 1 THEN _
         GOTO 22161
      IF LEN(Y$) = 2 THEN _               ' IF A FUNCTION KEY, BRANCH
         GOTO 22240
      IF ASC(Y$) = 13 THEN _              ' IF A CARRIAGE RETURN, RETURN
         ZIX = 22 : _
         RETURN
      IF ASC(Y$) = 8 AND LEN(ZHJ$) > 0 THEN _
         ZHJ$ = LEFT$(ZHJ$,LEN(ZHJ$) - 1) : _
         PRINT CHR$(29) + " " + CHR$(29); : _
         GOTO 22161
      IF ASC(Y$) < 48 OR ASC(Y$) > 57 THEN _
         GOTO 22161
      PRINT Y$;
      ZHJ$ = ZHJ$ + _
            Y$
      ZOption$ = ZHJ$
      IF LEN(ZHJ$) > 4 THEN _              ' IF MORE THAN FOUR CHARACTERS,
         ZIX = 22                          ' RETURN
      RETURN
'
' * COMMON SUBROUTINE TO HANDLE SET UP RETURN CODES FOR FUNCTION KEYS THAT
' * WERE PRESSED ON THE LOCAL PC RUNNING CONFIG
'
22240 ZIX = ASC(RIGHT$(Y$,1))
      IF ZIX < 59 OR ZIX > 91 THEN _        ' IGNORE IF NOT F1 THROUGH F10 OR
         ZIX = 0: _                        ' SHIFT-F1 THROUGH SHIFT-F8
         RETURN
      IF ZIX = 73 THEN _                   ' IF PGUP THEN SET ZIX = 19
         ZIX = 19 : _
         RETURN
      IF ZIX = 79 THEN _                   ' IF END THEN SET ZIX = 21
         ZIX = 21 : _
         RETURN
      IF ZIX = 81 THEN _                   ' IF PGDN THEN SET ZIX = 20
         ZIX = 20 : _
         RETURN
      IF (ZIX-58) < 11 THEN _              ' IF F1 THROUGH F10 SET ZIX = 1
         ZIX = ZIX - 58 : _                 ' THROUGH 10 ACCORDINGLY.
         RETURN
      IF (ZIX-73) > 10 AND _               ' IF SHIFT-F1 THROUGH SHIFT-F8 THEN
         (ZIX-73) < 19 THEN _              ' SET ZIX = 11 THROUGH 18
            ZIX = ZIX - 73 : _              ' ACCORDINGLY.
            RETURN
      ZIX = 0
      RETURN
'
' * ROUTINE TO DISPLAY THE PAGE HEADER FOR CONFIG'S DISPLAYS
'
24800 CLS
      I! = FRE(ZC$)
      COLOR 0,7,0
      LOCATE 1,4
      PRINT " RBBS-PC/CDor "+ ZConfigVersion$ + _
            " CONFIGURATION PROGRAM " + " FILE: " + ZConfigFileName$ + " ";
      IF ZConferenceMode THEN _
         GOSUB 24970
      COLOR ZFG,ZBG
      PRINT " Page" + STR$(ZDisplayedPageNumber) + " of" + STR$(ZMaximumDisplayablePages)
      RETURN
24890 A$ = "Enter parameter # to change, END to update, PgUp/PgDn to scroll:"
24900 LOCATE 24,5
      PRINT A$;
      X = POS(0) + 2
      PRINT STRING$((75 - LEN(A$)),32);
      LOCATE 24,X
      COLOR ZFG,ZBG
      ZHJ$ = "
      I! = FRE(ZC$)
      RETURN
'
' * ROUTINE TO DISPLAY CONFERENCE MAINTENANCE MODE IN CONFIG'S DISPLAYS
'
24970 LOCATE 2,1
      PRINT SPACE$(10)
      LOCATE 2,10
      PRINT "(Conference Maintenance Mode for " + _
            ZConfName$ + _
            ")";
      RETURN
'
' * COMMON SUBROUTINE TO READ THE MESSAGES FILE'S CHECKPOINT RECORD
'
30040 IF ZNetWorkType = 6 THEN _
         OPEN ZMainMessageFile$ FOR RANDOM SHARED AS #2 LEN=128 _
      ELSE OPEN "R",2,ZMainMessageFile$,128
      FIELD 2,128 AS RR$
      GET 2,1
      CallsToDate! = VAL(MID$(RR$,1,8))             '  1-  8  =  number of last message on system
      FirstUserRecord = VAL(MID$(RR$,52,5))        ' 52- 56  =  first rec. of user file
      CurrentUserCount = VAL(MID$(RR$,57,5))       ' 57- 61  =  next avail. user record
      HighestUserRecord = VAL(MID$(RR$,62,5))      ' 62- 66  =  last rec. of user file
      FirstMessageRecord = VAL(MID$(RR$,68,7))     ' 68- 74 = first rec. of msgs file
      NextMessageRecord = VAL(MID$(RR$,75,7))      ' 75- 81 = next avail. msgs record
      HighestMessageRecord = VAL(MID$(RR$,82,7))   ' 82- 88 = last rec. of msgs file
      MaximumNumberOfMsgs = VAL(MID$(RR$,89,7))   ' 89- 95 = maximum number of messages
      ZMaximumNumberOfNodes = VAL(MID$(RR$,127,2)) '127-128 = maximum number of "nodes"
      CLOSE 2
      RETURN
'
' * COMMON ROUTINE TO GET THE LENGTH OF A FILE
'
30180 IF ZNetWorkType = 6 THEN _
         OPEN ZFile$ FOR RANDOM SHARED AS #2 LEN=128 _
      ELSE OPEN "R",2,ZFile$,128
      FIELD 2,128 AS RR$
      UG = LOF(2) / 128
      CLOSE 2
      RETURN
'
' * COMMON SUBROUTINE TO KEEP STRING SPACE CLEAN AND CLEAR LINE 24
'
50340 I! = FRE(ZC$)
      LOCATE 24,1
      PRINT STRING$(79,32);
      RETURN
'
' * COMMON SUBROUTINE TO DISPLAY A MESSAGE ON LINE 24
'
50345 GOSUB 50340
      LOCATE 24,5
      PRINT XX$;
      RETURN
'
' * COMMON SUBROUTINE TO BEEP AT THE SYSOP
'
60380 FOR I = 1 TO 3
        BEEP
      NEXT
      RETURN
      END SUB
'  $SUBTITLE: 'NETTYPE - subroutine to select supported networks'
'  $PAGE
'
'  SUBROUTINE NAME    --  NETTYPE
'
'  INPUT PARAMETERS   --  MLCOM
'                         ZNetWorkType
'                         ZNetWorkType$
'                         ZSubroutineParameter
'
'  OUTPUT PARAMETERS  --  MLCOM
'                         ZNetWorkType
'                         ZNetWorkType$
'
'  SUBROUTINE PURPOSE --  TO SELECT THE RBBS-PC SUPPORTED NETWORKS
'
      SUB NETTYPE STATIC
      ON ZSubroutineParameter GOTO 60382,60384
60382 CLS
      LOCATE 3,1
      PRINT "     RBBS-PC is supported in the following:"
      PRINT "                   Environment"
      PRINT "          0. Single RBBS-PC in an IBM DOS environment"
      PRINT "          1. DesqView"
      PRINT "          2. NETBIOS (DOS SHARE)"
60383 XX$ = "Select environment (0 to 2, [ENTER] quits) "
      I! = FRE(ZC$)
      LOCATE 24,1
      PRINT STRING$(79,32);
      LOCATE 24,5
      PRINT XX$;
      LINE INPUT;X$
      IF X$ = "" THEN _
         EXIT SUB
      ZNetWorkType = VAL(X$)
      IF ZNetWorkType < 0 OR ZNetWorkType > 7 THEN _
         GOTO 60383
      IF ZNetWorkType = 1 THEN ZNetWorkType = 4
      IF ZNetWorkType = 2 THEN ZNetWorkType = 6
60384 IF ZNetWorkType = 0 THEN _
         ZNetWorkType$ = "IBM's DOS"
      IF ZNetWorkType = 4 THEN _
         ZNetWorkType$ = "DESQview"
      IF ZNetWorkType = 6 THEN _
         ZNetWorkType$ = "NETBIOS"
      IF ZSubroutineParameter = 2 THEN _
         EXIT SUB
      END SUB
'  $SUBTITLE: 'CNFGINIT - subroutine to initialize CONFIG's constants'
'  $PAGE
'
'  SUBROUTINE NAME    --  CNFGINIT
'
'  INPUT PARAMETERS   --  NONE
'
'  OUTPUT PARAMETERS  --  CONFIG'S CONSTANTS INITIALIZED
'
'  SUBROUTINE PURPOSE --  TO INITIALIZE THE CONSTANTS USED BY CONFIG
'
60385 SUB CNFGINIT STATIC
'
' * INITALIZE ALL VARIABLES IF A .DEF FILE DOESN'T AREADY EXIST
'
      D$ = ZDD$
      DRV$ = LEFT$(D$,1)
      ZFalse                     = 0
      ZTrue                       = NOT ZFalse
      ZSysopSecurityLevel       = 10
      ZActMnthsB4Deleting        = 1
      ZActiveBulletins           = 6
      ZAddDirSecurity            = ZSysopSecurityLevel
      ZAllowCallerTurbo          = 6
      ZAltDirExtension$          = ""
      ZAlwaysStrewTo$            = ""
      ZAnsMenu$                  = D$ + "MENUA"
      ZAskExtendedDesc           = ZSysopSecurityLevel
      ZShowXferTime              = ZTrue
      ZAutoAddSecurity           = 5
      ZAutoUpgradeSec            = ZSysopSecurityLevel
      ZAutoPageDef$              = D$ + "AUTOPAGE.DEF"
      ZBG                        = 0
      ZNewUserSelect             = 32767
      ZBufferSize                = 128
      ZBulletinMenu$             = "BULLET"
      ZBulletinPrefix$           = "BULLET"
      ZBulletinsOptional         = ZTrue
      ZC$                        = ""
      ZExtendedConfMail          = 0
      ZCallersFile$              = D$ + "CALLERS"
      ZSecKillAny               = ZSysopSecurityLevel
      ZComPort$                  = "COM1"
      ZCommandBetweenRings       = ZFalse
      ZCommandsInPrompt          = ZTrue
      ZCommentsAsMessages        = ZFalse
      ZCommentsFile$             = D$ + "COMMENTS"
      ZCompressedExt$            = ".ARJ.LZH.GIF"
      ZShowTimesDownloaded       = ZFalse
      ZConferenceMenu$           = D$ + "CONFENCE"
      ZConfMailList$             = D$ + "CONFMAIL.DEF"
      ZConfigVersion$            = "Version 17.4"
      ZDefaultCategoryCode$      = "UNC"
      ZDaysInSubscriptionPeriod  = 365
      ZDaysToWarn                = 60
      ZDirCategoryFile$          = D$ + "DIR.CAT"
      ZDirectoryPrefix$          = "DIR"
      ZDefaultEchoer$            = "R"
      ZDefaultLineAck$           = ""
      ZDefaultSecurityLevel      = 5
      ZDirectoryExtension$       = "DIR"
      ZDirectoryPath$            = D$
      ZDiskForDOS$               = D$
      ZDiskFullGoOffline         = ZTrue
      ZDnldSub                   = 0
      ZDoorsAvailable            = ZFalse
      ZDoorsDef$                 = D$ + "DOORS.DEF"
      ZDefaultNewUserOptions     = 0
      ZDOSANSI                   = ZFalse
      ZDownLoadDrives$           = DRV$ + DRV$
      ZDriveForBulletins$        = D$
      ZDTRDropDelay              = 3
      ZSmartTextInMsgs           = ZTrue
      ECHOER$                    = "R"
      ZEmphasizeOffDef$          = "[27]" + "[0;40;33m"
      ZEmphasizeOnDef$           = "[27]" + "[1;41;37m"
      ZEndOfficeHours            = 2200
      ZEnforceUploadDownloadRatios = ZFalse
      ZEpilog$                   = D$ + "EPILOG.DEF"
      ZEscapeInsecure            = 0
      ZExpiredSecurity           = ZDefaultSecurityLevel
      ZExtendedLogging           = ZFalse
      ZExtensionList$            = "ZIP"
      ZFastFileList$             = D$ + "FIDX.DEF"
      ZFastFileLocator$          = D$ + "LIDX.DEF"
      ZFC                        = 5
      ZFG                        = 7
      ZFG1Def$                  = "Bright Green"
      ZFG2Def$                  = "Bright Yellow"
      ZFG3Def$                  = "Bright Purple"
      ZFG4Def$                  = "Bright Cyan"
      ZFG5Def$                  = "Normal Yellow"
      ZFileCommandsDefaults$    = "DGLNPSUV"
      ZFileCommands$             = ZFileCommandsDefaults$
      ZFilesFunction$(1,1)       = "D)ownload a file      "
      ZFilesFunction$(2,1)       = "G)oodbye              "
      ZFilesFunction$(3,1)       = "L)ist file directory  "
      ZFilesFunction$(4,1)       = "N)ew file search      "
      ZFilesFunction$(5,1)       = "P)ersonal files       "
      ZFilesFunction$(6,1)       = "S)earch files         "
      ZFilesFunction$(7,1)       = "U)pload a file        "
      ZFilesFunction$(8,1)       = "V)erbose archive list "
      ZFilesFunction$(1,2)       = "D"
      ZFilesFunction$(2,2)       = "G"
      ZFilesFunction$(3,2)       = "L"
      ZFilesFunction$(4,2)       = "N"
      ZFilesFunction$(5,2)       = "P"
      ZFilesFunction$(6,2)       = "S"
      ZFilesFunction$(7,2)       = "U"
      ZFilesFunction$(8,2)       = "V"
      ZFileSecFile$              = D$ + "FILESEC"
      ZFirstNamePrompt$          = "FIRST name"
      ZFOSSIL                    = 0
      ZGB                         = ZFC
      ZGlobalCommandsDefaults$   = "H?QX"
      ZGlobalCommands$           = ZGlobalCommandsDefaults$
      ZGlobalFunction$(1,1)      = "H)elp on-line           "
      ZGlobalFunction$(2,1)      = "?)help on-line (=H)     "
      ZGlobalFunction$(3,1)      = "Q)uit this part         "
      ZGlobalFunction$(4,1)      = "X)Expert toggle on/off  "
      ZGlobalFunction$(1,2)      = "H"
      ZGlobalFunction$(2,2)      = "?"
      ZGlobalFunction$(3,2)      = "Q"
      ZGlobalFunction$(4,2)      = "X"
      ZHelp$(3)                   = "HELP03"
      ZHelp$(4)                   = "HELP04"
      ZHelp$(7)                   = "HELP07"
      ZHelp$(9)                   = "HELP09"
      ZHelpExtension$            = "HLP"
      ZHelpFilePrefix$          = "HELP0"
      ZHelpPath$                 = D$
      ZHostEchoOff$             = ""
      ZHostEchoOn$              = ""
      ZIB                         = 0
      ZKeepInitBaud             = ZFalse
      ZKeepTimeCredits          = ZFalse
      ZLastNamePrompt$          = "LAST name"
      ZLenHash                   = 31
      ZLenIndiv                  = 0
      ZLibraryCommandsDefaults$   = "ACDGLSV"
      ZLibraryCommands$            = ZLibraryCommandsDefaults$
      ZLibraryDrive$               = D$
      ZDefaultNewUserGraphics     = 3
      ZPrinterNumber               = 0
      ZDefaultNewUserProto$       = "N"
      ZSysopColor$                 = "[27]" + "[0;40;37m"
      ZLanguageFile$               = "RBBS-PC.LNG"
      ZLibraryFunction$(1,1)       = "A)rchive a Library disk  "
      ZLibraryFunction$(2,1)       = "C)hange Library disk     "
      ZLibraryFunction$(3,1)       = "D)ownload a file         "
      ZLibraryFunction$(4,1)       = "G)oodbye                 "
      ZLibraryFunction$(5,1)       = "L)ist a file directory   "
      ZLibraryFunction$(6,1)       = "S)earch files            "
      ZLibraryFunction$(7,1)       = "V)erbose archive list    "
      ZLibraryFunction$(1,2)       = "A"
      ZLibraryFunction$(2,2)       = "C"
      ZLibraryFunction$(3,2)       = "D"
      ZLibraryFunction$(4,2)       = "G"
      ZLibraryFunction$(5,2)       = "L"
      ZLibraryFunction$(6,2)       = "S"
      ZLibraryFunction$(7,2)       = "V"
      ZLibraryWorkDiskPath$      = D$
      ZLimitSearchToFMS         = ZFalse
      ZLogonMailLevel$          = "A"
      ZLSB                       = 1016
60390 ZMacroDrvPath$             = D$
      ZMacroExtension$           = ""
      ZMainCommandsDefaults$    = "ABCDEFIJKOPRSTUVWG"
      ZMainCommands$             = ZMainCommandsDefaults$
      ZMainFunction$(1,1)        = "A)nswer questionnaire  "
      ZMainFunction$(2,1)        = "B)ulletins             "
      ZMainFunction$(3,1)        = "C)omments              "
      ZMainFunction$(4,1)        = "D)oor subsystem        "
      ZMainFunction$(5,1)        = "E)nter message         "
      ZMainFunction$(6,1)        = "F)iles subsystem       "
      ZMainFunction$(7,1)        = "I)nitial welcome       "
      ZMainFunction$(8,1)        = "J)oin a conference     "
      ZMainFunction$(9,1)        = "K)ill messages         "
      ZMainFunction$(10,1)       = "O)perator page         "
      ZMainFunction$(11,1)       = "P)ersonal mail         "
      ZMainFunction$(12,1)       = "R)ead messages         "
      ZMainFunction$(13,1)       = "S)can messages header  "
      ZMainFunction$(14,1)       = "T)opic msg scan        "
      ZMainFunction$(15,1)       = "U)tilities subsystem   "
      ZMainFunction$(16,1)       = "V)iew conference mail  "
      ZMainFunction$(17,1)       = "W)ho's on other nodes  "
      ZMainFunction$(18,1)       = "G)oodbye               "
      ZMainFunction$(1,2)        = "A"
      ZMainFunction$(2,2)        = "B"
      ZMainFunction$(3,2)        = "C"
      ZMainFunction$(4,2)        = "D"
      ZMainFunction$(5,2)        = "E"
      ZMainFunction$(6,2)        = "F"
      ZMainFunction$(7,2)        = "I"
      ZMainFunction$(8,2)        = "J"
      ZMainFunction$(9,2)        = "K"
      ZMainFunction$(10,2)       = "O"
      ZMainFunction$(11,2)       = "P"
      ZMainFunction$(12,2)       = "R"
      ZMainFunction$(13,2)       = "S"
      ZMainFunction$(14,2)       = "T"
      ZMainFunction$(15,2)       = "U"
      ZMainFunction$(16,2)       = "V"
      ZMainFunction$(17,2)       = "W"
      ZMainFunction$(18,2)       = "G"
      ZMainMessageBackup$       = D$ + "MESSAGES.BAK"
      ZMainMessageFile$         = D$ + "MESSAGES"
      ZMainPUI$                  = D$ + "MAIN.PUI"
      ZMainUserFile$            = D$ + "USERS"
      ZMasterDirectoryName$     = ""
      ZMaxAllowedMsgsFrmDef   = 5
      ZMaxCarrierWait           = 30
      ZMaxDescLen               = 40
      ZMaxExtendedLines         = 2
      ZMaxMessageLines          = 19
      ZMaxPerDay                = 0
      ZMaxRegSec                = 0
      ZMaxUsrFileSizeFrmDef  = 16
      ZMaxWorkVar               = 30
      ZMaxD                       = 15
      ZMaximumDisplayablePages  = 18
      ZMaximumPasswordChanges   = 3
      ZMaximumViolations         = 5
      ZMaximumNumberOfNodes    = 1
      ZMenu$(1)                   = D$ + "MENU1"
      ZMenu$(2)                   = D$ + "MENU2"
      ZMenu$(3)                   = D$ + "MENU3"
      ZMenu$(4)                   = D$ + "MENU4"
      ZMenu$(5)                   = D$ + "MENU5"
      ZRIPIconFile$             = "ICONS.ZIP"
      ZDisplayOptions            = 2
      ZMessageReminder           = ZTrue
      ZMessagesCanGrow          = ZFalse
      ZMinNewCallerBaud         = 0
      ZMinOldCallerBaud         = 0
      ZMinSecToView            = ZDefaultSecurityLevel
      ZMinimumLogonSecurity     = 0
      ZMinimumSecurityForTempPassword = 5
      ZMinutesPerSession!       = 72
      ZBBSOptions                = 0
      MM                         = 5
      ZMO$                        = ZDD$
      ZDontShowLogOff           = ZFalse
      ZNetMail$                  = "<none>"
      ZNetWorkType               = 0
      ZNetWorkType$              = "IBM's DOS"
      ZNewFilesCheck            = ZFalse
      ZNewUserQuestionnaire$    = D$ + "RBBS-REG.DEF"
      ZNewUserFile$              = D$ + "NEWUSER"
      ZNewUserSetsDefaults      = ZTrue
      ZOmitMainDirectory$       = "NO"
      ZOverWriteSecurityLevel   = ZSysopSecurityLevel
      ZPageLength                = 23
      ZPagingPrinterSupport$    = ". "
      ZPasswordFile$             = D$ + "PASSWRDS"
      ZLocalPageLength          = 25
      ZPersonalBegin             = 1
      ZPersonalDir$              = D$+"PRIV.DEF"
      ZPersonalDrvPath$          = D$
      ZPersonalLen               = 31
      ZPersonalConCat            = ZFalse
      ZPreLog$                    = D$ + "PRELOG"
      ZPrivateReadSec           = ZDefaultSecurityLevel
      ZProtoDef$                 = D$ + "PROTO.DEF"
      ZPromptBell                = 0
      ZPromptHash$               = "Name"
      ZPromptIndiv$              = ""
      ZPS                         = 5
      ZPublicReadSec            = ZDefaultSecurityLevel
      ZQuesPath$                 = D$
      ZRBBSBat$                  = D$ + "RBBS" + ZNodeID$ + ZDefaultBatchExt$
      ZRBBSName$                 = "RBBS-PC"
      ZRCTTYBat$                 = D$ + "RCTTY" + ZNodeID$ + ZDefaultBatchExt$
      ZUpdateOnLine              = ZTrue
      ZRecycleWait               = 0
      ZRedirectIOMethod         = ZTrue
      ZRegistrationProgram$      = "<none>"
      ZRememberNewUsers         = ZTrue
      ZShowAllWhosOn           = ZFalse
      ZRegReset                  = ZFalse
      ZRemindProfile             = ZFalse
      ZRequireNonASCII          = ZTrue
      ZRequireQuestionnaire$    = "<none>"
      ZRequiredRings             = 1
      ZRestrictByDate           = ZFalse
      ZRestrictValidCmds        = ZFalse
      ZRTS$                       = "NO"
      ZScreenOutMsg$             = "SEEN-BY: "
      ZSecChangeMsg             = ZSysopSecurityLevel
      ZSecLvlExemptFrmPurging = ZSysopSecurityLevel
      ZSecVioHlp$                = D$ + "SECVIO." + ZHelpExtension$
      ZSecurityExemptFromEpilog= ZDefaultSecurityLevel + 1
      ZSF                         = ZSysopSecurityLevel
      ZShootYourSelf             = ZFalse
      ZShowSection               = ZTrue
      ZSizeOfStack              = 1024
      ZSLCategorizeUploads      = ZSysopSecurityLevel
      ZSmartText                 = 123
      ZStartHash                 = 1
      ZStartIndiv                = 0
      ZStartOfficeHours         = 800
      ZSurviveNoUserRoom        = ZFalse
      ZSwitchBack                = ZFalse
      ZSysopCommandsDefaults$   = "12345678"
      ZSysopCommands$            = ZSysopCommandsDefaults$
      ZSysopFunction$(1,1)       = " 1 List comments      "
      ZSysopFunction$(2,1)       = " 2 List CALLERS log   "
      ZSysopFunction$(3,1)       = " 3 Recover a message  "
      ZSysopFunction$(4,1)       = " 4 Erase comments     "
      ZSysopFunction$(5,1)       = " 5 User maintenance   "
      ZSysopFunction$(6,1)       = " 6 Toggle Page bell   "
      ZSysopFunction$(7,1)       = " 7 Exit to DOS        "
      ZSysopFunction$(8,1)       = " 8 FMS Maintenance    "
      ZSysopFunction$(1,2)       = " 1"
      ZSysopFunction$(2,2)       = " 2"
      ZSysopFunction$(3,2)       = " 3"
      ZSysopFunction$(4,2)       = " 4"
      ZSysopFunction$(5,2)       = " 5"
      ZSysopFunction$(6,2)       = " 6"
      ZSysopFunction$(7,2)       = " 7"
      ZSysopFunction$(8,2)       = " 8"
      ZSysopFirstName$          = "TOM"
      ZSysopLastName$           = "MACK"
      ZSysopMenuSecurityLevel  = ZSysopSecurityLevel
      ZSysopPassword1$          = "SECRET"
      ZSysopPassword2$          = "NAME"
      ZTestANSITime             = 0
      ZTimeToDropToDOS        = 0
      ZTrashCanFile$             = D$ + "TRASHCAN"
      ZTurnPrinterOff           = ZFalse
      ZNewsInterruptable         = ZTrue
      UE                         = 5
      ZFMSDirectory$             = ""
      ZUpCatHelp$                = "UPCAT"
      ZUploadDirectory$          = "99"
      ZUploadPath$               = D$
      ZUploadSubDir$             = ""
      ZUploadTimeFactor!        = 0
      ZUseDeviceDriver$         = ""
      ZUserLocation$             = "CITY and STATE"
      ZUtilCommandsDefaults$    = "BWEFGLMPRSTU"
      ZUtilCommands$             = ZUtilCommandsDefaults$
      ZUtilityFunction$(1,1)     = "B)ank time            "
      ZUtilityFunction$(2,1)     = "W)ho Uploaded What?   "
      ZUtilityFunction$(3,1)     = "E)cho                 "
      ZUtilityFunction$(4,1)     = "F)ile x-fer protocol  "
      ZUtilityFunction$(5,1)     = "G)raphics             "
      ZUtilityFunction$(6,1)     = "L)ines per page       "
      ZUtilityFunction$(7,1)     = "M)sg margin setting   "
      ZUtilityFunction$(8,1)     = "P)ers. Info Change    "
      ZUtilityFunction$(9,1)     = "R)eview defaults      "
      ZUtilityFunction$(10,1)    = "S)tatistics           "
      ZUtilityFunction$(11,1)    = "T)oggle               "
      ZUtilityFunction$(12,1)    = "U)ser log scan        "
      ZXOnXOff                   = ZFalse
      ZCallersLst$               = D$ + "CALLLST.DEF"
      ZCopyrightSecs             = 8
      ZDistriHelp$               = "DISTRI"
      ZDistriPath$               = D$
      ZEnableCC                  = ZFalse
      ZFMSBreakPoint             = 1000
      ZMaxBank                   = 60
      ZMinSecPersUpld            = ZSysopSecurityLevel
      ZMsgSecCats$               = "URP"
      ZNetMailSystem             = ZFalse
      ZNetMailPath$              = ""
      ZNetMailAttr               = 259
      ZNetMailAddr$              = ""
      ZNetMailUserLst$           = ""
      ZLocalNetMailUserLst$      = ""
      ZShowConfName              = 3
      ZViewDropFile$             = "N"
      ZChatLogPath$              = D$
      ZInternetMsgTo$            = ""
      ZSkipConfCheck             = ZFalse
      FOR I = 1 TO LEN(ZUtilCommandsDefaults$)
         ZUtilityFunction$(I,2) = MID$(ZUtilCommandsDefaults$,I,1)
      NEXT
      ZWaitBeforeDisconnect     = 180
      ZWelcomeFile$              = D$ + "WELCOME"
      ZWelcomeInterruptable      = ZTrue
      ZWriteBufDef              = 1024
      ZCallerIDNumStr$           = "NUMBER ="
      ZCallerIDNamStr$           = "NAME ="
      ZCallerIDBlockStr$         = "REASON FOR NO NUMBER"
      ZAllowFileAttach           = ZFalse
      ZAllowFileAttach         = ZFalse
      ZFileAttachPath$           = ""
      ZFileAttachHoldPath$       = ""
      ZPublicAttachSecLevel      = 5
      ZPrivateAttachSecLevel     = 6
      ZDefaultBatchExt$          = ".BAT"
      ZReFormatDiz               = ZFalse
      ZPrintOrigin               = ZTrue
      FOR I = 1 TO ZNumSysop
         ZSysopFunction(I) = ZSF
      NEXT
      FOR I = 1 TO ZNumMain
         ZMainFunction(I) = MM
      NEXT
      FOR I = 1 TO ZNumFiles
         ZFilesFunction(I) = ZFC
      NEXT
      FOR I = 1 TO ZNumLibrary
         ZLibraryFunction(I) = ZPS
      NEXT
      FOR I = 1 TO ZNumUtility
         ZUtilityFunction(I) = UE
      NEXT
      FOR I = 1 TO ZNumGlobal
         ZGlobalFunction(I) = ZGB
      NEXT
      CALL MODEMINITCMD
      ZOmitFromLog              = ZTrue
      ZAddNameToDir            = ZFalse
      ZSkipMailCheck              = ZFalse
      END SUB
'  $SUBTITLE: 'ASKRO - ask a question at a specific row'
'  $PAGE
'
'  SUBROUTINE NAME    --  ASKRO
'
'  INPUT PARAMETERS   --  PARAMETER         MENANING
'                         ANS$           STRING TO PUT THE ANSWER IN
'                         STRNG$         STRING CONTAINING THE QUESTION
'                         RO             ROW TO ASK THE QUESTION ON
'
'  OUTPUT PARAMETERS  --  ANS$           RESPONSE FROM THE KEYBOARD
'
'  SUBROUTINE PURPOSE --  TO ASK A QUESTION ON THE PC'S DISPLAY AT A
'                         SPECIFIC ROW
'
      SUB ASKRO (STRNG$,RO,ANS$) STATIC
61100 LOCATE RO,1
      PRINT SPACE$(79);
      LOCATE RO,5
      PRINT STRNG$;" ";
      LINE INPUT;ANS$
      END SUB
'  $SUBTITLE: 'GETINIT - get an integer'
'  $PAGE
'
'  SUBROUTINE NAME    --  GETINIT
'
'  INPUT PARAMETERS   --  PARAMETER         MENANING
'                         ANS            WHERE TO PUT THE ANSWER IN
'                         STRNG$         STRING CONTAINING THE QUESTION
'                         RO             ROW TO ASK THE QUESTION ON
'                         MIN            MINIMUM ACCEPTABLE NUMBER
'                         MAX            MAXIMUM ACCEPTABLE NUMBER
'
'  OUTPUT PARAMETERS  --  ANS            RESPONSE FROM THE KEYBOARD
'
'  SUBROUTINE PURPOSE --  TO ASK A QUESTION ON THE PC'S DISPLAY AT A
'                         SPECIFIC ROW AND GET AN INTEGER BACK
'
      SUB GETINIT (STRNG$,RO,MIN,MAX,ANS,CR) STATIC
61110 LOCATE RO,1
      CR = ZFalse
      ANS = MIN
      PRINT SPACE$(79);
      LOCATE RO,5
      PRINT STRNG$;" ";
      LINE INPUT;ANS$
      IF ANS$ = "" THEN _
         CR = ZTrue : _
         EXIT SUB
      IF VAL(ANS$) < MIN OR _
         VAL(ANS$) > MAX THEN _
         GOTO 61110
      ANS = VAL(ANS$)
      IF ANS = 0 AND LEFT$(ANS$,1) <> "0" THEN _
         GOTO 61110
      END SUB
'  $SUBTITLE: 'GETNUMYN - get a TRUE-FALSE answer to a YES OR NO question'
'  $PAGE
'
'  SUBROUTINE NAME    --  GETNUMYN
'
'  INPUT PARAMETERS   --  PARAMETER         MENANING
'                         STRNG$         STRING CONTAINING THE QUESTION
'
'  OUTPUT PARAMETERS  --  ANS            Returned value - -1 IF yes, 0 IF no
'
'  SUBROUTINE PURPOSE --  TO ASK A QUESTION ON THE PC'S DISPLAY AND GET A
'                         YES OR NO ANSWER CONVERTED TO TRUE/FALSE
'
       SUB GETNUMYN (STRNG$,ANS) STATIC
       CALL GETYESNO (STRNG$,ANS$)
       ANS = FNYESNO (ANS$)
       END SUB
'  $SUBTITLE: 'GETYESNO - Ask a YES OR NO question'
'  $PAGE
'
'  SUBROUTINE NAME    --  GETYESNO
'
'  INPUT PARAMETERS   --  PARAMETER         MENANING
'                         ANS$           STRING TO PUT THE ANSWER IN
'                         STRNG$         STRING CONTAINING THE QUESTION
'
'  OUTPUT PARAMETERS  --  ANS$           RESPONSE FROM THE KEYBOARD
'
'  SUBROUTINE PURPOSE --  TO ASK A QUESTION ON THE PC'S DISPLAY AND GET A
'                         YES OR NO ANSWER
'
      SUB GETYESNO (STRNG$,ANS$) STATIC
61200 CALL ASKRO (STRNG$+" Y)es or N)o",24,ZHJ$)
      L = LEN(ZHJ$)
      IF L < 1 OR L > 3 THEN _
         GOTO 61207
      CALL ALLCAPS(ZHJ$)
      X = INSTR("NY",LEFT$(ZHJ$,1))
      ON X GOTO 61210,61212
61207 BEEP
      GOTO 61200
61210 ANS$ = "NO"
      EXIT SUB
61212 ANS$ = "YES"
      EXIT SUB
      END SUB
'  $SUBTITLE: 'ALLCAPS - convert a sting into all capital letters'
'  $PAGE
'
'  SUBROUTINE NAME    --  ALLCAPS
'
'  INPUT PARAMETERS   --  PARAMETER         MENANING
'                         STRNG$         STRING CONTAINING THE QUESTION
'
'  OUTPUT PARAMETERS  --  STRNG$         CAPITALIZED STRING
'
'  SUBROUTINE PURPOSE --  TO CAPITALIZE A STRING
'
      SUB ALLCAPS (STRNG$) STATIC
      STRNG$ = UCASE$(STRNG$)
      END SUB
'  $SUBTITLE: 'ASKUPOS - find the unique user field for USERS'
'  $PAGE
'
'  SUBROUTINE NAME    --  ASKUPOS
'
'  INPUT PARAMETERS   --  PARAMETER         MENANING
'                         HDR$           HEADER
'                         BeginCol      BEGINNING COLUMN OF FIELD
'                         FieldLen      LENGTH OF FIELD IN USER'S RECORD
'                         PRMPT$         PROMPT TO GIVE FOR FIELD
'
'  OUTPUT PARAMETERS  --  ABOVE INPUTS UPDATED WITH USER'S RESPONSES
'
'  SUBROUTINE PURPOSE --  TO ASK THE SYSOP WHAT UNIQUE FIELD IN THE USERS
'                         RECORD IS TO BE ASKED FOR AT LOGON
'
      SUB ASKUPOS (HDR$,BeginCol,FieldLen,PRMPT$) STATIC
      CLS
      LOCATE 3,20
      PRINT HDR$;
61300 LOCATE 6,5
      PRINT "1.  BEGINNING COLUMN in USERS file";TAB(44);STR$(BeginCol);"   ";
      LOCATE 8,5
      PRINT "2.  Number of CHARACTERS to use";TAB(44);STR$(FieldLen);"   ";
      LOCATE 10,5
      PRINT "3.  PROMPT to display to callers";TAB(45);PRMPT$;SPACE$(34-LEN(PRMPT$));
61310 CALL ASKRO ("Select option to change (1-3, ENTER to end)",24,X$)
      IF X$ = "" THEN _
         EXIT SUB
      X = VAL(X$)
      IF X < 1 OR X > 3 THEN _
         GOTO 61310
      ON X GOTO 61320,61330,61340
61320 CALL ASKRO ("New BEGINNING COLUMN",24,ZHJ$)
      IF ZHJ$ = "" THEN _
         GOTO 61320
      X = VAL(ZHJ$)
      IF X < 0 OR X > 128 THEN _
         GOTO 61320
      BeginCol = X
      GOTO 61300
61330 CALL ASKRO ("New # CHARACTERS to use",24,ZHJ$)
      IF ZHJ$ = "" THEN _
         GOTO 61330
      X = VAL(ZHJ$)
      IF X < 0 OR X > 31 THEN _
         GOTO 61330
      FieldLen = X
      GOTO 61300
61340 CALL ASKRO ("New PROMPT",24,ZHJ$)
      IF LEN(ZHJ$) > 34 THEN _
         GOTO 61340
      PRMPT$ = ZHJ$
      GOTO 61300
      END SUB
'  $SUBTITLE: 'ANYNUMBER - input any numeric value'
'  $PAGE
'
'  SUBROUTINE NAME    --  ANYNUMBER
'
'  INPUT PARAMETERS   --  PARAMETER         MENANING
'                         PRMPT$           PROMPT
'
'  OUTPUT PARAMETERS  --  ReturnedValue!  VALUE RETURNED
'
'  SUBROUTINE PURPOSE --  TO GET A NUMERIC VALUE
'
      SUB ANYNUMBER (PRMPT$,ReturnedValue!) STATIC
61400 CALL ASKRO (PRMPT$,24,ZHJ$)
      ReturnedValue! = VAL(ZHJ$)
      END SUB
'  $SUBTITLE: 'ANYINTEGER - input any integer value'
'  $PAGE
'
'  SUBROUTINE NAME    --  ANYINTEGER
'
'  INPUT PARAMETERS   --  PARAMETER         MENANING
'                         PRMPT$           PROMPT TO DISPLAY
'
'  OUTPUT PARAMETERS  --  ReturnedValue   VALUE RETURNED
'
'  SUBROUTINE PURPOSE --  TO GET AN INTEGER VALUE
'
      SUB ANYINTEGER (PRMPT$,ReturnedValue) STATIC
61450 CALL ANYNUMBER (PRMPT$,ReturnedValue!)
      IF ReturnedValue! >  32767.0 OR _
         ReturnedValue! < -32767.0 THEN _
         BEEP : _
         GOTO 61450
      ReturnedValue = ReturnedValue!
      END SUB
'  $SUBTITLE: 'MMINTEGER - input any integer value with range check'
'  $PAGE
'
'  SUBROUTINE NAME    --  MMINTEGER
'
'  INPUT PARAMETERS   --  PARAMETER         MENANING
'                         PRMPT$           PROMPT
'                         MIN              MINIMUM VALUE (INCLUSIVE)
'                         MAX              MAXIMUM VALUE (INCLUSIVE)
'
'  OUTPUT PARAMETERS  --  ReturnedValue   VALUE RETURNED
'
'  SUBROUTINE PURPOSE --  TO GET AN INTEGER VALUE WITHIN A RANGE
'
      SUB MMINTEGER (PRMPT$,MIN,MAX,ReturnedValue) STATIC
61500 CALL ANYINTEGER (PRMPT$,ReturnedValue)
      IF ReturnedValue < MIN OR ReturnedValue > MAX THEN _
         BEEP : _
         GOTO 61500
      END SUB
61510 SUB MMBAUD (PRMPT$,MIN!,MAX!,B1!)
61512 CALL MMREAL (PRMPT$,MIN!,MAX!,B1!)
      IF B1! = 300 OR B1! = 1200 OR B1! = 2400 OR B1! = 4800 OR B1! = 9600 OR _
         B! = 12000 OR B1! = 14400 OR B1! = 16800 OR B1! = 19200 OR B1! = 21600 OR _
         B1! = 24000 OR B1! = 26400 OR B1! = 28800 OR B1! = 31200 OR B1! = 33600 OR _
         B1! = 38400 OR B1! = 57600 OR B1! = 64000 OR B1! = 76800 OR _
         B1! = 115200 THEN
         EXIT SUB
      ELSE
         BEEP
         GOTO 61512
      END IF
      END SUB
'  $SUBTITLE: 'MMREAL - input any single precision real # with range check'
'  $PAGE
'
'  SUBROUTINE NAME    --  MMREAL
'
'  INPUT PARAMETERS   --  PARAMETER         MENANING
'                         PRMPT$           PROMPT
'                         MIN!             MINIMUM VALUE (INCLUSIVE)
'                         MAX!             MAXIMUM VALUE (INCLUSIVE)
'
'  OUTPUT PARAMETERS  --  ReturnedValue!  VALUE RETURNED
'
'  SUBROUTINE PURPOSE --  TO GET AN REAL # VALUE WITHIN A RANGE
'
      SUB MMREAL (PRMPT$,MIN!,MAX!,ReturnedValue!) STATIC
61550 CALL ANYNUMBER (PRMPT$,ReturnedValue!)
      IF ReturnedValue! < MIN! OR ReturnedValue! > MAX! THEN _
         BEEP : _
         GOTO 61550
      END SUB
'  $SUBTITLE: 'FINDFILE - Determine whether a file exists'
'  $PAGE
'
'  SUBROUTINE NAME    --  FINDFILE
'
'  INPUT PARAMETERS   --  PARAMETER         MENANING
'                         FILNAME$         FILE TO LOOK FOR
'                         FEXISTS          WHETHER FILE EXISTS
'
'  OUTPUT PARAMETERS  --  ReturnedValue   VALUE RETURNED
'
'  SUBROUTINE PURPOSE --  DETERMINE WHETHER PASSED FILE NAME EXISTS
'                         RETURN TRUE OR FALSE IN "FEXISTS"
'
      SUB FINDFILE (FILNAME$,FEXISTS) STATIC
61600 CALL RBBSFIND (FILNAME$,Z,Y,M,D)
      FEXISTS = (Z = 0)
      END SUB
'  $SUBTITLE: 'CHKFMSDIR - Validate structure of FMS directory'
'  $PAGE
'
'  SUBROUTINE NAME    --  CHKFMSDIR
'
'  INPUT PARAMETERS   --  PARAMETER         MENANING
'                         FMSDIR$         NAME OF FMS DIRECTORY
'                         LINELEN         PROPER LENGTH OF LINES
'                                         (EXCLUDING CR/LF AT END)
'                         FMSDirCat$     CATEGORY FILE FOR FMS
'
'  OUTPUT PARAMETERS  --  ReturnedValue   VALUE RETURNED
'
'  SUBROUTINE PURPOSE --  VERIFIES THAT FMS IS IN VALID FORMAT
'                         AND DIAGNOSES PROBLEMS
'
61700 SUB CHKFMSDIR (FMSDIR$,LINELEN,FMSDirCat$) STATIC
      CALL GETNUMYN ("Really check FMS directory",AB)
      IF NOT AB THEN _
         EXIT SUB
      DIM CatCode$(200)
      CALL SETSCRCHK ("FMS",FMSDIR$)
      NCATS = 0
      CALL FINDFILE (FMSDirCat$,FEXISTS)
      IF NOT FEXISTS THEN _
         GOTO 61702
      NCATS = 1
      CatCode$(1) = "***"
      IF ZNetWorkType = 6 THEN _
         OPEN FMSDirCat$ FOR INPUT SHARED AS #2 _
      ELSE  OPEN FMSDirCat$ FOR INPUT AS #2
      WHILE NOT EOF(2) AND NCATS <= UBOUND(CatCode$)
         NCATS = NCATS + 1
         INPUT #2,X$,Y$,X$
         CatCode$(NCATS) = Y$
      WEND
      CLOSE 2
61702 GoOn = -1
      CALL FINDFILE (FMSDIR$,FEXISTS)
      IF NOT FEXISTS THEN _
         LOCATE 6,25 : _
         PRINT "File not found"; : _
         GOTO 61750
      IF ZNetWorkType = 6 THEN _
         OPEN FMSDIR$ FOR INPUT SHARED AS #2 _
      ELSE OPEN FMSDIR$ FOR INPUT AS #2
      WHILE NOT EOF(2) AND GoOn
         NLINES = NLINES + 1
         LINE INPUT #2, A$
         L = LEN(A$)
         LOCATE 7,36
         PRINT NLINES;
         IF L > LINELEN THEN _
            CALL HANDERR (A$,NLINES,"Too LONG: has" + STR$(L) + " chars but should have" + STR$(LINELEN),GoOn):_
            IF NOT GoOn THEN _
               GOTO 61740
         IF L < LINELEN THEN _
            X$ = "Too SHORT: has" + STR$(L) + " chars but should have" + STR$(LINELEN) : _
            CALL HANDERR (A$,NLINES,X$,GoOn):_
            IF NOT GoOn THEN _
               GOTO 61740
         IF L = LINELEN THEN _
            I = INSTR(A$," ") : _
            IF I = 0 OR I > 13 THEN _
               CALL HANDERR (A$,NLINES, "Space must begin line or be after file name",GoOn) : _
               IF NOT GoOn THEN _
                  GOTO 61740
         IF L > 0 THEN _
            IF INSTR ("\* ",LEFT$(A$,1)) THEN _
               GOTO 61740
         IF L > 30 THEN _
            X$ = MID$(A$,24,2) + _
                 MID$(A$,27,2) + _
                 MID$(A$,30,2) : _
            I = 1 : _
            WHILE I < 7 AND INSTR("0123456789",MID$(X$,I,1)) > 0 : _
               I = I + 1: _
            WEND: _
            IF I < 7 THEN _
               CALL HANDERR (A$,NLINES,"INVALID CHARACTER <" + MID$(X$,I,1) + "> in date field",GoOn) : _
               IF NOT GoOn THEN _
                  GOTO 61740
         I = 1
         Y$ = MID$(A$,L - 2)
         CALL REMOVE (Y$," ")
         WHILE I <= NCATS AND Y$ <> CatCode$(I)
            I = I + 1
         WEND
         IF I > NCATS THEN _
            CALL HANDERR (A$,NLINES,"Category code <" + Y$ + "> NOT IN " + FMSDirCat$,GoOn)
61740 WEND
61750 CLOSE 2
      IF NOT GoOn THEN _
         COLOR ZFG,ZBG : _
         EXIT SUB
      CALL CHKRANDOM (FMSDIR$,LINELEN,"FMS")
      END SUB
61751 SUB CHKRANDOM (CHKTHIS$, LINELEN, KindChk$) STATIC
      LOCATE 15,15
      BEEP
      CALL ASKRO ("          1st check done.  Press [ENTER] to continue",20,ANS$)
      CALL SETSCRCHK (KindChk$,CHKTHIS$)
      RECLEN = LINELEN + 2
      IF ZNetWorkType = 6 THEN _
         OPEN CHKTHIS$ FOR RANDOM SHARED AS #2 LEN=RECLEN _
      ELSE OPEN "R",2,CHKTHIS$,RECLEN
      FIELD 2, RECLEN AS FMSREC$
      LASTREC = LOF(2)/RECLEN
      CRLF$ = CHR$(13) + CHR$(10)
      FOR NLINES = 1 TO LASTREC
         GET 2,NLINES
         LOCATE 7,36
         PRINT NLINES;
         IF INSTR ("\*=",MID$(FMSREC$,1,1)) THEN _
            GOTO 61753
         I = INSTR(FMSREC$," ") : _
         IF I = 0 OR I > 13 THEN _
            J = INSTR(FMSREC$,CHR$(0)) : _
            IF J > 0 AND J < I THEN _
               CALL HANDERR (FMSREC$,NLINES, "Space must begin line or be after file name",GoOn) : _
               IF NOT GoOn THEN _
                  GOTO 61752
         IF RIGHT$(FMSREC$,2) <> CRLF$ THEN _
            CALL HANDERR (FMSREC$,NLINES,"Does not end with carriage-return-line-feed",GoOn) :_
            IF NOT GoOn THEN _
               GOTO 61752
        GOTO 61753
61752   NLINES = LASTREC + 1
61753 NEXT
      CLOSE 2
      BEEP
      CALL ASKRO ("           Done checking.  Press [ENTER] to continue",20,ANS$)
      COLOR ZFG,ZBG
      END SUB
61754 SUB SETSCRCHK (KindChk$,FileChk$) STATIC
      CLS
      LOCATE 5,14
      PRINT "Checking ";KindChk$;" Directory ";FileChk$
      NLINES = 0
      LOCATE 7,27
      PRINT "Line #";
      LOCATE 9,20
      COLOR 0,7
      PRINT " Last Line with an ERROR ";
      LOCATE 12,28
      PRINT " Last ERROR ";
      COLOR 7,0
      END SUB
'  $SUBTITLE: 'CHKPERSDIR - Validate personal directories'
'  $PAGE
'
'  SUBROUTINE NAME    --  CHKPERSDIR
'
'  INPUT PARAMETERS   --  PARAMETER         MENANING
'                         PDIR$           NAME OF PERSONAL DIRECTORY
'                         NAMELEN         PROPER LENGTH OF NAME FIELD
'
'  OUTPUT PARAMETERS  --  NONE
'
'  SUBROUTINE PURPOSE --  CHECKS PERSONAL DIRECTORY FOR PROPER FORMAT
'
61755 SUB CHKPERSDIR (PDIR$, DescLen, NAMELEN) STATIC
      CALL GETNUMYN ("Really check Personal directory",AB)
      IF NOT AB THEN _
         EXIT SUB
      CLS
      LOCATE 5, 14
      PRINT "Checking Personal Directory "; PDIR$;
      NLINES = 0
      LOCATE 7, 27
      PRINT "Line #";
      LOCATE 9, 20
      COLOR 0, 7
      PRINT " Last Line with an ERROR ";
      LOCATE 12, 28
      PRINT " Last ERROR ";
      COLOR 7, 0
      GoOn = -1
      CALL FINDFILE(PDIR$, FEXISTS)
      IF NOT FEXISTS THEN _
         LOCATE 6, 25: _
         PRINT "File not found"; : _
         GOTO 61775
      LINELEN = 34 + DescLen + NAMELEN
      IF ZNetWorkType = 6 THEN _
         OPEN PDIR$ FOR INPUT SHARED AS #2 _
      ELSE OPEN PDIR$ FOR INPUT SHARED AS #2
      WHILE NOT EOF(2) AND GoOn
         NLINES = NLINES + 1
         LINE INPUT #2, A$
         L = LEN(A$)
         LOCATE 7, 36
         PRINT NLINES;
         IF L > LINELEN THEN _
            CALL HANDERR(A$, NLINES, "Too LONG: has" + STR$(L) + " chars but should have" + STR$(LINELEN), GoOn) : _
            IF NOT GoOn THEN _
               GOTO 61770
         IF L < LINELEN THEN _
            CALL HANDERR(A$, NLINES, "Too SHORT: has" + STR$(L) + " chars but should have" + STR$(LINELEN), GoOn) : _
               IF NOT GoOn THEN _
                  GOTO 61770
         IF L > 30 AND (LEFT$(A$,1) <> " ") THEN _
            X$ = MID$(A$, 24, 2) + MID$(A$, 27, 2) + MID$(A$, 30, 2) : _
            I = 1 : _
            WHILE I < 7 AND INSTR("0123456789", MID$(X$, I, 1)) > 0 : _
               I = I + 1 : _
            WEND : _
            IF I < 7 THEN _
               CALL HANDERR(A$, NLINES, "INVALID CHARACTER <" + MID$(X$, I, 1) + "> in date field", GoOn) : _
               IF NOT GoOn THEN _
                  GOTO 61770
           IF L = LINELEN THEN _
              X$ = RIGHT$(A$, 1) : _
              IF INSTR("*!.", X$) = 0 THEN _
                 CALL HANDERR(A$, NLINES, "Last char on line should be *  . or ! but found <" + X$ + ">", GoOn) : _
                 IF NOT GoOn THEN  _
                    GOTO 61770
           IF L = LINELEN THEN _
              X$ = MID$(A$, L - NAMELEN, LINELEN) : _
              IF LEFT$(X$, 1) = " " THEN _
                 IF INSTR("0123456789- ", MID$(X$, 2, 1)) = 0 THEN _
                    CALL HANDERR(A$, NLINES, "Name field at col" + STR$(L - NAMELEN) + " has <" + LEFT$(X$, 1) + ">, needs non-blank or blank+number", GoOn) : _
                    IF NOT GoOn THEN _
                       GOTO 61770
           IF L = LINELEN THEN _
              I = INSTR(A$," ") : _
              IF I = 0 OR I > 13 THEN _
                 CALL HANDERR(A$,NLINES, "Space must begin line or be after file name",GoOn) : _
                 IF NOT GoOn THEN _
                    GOTO 61770
61770 WEND
61775 CLOSE 2
      IF NOT GoOn THEN _
         EXIT SUB
      CALL CHKRANDOM (PDIR$,LINELEN,"Personal")
      END SUB
'  $SUBTITLE: 'HANDERR - subroutine to handle FMS errors'
'  $PAGE
'
'  SUBROUTINE NAME    -- HANDERR
'
'  INPUT PARAMETERS   -- PARAMETER                      MEANING
'                        ERRLINE$                LINE THAT HAS THE ERROR
'                        ERRL                    LINE NUMBER WITH ERROR
'                        ERRMES$                 ERROR MESSAGE TO ISSUE
'
'  OUTPUT PARAMETERS  -- GoOn                   INIDCATE TO PROCEDURE OR NOT
'
'  SUBROUTINE PURPOSE -- TO HANDLE ERROR CHECKING OF THE FMS DIRECTORY
'
      SUB HANDERR (ERRLINE$,ERRL,ERRMES$,GoOn) STATIC
      LOCATE 10,1
      PRINT SPACE$(80);
      LOCATE 10,1
      PRINT ERRLINE$;
      LOCATE 9,45
      PRINT STR$(ERRL);
      LOCATE 13,1
      PRINT SPACE$(79);
      L = LEN(ERRMES$)
      IF L > 68 THEN _
         STRT = 1 _
      ELSE STRT = (70 - L) / 2
      LOCATE 13,STRT
      PRINT ERRMES$;
      CALL ASKRO ("               CONTINUE checking (Y/N,[ENTER]=Y) ",20,ANS$)
      IF ANS$ = "" THEN _
         ANS$ = "Y"
      CALL ALLCAPS (ANS$)
      GoOn = FNYESNO (ANS$)
      END SUB
' $SUBTITLE: 'REMOVE - subroutine to delete a string from within a string'
' $PAGE
'
'  SUBROUTINE NAME    -- REMOVE
'
'  INPUT PARAMETERS   -- PARAMETER                      MEANING
'                        BADSTRING$              STRING CONTAINING CHARACTERS
'                                                TO BE DELETED FROM "L$"
'                        L$                      STRING TO BE ALTERED
'
'  OUTPUT PARAMETERS  -- L$                      WITH THE CHARACTERS IN
'                                                "BADSTRING#" DELETED FROM IT
'
'  SUBROUTINE PURPOSE -- TO REMOVE ALL INSTANCES OF THE CHARACTERS IN
'                        "BADSTRING$" FROM "L$"
'
      SUB REMOVE (L$,BADSTRNG$) STATIC
61800 J = 0
      FOR I = 1 TO LEN(L$)
         IF INSTR(BADSTRNG$,MID$(L$,I,1)) = 0 THEN _
            J = J + 1:_
            MID$(L$,J,1) = MID$(L$,I,1)
      NEXT I
      L$ = LEFT$(L$,J)
      END SUB
' $SUBTITLE: 'GETASCII - subroutine to prompt for any ASCII values'
' $PAGE
'
'  SUBROUTINE NAME    -- GETASCII
'
'  INPUT PARAMETERS   -- PARAMETER                      MEANING
'                        TITLE$                  HEADER EXPANATION FOR PARAM
'
'  OUTPUT PARAMETERS  -- STRNG$                  RESULTANT CONFIG PARAMETER
'
'  SUBROUTINE PURPOSE -- ALLOWS ANY ASCII CHARACTER TO BE STORED IN A PARAMETER
'                        BY ENCLOSING IT IN SQUARE BRACKETS.  CHARACTERS NOT IN
'                        SQUARE BRACKETS ARE INTERPRETED EXACTLY AS ENTERED.
'                        CHARACTER'S ASCII VALUE EQUAL THE NUMERIC VALUE IN THE
'                        SQUARE BRACKETS.
'
      SUB GETASCII (TITLE$,STRNG$) STATIC
61810 CLS
      LOCATE 8,30
      PRINT TITLE$;
      LOCATE 13,5
      PRINT "Current value is"
      PRINT STRNG$
      PRINT
      PRINT "Please enter the new values by entering the character"
      PRINT "or enclosing its ASCII value in square brackets:"
      PRINT "(Press ENTER to make empty)
      LINE INPUT "";ZHJ$
      STRNG$ = ZHJ$
      END SUB
' $SUBTITLE: 'BRKFNAME - subroutine to decompose a file name'
' $PAGE
'
'  SUBROUTINE NAME    -- BRKFNAME
'
'  INPUT PARAMETERS   -- PARAMETER                     MEANING
'                        FILENAME$       NAME OF THE FILE TO BE DECOMPOSED
'                        ForJoining     INDICATOR IF OUTPUT IS TO BE COMPBINED
'
'  OUTPUT PARAMETERS  -- DRVPATH$        DRIVE AND PATH
'                        PREFIX$         8-CHARACTER FILE NAME PREFIX
'                        EXTENSION$      3-CHARACTER EXTENSION
'
'  SUBROUTINE PURPOSE -- BREAKS DOWN A FILE NAME INTO A DRIVE AND PATH,
'                        FILE PREFIX (8 CHARACTERS), AND FILE EXTENSION
'                        (3 CHARACTERS).  IF "ForJoining" IS TRUE, THE
'                        DRIVE AND PATH HAVE A ":" AND A "\" IN IT AND
'                        THE EXTENSION BEGINS WITH A ".".
'
      SUB BRKFNAME (FILENAME$,DRVPATH$,PREFIX$,EXTENSION$,ForJoining) STATIC
      FLNAME$ = FILENAME$
61830 CALL ALLCAPS (FLNAME$)
      DRVPATH$ = ""
      PREFIX$ = ""
      EXTENSION$ = ""
      L = LEN(FLNAME$)
      IF L < 1 THEN _
         EXIT SUB
      CALL FINDLAST (FLNAME$,"\",X,Y)
      IF X < 1 THEN _
         IF MID$(FLNAME$,2,1) = ":" THEN _
            DRVPATH$ = LEFT$(FLNAME$, 2): _
            S = 3 _
         ELSE S = 1 _
      ELSE DRVPATH$ = LEFT$(FLNAME$,X) : _
           S = X + 1
      X = INSTR(FLNAME$+".",".")
      IF X < L THEN _
         EXTENSION$ = MID$(FILENAME$,X)
      IF S <= L THEN _
         IF X >= S THEN _
            PREFIX$ = MID$(FLNAME$,S,X - S)
      IF ForJoining THEN _
         EXIT SUB
      IF Y > 1 THEN _
         DRVPATH$ = LEFT$(DRVPATH$, LEN(DRVPATH$) - 1)
      IF LEN(EXTENSION$) > 0 THEN _
         EXTENSION$ = MID$(EXTENSION$, 2)
      END SUB
'
'  $SUBTITLE: 'TRIMTRAIL - subroutine to trim off trailing characters'
'  $PAGE
'
'  SUBROUTINE NAME    --  TRIMTRAIL
'
'  INPUT PARAMETERS   --  PARAMETER           MEANING
'                         TrimParm$  TIME IN SECONDS AFTER MIDNIGHT TO WAIT
'                                     BEFORE DISPLAYING
'                         TrimThis$  WHAT CHARACTER TO TRIM OFF END
'
'  OUTPUT PARAMETERS  --  NONE
'
'  SUBROUTINE PURPOSE --  TO DISPLAY RBBS-PC's SYSOP MENU ON THE LOCAL SCREEN
'
61840 SUB TRIMTRAIL (TrimParm$,TrimThis$) STATIC
      WHILE RIGHT$(TrimParm$,1) = TrimThis$
         TrimParm$ = LEFT$(TrimParm$,LEN(TrimParm$) - 1)
      WEND
      END SUB
' $SUBTITLE: 'FINDLAST - subroutine to find last occurence of a string'
' $PAGE
'
'  SUBROUTINE NAME    -- FINDLAST
'
'  INPUT PARAMETERS   -- PARAMETER             MEANING
'                        LookIn$           STRING TO LOOK INTO
'                        LookFor$          STRING TO SEARCH FOR
'
'  OUTPUT PARAMETERS  -- WhereFound        POSITION IN LookIn$ THAT
'                                            LookFor$ FOUND
'                        NumFinds          HOW MANY OCCURENCES IN LookIn$
'
'  SUBROUTINE PURPOSE -- FINDS THE LAST OCCURANCE OF "LookFor$" IN "LookIn$"
'                        AND RETURNS COUNT OF NUMBER OF OCCURENCES.  IF NONE
'                        ARE FOUND, BOTH RETURNED PARAMETERS ARE ZERO.
'
      SUB FINDLAST (LookIn$,LookFor$,WhereFound,NumFinds) STATIC
61850 WhereFound = INSTR(LookIn$,LookFor$)
      NumFinds = -(WhereFound > 0)
      NextFound = INSTR(WhereFound + 1,LookIn$,LookFor$)
      WHILE NextFound > 0
         NumFinds = NumFinds + 1
         WhereFound = NextFound
         NextFound = INSTR(WhereFound + 1,LookIn$,LookFor$)
      WEND
      END SUB
' $SUBTITLE: 'SECURE - subroutine to assign security to commands'
' $PAGE
'
'  SUBROUTINE NAME    -- SECURE
'
'  INPUT PARAMETERS   -- PARAMETER             MEANING
'                        SECTION$           NAME OF THE SECTION
'                        DEFAULTS$          DEFAULT COMMANDS FOR THE SECTION
'                        NumberOfCommands NUMBER OF COMMANDS IN THE SECTION
'                        COMMANDS$()        CHARACTERS REPRESENTING THE ONE-
'                                              CHARACTER COMMANDS
'                        COMMANDS()         SECURITY LEVEL ASSOCIATED WITH
'                                           THE COMMAND
'                        SectionCommands$  PROMPT STRING OF ALL COMMANDS IN
'                                             THE SECTION
'
'  OUTPUT PARAMETERS  -- COMMANDS$()        CHARACTERS REPRESENTING THE ONE-
'                                              CHARACTER COMMANDS
'                        COMMANDS()         SECURITY LEVEL ASSOCIATED WITH
'                                           THE COMMAND
'                        SectionCommands$  PROMPT STRING OF ALL COMMANDS IN
'                                             THE SECTION
'
'  SUBROUTINE PURPOSE -- ALLOWS USERS TO MODIFY COMMANDS AND SECURITY FOR
'                        EACH COMMAND.
'
      SUB SECURE (SECTION$,DEFAULTS$,NumberOfCommands,COMMANDS$(2),COMMANDS(1),SectionCommands$) STATIC
61860 IF ZIPage = 2 OR _
         VAL(ZOption$) = 310 THEN _
         XX$ = "ALL " + _
               SECTION$ + _
               " commands use default letters?" _
      ELSE XX$ = "ALL " + _
               SECTION$ + _
               " commands = SAME security level?"
      LOCATE 24,1
      PRINT SPACE$(79);
      LOCATE 24,1
      CALL GETNUMYN (XX$,AB)
      IF NOT AB THEN _
         GOTO 61880
61870 IF ZIPage = 2 OR _
         VAL(ZOption$) = 310 THEN _
         SectionCommands$ = DEFAULTS$ : _
         FOR I = 1 TO NumberOfCommands : _
            COMMANDS$(I,2) = MID$(SectionCommands$,I,1) : _
         NEXT : _
         EXIT SUB
      CALL MMINTEGER("Security level for all " + _
                      SECTION$ + _
                     " commands is?",-32767,32767,B1)
      FOR I = 1 TO NumberOfCommands
         COMMANDS(I) = B1
      NEXT
      ZGB = B1
      EXIT SUB
61880 GOSUB 61900
      IROW = 4
      ICOL = 10
      FOR I = 1 TO NumberOfCommands
         LOCATE IROW + I,ICOL
         IF ZIPage = 2 OR _
            VAL(ZOption$) = 310 THEN _
            PRINT COMMANDS$(I,1);" ";COMMANDS$(I,2) _
         ELSE PRINT COMMANDS$(I,1);STR$(COMMANDS(I))
      NEXT
61890 CALL ASKRO("Enter first character of command ([ENTER] quits)",24,X$)
      IF X$ = "" THEN _
         EXIT SUB
      IF LEN(X$) <> 1 THEN _
         GOTO 61890
      CALL ALLCAPS(X$)
      FF = INSTR(DEFAULTS$,X$)
      IF FF = 0 THEN _
         GOTO 61890
      IF ZIPage = 2 OR _
         VAL(ZOption$) = 310 THEN _
         GOTO 61892
      CALL MMINTEGER("Security level for all " + _
                      SECTION$ + _
                     " '" + _
                     X$ + _
                     "' commands is?",-32767,32767,B1)
      GOTO 61893
61892 CALL ASKRO("New command for " + _
                  MID$(COMMANDS$(FF,1),1,INSTR(COMMANDS$(FF,1),"  ")) + _
                 "is?",24,HK$)
      IF HK$ = CHR$(34) THEN _
         GOTO 61892
      X$ = MID$(HK$,1,1)
      CALL ALLCAPS (X$)
      IF LEN(HK$) > 1 THEN _
         HK$ = X$ + MID$(HK$,2)
      IF LEN (HK$) = 1 THEN _
         HK$ = X$
      COMMANDS$(FF,2) = HK$
      MID$(SectionCommands$,FF,1) = HK$
      GOTO 61880
61893 COMMANDS(FF) = B1
      GOTO 61880
'
' * COMMON ROUTINE TO DISPLAY SUBSYSTEM COMMANDS AND THEIR SECURITY LEVELS
'
61900 CLS
      I! = FRE(ZC$)
      COLOR 0,7,0
      LOCATE 1,23
      PRINT "RBBS-PC/CDor "+ ZConfigVersion$ + " Default Configuration";
      COLOR ZFG,ZBG
      LOCATE  2,5
      PRINT "The RBBS-PC " + _
             SECTION$ + _
            " Commands are as follows:"
      LOCATE   3,10
      XX$ = "Command             Security"
      IF ZIPage = 2 OR _
         VAL(ZOption$) = 310 THEN _
         XX$ = "Description         Command"
      PRINT XX$
      RETURN
      END SUB
'  $SUBTITLE: 'GETCOLOR - get colors using natural language'
'  $PAGE
'
'  SUBROUTINE NAME    -- GETCOLOR
'
'  INPUT PARAMETERS   -- PARAMETER             MEANING
'                        STRNG$             TITLE OF WHAT COLOR IS FOR
'                        NumColor          CURRENT COLOR SETTING
'
'  OUTPUT PARAMETERS  -- NumColor          NEW COLOR SETTING
'
'  SUBROUTINE PURPOSE -- SET THE COLOR USING NATURAL LANGUAGE PHRASES
'
      SUB GETCOLOR (STRNG$,NumColor) STATIC
      CLS
61950 IF NumColor > 7 THEN _
         X = NumColor - 8 _
      ELSE X = NumColor
      X$ = MID$("<none>Blue  Green Cyan  Red   PurpleYellowWhite",X*6+1,6)
      LOCATE 9,15
      PRINT STRNG$;" now ";X$;"     ";
61955 CALL ASKRO ("Make N)one,R)ed,G)reen,Y)ellow,B)lue,P)urple,C)yan,W)hite,[ENTER] quits",20,ANS$)
      IF ANS$ = "" THEN _
         EXIT SUB
      CALL ALLCAPS (ANS$)
      Y = INSTR("NBGCRPYW",ANS$) - 1
      IF Y < 0 THEN _
         GOTO 61955
      NumColor = Y
      GOTO 61950
      END SUB
' $SUBTITLE: 'GETANSI - SUBROUTINE TO GET CALLERS COLOR VALUES'
' $PAGE
'
'  SUBROUTINE NAME    -- GETANSI
'
'  INPUT PARAMETERS   -- PARAMETER                      MEANING
'                        SELECTION$       NAME OF SELECTION TO HAVE COLOR
'                        PRMPT$           WHAT TO PROMPT ON THE SCREEN
'
'  OUTPUT PARAMETERS  -- ZFG1Def$        FIRST COLOR SELECTION
'                        ZFG2Def$        SECOND COLOR SELECTION
'                        ZFG3Def$        THIRD COLOR SELECTION
'                        ZFG4Def$        FOURTH COLOR SELECTION
'                        ZFG5Def$        5th Color Selection
'
'  SUBROUTINE PURPOSE -- ASK THE SYSOP TO SELECT THE FOUR COLORS TO BE
'                        USED FOR CALLERS THAT SELECT COLOR DISPLAYS.
'
      SUB GETANSI (SELECTION$,PRMPT$) STATIC
      CLS
62000 LOCATE 8,10
      PRINT PRMPT$;" Foreground for caller now ";SELECTION$;"       "
      LOCATE 10,1
      PRINT "Current Directory Listing Colors: "
      CALL COLORCODE (ZFG1Def$,X$,X)
      COLOR X,CallerBkgrd
      PRINT "Filename     ";
      CALL COLORCODE (ZFG2Def$,X$,X)
      COLOR X
      PRINT "Filesize";
      CALL COLORCODE (ZFG3Def$,X$,X)
      COLOR X
      PRINT "  Filedate  ";
      CALL COLORCODE (ZFG4Def$,X$,X)
      COLOR X
      PRINT "Main Description of File"
      CALL COLORCODE (ZFG5Def$,X$,X)
      COLOR X
      PRINT "  Extended Description of File"
      COLOR ZFG,ZBG
62040 CALL ASKRO ("Make N)one,R)ed,G)reen,Y)ellow,B)lue,P)urple,C)yan,W)hite,[ENTER] quits",14,ANS$)
      IF ANS$ = "" THEN _
         EXIT SUB
      CALL ALLCAPS (ANS$)
      X = INSTR("NRGYBPCW",ANS$)
      IF X < 2 THEN _
         SELECTION$ = ZNonePicked$ : _
         GOTO 62000
      X$ = MID$("Red   Green YellowBlue  PurpleCyan  White",X*6-11,6)
      CALL ASKRO ("Make "+X$+" [B]right, or N)ormal",17,ANS$)
      CALL ALLCAPS (ANS$)
      IF ANS$ <> "N" THEN _
         SELECTION$ = "Bright " + X$ _
      ELSE SELECTION$ = "Normal " + X$
      GOTO 62000
      END SUB
' $SUBTITLE: 'COLORCODE - SUBROUTINE TO GET COLOR CODES'
' $PAGE
'
'  SUBROUTINE NAME    -- COLORCODE
'
'  INPUT PARAMETERS   -- PARAMETER                      MEANING
'                        NatLangColor$  NATURAL LANGUAGE LETTER OF COLOR
'                                           N = NONE
'                                           B = BLUE
'                                           G = GREEN
'                                           C = CYAN
'                                           R = RED
'                                           P = PURPLE
'                                           Y = YELLOW
'                                           W = WHITE
'
'  OUTPUT PARAMETERS  -- ANSIColor$      CORRECT CHARACTER SEQUENCE OF COLOR
'                        BASICFG         NUMBER FOR BASIC FORGROUND
'
'  SUBROUTINE PURPOSE -- TO CONVERT THE NATURAL LANGUAGE COLOR SELECTION INTO
'                        COLOR CODES THAT ARE MEANINGFUL.
'
      SUB COLORCODE (NatLangColor$,ANSIColor$,BASICFG) STATIC
      BASICFG = 7
      IF NatLangColor$ = ZNonePicked$ THEN _
         ANSIColor$ = "" : _
         EXIT SUB
      X = INSTR(" BN",LEFT$(NatLangColor$,1))
      IF X < 2 THEN _
         EXIT SUB
      X$ = MID$("10",X-1,1)
      X = INSTR(NatLangColor$," ")
      IF X < 1 OR X >= LEN(NatLangColor$) THEN _
         EXIT SUB
      Z$ = MID$(NatLangColor$,X+1,1)
      X = INSTR("RGYBPCW",Z$)
      IF X < 1 THEN _
         EXIT SUB
      BASICFG = INSTR("BGCRPYW",Z$) - 8 * (X$="1")
      Y$ = MID$(STR$(30+X),2)
      Z = INSTR("NRGYBPCW",MID$("NBGCRPYW",CallerBkgrd+1,1))
      Z$ = MID$(STR$(39+Z),2)
      ANSIColor$ = CHR$(27) + "[" + X$ + ";" + Z$ + ";" + Y$ + "m"
      END SUB
' $SUBTITLE: 'ANSIDECODE - SUBROUTINE TO DECODE ANSI VALUES'
' $PAGE
'
'  SUBROUTINE NAME    -- ANSIDECODE
'
'  INPUT PARAMETERS   -- PARAMETER                      MEANING
'                        ANSIExpression$ EXPRESSION WITH ANSI COLOR CODES IN
'
'  OUTPUT PARAMETERS  -- ANSIExpression$ ENGLISH LANGUAGE DESCRIPTION OF COLOR
'
'  SUBROUTINE PURPOSE -- DECODES THE ANSI EXPRESSION INTO A MEANINGFUL
'                        ENGLISH TEXT DESCRIPTION.
'
      SUB ANSIDECODE (ANSIExpression$) STATIC
      IF LEN (ANSIExpression$) < 3 THEN _
         EXIT SUB
      IF ASC(ANSIExpression$) <> 27 THEN _
         EXIT SUB
      X = INSTR(ANSIExpression$,";")
      IF X < 1 THEN _
         EXIT SUB
      IF MID$(ANSIExpression$,X-1,1) = "1" THEN _
         X$ = "Bright " _
      ELSE X$ = "Normal "
      X = INSTR(X,ANSIExpression$,"m")
      IF X < 1 THEN _
         EXIT SUB
      X = VAL(MID$(ANSIExpression$,X-2,2)) - 30
      IF X < 1 OR X > 7 THEN _
         EXIT SUB
      ANSIExpression$ = X$ + MID$("Red   Green YellowBlue  PurpleCyan  White",X*6-5,6)
      END SUB
62100 ' set modem strings by selecting a modem
      SUB SELMODEM STATIC
      CALL FINDFILE ("MODEMS.SET",OK)
      IF OK THEN _
         GOTO 62103
      CALL MODEMINITCMD
      EXIT SUB
62103 CLOSE 2
      IF ZNetWorkType = 6 THEN _
         OPEN "MODEMS.SET" FOR INPUT SHARED AS #2 _
      ELSE OPEN "I",2,"MODEMS.SET"
      ModemModel = 0
      ModemPage = 0
62105 CLS
      PRINT "NUMBER";
      LOCATE 1,10
      PRINT "Modem Model";
      LOCATE 1,40
      PRINT "Switch Settings";
      LOCATE 2,1
      PRINT STRING$(78,"-");
      FOR DisplayLine = 3 TO 19
         IF EOF(2) THEN _
            ModemPage = 1 : _
            GOTO 62110
         ModemModel = ModemModel + 1
         INPUT #2, ModemModel$, SWITCHES$
         FOR I = 1 TO 14                    ' # MODEMS.SET parms - 2
            INPUT #2,GARBAGE$
         NEXT
         LOCATE DisplayLine, 2
         PRINT ModemModel;
         LOCATE DisplayLine, 10
         PRINT ModemModel$;
         LOCATE DisplayLine, 40
         PRINT SWITCHES$;
      NEXT
      LOCATE DisplayLine + 1, 2
      PRINT " 0"
      LOCATE DisplayLine + 1, 10
      PRINT "Next Page"
62110 LOCATE 24,10
      PRINT "Use Parameter 231 to initialize modem's firmware";
      CALL GETINIT("Select modem number, or [ENTER] to exit", _
                    22,ModemPage,ModemModel,ModemSelected, CR)
      IF CR THEN _
         EXIT SUB
      IF ModemSelected = 0 THEN _
         GOTO 62105
      CLOSE 2
      IF ZNetWorkType = 6 THEN _
         OPEN "MODEMS.SET" FOR INPUT SHARED AS #2 _
      ELSE OPEN "I",2,"MODEMS.SET"
      FOR I = 1 TO (ModemSelected - 1) * 16      ' # of parms * modem
         INPUT #2,GARBAGE$
      NEXT
      INPUT #2, ModemModel$, _
                SWITCHES$, _
                ZUserAnswerCommand$, _
                ZUserCountRingsCommand$, _
                ZUserGoOffHookCommand$, _
                ZUserInitCommand$, _
                ZUserResetCommand$, _
                ZUserInitializeCommand$, _
                ZUserFirmWareClearCmnd$, _
                ZUserFirmWareWriteCmnd$, _
                ZRTS$, _
                ZModemInitWaitTime, _
                ZModemCommandDelayTime, _
                ZCommandBetweenRings, _
                ZModemInitBaud$, _
                ZKeepInitBaud
      CLOSE 2
      END SUB
62120 SUB MODEMINITCMD STATIC
      ZRTS$ = "NO"
      ZModemInitWaitTime = 3
      ZCommandBetweenRings = ZFalse
      FirmWareInitializeCommand$ = "AT&C1&D3B1E0V1M0S0=0"
      FirmWareClearCommand$ = "AT&F"
      FirmWareWriteCommand$ = "AT&W"
      ZKeepInitBaud = ZFalse
      ZModemAnswerCommand$      = "ATQ0X1V1A"
      ZModemCommandDelayTime   = 1
      ZModemCountRingsCommand$ = "ATS1?"
      ZModemGoOffHookCommand$  = "ATH1M0"
      ZModemInitBaud$           = "300"
      ZModemInitCommand$        = "ATE0M0Q0V1X1S0=254S2=255S10=20"
      ZModemResetCommand$       = "ATZ"
      ZUserAnswerCommand$ = ZModemAnswerCommand$
      ZUserCountRingsCommand$ = ZModemCountRingsCommand$
      ZUserGoOffHookCommand$ = ZModemGoOffHookCommand$
      ZUserInitCommand$ = ZModemInitCommand$
      ZUserResetCommand$ = ZModemResetCommand$
      ZUserInitializeCommand$ = FirmWareInitializeCommand$
      ZUserFirmWareClearCmnd$ = FirmWareClearCommand$
      ZUserFirmWareWriteCmnd$ = FirmWareWriteCommand$
      END SUB
