' $segment
' $linesize:132
' $title: 'RBBSSUB2.BAS 17.4, Copyright 1986 - 92 by D. Thomas Mack'
'  Copyright 1991 by D. Thomas Mack, all rights reserved.
'  Name ...............: RBBSSUB2.BAS
'  First Released .....: June 21, 1992
'  Subsequent Releases.: 
'  Copyright ..........: 1986 - 1992
'  Purpose.............: The Remote Bulletin Board System for the IBM PC,
'     RBBS-PC.BAS utilizes a lot of common subroutines.  Those that do not
'     require error trapping are incorporated within RBBSSUB 2-5 as
'     separately callable subroutines in order to free up as much
'     code as possible within the 64K code segment used by RBBS-PC.BAS.
'  Parameters..........: Most parameters are passed via a COMMON statement.
'
' Subroutine  Line               Function of Subroutine
'   Name     Number
'  AnswerIt        200  Answer the telephone when it rings
'  ASCIICodes      129  Allow a CONFIG string to have any ASCII value
'  BadChar         455  Check user name for invalid characters
'  BadName       20235  Check for system crash attempt with bad file name
'  BankTime       5500  Let caller change banked time
'  CheckRatio    20096  Test upload/download ratio
'  CheckMacro     1242  Checks for macro and processes
'  CopyRight        97  Display RBBS-PC's copyright notice
'  DefaultU       9600  Write out the user's defaults
'  DenyAccess     1386  Downgrade security so access denied
'  DoorExit      10983  Set up a .BAT file to exit RBBS-PC to a "door"
'  DoorInfo      10991  Writes out information for a door
'  DosExit       10934  Set up a .BAT file to exit to DOS (second level)
'  EditALine      2618  Edits a single line
'  EditDef         120  Edit configuration parameters
'  FileNameCheck 20240  Matches file name to a prefix & extension
'  GetArc        20140  Handle request for verbose listing
'  GetCommand      101  Get RBBS-PC's node id from command line
'  GetTime        9140  Calculates callers elapsed time (hh,mm,ss)
'  GoIdle           90  Release resources when waiting for keyboard input
'  KillMsg        3952  Delete old or unnecessary messages
'  Line25          945  Build and/or update line 25 of RBBS-PC's local screen
'  LineEdit       3700  Edit a line while minimizing string space consumption
'  LogError      13660  Log error message to CALLERS file
'  LPrnt          1480  Subroutine to write to local display
'  Macro          1320  Check/execute macro
'  MLInit            8  Handle MultiLink initialization/de-initialization
'  MsgProt        2055  Sets protection for a message
'  ParseIt        1637  Parses a string
'  PassWrd         660  Verify user & message passwords
'  PopCmdStack    1650  Get user input, 1st checking command stack
'  PScrn          1483  Print to display
'  QuickLPrnt     1482  Quickly writes count of blocks on file transfer
'  QuickTPut      1478  Fast, but limited, "TPut" equivalent
'  QuickTPut1     1478  Outputs short string followed by CR LF
'  RBBSExit      10992  RBBS-PC exit to transfer control to other programs
'  RecoverMsg    10410  Recover a deleted message
'  RemNonAlf      5100  Removes non-alpha characters from a string
'  RingCaller     1636  Ring caller's bell and put message in emphasis
'  SetBaud        1654  Set baud rate in the 8250 chip of the RS232 interface
'  SetCrLf        1496  Set up the necessary carriage return/line feed string
'  SetSection    12000  Set the proper section prompts (main, file, util, libr)
'  SetThread      4554  Set up request for threading thru messages
'  SetWhoTo       2018  Sets who a message/personal upload is to
'  SkipLine       1485  Write a # of blank lines to the communications port
'  SearchCmd      1238  Searches list of commands in RBBS for a request
'  SecViolation   1380  Process a security violation
'  SysMenu         112  Displays sysop menu/status
'  SysopChat      4773  Sysop and caller chat
'  TestRel         336  Tests for Reliable connect
'  TGet           1498  Read a line from the communications port
'  TPut           1396  Write a line to the communications port
'  Trim            105  Strip leading and trailing blanks from a string
'  TrimTrail       107  Strip off specified string off end of another string
'  UntilRight    12878  Ask a question until user says answer is right
'  UpdateU       10600  Updates the user record on logging off/exiting RBBS-PC
'  VarInit         109  Initialize system variables
'  ViewHelp       1330  Processes help command
'  WhoCheck       2250  Checks whether a user exists in user file
'  WhosOn         9801  Report status of each node - who's on
'  WordInFile    10976  Find a whole word within a file/menu
'
' * For BLINKER encrypted serial number
'
'  DECLARE FUNCTION BLISERNUMBAS$ CDECL ()
'
'  $INCLUDE: 'RBBS-VAR.BAS'
'
97 '  $SUBTITLE: 'CopyRight - subroutine to display RBBS-PC copyright'
'  $PAGE
'
'  NAME    -- CopyRight
'
'  INPUTS  --  NONE
'
'  OUTPUTS --  NONE
'
'  PURPOSE --  To display RBBS-PC's copyright notice on the local screen
'
      SUB CopyRight STATIC
   ZWasA = (ZDebug OR ZExitToDoors OR ZCopyrightSecs < 1)
   IF ZWasA THEN _
      ZOK = ZTrue : _
      EXIT SUB
   WIDTH 80
   CALL FindIt ("COPYRITE.DEF")
   IF NOT ZOK THEN
      '* "COPYRITE.DEF not found - aborting"
      CALL FormatString (249,ZTrue,ZFalse,0,ZFalse,0,"")
      GOTO 98
   END IF
   CALL OpenWork (2,"COPYRITE.DEF")
   CLS
   KEY OFF
   LOCATE ,,0
   WHILE NOT EOF(2)
      LINE INPUT #2, ZOutTxt$
      PRINT ZOutTxt$
   WEND
98 CALL DelayTime (ZCopyrightSecs)
   END SUB
101 ' $SUBTITLE: 'GetCommand - sub to get command from command line'
' $PAGE
'
'  NAME    -- GetCommand
'
'  INPUTS  --     PARAMETER                    MEANING
'             ZConfigFileName$     NAME OF RBBS-PC ".DEF" FILE TO
'                                  USE AS A MODEL WHEN CREATING THE
'                                  .DEF FILE NAME TO BE USED BY THIS
'                                  COPY OF RBBS-PC.
'
'             COMMAND LINE         COMMAND LINE USED TO INVOKE
'                                  RBBS-PC IN THE FORM:
'
' RBBS-PC.EXE x filename DEBUG NULLMODEM NOSWAP /time /baud /cbaud /reliable /callerid
'
' Command line paramtaters are as follows:
'
' x         - Node number for this copy of RBBS-PC
' filename  - RBBSxPC.DEF config filename
' DEBUG     - Enables extra process reporting/logging
' NULLMODEM - Enables Null Modem support
' NOSWAP    - Disables EMS/XMS shell swapping for CDOR EXE's

' Network/Front End systems must provide the following information:

' /T: or /time     - time before next external mailer event
' /B: or /baud     - DTE rate which should be the same as CONFIG #228
' /C: or /cbaud    - Connect speed of current call
' /R: or /reliable - Reliable connect of current call
' /I: or /callerid - Caller ID info of current call
'
'
' Note that if the /T:,/B:,/C:,/R or /I: switches are used then they must
' ALL be used!
'
'
' By default, RBBS-PC will use RBBS-PC.DEF and node 1 if no command line is
' given.
'
'  OUTPUTS -- ZConfigFileName$     NAME OF RBBS-PC ".DEF" FILE FOR
'                                  THIS COPY OF RBBS-PC TO USE
'             ZNodeRecIndex        RECORD NUMBER WITHIN THE
'                                  MESSAGES FILE FOR THIS "NODE"
'                                  (RANGE IS 2 TO 36)
'
'  PURPOSE --  To get node id from command line and determine if rbbs
'              is being run as a door
'
      SUB GetCommand (PassedDebug,NetTime$,NetBaud$,NetReliable$) STATIC
'
      WasPM$ = UCASE$(COMMAND$)

      IF INSTR(WasPM$,"/T:") > 0 THEN _
         GOTO 103

      IF INSTR(WasPM$,"/") = 0 THEN _
         GOTO 104
'
'
' * PARSE THE COMMAND LINE FOR THREE POSITIONAL SWITCHES FOR NET MAIL
'
'
      CmdLine$ = MID$(WasPM$,INSTR(WasPM$,"/"))
      WasPM$ = LEFT$(WasPM$,INSTR(WasPM$,"/") - 1)
      ZWasA = 0
      FOR WasX = 1 TO LEN(CmdLine$)
          IF MID$(CmdLine$,WasX,1) = "/" THEN _
             ZWasA = ZWasA + 1 : _
             ZSubDir$(ZWasA) = "" _
          ELSE ZSubDir$(ZWasA) = ZSubDir$(ZWasA) + MID$(CmdLine$,WasX,1)
      NEXT
      NetTime$ = ZSubDir$(1)
      IF ZWasA > 1 THEN _
         NetBaud$ = ZSubDir$(2)
      IF ZWasA > 2 THEN _
         ZCBaud$ = STR$(VAL(ZSubDir$(3)))
      IF ZWasA > 3 THEN _
         ZNetReliable$ = ZSubDir$(4)
      IF ZWasA > 4 THEN _
         ZCallerID$ = ZSubDir$(5)

      IF ZWasA = 4 AND (INSTR(ZSubDir$(4),ZCallerIDNumStr$) OR _
         INSTR(ZSubDir$(4),ZCallerIDBlockStr$)) THEN
         ZCallerID$ = ZSubDir$(4)
         ZNetReliable$ = ""
      END IF

      GOTO 104
'
' *** Get command line options using "/" method ***
'
103   WasX = INSTR(WasPM$,"/T:")                          ' Time to External
      IF WasX THEN
         NetTime$ = MID$(WasPM$,WasX+3)
         WasX = INSTR(NetTime$,"/")
         IF WasX THEN
            NetTime$ = LEFT$(NetTime$,WasX-1)
         END IF
      END IF

      WasX = INSTR(WasPM$,"/B:")                          ' Net Baud (DTE)
      IF WasX THEN
         NetBaud$ = MID$(WasPM$,WasX+3)
         WasX = INSTR(NetBaud$,"/")
         IF WasX THEN
            NetBaud$ = LEFT$(NetBaud$,WasX-1)
         END IF
      END IF

      WasX = INSTR(WasPM$,"/C:")                          ' Connect Speed
      IF WasX THEN
         ZCBaud$ = MID$(WasPM$,WasX+3)
         WasX = INSTR(ZCBaud$,"/")
         IF WasX THEN
            ZCBaud$ = LEFT$(ZCBaud$,WasX-1)
         END IF
      END IF

      WasX = INSTR(WasPM$,"/R:")                          ' Reliable Connect
      IF WasX THEN
         ZNetReliable$ = MID$(WasPM$,WasX+3)
         IF LEFT$(ZNetReliable$,1) = " " THEN
            ZNetReliable$ = ""
         END IF
         IF LEFT$(ZNetReliable$, 1) = "/" AND INSTR(ZNetReliable$," ") > 0 THEN
            ZNetReliable$ = MID$(ZNetReliable$, 1, INSTR(ZNetReliable$, " "))
         END IF
         IF LEFT$(ZNetReliable$, 1) = "/"  THEN
            ZNetReliable$ = MID$(ZNetReliable$,2)
         END IF
      END IF

      WasX = INSTR(WasPM$,"/I:")                          ' Caller ID
      IF WasX THEN
         ZCallerID$ = MID$(WasPM$,WasX+3)
         WasX = INSTR(ZCallerId$, "/")
         IF WasX THEN
            ZCallerID$ = LEFT$(ZCallerID$,WasX-1)
         END IF
      END IF

'     WasX = INSTR(WasPM$,"/S:")                          ' Subboard
'     IF WasX THEN
'        ZTurboSubBoard$ = MID$(WasPM$,WasX+3)
'        WasX = INSTR(ZTurboSubBoard$, "/")
'        IF WasX THEN
'           ZTurboSubBoard$ = LEFT$(ZTurboSubBoard$,WasX-1)
'        END IF
'     END IF

      WasPM$ = LEFT$(WasPM$,INSTR(WasPM$,"/") - 1)

104   CALL Trim (NetTime$)
      CALL Trim (NetBaud$)
      CALL Trim (ZCBaud$)
      CALL Trim (NetReliable$)

      ZWasA = INSTR(WasPM$,"DEBUG")
      IF ZWasA > 0 THEN _
         ZDebug = -1 : _
         WasPM$ = LEFT$(WasPM$,ZWasA - 1) + _
               RIGHT$(WasPM$,LEN(WasPM$) - ZWasA - 4)
      PassedDebug = ZDebug
      ZWasA = INSTR(WasPM$,"LOCAL")
      IF ZWasA > 0 THEN _
         ZComPort$ = "COM0" : _
         WasPM$ = LEFT$(WasPM$,ZWasA - 1) + _
               RIGHT$(WasPM$,LEN(WasPM$) - ZWasA - 4)
      ZWasA = INSTR(WasPM$,"NULLMODEM")
      IF ZWasA > 0 THEN
         ZNullModem = ZTrue
         WasPM$ = LEFT$(WasPM$,ZWasA - 1) + _
               RIGHT$(WasPM$,LEN(WasPM$) - ZWasA - 8)
      END IF
      ZWasA = INSTR(WasPM$,"NOSWAP")
      IF ZWasA > 0 THEN
         ZSwapToDisk = -1
         WasPM$ = LEFT$(WasPM$,ZWasA - 1) + _
               RIGHT$(WasPM$,LEN(WasPM$) - ZWasA - 5)
      END IF
      CALL CheckInt (WasPM$)
      ZNodeRecIndex = ZTestedIntValue + 1
      IF ZNodeRecIndex < 2 THEN _
         ZNodeRecIndex = 2
      IF ZNodeRecIndex > 100 THEN _
         ZNodeRecIndex = 100
      ZNodeID$ = STR$(ZNodeRecIndex-1)
      CALL Trim (ZNodeID$)
      ZNodeFileID$ = ZNodeID$
      IF LEN(WasPM$) > 4 AND MID$(WasPM$,2,1) = SPACE$(1) THEN _
         ZConfigFileName$ = MID$(WasPM$,3) _
      ELSE IF ZTestedIntValue > 0 THEN _
         ZConfigFileName$ = LEFT$(ZConfigFileName$,4) + _
                            ZNodeID$ + _
                            RIGHT$(ZConfigFileName$, _
                            LEN(ZConfigFileName$) - LEN(ZNodeID$) - 3)
      ZOrigCnfg$ = ZConfigFileName$
      END SUB
105 ' $SUBTITLE: 'Trim - sub to eliminate leading/trailing blanks'
' $PAGE
'
'  NAME    -- Trim
'
'  INPUTS  --  PARAMETER                    MEANING
'              TrimParm$           STRING THAT IS TO HAVE LEADING
'                                  AND TRAILING BLANKS ELIMINATED FROM
'
'  OUTPUTS --  TrimParm$           STRING WITH NO LEADING OR TRAILING
'                                   BLANKS
'
'  PURPOSE --  To strip leading and trailing blanks
'
      SUB Trim (TrimParm$) STATIC
      TrimParm$ = LTRIM$(TrimParm$)
      TrimParm$ = RTRIM$(TrimParm$)
      END SUB
'
107 '  $SUBTITLE: 'TrimTrail - sub to trim off trailing characters'
'  $PAGE
'
'  NAME    --  TrimTrail
'
'  INPUTS  --  PARAMETER           MEANING
'              TrimParm$  WHAT STRING TO Trim FROM
'              TrimThis$  WHAT CHARACTER TO Trim OFF END
'
'  OUTPUTS --  NONE
'
'  PURPOSE --  To remove all occurences of a character from end of string
'
      SUB TrimTrail (TrimParm$,TrimThis$) STATIC
      IF RIGHT$(TrimParm$, 1) <> TrimThis$ THEN _
         EXIT SUB
      WasJ = LEN(TrimParm$) - 1
108   IF WasJ > 0 THEN _
         IF MID$(TrimParm$, WasJ, 1) = TrimThis$ THEN _
            WasJ = WasJ - 1 : _
            GOTO 108
      TrimParm$ = LEFT$(TrimParm$, WasJ)
      END SUB
'
109 '  $SUBTITLE: 'VarInit - subroutine to initialize system variables'
'  $PAGE
'
'  NAME    --  VarInit
'
'  INPUTS  --  PARAMETER           MEANING
'              NONE
'
'  OUTPUTS --  NONE
'
'  PURPOSE --  To initialize system variable
'
      SUB VarInit STATIC
    DEF SEG                            ' Point to BASIC
    WIDTH 80                           ' Set Screen Width
    KEY OFF                            ' Line 25 turned off
' ********************* Variable Definitions *******************************
    ZMsgDim = 199
    WasMM = 5000
    WasBX = 200                   'was 75
    WasJ = 200
    REDIM ZOptSec(WasJ)
    DIM ZWorkAra$(WasJ)
    DIM ZSaveTxtAra$(WasJ)
    DIM ZGSRAra$(WasJ)
    DIM ZCategoryName$(WasBX),ZCategoryCode$(WasBX),ZCategoryDesc$(WasBX)
    DIM ZOutTxtAra$(ZMsgDim)                   ' Message line table
    DIM ZUserInAra$(ZMsgDim)                   ' Message line table
    DIM ZMsgPtr(WasMM,2)                       ' Message pointers
    ZActiveMenu$ = "|"
    ZActiveMessage$ = CHR$(225)
    ZBackSpace$ = CHR$(8) + " " + CHR$(8)
    ZBaudRates$ = "          300    450   1200   2400   4800   7200   9600  12000  14400  16800  19200  21600  24000  26400  28800  31200  33600  38400  57600  64000  76800 115200"
    ZBaudRateVals$ = "0000030004501200240048007200960120014401680192021602400264028803120336038405760640076801152"
    ZBellRinger$ = CHR$(7)
    ZBulletinMenu$ = ""
    ZColorReset$ = CHR$(27) + "[0;37;40m"
    ZConfigFileName$ = "RBBS-PC.DEF"
    ZCarriageReturn$ = CHR$(13)
    ZDeletedMsg$ = CHR$(226)
    ZEscape$ = CHR$(27)
    ZExpectActiveModem = 0
    ZFalse = 0
    ZConfName$ = "MAIN"
    CALL SetHiLite (ZTrue)
    ZHomeConf$ = ""
    ZInConfMenu = -1
    ZLastCommand$ = "M "
    ZLimitMinsPerSession = 0
    ZLineFeed$ = CHR$(10)
    ZLineFeeds = NOT ZFalse
    ZLineEditChk$ = CHR$(9) + _
                    ZLineFeed$ + _
                    CHR$(11) + _
                    CHR$(12) + _
                    CHR$(127) + _
                    CHR$(8) + _
                    ZBellRinger$ + _
                    CHR$(26) + _
                    CHR$(227)
    ZLineMes$ = SPACE$(78)          ' fixed length string workspace
    ZLockStatus$ = "UM UU UB UD"
    ZMenuIndex = 2
    ZNoAdvance = ZFalse
    ZPageLength = 23
    ZPageLengthHold = 23
    ZParseOff = ZFalse
    ZYesPrompt$ = " ([Y],N)"
    ZNoPrompt$ = " (Y,[N])"
    ZPressEnter$ = " (Press [ENTER] to Quit)"
    ZPressEnterExpert$ = " ([ENTER] Quits)"
    ZPrivateDoor = ZFalse
    ZRightMargin = 72
    ZReturnLineFeed$ = ZCarriageReturn$ + _
                        ZLineFeed$
'* Reserved characters: WT, ST, ON, EY, EN LV, NV, CV, LO (macro cmds)
    ZSmartTable$ = "CS PB NS FN LN SL DT TM TR TE TL RP RR CT " + _
                   "C1 C2 C3 C4 C0 DD BD DB UB DL UL FI VY VN " + _
                   "TY TN BN ND FS LS CN C5 C6 C7 C8 C9 CA CB " + _
                   "CC CD CE CF G0 G1 G2 G3 G4 G5 G6 G7 SN SO " + _
                   "MS CR LT SD TD HB DC ZV LD TO TC MA MN ML " + _
                   "BP BB CL FB FK FM DR PW UM PR UC LF NL TK " + _
                   "GR HL RB NB NU AE IC RG NF 2J RI AM EF NM " + _
                   "EM TU LC F3 F4 F6 F7 F9 D1 FR BR ID PA SP " + _
                   "AN TF BC CP ZZ MH EX LM MT SM MB SS CO MF " + _
                   "CM ZU ER Z1 BM DN DE FH HC TS RV SF DF UA " + _
                   "MR MU NR NO SH EH IV NC RC UN TG SE LG IN "
    ZTimeLoggedOn$ = SPACE$(8)
    ZTrue = NOT ZFalse
    ZUpInc = -1
    ZInterrupOn$ = CHR$(11) + CHR$(24) + CHR$(19) + CHR$(17) + ZCarriageReturn$
    ZOptionEnd$ = ZReturnLineFeed$ + " ,("
    ZCrLf$ = ZCarriageReturn$ + ZLineFeed$
'
' * Blinker encrypted serial number
' * stores version number for pre-
' * compiled RBBS/CDor mods
'
'   ZVersionID$ = BLISERNUMBAS$
    ZVersionID$ = "17.4  CDOR 2000"
'
    CALL GetCommand (ZDebug,ZNetTime$,ZNetBaud$,ZNetReliable$)
    ZSubParm = 1
    CALL ReadDef (ZConfigFileName$)
    CALL CallerID (ZCallerID$)
    '* "Registration Check Failed"
    '* "Sysop name attempted"
    '* "Locked out attempt"
    '* "Password Attempt Failed"
    '* "Auto Lockout done"
    '* "Name in use on another Node!"
    '* ""
    '* ""Locked reason read!"
    '* ""Expired Registration"
    FOR icount = 250 TO 258
       GOSUB 110
    NEXT icount
    REDIM ZWorkAra$(ZMaxWorkVar)
    REDIM ZGSRAra$(ZMaxWorkVar)
    ZUseTPut = (ZUpperCase OR ZXOnXOff)
    ZOrigCallers$ = ZCallersFile$
    ZOrigMsgFile$ = ZMainMsgFile$
    ZOrigUserFile$ = ZMainUserFile$
    IF (NOT ZConfMode) AND (NOT ZSubBoard) THEN
       ZOrigSysopFN$ = ZSysopFirstName$
       ZOrigSysopLN$ = ZSysopLastName$
    END IF
    ZPromptBell = ZPromptBellDef
    ZSecretName$ = UCASE$(ZSysopPswd1$ + SPACE$(1) + ZSysopPswd2$)
    ZDropChange = ZFalse
    IF NOT ZSubBoard THEN _
       ZOrigRBBSName$ = ZRBBSName$
    ZRIPGraphicsReset$ = "!|*!|0000270P01"
    IF ZErrCode > 0 THEN
       CALL ConfigError
    END IF
    EXIT SUB
110 CALL FormatString (icount,ZFalse,ZFalse,0,ZFalse,0,ZWasLG$(icount-249))
    RETURN
    END SUB
'
112 ' $SUBTITLE: 'SysMenu - sub to display RBBS-PC SYSOP menu'
'  $PAGE
'
'  NAME    --  SysMenu
'
'  INPUTS  --  PARAMETER           MEANING
'
'  OUTPUTS --  NONE
'
'  PURPOSE --  TO DISPLAY RBBS-PC's SYSOP MENU ON THE LOCAL SCREEN
'
    SUB SysMenu STATIC
    ZLocalUser = ZTrue
    ZSnoop = ZTrue
    ZNonStop = ZTrue
    CALL CheckTime (TIMER, ZDelay!, 1)
    CLS
    ZStopInterrupts = ZTrue
    ZBypassTimeCheck = ZTrue
    CALL BufFile ("MENU0",WasX)
    ZNonStop = ZFalse
    ZBypassTimeCheck = ZFalse
    ZLocalUser = ZFalse
    IF NOT ZOK THEN
       '* "MENU0 not found"
       CALL FormatString (259,ZFalse,ZFalse,0,ZFalse,0,Strng$)
       CALL LPrnt(Strng$,1)
    END IF
    LOCATE 2,14
    CALL LPrnt(ZSysopColor$ + LEFT$(ZVersionID$,13),0)
    LOCATE 2,33
    CALL LPrnt(ZNodeID$,0)
    LOCATE 2,35
    Temp$ = STR$(ZMaxNodes)
    CALL TRIM (Temp$)
    CALL LPrnt (Temp$,0)
    LOCATE 2,48
    CALL LPrnt(LEFT$(TIME$,5),0)
    LOCATE 2,60
    WasX$ = DATE$
    CALL LPrnt(LEFT$(WasX$,6) + RIGHT$(WasX$,2),0)
    LOCATE 2,74
    CALL LPrnt(LEFT$(TIME$,5),0)
    '* "YES"
    CALL FormatString (1017,ZFalse,ZFalse,0,ZFalse,0,YesStr$)
    IF ZFMSDirectory$ <> "" THEN _
       LOCATE 6,76 : _
       CALL LPrnt(YesStr$,0)
    IF ZExtendedLogging THEN _
       LOCATE 8,76 : _
       CALL LPrnt(YesStr$,0)
    IF ZFossil THEN _
       LOCATE 10,76 : _
       CALL LPrnt(YesStr$,0)
    LOCATE 12,75 : _
    CALL LPrnt(ZComPort$,0)
    LOCATE 14,75
    CALL LPrnt (STR$(CINT(FRE("A")/1024)) + "k",0)
    IF ZDebug THEN _
       LOCATE 22,76 : _
       CALL LPrnt(YesStr$,0)
    CALL GetLastCaller (ZFalse)
    LOCATE 17,17
    CALL LPrnt (ZLastCaller$,0)
    LOCATE 18,17
    CALL LPrnt (STR$(ZMenuNewCalls),0)
    LOCATE 19,17
    CALL LPrnt (STR$(ZMenuNewUsers),0)
    LOCATE 20,17
    CALL LPrnt (STR$(ZMenuNewMsgs),0)
    LOCATE 21,17
    CALL LPrnt (STR$(ZMenuNewUpld),0)
    LOCATE 22,17
    CALL LPrnt (STR$(ZMenuDownloads),0)
    LOCATE 18,46
    CALL LPrnt (STR$(ZMenuNewSysop),0)
    LOCATE 19,46
    CALL LPrnt (STR$(ZMenuSysopPages),0)
    LOCATE 20,46
    CALL LPrnt (STR$(ZMenuDoors),0)
    LOCATE 21,46
    CALL LPrnt (STR$(ZMenuCarriers),0)
    ZWasZ$ = ZUpldDriveFile$
    CALL FindFree
    LOCATE 22,46
    CALL LPrnt (ZFreeSpaceM$,0)
    END SUB
'
120 '  $SUBTITLE: 'EditDef - sub to edit config parameters'
'  $PAGE
'
'  NAME    -- EditDef
'
'  INPUTS  --     PARAMETER                    MEANING
'
'  OUTPUTS --                          OUTPUT STRING
'
'  PURPOSE -- Interpretes and adjusts stored configuration parameters
'
      SUB EditDef STATIC
      ZMinsPerSessionDef = ZMinsPerSession
      ZAllOpts$ = ZMainCmds$ + _
                  ZFileCmd$ + _
                  ZUtilCmds$ + _
                  ZLibCmds$ + _
                  ZGlobalCmnds$ + _
                  ZSysopCmds$
      ZHelpExtension$ = "." + ZHelpExtension$
      ZCompressedExt$ = ZDefaultExtension$
      ZWasQ = INSTR(ZDefaultExtension$,".")
      IF ZWasQ > 0 THEN _
         ZDefaultExtension$ = LEFT$(ZDefaultExtension$, ZWasQ-1)
      IF RIGHT$(ZDirPath$,1) <> "\" THEN
         ZDirPath$ = ZDirPath$ + "\"
      END IF
      ZCurDirPath$ = ZDirPath$
      ZTempExpiredSec = ZExpiredSec
      ZBegMain = 1
      ZBegFile = LEN(ZMainCmds$) + ZBegMain
      ZBegUtil = LEN(ZFileCmd$) + ZBegFile
      ZBegLibrary = LEN(ZUtilCmds$) + ZBegUtil
      ZHelp$(3) = ZHelpPath$ + _
                 ZHelp$(3)
      ZHelp$(4) = ZHelpPath$ + _
                 ZHelp$(4)
      ZHelp$(7) = ZHelpPath$ + _
                 ZHelp$(7)
      ZHelp$(9) = ZHelpPath$ + _
                 ZHelp$(9)
      CALL BreakFileName (ZWelcomeFile$,ZWelcomeFileDrvPath$,Prefix$,_
                     Extension$,ZTrue)
     CALL ASCIICodes ("[","]",ZDefaultLineACK$)
     CALL ASCIICodes ("[","]",ZHostEchoOn$)
     CALL ASCIICodes ("[","]",ZHostEchoOff$)
     CALL ASCIICodes ("[","]",ZEmphasizeOffDef$)
     CALL ASCIICodes ("[","]",ZEmphasizeOnDef$)
     CALL ASCIICodes ("[","]",ZSysopColor$)
     IF ZSubParm = -62 THEN _
        EXIT SUB
     ZLocalUserMode = (RIGHT$(ZComPort$,1) < "1")
     ZEchoer$ = ZDefaultEchoer$
     ZMSB = ZLSB + 1
     ZLineCntlReg = ZLSB + 3
     ZModemCntlReg = ZLSB + 4
     ZLineStatusReg = ZLSB + 5
     ZModemStatusReg = ZLSB + 6
     IF LEN(ZScreenOutMsg$) < 2 THEN _
        ZScreenOutMsg$ = CHR$(1)
     ZSmartTextChar$ = CHR$(ZSmartTextCode)
     IF ZMaxWorkVar < 13 THEN _
        ZMaxWorkVar = 13
'
' *** LOAD ListFile array with Numbers
'
    FOR icount = ListFileCount + 1 TO 255
       ZListFile$(icount) = STR$(icount)
    NEXT icount
'
' ***  ESTABLISH RBBS-PC'S DOS SUBDIRECTORIES USAGE  ***
'
    IF ZMainFMSDir$ <> "" THEN _
       ZFMSDirectory$ = ZDirPath$ + _
                        ZMainFMSDir$ + _
                        "." + _
                        ZMainDirExtension$ : _
       ZActiveFMSDir$ = ZFMSDirectory$ : _
    ZUpcatHelp$ = ZHelpPath$ + _
                  ZUpcatHelp$ + _
                  ZHelpExtension$
    IF ZSubDirCount < 1 THEN _
       GOTO 123
    FOR ZSubDirIndex = 1 TO ZSubDirCount
       INPUT #2,ZSubDir$
       IF RIGHT$(ZSubDir$,1) <> "\" THEN _
         ZSubDir$(ZSubDirIndex) = ZSubDir$ + _
                                 "\" _
       ELSE ZSubDir$(ZSubDirIndex) = ZSubDir$
    NEXT
    GOTO 125
123 FOR ZSubDirIndex = 1 TO LEN(ZDnldDrives$) - 1
       ZSubDir$(ZSubDirIndex) = MID$(ZDnldDrives$,ZSubDirIndex,1) + ":"
    NEXT
    ZSubDirCount = LEN(ZDnldDrives$) - 1
'
' *****  SETUP UPLOAD DRIVE AND DIRECTORY.NAME  ***
'
125 ZUpldDirCheck$ = ZUpldDir$
    ZSubDirCount = ZSubDirCount + 1
    IF RIGHT$(ZUpldSubdir$,1) = "\" THEN
       ZUpldSubdir$ = LEFT$(ZUpldSubdir$,LEN(ZUpldSubdir$)-1)
    END IF
    ZSubDir$(ZSubDirCount) = ZUpldSubdir$ + "\"
    ZUpldDir$ = ZUpldDir$ + "." + ZMainDirExtension$
    CALL SearchArray (ZSubDir$(ZSubDirCount),ZSubDir$(),ZSubDirCount-1,Found)
    ZCanDnldFromUp = (Found > 0)
    ZUpldDir$ = ZUpldPath$ + _
                        ZUpldDir$
126 CLOSE #2
'
' *****  CHECK FOR WILDCARD DOWNLOAD SUPPORT ***
'
    CALL FindIt (LEFT$(ZFastFileList$, _
                 INSTR(ZFastFileList$, ".") -1) + ".CFG")
    IF ZOK THEN _
       ZWildDownOK = ZTrue _
    ELSE _
       ZWildDownOK = ZFalse
'
' ***** SET DESCRIPTION LENGTH FOR DOWNLOAD INFO IN FMS
'
    ZMaxDescLen = ZMaxDescLen - (5 * ZShowTimesDownloaded)

    END SUB
'
129 '  $SUBTITLE: 'ASCIICodes - subrotuine to allow any ASCII codes'
'  $PAGE
'
'  NAME    -- ASCIICodes
'
'  INPUTS  --     PARAMETER                    MEANING
'                 LeftParen$           MARKS BEGINNING OF #
'                 RightParen$          MARKS END OF #
'                 Strng$                INPUT STRING
'
'  OUTPUTS --    Strng$                OUTPUT STRING
'
'  PURPOSE -- To allow a config string to have any ascii values.
'             characters not enclosed taken as is.  Enclosed
'             characters interpreted as value of ascii code.
'             (e.g. "123[32]4" is interpreted as "123 4").
'
    SUB ASCIICodes (LeftParen$,RightParen$,Strng$) STATIC
    IF LEN(Strng$) < 1 THEN _
       EXIT SUB
    Start = 1
    WasL = LEN(Strng$)
    ZUserIn$ = Strng$ + _
         LeftParen$
    WasX = INSTR(ZUserIn$,LeftParen$)
    NewString$ = ""
    WHILE Start <= WasL
       NewString$ = NewString$ + _
                    MID$(ZUserIn$,Start,WasX - Start)
       WasY = INSTR(WasX,ZUserIn$,RightParen$)
       IF WasY > 0 THEN _
          WasK = VAL(MID$(ZUserIn$,WasX + 1,WasY - WasX - 1)) : _
          NewString$ = NewString$ + _
                       CHR$(WasK) : _
          Start = WasY + 1 _
       ELSE NewString$ = NewString$ + _
                         MID$(ZUserIn$,WasX,WasL + 1 - WasX) : _
            Start = WasL + 1
       WasX = INSTR(Start,ZUserIn$,LeftParen$)
    WEND
    Strng$ = NewString$
    END SUB
200 ' $SUBTITLE: 'AnswerIt - sub to establish connection'
' $PAGE
'
'  NAME    -- AnswerIt
'
'  INPUTS  --     PARAMETER                    MEANING
'                 ZSubParm = 1           WAIT FOR PHONE TO RING
'                          = 2           CONTINUE LOOKING FOR CONNECT
'                          = 3           RENTRY AFTER FUNCTION KEY
'                          = 4           GO ON LINE IMMEDIATELY
'                 ZBG                    LOCAL DISPLAY'S BACKGROUND
'                 ZBorder                LOCAL DISPLAY'S BORDER COLOR
'                 ZComPort$              COMMUNICATIONS PORT NAME
'                 ZComputerType          TYPE OF COMPUTER RUNNING ON
'                 ZExtendedLogging       EXTENDED CALLERS LOG FLAG
'                 ZFG                    LOCAL DISPLAY'S FOREGROUND
'                 ZModemAnswerCmd$       COMMAND TO ANSWER PHONE
'                 ZModemCntlReg          LOCATION WasOF MODEM CNTRL. REG
'                 ZModemCountRingsCmd$   COMMAND TO COUNT PHONE RINGS
'                 ZModemInitBaud$        BAUD AT WHICH TO OPEN COMM.
'                 ZModemResetCmd$        COMMAND TO RESET THE MODEM
'                 ZModemStatusReg        LOCATION OF MODEM STATUS REG
'                 ZPrinter               FLAG TO PRINT ON LOCAL PRT.
'                 ZRequiredRings         NUMBER OF RINGS TO ANSWER ON
'                 ZSnoop                 FLAG TO DISPLAY ON LOCAL PC
'                 ZSysopNext             FLAG TO GIVE SYSOP CONTROL
'
'  OUTPUTSS --    BaudTest!              BAUD RATE TO SET RS232 AT
'                 ZEightBit              PARITY INDICATOR
'                 ZReliableMode          INDICATES MODEM-SUPPLIED
'                                        "ERROR-FREE" Protocol ACTIVE
'                 ZSubParm          = 1  Carrier DETECT Found (I.E.
'                                        MODEM AUTO-ANSWERED).
'                                   = 2  ANSWERED THE PHONE AND
'                                        Carrier DETECT OCCURRED.
'                                   = 3  SYSOP HIT "ESC" KEY ON THE
'                                        LOCAL KEYBOARD.
'                                   = 4  ANSWERED THE PHONE BUT NO
'                                        Carrier WAS DETECTED.
'                                   = 5  COMM. BUFFER OVERFLOW.
'                                   = 6  FUNCTION KEY PRESSED ON THE
'                                        LOCAL KEYBOARD.
'
'  PURPOSE -- To detect incoming call and establish connection.
'
      SUB AnswerIt STATIC
      ZErrCode = 0
      ZReliableMode = ZFalse
      ZFF = ZSubParm
      ZSubParm = 0
      ON ZFF GOTO 201,324,245,320
'
'
' *  INITIALIZE MODEM AND ANNOUNCE RBBS-PC IS UP AND READY FOR CALLS
'
'
201 ZSubParm = -10
    CALL CheckCarrier
    IF ZSubParm = 0 THEN
       GOTO 210
    END IF
'
'
' *  RESET THE MODEM VIA THE MODEM CONTROL REGISTER  TO ASSURE IT IS READY
'
'
    IF ZFossil THEN
       State = 0
       CALL FosDTR(ZComPortNum,State)
    ELSE
       OUT ZModemCntlReg,&H4
    END IF
    CALL DelayTime (ZModemInitWaitTime)
'
'
' *  CLEAR THE MODEM CONTROL REGISTER PRIOR TO OPEN THE COMMUNICATIONS PORT
'
'
    IF ZFossil THEN
       State = 1
       CALL FosDTR(ZComPortNum,State)
    ELSE
       OUT ZModemCntlReg,&H0
    END IF
    CALL DelayTime (ZModemInitWaitTime)
210 IF ZPrivateDoor THEN
       CALL Transfer
       GOTO 235
    END IF
    CALL OpenCom(ZModemInitBaud$,",N,8,1")
220 CALL AMorPM
230 '* "{SPRBBS-PC {ZV Node {ND up at {TM on {DT"
    CALL FormatString (260,ZFalse,ZFalse,0,ZFalse,0,Strng$)
    CALL Printit (Strng$)
235 ZEightBit = ZTrue
    IF ZExitToDoors THEN
       CALL ReadProf
    END IF
    ZSubParm = -10
    CALL CheckCarrier
    IF ZSubParm = 0 AND ZExitToDoors THEN
       ZSubParm = 1
       GOTO 335
    END IF
    IF ZSubParm = 0 AND ZExpectActiveModem THEN
       ZBaudTest! = VAL(ZNetBaud$)
       CALL TestRel (ZNetReliable$)
       GOTO 328
    END IF
    IF ZExpectActiveModem OR ZExitToDoors THEN
       ZSubParm = 4
       ZExitToDoors = ZFalse
       EXIT SUB
    END IF
    IF ZSubParm = 0 THEN
       ConnectDelay! = TIMER + ZMaxCarrierWait
       GOTO 324
    END IF
    CALL SysMenu
    CALL ModemPut (ZModemResetCmd$)
    CALL DelayTime (ZModemInitWaitTime)
    CALL ModemPut (ZModemInitCmd$)
    RingBack = ZFalse
    LOCATE 16,55
    IF ZRequiredRings = 0 THEN
       '* "WAITING FOR CARRIER"
       LineNum = 261
       GOSUB 336
       CALL LPrnt(ZSysopColor$ + Strng$,0)
       GOTO 237
    END IF
    IF MID$(ZModemInitCmd$,INSTR(ZModemInitCmd$,"S0") + 3,3) = "255" THEN
       '* "RING BACK SYSTEM"
       LineNum = 262
       GOSUB 336
       CALL LPrnt(ZSysopColor$ + Strng$,0)
       RingBack = ZTrue
       GOTO 236
    END IF
    '* "{SPWAITING FOR RING{SP"
    LineNum = 263
    GOSUB 336
    CALL LPrnt(ZSysopColor$ + Strng$,0)
236 LOCATE 16,76 : _
    CALL LPrnt(MID$(STR$(ZRequiredRings),2),0)
237 LOCATE 18,76
    '* "YES"
    CALL FormatString (1017,ZFalse,ZFalse,0,ZFalse,0,YesStr$)
    CALL LPrnt (ZSysopColor$ + YesStr$,0)
    LOCATE 20,56,0
'
'
' *  GET READY TO ANSWER INCOMMING CALL:
' *       1.  LET THE MODEM "AUTO-ANSWER" FOR RBBS-PC.
' *           REQUIRED RINGS = 0 AND S0 = 1 IN MODEM INIT COMMAND.
' *       2.  ANSWER THE MODEM ON A SPECIFIED NUMBER OF RINGS.
' *           REQUIRED RINGS > 0 AND S0 = 254 IN MODEM Init COMMAND.
' *       3.  ANSWER THE MODEM ON A SPECIFIED NUMBER OF RINGS AFTER A USER
' *           First CALLS AND THEN HANGS UP (I.E. RING-BACK).
' *           REQUIRED RINGS > 0 AND S0 = 255 IN MODEM INIT COMMAND.
'
'
    WasQQ = 255
    WasI = INSTR(ZModemInitCmd$,"S0")
    IF WasI = 0 THEN
       GOTO 239
    END IF
    IF VAL(MID$(ZModemInitCmd$,WasI + 3,3)) = 255 THEN
       WasQQ = 0
       ZBlk = WasQQ
    END IF
    ZSecsUsedSession! = TIMER
    ZSubParm = 1
    CALL Line25
    RingAnswer = ZTrue
    IF RingBack THEN
       RingAnswer = ZFalse
    END IF
239 RingBackWaitStart! = 0
    IF RingBack THEN
       RingBackWaitStart! = TIMER
       COLOR 7,0,0
    END IF
240 IF ZSysopNext THEN
       ZSubParm = 3
       EXIT SUB
    END IF
'
'
' * WAIT FOR INCOMING CALLS
'
'
    ScreenCleared = ZFalse
245 InactiveDelay! = TIMER + (60 * ZRecycleWait)
    NoCall = ZTrue
    CALL FlushCom (ModemResponse$)
    ModemResponse$ = ""
247 IF INP(ZModemStatusReg) > 127 OR (NOT NoCall) THEN
       GOTO 274
    END IF
    CALL FindFKey
    IF ZSubParm < 0 THEN
       EXIT SUB
    END IF
250 IF ZKeyPressed$ = ZEscape$ THEN
       ZSubParm = 3
       EXIT SUB
    END IF
    IF ZKeyPressed$ <> "" THEN
       GOTO 235
    END IF
260 IF RingBackWaitStart! > 0 THEN
       CALL CheckTime(RingBackWaitStart!, TempElapsed!, 2)
       IF TempElapsed! > 45 THEN
          RingBackWaitStart! = 0
          RingBackCount = 0
          RingAnswer = ZFalse
          IF RingBack THEN
             '* "Ringback timeout"
             LineNum = 264
             GOSUB 336
             LOCATE 20,56
             CALL LPrnt(ZSysopColor$ + Strng$ + ZPagingPtrSupport$,1)
          END IF
       END IF
    END IF
265 CALL CheckTime(ZSecsUsedSession!, TempElapsed!, 2)
    IF TempElapsed! > 120 AND _
       (ZBBSOptions AND 4096) > 0 AND _
       NOT ScreenCleared THEN
       LOCATE ,,0
       CLS
       ScreenCleared = ZTrue
       ZSecsUsedSession! = TIMER
    END IF
    IF ZTimeToDropToDos! > 0 THEN
       IF ZOldDate$ <> DATE$ THEN
          IF TIMER => ZTimeToDropToDos! AND TIMER < 86340 THEN
             ' Skip btw 23:59 and 00:00
             ZSubParm = 7
             EXIT SUB
          END IF
       END IF
    END IF
266 IF (INP(ZModemStatusReg) AND &H40) > 0 AND ZRequiredRings > 0 THEN
       GOTO 276
    END IF
270 IF ZRecycleWait > 0 THEN
       CALL CheckTime(InactiveDelay!, TempElapsed!, 1)
       IF TempElapsed! <= 0 THEN
          ZSubParm = 8
          EXIT SUB
       END IF
    END IF
    CALL FlushCom (WasX$)
    IF LEN(WasX$) > 0 THEN
       ModemResponse$ = ModemResponse$ + WasX$
       RingDetected = (INSTR(ModemResponse$,"RING") > 0)
       ConnectDetected = (INSTR(ModemResponse$,"ONNECT") > 0)
       CALL CallerID (ModemResponse$)
       NoCall = (NOT RingDetected) AND (NOT ConnectDetected)
    END IF
    IF RingDetected AND ZRequiredRings > 0 THEN
       MID$(ModemResponse$, INSTR(ModemResponse$,"RING")+1,1) = "A"
       RingDetected = ZFalse
       GOTO 276
    END IF
    CALL GiveBack
    IF NOT ScreenCleared THEN
       LOCATE 2,60,0
       WasX$ = DATE$
       CALL LPrnt(ZSysopColor$ + LEFT$(WasX$,6) + RIGHT$(WasX$,2),0)
       LOCATE 2,74,0
       CALL LPrnt(ZSysopColor$ + LEFT$(TIME$,5) + ZEmphasizeOffDef$,0)
    END IF
    LOCATE 20,56,0
    GOTO 247
274 IF NOT RingBack THEN
       IF ConnectDetected THEN
          GOTO 321
       END IF
    END IF
    IF ZRequiredRings = 0 THEN
       CALL DelayTime (3)
       GOTO 321
    END IF
'
'
' * PREPARE TO ANSWER THIS CALL ON A SPECIFIED NUMBER OF RINGS (S0 = 254) OR
' * THE CALL AFTER THIS CALL ON A SPECIFIED NUMBER OF RINGS (S0 = 255) --
' * "RING BACK."
'
'
276 CALL EofComm (Char)
    IF Char <> -1 THEN
       CALL FlushCom(WasX$)
       IF ZSubParm = - 1 THEN
          EXIT SUB
       END IF
    END IF
    ZOutTxt$ = ZModemCountRingsCmd$
    CALL ModemPut (ZOutTxt$)
    CALL DelayTime (ZModemCmdDelayTime)
290 CALL FlushCom(WasX$)
    IF ZSubParm = -1 THEN
       EXIT SUB
    END IF
    CALL CallerID (WasX$)
291 IF LEN(WasX$) = 0 THEN
       GOTO 310
    END IF
292 IF INSTR(WasX$,"0") < 1 THEN
       GOTO 293
    END IF
    WasX$ = MID$(WasX$,INSTR(WasX$,"0"),4)
293 IF (NOT RingAnswer) AND (VAL(WasX$) < RingBackCount) THEN
       RingAnswer = ZTrue
    END IF
300 RingBackCount = VAL(WasX$)
    ZWasQ = RingBackCount + 1
    IF (NOT RingAnswer) THEN
       ZWasQ = 0
    END IF
305 LOCATE 20,56
    CALL LPrnt(ZSysopColor$ + TIME$ + _
               " Ring " + STR$(ZWasQ) + ZEmphasizeOffDef$,0)
310 IF (RingBackCount + 1 < ZRequiredRings) OR (NOT RingAnswer) THEN
       GOTO 239
    END IF
320 CALL ModemPut (ZModemAnswerCmd$)
'
'
' *  TEST FOR Carrier PRESENT
'
'
321 ConnectDelay! = TIMER + ZMaxCarrierWait
322 CALL CheckTime(ConnectDelay!, TempElapsed!, 1)
323 ZSubParm = -10
    CALL CheckCarrier
    IF ZSubParm AND TempElapsed! > 0 THEN
       GOTO 322
    END IF
    IF ZSubParm THEN
       ZSubParm = 4
       EXIT SUB
    END IF
    CALL DelayTime (3)
324 ZSubParm = 0
    CALL CheckTime(ConnectDelay!, TempElapsed!, 1)
    IF TempElapsed! <= 0 THEN
       '* "Connect timeout"
       CALL FormatString (264,ZFalse,ZTrue,1,ZFalse,0,"")
       ZSubParm = 4
       EXIT SUB
    END IF
325 CALL FlushCom(WasX$)
    IF ZSubParm = -1 THEN
       IF ZErrCode = 69 THEN
          ZSubParm = 5
       END IF
       EXIT SUB
    END IF
    ModemResponse$ = ModemResponse$ + WasX$
    IF LEN(ModemResponse$) > 200 THEN
       ModemResponse$ = RIGHT$(ModemResponse$,20)
    END IF
    CALL CheckTime(ConnectDelay!, TempElapsed!, 1)
    IF TempElapsed! <= 0 THEN
       CALL UpdtCalr ("Connect timeout",1)
       ZSubParm = 4
       EXIT SUB
    END IF
    IF ZNullModem THEN
       ZBaudTest! = VAL(ZModemInitBaud$)
       GOTO 327
    END IF
    IF INSTR(ModemResponse$,"FAST") THEN
       ZBaudTest! = 19200
       GOTO 327
    END IF
    IF INSTR(ModemResponse$,"ONNECT") THEN
       ZBaudTest! = VAL(MID$(ModemResponse$,INSTR(ModemResponse$,"ONNECT") + 7))
       GOTO 327
    END IF
    IF INSTR(ModemResponse$,"ONLINE") THEN
       ZBaudTest! = VAL(MID$(ModemResponse$,INSTR(ModemResponse$,"ONLINE") + 7))
       GOTO 327
    END IF
    GOTO 324
327 CALL TestRel (ModemResponse$)
328 CALL SetBPS (ZBaudTest!,ZBPS)
    IF ZBPS = 0 THEN GOTO 324
331 CALL SetBaud
    ZSubParm = 2
335 DontWrite = 0
    EXIT SUB
336 CALL FormatString (LineNum,ZFalse,ZFalse,0,ZFalse,0,Strng$)
    RETURN
    END SUB
340 ' $SUBTITLE: 'TestRel - Test for Reliable mode connection'
' $PAGE
'
'  NAME    -- TestRel
'
'  INPUTS  --     PARAMETER                    MEANING
'                 Strng$                 String to check for reliable
'
'  OUTPUTS --    ZReliableMode          Reliable mode indicator
'
'  PURPOSE -- To test for reliable connect
'
    SUB TestRel (Strng$) STATIC
    ZReliableMode = ZFalse
    IF Strng$ = "" THEN _
       EXIT SUB
    Strng$ = UCASE$(Strng$)
    IF INSTR(Strng$,"REL") OR _
       INSTR(Strng$,"R C") OR _
       INSTR(Strng$,"ARQ") OR _
       INSTR(Strng$,"LAP") OR _
       INSTR(Strng$,"ECL") OR _
       INSTR(Strng$,"AFT") OR _
       INSTR(Strng$,"MNP") OR _
       INSTR(Strng$,"EC ") OR _
       INSTR(Strng$," EC") THEN _
         ZReliableMode = -1
    ZWasZ = INSTR(Strng$,"ARRIER ")
    IF ZWasZ > 0 THEN _
       IF VAL(MID$(Strng$,ZWasZ+6)) > 0 THEN _
          ZCBaud$ = STR$(VAL(MID$(Strng$,ZWasZ+6))) : _
          CALL Trim (ZCBaud$)
    END SUB
660 ' $SUBTITLE: 'PassWrd - verify User and Message passwords'
' $PAGE
'
'  NAME    -- PassWrd
'
'  INPUTS  --     PARAMETER                    MEANING
'                 ZSubParm         = 1      VERIFY USER PASSWORD
'                                  = 2      VERIFY MESSAGE PASSWORD
'                                  = 3      VERIFY MESSAGE PASSWORD
'                                  = 4      VERIFY MESSAGE PASSWORD
'                                  = 5      VERIFY MESSAGE PASSWORD
'
'  OUTPUTS -- ZPswdFailed                   SET TO 0 IF PASSED
'                                           SET TO -1 IF FAILED
'
'  PURPOSE -- To verify user and message passwords
'
    SUB PassWrd STATIC
    ZErrCode = 0
    ON ZSubParm GOTO 665,667,670,675,677
665 IF ZPswdSave$ = ZPswd$ THEN _
       ZPswdFailed = 0 : _
       EXIT SUB
667 Attempts = 0
670 Attempts = Attempts + 1
    IF Attempts > ZAttemptsAllowed THEN _
       ZPswdFailed = ZTrue : _
       EXIT SUB
675 '* "{C7Enter Password"
    CALL FormatString (266,ZFalse,ZFalse,0,ZFalse,0,ZOutTxt$)
    ZHidden = ZTrue
    CALL PopCmdStack
    IF ZSubParm < 0 THEN _
       ZPswdFailed = ZTrue : _
       EXIT SUB
    ZHidden = ZFalse
    ZWasZ$ = ZUserIn$
    ZOldPassword$ = ZUserIn$
677 IF LEN(ZWasZ$) > 15 THEN _
       GOTO 680
    IF ZErrCode <> 0 THEN _
       GOTO 670
    ZWasZ$ = UCASE$(ZWasZ$)
    ZWasZ$ = ZWasZ$ + SPACE$(15 - LEN(ZWasZ$))
    IF ZPswdSave$ = ZWasZ$ THEN _
       ZPswdFailed = 0 : _
       ZOutTxt$ = "" : _
       EXIT SUB
680 '* "{CR{CE{G4Wrong Password!{C7{G0"
    CALL FormatString (1018,ZFalse,ZFalse,0,ZTrue,1,"")
    ZLastIndex = 0
    IF NOT ZMsgPswd THEN
       '* "{AN PW fail:{SP"
       CALL FormatString (234,ZFalse,ZFalse,0,ZFalse,0,Strng$)
       CALL UpdtCalr (Strng$ + ZWasZ$,1)
    END IF
    GOTO 670
    END SUB
945 ' $SUBTITLE: 'Line25 - sub to build/display RBBS-PCs line 25'
' $PAGE
'
'  NAME    -- Line25
'
'  INPUTS  --     PARAMETER                    MEANING
'                 ZSubParm           = 1  BUILD DISPLAY FOR LINE 25
'                                    = 2  UPDATE LINE 25
'                 ZLockStatus$            STATUS OF LOCKS IN A MULTI-
'                                         USER ENVIRONMENT OR TIME OF
'                                         DAY USER LOGGED ON OR THE
'                                         RE-CYCLED
'
'  PURPOSE -- To build or update RBBS-PC's line 25 displayed
'             on the PC screen that is running RBBS-PC.
'
      SUB Line25 STATIC
      IF ZSubParm = 2 THEN _
         GOTO 950
'
'
' *  BUILD LINE 25 DISPLAY
'
'
949 IF ZLocalUser THEN
       Speed$ = "LOCAL"
    ELSE
       Speed$ = ZCBaud$
       IF ZReliableMode THEN
          Speed$ = Speed$ + "-R"
       END IF
       Speed$ = Speed$ + SPACE$(1) + RIGHT$(ZBaudParity$,5)
       CALL Remove (Speed$,",")
    END IF

    ZLine25$ = "Node " + _
               ZNodeID$ + SPACE$(1) + _
               Speed$ + SPACE$(1) + _
               ZPageStatus$ + SPACE$(1) + _
               MID$("AVL ",1, -4 * ZSysopAvail) + _
               MID$("ANY ",1, -4 * ZSysopAnnoy) + _
               MID$("LPT ",1, -4 * ZPrinter) + _
               MID$("SYS ",1, -4 * ZSysopNext) + _
               MID$("XOFF ",1,-5 * ZXOffEd) + _
               MID$("CTS ",1,-4 * ZNotCTS) + _
               MID$("NEW ",1,-4 * ZNewUserDGS)
'
'
' *  LINE 25 UPDATE ROUTINE
'
'
950 IF NOT ZSnoop THEN _
       EXIT SUB
    CursorRow = CSRLIN
    CursorCol = POS(0)
    IF ZOrigUserName$ = "" THEN
       UserName$ = ZActiveUserName$
    ELSE
       UserName$ = ZOrigUserName$
    END IF
    ZWasHH = LEN(UserName$) + _
         LEN(ZWasCI$) + _
         LEN(ZLine25$) + _
         LEN(STR$(ZUserSecLevel))+ _
         LEN(STR$(INT(MinsRemaining))) + 2
    LOCATE ZLocalPageLength,1
    IF ZNetworkType = 0 THEN _
        ZLockStatus$ = SPACE$(2) + _
                       LEFT$(ZTimeLoggedOn$,5)
    IF ZWasHH > 64 THEN _
       ZWasHH = 0 _
    ELSE _
       ZWasHH = 65 - ZWasHH
    ZLine25Hold$ = ZLine25$ + _
                    SPACE$(ZWasHH) + _
                    STR$(ZUserSecLevel) + _
                    SPACE$(1) + _
                    UserName$ + _
                    SPACE$(1) + _
                    ZWasCI$ + _
                    SPACE$(1) + _
                    STR$(INT(MinsRemaining)) + _
                    SPACE$(1) + _
                    ZLockStatus$
    ZLine25Hold$ = LEFT$(ZLine25Hold$, 67) + SPACE$(1) + ZLockStatus$
    CALL LPrnt (ZEmphasizeOnDef$ + ZLine25Hold$ + ZEscape$ + "[K" + _
                ZEmphasizeOffDef$,0)
    LOCATE CursorRow,CursorCol
    END SUB
1238 ' $SUBTITLE: 'SearchCmd    - sub to search command list'
' $PAGE
'
'  NAME    -- SearchCmd
'
'  INPUTS  -- PARAMETER             MEANING
'             StartPos         POSITION TO BEGIN SEARCH AT
'             ZAllOpts$        STRING TO SEARCH (COMMAND LIST)
'             ZWasZ$            WHAT TO LOOK FOR
'
'  OUTPUTS -- WhereFound   POSITION OF ZWasZ$ IN ZAllOpts$
'                           0 IF NOT Found
'
'  PURPOSE -- Searches valid command list for the requested
'             command.  If the sysop has configured RBBS-PC to
'             restrict commands to only those valid within the
'             RBBS-PC subsystem, then only those commands and
'             "GLOBAL" commands are valid.  Otherwise all commands
'             are valid from any of the RBBS-PC subsections.
'
     SUB SearchCmd (StartPos,WhereFound) STATIC
1240 IF LEN(ZWasZ$) < 1 THEN
        WhereFound = 0
        EXIT SUB
     END IF
     CALL Trim (ZWasZ$)
     ZWasZ$ = UCASE$(ZWasZ$)
     ZWasY$ = LEFT$(ZWasZ$,1)
     WhereFound = INSTR(StartPos,ZAllOpts$,ZWasY$)
     IF WhereFound = 0 THEN 'Not found: decide whether to hunt further
        IF StartPos < 2 OR ZRestrictValidCmds THEN
           GOTO 1242   ' fully searched or restricted
        ELSE
           WhereFound = INSTR(1,ZAllOpts$,ZWasY$)  'hunt further
           GOTO 1242
        END IF
     END IF
     IF WhereFound => ZBegLibrary THEN    'commented out if zlibtype
        IF WhereFound < LEN(ZAllOpts$) - 12 THEN
           WhereFound = INSTR(WhereFound+1,ZAllOpts$,ZWasY$)
           IF WhereFound = 0 THEN
              WhereFound = INSTR(1,ZAllOpts$,ZWasY$)
              IF WhereFound >= ZBegLibrary OR WhereFound = 0 THEN
                 WhereFound = 0
                 GOTO 1242
              END IF
           END IF
        END IF
     END IF
     IF NOT ZRestrictValidCmds THEN _
        GOTO 1242            ' everything found valid
'
'
' * RESTRICT COMMANDS TO SUBSYSTEMS (EXCEPT GLOBAL AND SYSOP)
'
'
     IF WhereFound > LEN(ZAllOpts$) - 12 THEN _
        IF ZUserSecLevel < ZOptSec(WhereFound) THEN _
           WhereFound = 0 : _
           EXIT SUB _
        ELSE GOTO 1242
     IF MID$(ZOrigCommands$,WhereFound,1) = "G" THEN _
        GOTO 1242          ' ACCEPT GOODBYE/GRAPHICS
     IF (WhereFound < StartPos) OR _
        (StartPos < ZBegFile AND WhereFound => ZBegFile ) OR _
        (StartPos < ZBegUtil AND WhereFound => ZBegUtil ) OR _
        (StartPos < ZBegLibrary AND WhereFound => ZBegLibrary ) THEN _
           WhereFound = 0                 ' REJECT: NOT IN Section
1242 IF WhereFound > 0 THEN
        IF WhereFound > LEN(ZAllOpts$) - 12 THEN
           IF ZUserSecLevel < ZOptSec(WhereFound) THEN
              WhereFound = 0
              EXIT SUB
           END IF
        ELSE
           LSET ZLastCommand$ = ZActiveMenu$ + _
                                MID$(ZOrigCommands$,WhereFound)
           EXIT SUB
        END IF
     END IF
     IF ZMacroActive OR LEN(ZWasZ$) <> 1 THEN _
        EXIT SUB
     CALL Macro (ZWasZ$,Found)
     IF Found THEN _
        CALL FDMACEXE : _
        ZWasZ$ = ZUserInAra$(1) : _
        GOTO 1240
     END SUB
1320 ' $SUBTITLE: 'CheckMacro - sub to check if macro exists & process'
' $PAGE
'
'  NAME    -- CheckMacro
'
'  INPUTS  -- PARAMETER             MEANING
'             Strng$               STRING TO CHECK IF IS A MACRO
'             ZMacroDrvPath$       DRIVE/PATH WHERE MACROS ARE
'             ZMacroExtension$     EXTENSION WasOF MACROS
'             MACRO.OFF            FORCE NO MACRO TO BE Found
'
'  OUTPUTS -- MacroFound           WHETHER A MACRO WAS Found
'             Strng$               SUBSTITUTE FOR COMMANDS
'             ZCommPortStack$      REST OF MACRO
'                                  0 IF NOT Found
'
'  PURPOSE -- Macro file is checked for security (1st line).
'             2nd line is substituted for passed string
'             and parsed.  Remaining part of macro put into
'             stack to be executed.
'
     SUB CheckMacro (Strng$,MacroFound) STATIC
     MacroFound = ZFalse
     IF ZMacroExtension$ = "" OR INSTR(Strng$,".") > 0 THEN _
        EXIT SUB
     IF LEN(Strng$) < ZMacroMin THEN _
        ZMacroMin = 1 : _
        EXIT SUB
     IF LEN(Strng$) = 1 THEN _
        Temp$ = UCASE$(Strng$) : _
        IF INSTR(ZAllOpts$,Temp$) > 0 THEN _
           EXIT SUB
     CALL Macro (Strng$,MacroFound)
     END SUB
1325 ' $SUBTITLE: 'Macro - check if macro exists & process'
' $PAGE
'
'  NAME    -- Macro
'
'  INPUTS  -- PARAMETER             MEANING
'             Strng$           STRING TO CHECK IF IS A MACRO
'             ZMacroDrvPath$   DRIVE/PATH WHERE MACROS ARE
'             ZMacroExtension$ EXTENSION OF MACROS
'             MACRO.OFF        FORCE NO MACRO TO BE Found
'
'  OUTPUTS -- MacroFound       WHETHER A MACRO WAS Found
'             Strng$           SUBSTITUTE FOR COMMANDS
'             ZCommPortStack$  REST OF MACRO
'                              0 IF NOT Found
'
'  PURPOSE -- Executes a macro if found.  Does not check if macro
'             letter uses a command.
     SUB Macro (Strng$,MacroFound) STATIC
     MacroFound = ZFalse
     FilName$ = Strng$
     CALL BreakFileName (FilName$,ZWasDFF$,Prefix$,WasX$,ZFalse)
     IF WasX$ = "" THEN _
        FilName$ = Strng$ + ZMacroExtension$
     IF ZWasDFF$ = "" THEN _
        FilName$ = ZMacroDrvPath$ + FilName$
     CALL BadFile (FilName$,ZWasA)
     IF ZWasA > 1 THEN _
        EXIT SUB
     CALL GRAPHICX (FilName$,18)
     IF NOT ZOK THEN _
        EXIT SUB
     CALL ReadDir (18,1)
     IF ZErrCode > 0 THEN _
        EXIT SUB
     CALL CheckInt (ZOutTxt$)
     IF ZErrCode > 0 OR ZUserSecLevel < ZTestedIntValue THEN _
        EXIT SUB
     ZWasA = INSTR(ZOutTxt$,"/")
     IF ZWasA > 0 THEN _    ' Check macro contraint
        WasX$ = RIGHT$(ZOutTxt$,LEN(ZOutTxt$)-ZWasA) : _
        IF RIGHT$(WasX$,1) = "/" THEN _
           IF ZLastCommand$ <> LEFT$(WasX$,LEN(WasX$)-1) THEN _
              EXIT SUB _
           ELSE GOTO 1327 _
        ELSE IF LEFT$(ZLastCommand$,LEN(WasX$)) <> WasX$ THEN _
                EXIT SUB
1327 ZMacroActive = ZTrue
     MacroFound = ZTrue
     ZMacroEcho = ZTrue
     END SUB
1330 ' $SUBTITLE: 'ViewHelp    - Processes requests for help'
' $PAGE
'
'  NAME    -- ViewHelp
'
'  INPUTS  -- PARAMETER             MEANING
'            Section             ORDER OF 1ST COMMAND IN CURRENT
'                                Section
'            GRAPHICS.DEFAULT    WHAT GRAPHICS TYPE USER WANTS
'            HelpDefault$        HELP GET IF PRESS ENTER
'            ZHelpPath$
'            ZHelpExtension$
'            ZBegFile
'            ZBegMain
'            ZBegUtil
'            ZBegLibrary
'
'  OUTPUTS -- DISPLAYS HELP
'
'  PURPOSE -- The main help processor for RBBS.  Puts up the
'             optional menu.  Accepts help with individual commands.
'
     SUB ViewHelp (Section,HelpDefault$) STATIC
     '* "HELP"
     CALL FormatString (1019,ZFalse,ZFalse,0,ZFalse,0,Strng$)
     HelpMenu$ = ZHelpPath$ + Strng$ + ZHelpExtension$
     SotMenu = ZTrue
     IF ZWasQ > 1 THEN _
        ZAnsIndex = 2 : _
        ZLastIndex = ZWasQ: _
        FastHelp = ZTrue : _
        GOTO 1332
1331 IF SotMenu THEN _
        ZFileName$ = HelpMenu$ : _
        GOSUB 1350 : _
        SotMenu = ZFalse
     ZAnsIndex = 1
     '* "{CBDisplay Help for What Command? {CE({CF{G1HELP{G0 for Menu{CE){RC{EX"
     CALL FormatString (267,ZFalse,ZFalse,0,ZFalse,0,ZOutTxt$)
     ZSubParm = 1
     CALL TGet
     IF ZSubParm = -1 THEN _
        EXIT SUB
     IF ZWasQ = 0 THEN _
        EXIT SUB
     ZLastIndex = ZWasQ
1332 ZWasZ$ = UCASE$(ZUserInAra$(ZAnsIndex))
     IF ZWasZ$ = "?" THEN _
        ZWasZ$ = "H"
     CALL BadFile (ZWasZ$,BadFileNameIndex)
     ON BadFileNameIndex GOTO 1333,1340,1340
1333 IF LEN(ZWasZ$) <> 1 THEN _
        GOTO 1335
     CALL SearchCmd (Section,ZFF)
     IF ZFF < 1 THEN _
        ZOK = ZFalse : _
        GOTO 1336
     IF ZFF > LEN(ZAllOpts$) - 11 THEN _
        IF ZFF > LEN(ZAllOpts$) - 7 AND NOT ZSysop THEN _
           ZOK = ZFalse : _
           GOTO 1336 _
        ELSE ZWasZ$ = MID$(ZOrigCommands$,ZFF,1) : _
             GOTO 1335 _
     ELSE WasX = - (ZFF => ZBegMain) - (ZFF => ZBegFile) - (ZFF => ZBegUtil) - (ZFF => ZBegLibrary) : _
          ZWasZ$ = MID$("MFU@",WasX,1) + _
                   MID$(ZOrigCommands$,ZFF,1)
1335 ZFileName$ = ZHelpPath$ + _
                  ZWasZ$ + _
                  ZHelpExtension$
     GOSUB 1350
1336 IF NOT ZOK THEN
        '* "No help for {ZZ"
        CALL FormatString (268,ZFalse,ZTrue,2,ZTrue,1,ZOutTxt$)
        CALL SmartPause (ZFalse)
     END IF
     ZAnsIndex = ZAnsIndex + 1
     IF ZAnsIndex <= ZLastIndex THEN _
        GOTO 1332
     IF FastHelp THEN _
        FastHelp = ZFalse : _
        EXIT SUB
     GOTO 1331
1340 ZOK = ZFalse
     GOTO 1336
1350 CALL GraphicDisplayFile (ZFileName$)
     RETURN
     END SUB
1380 ' $SUBTITLE: 'VIOLATION - handles all security violations'
' $PAGE
'
'  NAME    -- SecViolation
'
'  INPUTS  --     PARAMETER                    MEANING
'
'  PURPOSE -- Inform caller of security violation, augment count of
'             violations and determine whether too many occurred.
'
     SUB SecViolation STATIC
     CALL FlushKeys
     CALL BufFile (ZSecVioHelp$,WasX)
     IF NOT ZOK THEN
        '* "{CE{G4Sorry, {FN, action not permitted!{RC"
        CALL FormatString (269,ZFalse,ZFalse,0,ZTrue,1,"")
        CALL SmartPause (ZFalse)
     END IF
     '* "SV!-"
     CALL FormatString (270,ZFalse,ZFalse,0,ZFalse,0,Strng$)
     CALL UpdtCalr (Strng$ + ZViolation$,2)
     ZLastIndex = 0
     ZViolationsThisSession = ZViolationsThisSession + 1
     IF ZMaxViolations = 0 OR ZViolationsThisSession <= ZMaxViolations THEN _
        EXIT SUB
1385 IF ZUserFileIndex < 1 THEN _
        EXIT SUB
     IF (ZBBSOptions AND 64) > 0 THEN
        '* "{CE{G4Too many security violations!{RC"
        LineNum = 271
     ELSE
        '* "{CE{G4Too many security violations!  Sysop can reinstate you.{RC"
        LineNum = 272
     END IF
     CALL FormatString (LineNum,ZFalse,ZFalse,0,ZFalse,0,ZOutTxt$)
     IF ZUserSecLevel <= ZMinLogonSec THEN
        ZOutTxt$ = ""
        ZUserSecLevel = ZUserSecLevel - 1
     ELSE
        ZUserSecLevel = ZMinLogonSec
     END IF
     ZDenyAccess = ZTrue
     END SUB
1386 ' $SUBTITLE: 'DenyAccess - sub to permanently deny access'
' $PAGE
'
'  NAME    -- DenyAccess
'
'  INPUTS  --     PARAMETER                    MEANING
'
'  OUTPUTS -- (USER'S RECORD)
'
'  PURPOSE -- Permanently resets user's security level when access denied
'
     SUB DenyAccess STATIC
     CALL TPut
     IF (ZBBSOptions AND 64) > 0 THEN
        ZSubParm = -6
        ZDenyAccess = ZFalse
     ELSE
        ZLogonErrorIndex = 5
        ZSubParm = 6
        CALL FileLock
        CALL OpenUser (ZHighestUserRecord)
        FIELD 5, 128 AS ZUserRecord$
        GET 5,ZUserFileIndex
        MID$(ZUserRecord$,47,2) = MKI$(ZUserSecLevel)
        PUT 5,ZUserFileIndex
        ZSubParm = 8
        CALL FileLock
     END IF
     END SUB
1396 ' $SUBTITLE: 'TPut -- common routine to write to comm. port'
' $PAGE
'
'  NAME    -- TPut (TERMINAL PUT)
'
'  INPUTS  --     PARAMETER                    MEANING
'                     ZOutTxt$                 STRING TO WRITE TO THE
'                                              COMMUNICATIONS PORT
'                 ZSubParm = 1           SKIP A LINE BEFORE WRITING
'                                        TO THE COMMUNICATIONS PORT
'                          = 2           SKIP A LINE BEFORE WRITING
'                                        TO THE COMMUNICATIONS PORT
'                                        AND THEN SKIP TWO LINES
'                                        AFTER WRITING TO THE COMM-
'                                        UNICATIONS PORT
'                           = 3          WRITE TO THE COMMUNICATIONS
'                                        PORT AND THEN SKIP TWO LINES
'                           = 4          WRITE TO THE COMMUNICATIONS
'                                        PORT WITHOUT A CR/LF
'                           = 5          WRITE TO THE COMMUNICATIONS
'                                        PORT WITH A CR/LF
'                           = 6          RESET EVERYTHING FOR INPUT STRING
'                           = 7          RE-ENTRY AFTER HANDLING A
'                                        FUNCTION KEY
'
'  OUTPUTS --  ZSubParm = -1 Carrier HAS BEEN DROPPED
'              ZFunctionKey        <>  0 FUNCTION KEY PRESSED
'
'  PURPOSE --  Common output routine for RBBS-PC to the
'              communications port (terminal put)
      SUB TPut STATIC
      IF ZSubParm <> 7 THEN _
         Parm = ZSubParm
      ON ZSubParm GOTO 1398,1399,1400,1403,1405,1450,1411
'
'
' *  COMMON OUTPUT ROUTINE
'
'
1398 CALL SkipLine (1)
     GOTO 1405
1399 CALL SkipLine (1)
1400 ZCR = 1
1403 ZCR = ZCR + 1
1405 ZRet = ZFalse
     IF ZWasCM THEN _
        GOTO 1435
1410 CALL FindFKey
     IF ZSubParm < 0 THEN _
        EXIT SUB
1411 ZWasY$ = ZKeyPressed$
     ZSubParm = Parm
     IF ZLocalUser THEN _
        GOTO 1430
     CALL EofComm (Char)
     IF Char = -1 THEN _
        CALL CheckCarrier : _
        IF ZSubParm = -1 THEN _
           EXIT SUB _
        ELSE GOTO 1430
     CALL GetCom(ZWasY$)
1425 IF ZSubParm = -1 THEN _
        EXIT SUB
1430 IF ZWasY$ = "" THEN _
        GOTO 1435
     ON INSTR(ZInterrupOn$,ZWasY$) GOTO 1434,1434,1473,1475,1433
     GOSUB 1476
     GOTO 1435
1433 GOSUB 1476
     IF ASC(RIGHT$(ZCommPortStack$,2)) = 13 OR _
        ZStopInterrupts THEN _
        GOTO 1435  'stack if series of [ENTER]s or no previous stack
     GOTO 1471
1434 IF ZStopInterrupts THEN _
        GOTO 1435
     ZCommPortStack$ = ""
     IF ZFossil THEN _
        CALL FOSTXPurge(ZComPortNum) : _
        CALL FosRXPurge(ZComPortNum)
     GOTO 1471
1435 LOCATE ,,1
     CALL LPrnt (ZOutTxt$,0)
1437 IF ZUpperCase THEN _
        IF ZWasGR < 2 THEN _
           ZOutTxt$ = UCASE$(ZOutTxt$)
     CALL PutCom (ZOutTxt$)
1450 IF ZCR <> 1 THEN _
        CALL SkipLine (1) _
     ELSE IF ZCR > 1 THEN _
             CALL SkipLine (1)
1470 ZCR = 0
     EXIT SUB
1471 IF ZOutTxt$ <> "" THEN _ ' interrupt the display
        CALL SkipLine (1)
     ZStopInterrupts = ZFalse
     ZRet = ZTrue
     ZNo = ZTrue
     ZNonStop = ZFalse
     GOTO 1470
1473 ZXOffEd = ZTrue
     GOTO 1410
1475 ZXOffEd = ZFalse
     GOTO 1410
1476 IF ASC(ZWasY$) < 127 THEN _
        ZCommPortStack$ = ZCommPortStack$ + ZWasY$
     RETURN
     END SUB
1478 ' $SUBTITLE: 'QuickTPut - subroutine to quickly write to terminal'
' $PAGE
'
'  NAME    -- QuickTPut
'
'  INPUTS  -- PARAMETER             MEANING
'             Strng$             STRING TO WRITE OUT
'             NumReturns         NUMBER OF CARRIAGE RETURNS
'
'  OUTPUTS -- NONE
'
'  PURPOSE -- Subroutine to quickly write to the terminal.  This is
'             different from "TPut" in the things it doesn't do:
'                A.) No function key check,
'                B.) No conversion to upper case,
'                C.) No check for carrier present
'                D.) No check for imbedded carriage return in "Strng$"
'                E.) No support for XON/XOff
'
      SUB QuickTPut (Strng$,NumReturns) STATIC
      IF ZSubParm < 0 THEN _
         EXIT SUB
      IF ZUseTPut THEN _
         ZOutTxt$ = Strng$ : _
         ZSubParm = 4 : _
         CALL TPut : _
         CALL SkipLine (NumReturns) : _
         EXIT SUB
      CALL PutCom (Strng$)
      LOCATE ,,1
      CALL LPrnt (Strng$,0)
      CALL SkipLine (NumReturns)
      END SUB
      SUB QuickTPut1 (Strng$) STATIC
      CALL QuickTPut (Strng$,1)
      END SUB
1480 ' $SUBTITLE: 'LPrnt    - subroutine to write to display'
' $PAGE
'
'  NAME    -- LPrnt
'
'  INPUTS  -- PARAMETER             MEANING
'             Strng$        STRING TO WRITE OUT
'             NumReturns   NUMBER OF CARRIAGE RETURNS
'
'  OUTPUTS -- NONE
'
'  PURPOSE -- Subroutine to write to the display.
'
      SUB LPrnt (Strng$,NumReturns) STATIC
      IF NOT ZSnoop THEN _
         EXIT SUB
      CALL PScrn (Strng$)
      FOR WasI = 1 TO NumReturns
         CALL ANSIPrint (ZCrLf$)
      NEXT
      END SUB
1482 ' $SUBTITLE: 'QuickLPrnt - subroutine to quickly write to display'
' $PAGE
'
'  NAME    -- QuickLPrnt
'
'  INPUTS  -- PARAMETER             MEANING
'             Strng$        STRING TO WRITE OUT
'             Num           NUMBER OF CARRIAGE RETURNS
'
'  OUTPUTS -- NONE
'
'  PURPOSE -- Subroutine to quickly write to the display.
'             Overwrites, and puts up count
      SUB QuickLPrnt (Strng$,Num) STATIC
      IF ZSnoop THEN _
         LOCATE ,1,1 : _
         CALL Pscrn (Strng$ + STR$(Num))
      END SUB
1483 ' $SUBTITLE: 'PScrn    - subroutine to print to the screen'
' $PAGE
'
'  NAME    -- PScrn
'
'  INPUTS  -- PARAMETER             MEANING
'             Strng$        STRING TO WRITE OUT
'
'  OUTPUTS -- NONE
'
'  PURPOSE -- Writes to local screen regardless of whether you have
'             carrier.  Assumes have positioned cursor where you want.
'
      SUB PScrn (Strng$) STATIC
      IF Strng$ = "" THEN _
         EXIT SUB
      CALL ANSIPrint (Strng$)
      END SUB
1485 ' $SUBTITLE: 'SkipLine - sub to write a blank line to user'
' $PAGE
'
'  NAME    -- SkipLine
'
'  INPUTS  --   PARAMETER             MEANING
'               ZLocalUser
'               ZModemStatusReg
'               NumReturns
'               ZReturnLineFeed$
'               ZSnoop
'
'  OUTPUTS -- NONE
'
'  PURPOSE -- Skip lines on the user's terminal
'
      SUB SkipLine (NumReturns) STATIC
      FOR WasI=1 TO NumReturns
          CALL PutCom (ZReturnLineFeed$)
      NEXT
      IF NOT ZSnoop THEN _
         GOTO 1486
      FOR WasI = 1 TO NumReturns
         CALL ANSIPrint (ZCrLf$)
      NEXT
1486  ZLinesPrinted = ZLinesPrinted + NumReturns
      ZUnitCount = ZUnitCount - ZDisplayAsUnit * NumReturns
      END SUB
1496 ' $SUBTITLE: 'SetCrLf -- sub to set up nulls/lf's for output'
' $PAGE
'
'  NAME    -- SetCrLf
'
'  INPUTS  --   PARAMETER          MEANING
'              ZCarriageReturn$    CARRIAGE RETURN CHARACTER
'              ZLineFeed$          LINE FEED CHARACTER
'              ZLineFeeds          LINE FEED Switch
'              ZNul$                NULL CHARACTER
'
'  OUTPUTS -- ZReturnLineFeed$   END-OF-LINE STRING
'
'  PURPOSE -- Set up the necessary nulls/line feeds to end
'             each output to the communications port with.
'
      SUB SetCrLf STATIC
      ZReturnLineFeed$ = _
         MID$(ZCarriageReturn$,1, - (NOT ZLocalUser)) + _
         ZNul$ + _
         MID$(ZLineFeed$,1, - (ZLineFeeds <> 0))
      END SUB
1498 ' $SUBTITLE: 'TGet -- ask a user a question and get reply'
' $PAGE
'
'  NAME    -- TGet
'
'  INPUTS  --    PARAMETER                   MEANING
'                ZSubParm          = 1  STANDARD ENTRY
'                                  = 2  ENTRY AFTER A FUNCTION KEY
'                                         HAS BEEN HANDLED
'                                  = 3  ENTRY AFTER STACKED COMMAND
'             ZOutTxt$                        STRING TO WRITE TO THE
'                                       COMMUNICATIONS PORT
'             ZHidden                    IF THIS IS TRUE THEN ECHO
'                                       '.' INSTEAD OF ACTUAL
'                                       CHARACTER ENTERED.
'             ZForceKeyboard            IF TRUE, STACKED INPUT
'                                       IS BYPASSED AND KEYBOARD
'                                       INPUT IS READ.
'
'  OUTPUTS -- ZSubParm = -1 Carrier HAS BEEN DROPPED
'             ZUserIn$                  STRING THAT WAS ENTERED
'             ZWasQ                     NUMBER OF PARAMETERES THAT
'                                       WERE ENTERED WHICH WHERE
'                                       SEPARATED BY A SEMICOLON
'             ZUserInAra$()                STRING MATRIX WITH EACH
'                                       ITEM CONTAIN THE STRING
'                                       THAT WAS ENTERED BETWEEN
'                                       SEMICOLONS.
'             ZFunctionKey        <>  0 FUNCTION KEY PRESSED
'             ZYes                      Reply IS "Y" OR "YES"
'             ZNo                       Reply IS "N" OR "NO"
'             ZNonStop                  Reply IS "NS" OR "ns"
'             ZKillMessage              Reply IS "K"
'             ZReply                    Reply IS "RE"
'
'  SUBROUTINE PURPOSE --  COMMON ROUTINE TO ASK A USER A QUESTION
'
     SUB TGet STATIC
     MacroIndex = ZForceKeyboard
     ON ZSubParm GOTO 1500,1538,1625
'
'
' *  COMMON INPUT ROUTINE
'
'
1500 CALL CheckCarrier
     IF ZSubParm = -1 THEN _
        EXIT SUB
     ZLinesPrinted = 0
     ZDisplayAsUnit = ZFalse
     InStack = ZFalse
     GOSUB 1580
     ZWasA = 0
     ZWasB = 0
     ZWasC = 0
     ZWasQ = 1
     ZStoreParseAt = 1
     ZYes = ZFalse
     ZUserIn$ = ""
     SleepWarn = ZTrue
     ZNo = ZFalse
     ZNonStop = (ZPageLength < 1)
     IF ZOutTxt$ = "" THEN _
        GOTO 1525
     IF ZHidden THEN
        '* "{SP(*'s echo)"
        CALL FormatString (273,ZFalse,ZFalse,0,ZFalse,0,Strng$)
        ZOutTxt$ = ZOutTxt$ + Strng$
     END IF
     '* "*"
     CALL FormatString (274,ZFalse,ZFalse,0,ZFalse,0,HiddenChar$)
     IF (NOT ZVerifying) OR HoldA$ = "" THEN _
        CALL ColorPrompt (ZOutTxt$) : _
        ZOutTxt$ = ZOutTxt$ + _
             MID$("? !  ",2*ZTurboKey+1,2) : _
        HoldA$ = ZOutTxt$ _
     ELSE ZOutTxt$ = HoldA$
     ZSubParm = 4
     StopSave = ZStopInterrupts
     ZStopInterrupts = ZTrue
     CALL TPut
     ZStopInterrupts = StopSave
     IF ZSubParm = -1 OR ZFunctionKey <> 0 THEN _
        EXIT SUB
1523 IF ZPromptBell THEN _
        IF ZLocalUser THEN _
           BEEP _
        ELSE CALL PutCom(ZBellRinger$)
1525 CALL CheckCarrier
     IF ZSubParm = -1 THEN _
        EXIT SUB
     IF LEN(ZCommPortStack$) > 0 THEN _
        InStack = ZTrue : _
        WasX = INSTR(ZCommPortStack$,ZCarriageReturn$) : _
        IF WasX > 0 THEN _
           ZOutTxt$ = LEFT$(ZCommPortStack$,WasX-1) : _
           ZCommPortStack$ = RIGHT$(ZCommPortStack$,LEN(ZCommPortStack$)-WasX) : _
           GOTO 1534 _
        ELSE ZWasY$ = LEFT$(ZCommPortStack$,1) : _
             ZCommPortStack$ = RIGHT$(ZCommPortStack$,LEN(ZCommPortStack$)-1) : _
             GOTO 1541
     IF (ZForceKeyboard OR (NOT ZMacroActive) OR (ZMacroSave > 0)) THEN _
        GOTO 1536
'
' *** MACRO PROCESSING
'
1526 CALL ReadMacro
     IF ZMacroSave > 0 THEN _
        GOTO 1500
     IF NOT ZMacroActive THEN _
        ZWasQ = 0 : _
        ZLastIndex = 0 : _
        EXIT SUB
     IF (ZDistantTGet > 0 ) OR (ZMacroTemplate$ <> "") THEN _
        GOTO 1536
1534 ZUserIn$ = ZOutTxt$   ' Not Macro command - pass to normal processing
' * strip off leading slash when not in turbokey mode so macros can be
' * written to work in both turbo and non-turbo-key mode
     IF LEFT$(ZUserIn$,1) = "/" AND NOT ZTurboKeyUser THEN _
        ZUserIn$ = RIGHT$(ZUserIn$,LEN(ZUserIn$)-1) : _
        ZTurboKey = ZFalse
     IF ZMacroEcho THEN _
        ZSubParm = 4 : _
        CALL TPut
     WasX$ = ZCarriageReturn$
     GOTO 1547
1536 IF ZLocalUser THEN _
        GOTO 1537
     CALL EofComm (Char)
     IF Char <> -1 THEN _
        CALL GetCom(ZWasY$) : _
        IF ZSubParm = -1 THEN _
           EXIT SUB _
        ELSE GOTO 1541
1537 CALL CheckTime(ZAutoLogoff!, TempElapsed!, 3)
     IF TempElapsed! < 30 THEN
        IF TempElapsed! <= 0 THEN
           CALL SkipLine (1)
           ZSubParm = -1
           ZNo = ZTrue
           ZRet = ZTrue
           ZSleepDisconnect = NOT ZAutoLogoffReq
           IF ZAutoLogoffReq OR (ZAutoEnd = 1 AND ZDnldCompleted) THEN
              '* "Auto-logoff"
              CALL FormatString (230,ZFalse,ZTrue,1,ZFalse,0,"")
              EXIT SUB
           ELSE
              '* "Sleep disconnect"
              CALL FormatString (201,ZFalse,ZTrue,1,ZFalse,0,"")
              EXIT SUB
           END IF
        ELSEIF SleepWarn THEN
           SleepWarn = ZFalse
           Temp! = TempElapsed!
           CALL SkipLine (2)
           '* "{CF{G2Auto-Logoff Counter Active!{RC"
           CALL FormatString (275,ZFalse,ZFalse,0,ZTrue,0,"")
           ZOutTxt$ = ""
           CALL RingCaller
           '* "{CFPress {CE{G1 ENTER {CF{G0to Abort!    {RC"
           CALL FormatString (276,ZFalse,ZFalse,0,ZTrue,0,"")
        ELSEIF Temp! - TempElapsed! > 1.0 THEN
                     CALL QuickTPut (ZBackSpace$+ZBackSpace$,0)
                     CALL QuickTPut (ZFGE$ + ZBG4$ + _
                                     RIGHT$(STR$(CINT(TempElapsed!)),2) + _
                                     ZFG7$ + ZBG0$,0)
                     Temp! = TempElapsed!
        END IF
     END IF
     CALL FindFKey
     IF ZSubParm < 0 THEN _
        EXIT SUB
1538 ZWasY$ = ZKeyPressed$
     IF ZWasY$ <> "" THEN _
        GOTO 1545
     SendRemote = ZTrue
     CALL GiveBack
     GOTO 1525
1541 SendRemote = ZRemoteEcho
     IF ZTestParity THEN _
        GOTO 1542
     IF ZWasY$ = CHR$(127) THEN _
        GOTO 1635
     GOTO 1545
1542 IF ZWasY$ = "" THEN _
        ZWasY$ = SPACE$(1)
     IF ASC(ZWasY$) = 141 THEN _
        OUT ZLineCntlReg,&H1A : _
        ZEightBit = ZFalse : _
        ZTestParity = ZFalse : _
        ZWasGR = ZFalse
     ZWasY$ = CHR$(ASC(ZWasY$) AND 127)
1545 WasX$ = ZWasY$
     ZAutoLogoffReq = ZFalse
     IF INSTR(ZLineEditChk$,ZWasY$) > 5 _
        GOTO 1635
     IF ZWasY$ < SPACE$(1) AND ZWasY$ <> ZCarriageReturn$ THEN _
        GOTO 1525
     IF ZWasY$ = "^" THEN _
        GOTO 1525
     IF ZWasY$ = ZCarriageReturn$ THEN _
        GOTO 1547 _
     ELSE GOSUB 1550
     IF ZTurboKey < 1 THEN _
        GOTO 1546
     IF ZWasY$ = SPACE$(1) THEN _
        ZWasY$ = ""
     IF ZWasY$ <> "/" THEN _
        ZUserIn$ = ZWasY$ : _
        ZWasY$ = ZCarriageReturn$ : _
        WasX$ = ZWasY$ : _
        GOTO 1547
     ZTurboKey = 0
     GOTO 1525
1546 IF LEN(ZUserIn$) => 512 THEN
        '* "Input too long!"
        CALL FormatString (277,ZFalse,ZFalse,0,ZFalse,0,ZOutTxt$)
        ZSubParm = 5
        CALL TPut
        ZWasY$ = ZCarriageReturn$
        WasX$ = ZWasY$
        GOTO 1547
     END IF
     ZUserIn$ = ZUserIn$ + _
          ZWasY$
     GOTO 1525
1547 ZTurboKey = ZFalse          ' Carriage Return Handler
     ZHidden = ZFalse
     IF ZNoAdvance THEN _
        ZNoAdvance = ZFalse : _
        GOTO 1575 _
     ELSE CALL LPrnt (ZCrLf$,0) : _
          GOSUB 1551 : _
          GOTO 1570
1549 IF INSTR(ZUserIn$,";") > 0 THEN _
        CALL ExcludeCount (";",ZUserIn$,Temp) _
     ELSE IF INSTR(ZUserIn$,SPACE$(1)) > 0 THEN _
        CALL ExcludeCount (SPACE$(1),ZUserIn$,Temp) _
     ELSE Temp = 0
     RETURN
1550 IF ZLogonActive THEN _
        GOSUB 1549 : _
        ZHidden = (Temp = 2 - (ZLenIndiv > 0 AND ZStartIndiv > 0))
     IF ZHidden THEN _
        IF (WasX$ <> SPACE$(1) AND WasX$ <> ";") THEN _
           WasX$ = HiddenChar$
     CALL LPrnt(WasX$,0)
     GOTO 1551
     IF ZHidden AND (WasX$ <> SPACE$(1)) THEN _
        WasX$ = HiddenChar$
     CALL LPrnt(WasX$,0)
1551 IF NOT SendRemote THEN _
        RETURN
     IF ZHidden AND (WasX$ <> SPACE$(1)) THEN _
        WasX$ = HiddenChar$
1553 CALL PutCom (WasX$)
     RETURN
1570 IF SendRemote THEN _
        IF ZLineFeeds THEN _
           CALL PutCom (ZLineFeed$)
1575 IF LEN(ZUserIn$) > 4000 THEN
        '* "TOO LONG!  Try again, {FN!"
        CALL FormatString (278,ZFalse,ZFalse,0,ZFalse,0,ZOutTxt$)
        ZSubParm = 5
        CALL TPut
        IF ZSubParm = -1 OR ZFunctionKey <> 0 THEN
           EXIT SUB
        ELSE
           GOTO 1500
        END IF
     END IF
     IF ZParseOff THEN _
        ZParseOff = ZFalse : _
        GOTO 1620
     CALL ParseIt
     IF ZWasQ = 1 THEN _
        GOTO 1622
     GOTO 1625
1580 ZAutoLogoff! = TIMER + ZWaitBeforeDisconnect
     IF ZAutoLogoffReq OR ZWaitExpired THEN _
        ZWaitExpired = ZFalse : _
        IF NOT ZSuspendAutologoff THEN _
           ZAutoLogoff! = TIMER + 15
     RETURN
1620 ZUserInAra$(ZStoreParseAt) = ZUserIn$
     ZWasQ = 1
1622 IF ZUserIn$ = "" THEN _
        ZWasQ = 0 : _
        ZHidden = ZFalse : _
        GOTO 1628
1625 IF LEN(ZUserIn$) < 4 THEN
        WasX$ = UCASE$(LEFT$(ZUserIn$,3))
        ZYes = (INSTR("YES",WasX$) = 1)
        ZNo = (INSTR("NO",WasX$) = 1 OR WasX$ = "A" OR WasX$ = "Q")
        ZReply = (WasX$ = "RE") OR ZReply
        ZKillMessage = (WasX$ = "K") OR ZKillMessage
     END IF
     ZHidden = ZFalse
1628 CALL VerifyAns
     IF NOT ZOK THEN
        '* "Invalid answer <{Z1>"
        CALL FormatString (279,ZFalse,ZFalse,0,ZTrue,1,"")
        GOTO 1500
     END IF
     HoldA$ = ""
     ZForceKeyboard = ZFalse
     IF ZMacroSave > 0 THEN _
        ZGSRAra$(ZMacroSave) = ZUserIn$ : _
        ZMacroSave = 0 : _
        GOTO 1632
     IF (ZDistantTGet > 0) OR (ZMacroTemplate$ <> "") THEN _
        CALL WipeLine (38) : _
        IF NOT ZNo THEN _
           GOTO 1632 _
        ELSE ZWasQ = 0 : _
             ZMacroTemplate$ = "" : _
             ZDistantTGet = 0 : _
             ZNo = ZFalse : _
             GOTO 1633
     IF ZMacroActive THEN _
        ZLastIndex = ZWasQ : _
        FirstIndex = 1: _
        ZMacroActive = NOT EOF(18) : _
        EXIT SUB
     IF ZAnsIndex > 255 OR ((NOT InStack) AND INSTR(ZUserIn$,".") > 0) THEN _
        EXIT SUB
     IF MacroIndex OR ZSubParm < 3 THEN _
        MacroIndex = 1 _
     ELSE MacroIndex = ZAnsIndex
     CALL NoPath (ZUserInAra$(MacroIndex),Found)
     IF Found THEN _
        EXIT SUB
     CALL CheckMacro (ZUserInAra$(MacroIndex),Found)
     IF Found THEN _
        ZStoreParseAt = ZAnsIndex : _
        GOTO 1525
     EXIT SUB
1632 ZUserIn$ = ""
     ZForceKeyboard = ZFalse
1633 GOSUB 1580
     ZWasQ = 1
     GOTO 1525
1635 IF LEN(ZUserIn$) = 0 THEN _
        GOTO 1525
     ZUserIn$ = LEFT$(ZUserIn$,LEN(ZUserIn$)-1)
     CALL LPrnt(ZLocalBksp$,0)
     IF SendRemote THEN _
        CALL PutCom(ZBackSpace$)
     GOTO 1525
     END SUB
1636 ' $SUBTITLE: 'RingCaller - sub to use sound + screen emphasis'
' $PAGE
'
'  NAME    -- RingCaller
'
'  INPUTS  --     PARAMETER                    MEANING
'                 ZOutTxt$                           STRING TO EMPHASIZE
'
'  OUTPUTS --  none
'
'  PURPOSE --  Rings the users bell before and after string
'              (but not snooping sysop) and adds emphasis around
'              message sent.
'
     SUB RingCaller STATIC
     WasX$ = LEFT$(ZBellRinger$,-ZLocalUser)
     CALL PutCom (ZBellRinger$)
     CALL LPrnt (WasX$,0)
     ZSubParm = 2
     ZOutTxt$ = ZEmphasizeOn$ + ZOutTxt$ + ZEmphasizeOff$
     CALL TPut
     CALL PutCom (ZBellRinger$)
     CALL LPrnt (WasX$,0)
     END SUB
1637 ' $SUBTITLE: 'ParseIt - subroutine to parse a string'
' $PAGE
'
'  NAME    -- ParseIt
'
'  INPUTS  --     PARAMETER              MEANING
'                 ZUserIn$             STRING TO PARSE
'                 ZSemiOnly            Only parse using semi-colon
'
'  OUTPUTS --  ZWasQ                   NUMBER PARSED
'              ZUserInAra$()              PARSED STRINGS
'
'  PURPOSE --  To parse a string into pieces.  Uses semicolon
'              if exists, otherwise space, otherwise comma
'
     SUB ParseIt STATIC
     ZWasA = INSTR(ZUserIn$,";")
     IF ZWasA > 0 THEN _
        ParseChar$ = ";" _
     ELSE IF ZSemiOnly THEN _
             ZSemiOnly = ZFalse : _
             GOTO 1638 _
          ELSE IF ZUserIn$ <> SPACE$(LEN(ZUserIn$)) THEN _
             CALL Trim (ZUserIn$) : _
             WasX$ = ZUserIn$ : _
             ZWasA = INSTR(ZUserIn$,SPACE$(2)) : _
             WHILE ZWasA > 0 : _
                ZUserIn$ = LEFT$(ZUserIn$,ZWasA - 1) + _
                     MID$(ZUserIn$,ZWasA + 1) : _
                ZWasA = INSTR(ZWasA,ZUserIn$,SPACE$(2)) : _
             WEND : _
             ZWasA = INSTR(ZUserIn$,SPACE$(1)) : _
             IF ZWasA > 1 THEN _
                ParseChar$ = SPACE$(1) _
             ELSE ZWasA = INSTR(ZUserIn$,",") : _
                  ParseChar$ = ","
     IF ZWasA > 1 THEN _
        GOTO 1639
1638 ZWasDFF$ = UCASE$(ZUserIn$)
     IF ZWasDFF$ = "NS" THEN _
         ZUserIn$ = "C" : _
         ZNonStop = ZTrue
     ZUserInAra$(ZStoreParseAt) = ZUserIn$
     ZNonStop = ZNonStop OR (ZWasDFF$ = "C" AND NOT ZStackC)
     IF ZAutoEnd = 3 THEN _
        ZNonStop = ZFalse
     GOTO 1642
1639 ZUserInAra$(ZStoreParseAt) = LEFT$(ZUserIn$,ZWasA - 1)
     ZWasA = ZWasA + 1
     ZEOL = ZFalse
1640 ZWasB = INSTR(ZWasA,ZUserIn$,ParseChar$)
     ZWasC = ZWasB-ZWasA
     IF ZWasC < 1 THEN _
        ZEOL = ZTrue : _
        ZWasC = 128
     ZWasDFF$ = MID$(ZUserIn$,ZWasA,ZWasC)
     IF ZWasDFF$ = "" THEN GOTO 1641
        ZWasQ = ZWasQ + 1
        ZStoreParseAt = ZStoreParseAt + 1
        ZUserInAra$(ZStoreParseAt) = ZWasDFF$
        ZWasDFF$ = UCASE$(ZWasDFF$)
        WasX = INSTR(";NS;/G;C;",";"+ZWasDFF$+";")
        IF WasX = 0 THEN GOTO 1641
           ZNonStop = ZNonStop OR (WasX = 1) OR (WasX = 7 AND NOT ZStackC)
     IF ZStoreParseAt > 1 THEN IF INSTR("Jj",ZUserInAra$(ZStoreParseAt-1)) THEN _
        ZNonStop = (ZPageLength < 1)
     IF ZAutoEnd = 3 THEN _
        ZNonStop = ZFalse
     ZAutoLogoffReq = ZAutoLogoffReq OR (WasX = 4)
     IF ZAutoLogoffReq THEN
        IF INSTR(UCASE$(ZUserIn$)," F D ") OR _
           INSTR(UCASE$(ZUserIn$),",F,D,") OR _
           INSTR(UCASE$(ZUserIn$),";F;D;") OR _
           ZMenuIndex = 3 THEN
           '* "{C9Automatic LogOff if {CBTRANSFER {C9Successful{RC"
           LineNum = 532
        ELSE
           '* "{C9Automatic LogOff if {CBDOOR {C9Successful{RC"
           LineNum = 953
        END IF
        IF ZFileSysParm > 0 THEN
           '* "{C9Automatic LogOff if {CBTRANSFER {C9Successful{RC"
           LineNum = 532
        END IF
        CALL FormatString (LineNum,ZFalse,ZFalse,0,ZTrue,1,"")
     END IF
           IF ZWasQ > 0 AND WasX < 7 THEN _
              ZWasQ = ZWasQ - 1 : _
              ZStoreParseAt = ZStoreParseAt - 1
1641 IF NOT ZEOL AND ZWasQ < 50 THEN _
        ZWasA = ZWasB + 1 : _
        GOTO 1640
     IF ParseChar$ <> ";" THEN _
        ZUserIn$ = WasX$
1642 ZStackC = ZFalse
     END SUB
1650 ' $SUBTITLE: 'PopCmdStack - prompt for value with command stack check'
     SUB PopCmdStack STATIC
     CALL CheckCarrier
     IF ZSubParm = -1 THEN _
        ZLastIndex = 0 : _
        ZWasQ = 0 : _
        EXIT SUB
     ZWasQ = 1
1651 IF ZAnsIndex < ZLastIndex THEN _
        ZAnsIndex = ZAnsIndex + 1 : _
        ZUserIn$ = ZUserInAra$(ZAnsIndex) : _
        IF MID$(ZLastCommand$,2,1) <> SPACE$(1) AND (NOT ZStackC) AND ZAnsIndex > 1 AND INSTR("Cc",ZUserIn$) > 0 AND LEN(ZUserIn$) = 1 THEN _
           GOTO 1651 _
        ELSE ZSubParm = 3 : _
             ZTurboKey = 0 : _
             CALL TGet : _
             GOTO 1652
     ZLastIndex = 0
     ZAnsIndex = 1
     ZSubParm = 1
     ZSearchingAll = ZFalse
     CALL TGet
     ZLastIndex = ZWasQ
1652 IF ZStoreParseAt > ZLastIndex THEN _
        IF ZLastIndex > 0 THEN _
           ZLastIndex = ZStoreParseAt
     ZStackC = ZFalse
     ZParseOff = ZFalse
     END SUB
1654 ' $SUBTITLE: 'SetBaud - sub to set the baud rate in the RS232'
' $PAGE
'
'  NAME    -- SetBaud
'
'  INPUTS  --     PARAMETER                    MEANING
'             ZBaudRateDivisor   NUMBER TO DIVIDE THE 8250 CHIP'S
'                                 PROGRAMABLE CLOCK TO ADJUST THE
'                                 BAUD RATE TO THE USER'S BAUD
'                                 RATE (INDEPENDENT OF THE BAUD
'                                 RATE USED TO OPEN THE COMM. PORT)
'
'        DESIRED BAUD        DIVISIOR (DECIMAL) TO OBTAIN DESIRED BAUD RATE
'            RATE              PCjr         PC AND XT
'              50             2237             2304
'              75             1491             1536
'             110             1017             1047
'             134.5            832              857
'             150              746              768
'             300              373              384
'             600              186              192
'            1200               93               96
'            1800               62               64
'            2000               56               58
'            2400               47               48
'            3600               31               32
'            4800               23               24
'            7200          not available         16
'            9600          not available         12
'           12000          not available         10
'           14400          not available          8
'           16800          not available          7
'           19200          not available          6
'           21600          not available          5 (closest to 5.333)
'           24000          not available          5
'           26400          not available          4
'           28800          not available          4
'           38400          not available          3
'           57600          not available          2
'  OUTPUTS -- BAUD RATE SET IN THE RS232 INTERFACE
'
'  PURPOSE -- To set the baud rate in the RS232 interface
'             inpependent of the baud rate the communications port
'             was opened at
'
      SUB SetBaud STATIC
     IF ZCBaud$ = "" THEN _
        ZCBaud$ = MID$(ZBaudRates$,(-7 * ZBPS),7) : _
        CALL Trim (ZCBaud$)
     Temp! = VAL(ZCBaud$)
     IF Temp! > 0 THEN CALL SetBPS (Temp!,ZCBPS)
     IF (ZCBPS = 0 OR Temp! = 0) THEN ZCBPS = ZBPS
     IF NOT ZKeepInitBaud THEN _
        ZTalkToModemAt$ =  MID$(ZBaudRates$,(-7 * ZBPS),7) _
     ELSE ZTalkToModemAt$ = ZModemInitBaud$
     CALL Trim (ZTalkToModemAt$)
     IF LEN(ZTalkToModemAt$) < 6 THEN _
        ZTalkToModemAt$ = SPACE$(5 - LEN(ZTalkToModemAt$)) + _
                            ZTalkToModemAt$
     IF ZEightBit THEN _
        Parity = 2 : _                                    ' No PARITY
        DataBits = 3 : _                                  ' 8 DATA BITS
        StopBits = 0 _                                    ' 1 STOP BIT
     ELSE Parity = 3 : _                                  ' EVEN PARITY
          DataBits = 2 : _                                ' 7 DATA BITS
          StopBits = 0                                    ' 1 STOP BIT
     ComSpeed! = VAL(ZTalkToModemAt$)
     IF ZFossil THEN _
        CALL FosSpeed(ZComPortNum,ComSpeed!,Parity,DataBits,StopBits) : _
        EXIT SUB
     ZBaudRateDivisor = INT(115200! / ComSpeed! +.5)
     MostSignifByte = FIX (ZBaudRateDivisor / 256)
     LeastSignifByte = ZBaudRateDivisor - (MostSignifByte * 256)
     LineCntlStatus = INP(ZLineCntlReg)
     MSBSave = INP(ZMSB)
     OUT ZMSB,0
     OUT ZLineCntlReg,LineCntlStatus OR 128
     OUT ZLSB,LeastSignifByte
     OUT ZMSB,MostSignifByte
     OUT ZLineCntlReg,LineCntlStatus
     OUT ZMSB,MSBSave
     END SUB
2018 ' $SUBTITLE: 'SetWhoTo - subroutine to get who a msg/upload is to'
' $PAGE
'
'  NAME    -- SetWhoTo
'
'  INPUTS  --     PARAMETER                    MEANING
'              HighestUserRecord
'
'  OUTPUTS --  MsgTo$              Who message is to
'              RcvrRecNum         User record # of who to
'
'  PURPOSE --  Asks who a message/upload is to and checks if receiver exists
'
     SUB SetWhoTo (EnableCC,MsgTo$,MsgFrom$,RcvrRecNum,Found,AllowPub) STATIC ' KG012502
     Temp$ = MsgFrom$
     CALL Trim (Temp$)
     ZNumHeaders = 0
     CALL KillWork (ZNodeWorkFile$)
2020 IF MsgTo$ <> "" THEN _
        GOTO 2032
2021 IF AllowPub AND EnableCC THEN
        '* "{RCTo [A]ll, (S)ysop, D)istribution, or Full or Partial Name"
        LineNum = 280
     ELSEIF AllowPub AND NOT EnableCC THEN
        '* "{RCTo [A]ll, (S)ysop, or Full or Partial Name"
        LineNum = 281
     ELSEIF NOT AllowPub AND EnableCC THEN
        '* "{RCTo (S)ysop, D)istribution, or Full or Partial Name"
        LineNum = 282
     ELSE
        '* "{RCTo (S)ysop or Full or Partial Name"
        LineNum = 283
     END IF
     CALL FormatString (LineNum,ZFalse,ZFalse,0,ZFalse,0,ZOutTxt$)
     ZSemiOnly = ZTrue
     CALL PopCmdStack
     IF ZSubParm < 0 THEN _
        GOTO 2035
     IF NOT ZSysop THEN _
        CALL SmartText(ZUserIn$,ZFalse,ZFalse,ZFalse)
     IF LEN(ZUserInAra$(ZAnsIndex)) > 30 THEN
        '* "{CF{G430 Chars max{RC"
        CALL FormatString (141,ZFalse,ZFalse,0,ZTrue,1,"")
        GOTO 2021
     END IF
     Found = ZTrue
     '* "ALL"
     CALL FormatString (1000,ZFalse,ZFalse,0,ZFalse,0,ALLStr$)
     IF ZWasQ = 0 THEN
        MsgTo$ = ALLStr$
        GOTO 2032
     ELSE
        ZWasDFF$ = ZUserInAra$(ZAnsIndex)
        CALL Trim(ZWasDFF$)
        IF ZWasDFF$ = "" THEN
           MsgTo$ = ALLStr$
           GOTO 2032
        END IF
        CALL Remove (ZWasDFF$,",")
        ZWasDFF$ = UCASE$(ZWasDFF$)
        CALL Trim (ZWasDFF$)
        ZUserInAra$(ZAnsIndex) = ZWasDFF$
        MsgTo$ = ZWasDFF$
        IF ZWasDFF$ = "A" AND AllowPub THEN
           MsgTo$ = ALLStr$
        ELSEIF ZWasDFF$ = "S" THEN
           MsgTo$ = ZSysopFullName$
        ELSEIF ZWasDFF$ = "D" AND EnableCC THEN
           GOTO 2025
        ELSE
           IF ZAnsIndex < ZLastIndex THEN
              ZAnsIndex = ZAnsIndex + 1
              MsgTo$ = ZWasDFF$ + " " + UCASE$(ZUserInAra$(ZAnsIndex))
           ELSE
              MsgTo$ = ZWasDFF$
           END IF
        END IF
     END IF
     GOTO 2032
2022 IF NOT ZExpertUser THEN
        GOTO 2025
     END IF
2024 ZFileName$ = ZHelpPath$ + ZDistriHelp$ + ZHelpExtension$
     CALL BufFile (ZFileName$,WasX)
2025 '* "Use what distribution list (H)elp)"
     CALL FormatString (284,ZFalse,ZFalse,0,ZFalse,0,ZOutTxt$)
     CALL PopCmdStack
     IF ZWasQ = 0 THEN
        GOTO 2021
     END IF
     ZFileName$ = UCASE$(ZUserInAra$(ZAnsIndex))
     IF INSTR("?H",ZFileName$) > 0 THEN
        GOTO 2024
     END IF
     CALL BadFile (ZFileName$,BadFileNameIndex)
     ON BadFileNameIndex GOTO 2026,2025,2025
2026 ZFileName$ = ZDistriPath$ + ZFileName$ + ".LST"
     CALL FindItX (ZFileName$,7)
     IF NOT ZOK THEN
        '* "{ZU not found"
        CALL FormatString (285,ZFalse,ZFalse,0,ZTrue,1,"")
        ZMplPersUpload = ZFalse
        GOTO 2024
     END IF
     ZNumHeaders = 0
     ZMplPersUpload = ZTrue
     CALL OpenWorkA (2,ZNodeWorkFile$)
     WHILE NOT EOF(7)
        CALL ReadDir (7,1)
        ZOutTxt$ = UCASE$(ZOutTxt$)
        ZWasDFF$ = ZOutTxt$
        CALL WhoCheck (ZOutTxt$, Found, RcvrRecNum)
        ZNumHeaders = ZNumHeaders + 1
        CALL PrintWorkA (2,ZWasDFF$ + "," + STR$(-RcvrRecNum*Found))
     WEND
     GOTO 2035
2032 RcvrRecNum = 0
     ZMplPersUpload = ZFalse
     IF ZNewUser THEN
        GOTO 2033
     END IF
     '* "ALL"
     CALL FormatString (1000,ZFalse,ZFalse,0,ZFalse,0,ALLStr$)
     IF MsgTo$ <> ALLStr$ OR NOT AllowPub THEN
        IF ((LEFT$(MsgTo$,4) <> ALLStr$ + SPACE$(1) OR NOT AllowPub) AND ZStartHash = 1) THEN
           CALL CheckInt (MsgTo$)
           IF ZTestedIntValue = 0 OR ZUserSecLevel < ZSysOpSecLevel OR _
              (ZUserSecLevel >= ZSysOpSecLevel AND ZFileSysParm < 1) THEN
              ZWasDF = INSTR(MsgTo$+" @"," @")
              TempHashValue$ = LEFT$(MsgTo$,ZWasDF-1)
              ZMplPersUpload = ZTrue
              CALL WhoCheck (TempHashValue$,Found,RcvrRecNum)
              IF NOT Found THEN
                 IF ZExtendedConfMail THEN
                    CALL FindIt (ZConfMailList$)
                    IF ZOK THEN
                       DO
                          CALL ReadParms (ZWorkAra$(),10,1)
                          IF MID$(ZConfName$,1,LEN(ZWorkAra$(2))) = ZWorkAra$(2) THEN
                             IF ZWorkAra$(7) = "Y" THEN
                                Found = ZTrue
                             ELSE
                                EXIT DO
                             END IF
                          END IF
                       LOOP WHILE NOT EOF(2) AND (NOT Found)
                    END IF
                 ELSE
                    CALL BreakFileName (ZActiveMessageFile$, _
                                        Pre$,Body$,Ext$,ZTrue)
                    CALL WordInFile ("ECHOCONF.DEF",Body$+Ext$,Found,ZTrue)
                 END IF
              END IF
              IF NOT Found THEN
                 CALL QuickPeek (ZUserInAra$(ZAnsIndex),MsgTo$,Found,ZFalse)
                 CALL AliasChk (MsgTo$,Found,UserNumFound)
              END IF
              IF NOT Found THEN
                 ZLastIndex = 0
                 RcvrRecNum = 0
                 IF ZReply THEN
                    CALL SkipLine (1)
                 END IF
                 ' * "{SPis not a local user on {BN!"
                 CALL FormatString (286,ZFalse,ZFalse,0,ZFalse,0,Strng$)
                 CALL QuickTPut1 (MsgTo$ + Strng$)
                 IF NOT ZReply THEN
                    '* "Send anyway? ([Y],N)"
                    CALL FormatString (287,ZFalse,ZFalse,0,ZFalse,0,ZOutTxt$)
                    ZTurboKey = -ZTurboKeyUser
                    ZLastIndex = 0
                    GOSUB 2040
                    IF ZNo THEN
                       ZMplPersUpload = ZFalse
                       IF ZNumHeaders = 0 THEN
                          MsgTo$ = ""
                          EXIT SUB
                       ELSE
                          GOTO 2034
                       END IF
                    END IF
                 ELSE
                    CALL SmartPause (ZTrue)
                 END IF
              ELSEIF ZFileSysParm > 0 THEN
                 CALL WhoCheck (MsgTo$,Found,RcvrRecNum)
                 IF NOT Found THEN
                    MsgTo$ = ""
                    EXIT SUB
                 END IF
              END IF
           END IF
        END IF
     END IF
     CALL CheckInt (MsgTo$)
     IF ZTestedIntValue > 1 AND ZUserSecLevel >= ZSysOpSecLevel THEN
        ZMplPersUpload = ZTrue
     END IF
     IF MsgTo$ = Temp$ THEN
        '* "Really send this to Yourself? (Y,[N])"
        CALL FormatString (288,ZFalse,ZFalse,0,ZFalse,0,ZOutTxt$)
        ZLastIndex = 0
        GOSUB 2040
        IF NOT ZYes THEN
           MsgTo$ = ""
        END IF
     END IF
2033 CALL OpenWorkA (2,ZNodeWorkFile$)
     CALL PrintWorkA (2,MsgTo$ + "," + STR$(RcvrRecNum))
     CLOSE 2
     ZNumHeaders = ZNumHeaders + 1

2034 IF EnableCC AND (NOT ZReply) AND (NOT ZNewUser) AND MsgTo$ <> ALLStr$ AND _
        MsgTo$ <> "" AND LEFT$(MsgTo$,4) <> ALLStr$ + SPACE$(1) AND _
        (NOT ZSysopComment) AND (NOT ZSysopMsg) THEN
        '* "Send Carbon copies to other users? (Y,[N])"
        CALL FormatString (289,ZFalse,ZFalse,0,ZFalse,0,ZOutTxt$)
        CALL PopCmdStack
        IF ZYes THEN
           GOTO 2021
        END IF
     END IF
     IF ZNewUser THEN
        EXIT SUB
     END IF
2035 IF ZNumHeaders < 1 THEN
        MsgTo$ = ""
     ELSEIF ZNumHeaders > 1 THEN
        '* "(list)"
        CALL FormatString (1020,ZFalse,ZFalse,0,ZFalse,0,MsgTo$)
     END IF
     EXIT SUB
2040 ZSubParm = 1
     CALL TGet
     IF ZSubParm < 0 THEN _
        EXIT SUB
     RETURN
     END SUB
2055 ' $SUBTITLE: 'MsgProt - gets protection wanted for a message'
' $PAGE
'
'  NAME    -- MsgProt
'
'  INPUTS  --     PARAMETER                    MEANING
'                 MsgTo$
'                 Found
'
'  OUTPUTS --  ZPswd$                Protection desired
'
'  PURPOSE --  Sets protection desired for a new message
'
     SUB MsgProt (MsgTo$,Found,MsgPswd$,ChangingSec,FileAttachName$) STATIC
2060 ZOutTxt$ = ""
     '* "Make msg"
     CALL FormatString (290,ZFalse,ZFalse,0,ZFalse,0,ZOutTxt$)
     IF INSTR(ZMsgSecCats$,"U") > 0 THEN
        '* "{SPp(U)blic,"
        CALL FormatString (291,ZFalse,ZFalse,0,ZFalse,0,Strng$)
        ZOutTxt$ = ZOutTxt$ + Strng$
        '* "ALL"
        CALL FormatString (1000,ZFalse,ZFalse,0,ZFalse,0,Strng$)
        IF MsgTo$ = Strng$ THEN
           MsgPswd$ = ""
           GOTO 2061
        END IF
     END IF
     IF INSTR(ZMsgSecCats$,"R") THEN
        '* "{SPp(R)ivate,"
        CALL FormatString (292,ZFalse,ZFalse,0,ZFalse,0,Strng$)
        ZOutTxt$ = ZOutTxt$ + Strng$
     END IF
     IF INSTR(ZMsgSecCats$,"P") THEN
        '* "{SP(P)assworded,"
        CALL FormatString (293,ZFalse,ZFalse,0,ZFalse,0,Strng$)
        ZOutTxt$ = ZOutTxt$ + Strng$
     END IF
2061 IF ZAllowFileAttach THEN
        '* "ALL"
        CALL FormatString (1000,ZFalse,ZFalse,0,ZFalse,0,Strng$)
        IF ((MsgTo$ <> Strng$) AND (ZUserSecLevel >= ZPrivateAttachSecLevel)) OR _
           ((MsgTo$ = Strng$) AND (ZUserSecLevel >= ZPublicAttachSecLevel)) THEN
           '* "{SP(@)Attach,"
           CALL FormatString (1161,ZFalse,ZFalse,0,ZFalse,0,Strng$)
           ZOutTxt$ = ZOutTxt$ + Strng$
        END IF
     END IF
     IF NOT ChangingSec THEN
        '* "{SP(E)dit more, H)elp"
        CALL FormatString (294,ZFalse,ZFalse,0,ZFalse,0,Strng$)
        ZOutTxt$ = ZOutTxt$ + Strng$
     ELSE
        ZOutTxt$ = LEFT$(ZOutTxt$,LEN(ZOutTxt$)-1)
     END IF
     IF MsgPswd$ = "^READ^" THEN _
        DefaultProt$ = "R" : _
        GOTO 2065
     IF LEFT$(MsgPswd$,1) = "!" THEN _
        DefaultProt$ = "P" _
     ELSE _
        DefaultProt$ = "U"
2065 IF INSTR(ZMsgSecCats$,DefaultProt$) > 0 THEN _
        MID$(ZOutTxt$,INSTR(ZOutTxt$,"("+DefaultProt$+")"),3) = "["+DefaultProt$+"]"
     ZTurboKey = -ZTurboKeyUser
     GOSUB 2096
     IF ZWasQ = 0 THEN _
        ZUserInAra$(ZAnsIndex) = DefaultProt$
     ZWasZ$ = UCASE$(LEFT$(ZUserInAra$(ZAnsIndex),1))
     IF INSTR(ZMsgSecCats$,ZWasZ$) = 0 THEN _
        GOTO 2060
     '* "RUPHE@"
     CALL FormatString (295,ZFalse,ZFalse,0,ZFalse,0,Strng$)
     ON INSTR(Strng$,ZWasZ$) GOTO 2075,2090,2075,2070,2067,2100
     GOTO 2060
2067 MsgPswd$ = ""
     EXIT SUB
'
' **  DISPLAY MESSAGE PROTECT HELP   *
'
2070 CALL BufFile (ZHelp$(3),WasX)
     GOTO 2060
'
' ** MAKE MESSAGE READ PROTECTED (ONLY ADDRESSEE AND SYSOP CAN READ IT) *
'
2075 '* "ALL"
     CALL FormatString (1000,ZFalse,ZFalse,0,ZFalse,0,Strng$)
     IF MsgTo$ = Strng$ THEN
        '* "Msg to ALL cannot be private"
        CALL FormatString (296,ZFalse,ZFalse,0,ZTrue,1,"")
        GOTO 2060
     END IF
     IF ZWasZ$ = "P" THEN _
        GOTO 2088
2081 '* "Sending private mail to{SP"
     CALL FormatString (297,ZFalse,ZFalse,0,ZFalse,0,Strng$)
     CALL QuickTPut1 (Strng$ + MsgTo$)
2084 MsgPswd$ = "^READ^"
     EXIT SUB
2085 '* "Password"
     CALL FormatString (113,ZFalse,ZFalse,0,ZFalse,0,ZOutTxt$)
     GOSUB 2096
     IF ZWasQ = 0 THEN
        IF LEFT$(MsgPswd$,1) = "!" THEN
           MsgPswd$ = MID$(MsgPswd$,2)
           '* "Password is{SP"
           CALL FormatString (298,ZFalse,ZFalse,0,ZFalse,0,Strng$)
           CALL QuickTPut1 (Strng$ + MsgPswd$)
           RETURN
        ELSE
           GOTO 2085
        END IF
     END IF
     IF LEN(ZUserIn$) > WasL THEN
        IF WasL = 14 THEN
           '* "14 Chars. max"
           LineNum = 299
        ELSE
           '* "15 Chars. max"
           LineNum = 300
        END IF
        CALL FormatString (LineNum,ZFalse,ZFalse,0,ZTrue,1,"")
        GOTO 2085
     END IF
     IF (WasL = 15 AND LEFT$(ZUserIn$,1) = "!") THEN _
        '* "Password can't begin with '!'"
        CALL FormatString (301,ZFalse,ZFalse,0,ZFalse,0,Strng$)
        CALL QuickTPut1 (Strng$ + LEFT$(ZUserIn$,1))
        GOTO 2085
     END IF
     RETURN
'
' **  PASSWORD PROTECT MESSAGE (USERS WITH PASSWORD AND SYSOP CAN READ) *
'
2088 '* "The Recipients Must Know the Password.  Really Use a Password? (Y,[N])"
     CALL FormatString (302,ZFalse,ZFalse,0,ZFalse,0,ZOutTxt$)
     ZTurboKey = -ZTurboKeyUser
     GOSUB 2096
     IF NOT ZYes THEN _
        GOTO 2070
     WasL = 14
     WasA1$ = "!"
     GOSUB 2085
     ZUserIn$ = UCASE$(ZUserIn$)
     GOTO 2092
'
' ** MAKE MESSAGE KILL PROTECTED (ONLY SENDER, ADDRESSEE AND SYSOP CAN KILL) *
'
2090 WasL = 15
     WasA1$ = ""
     ZUserIn$ = "^KILL^"
2092 MsgPswd$ = WasA1$ + ZUserIn$
     EXIT SUB
2093 ZTurboKey = -ZTurboKeyUser
2094 ZSubParm = 1
     CALL TGet
2095 IF ZSubParm = -1 THEN _
        EXIT SUB
     RETURN
2096 CALL PopCmdStack
     GOTO 2095
'
' *** File Attach to Message
'
2100 '* "ALL"
     CALL FormatString (1000,ZFalse,ZFalse,0,ZFalse,0,Strng$)
     IF MsgTo$ <> Strng$ AND ZUserSecLevel < ZPrivateAttachSecLevel THEN
        GOTO 2060
     END IF
     IF ZUserSecLevel < ZPublicAttachSecLevel THEN
        GOTO 2060
     END IF
2110 CALL SkipLine (1)
     DO
        '* "Upload File Attach ([Y],N)"
        CALL FormatString (1159,ZFalse,ZFalse,0,ZFalse,0,ZOutTxt$)
        ZSubParm = 1
        CALL TGet
        IF ZSubParm < 0 THEN
           EXIT SUB
        END IF
        ZUserIn$ = UCASE$(ZUserIn$)
     LOOP UNTIL ZWasQ = 0 OR INSTR("YN",ZUserIn$) <> 0
     CALL SkipLine (1)
     IF ZUserIn$ = "N" THEN
        FileAttachName$ = ""
        GOTO 2060
     END IF
     '* "Enter Name of File to Upload{EX"
     CALL FormatString (1160,ZFalse,ZFalse,0,ZFalse,0,ZOutTxt$)
     GOSUB 2096
     ZUserIn$ = UCASE$(ZUserIn$)
     CALL BadFile (ZUserIn$,BadFileNameIndex)
     IF BadFileNameIndex > 1 THEN
        GOTO 2100
     END IF
     CALL FindFile (ZFileAttachPath$ + ZUserIn$,Found)
     IF Found THEN
        CALL SkipLine (1)
        '* "Thanks, but we already have {ZU"
        CALL FormatString (957,ZFalse,ZFalse,0,ZTrue,1,"")
        GOTO 2110
     END IF
     FileAttachName$ = ZUserIn$
     ZErrCode = 0
     ZFileName$ = ZFileAttachPath$ + FileAttachName$
     ZFileNameHold$ = FileAttachName$
     CALL XFerType (1,ZTrue)
     IF ZWasQ = 0 THEN
        CALL SkipLine (1)
        GOTO 2060
     END IF
     CALL CheckCarrier
     IF ZSubParm = -1 THEN
        EXIT SUB
     END IF
     ZTransferFunction = 2
     ZBatchTransfer = ZFalse
     ZWasBatchTransfer = ZFalse
     IF ZProtoMacro$ <> "" THEN
        ZGSRAra$(1) = MID$("DU ",ZTransferFunction,1)
        CALL MacroExe (ZProtoMacro$)
     END IF
     CALL Transfer
     CALL KillWork ("XFER-" + ZNodeID$ + ".DEF")
     CALL SkipLine (1)
     GOTO 2060
     END SUB

2250 ' $SUBTITLE: 'WhoCheck - Checks whether user exists'
' $PAGE
'
'  NAME    -- WhoCheck
'
'  INPUTS  --   PARAMETER                    MEANING
'              WhoFind$                User to find
'
'  OUTPUTS --  WhoFound                Whether user found
'              UserNumFound           Record # of user
'
'  PURPOSE --  Validate that user record exists.  Sysop
'              counted as found even if lack user record.
'
     SUB WhoCheck (WhoFind$,WhoFound,UserNumFound) STATIC
     UserNumFound = 0
     IF ZStartHash <> 1 THEN _
        WhoFound = ZTrue : _
        EXIT SUB
     Work128$ = ZUserRecord$
     WhoFound = ZFalse
     '* "SYSOP"
     CALL FormatString (131,ZFalse,ZFalse,0,ZFalse,0,Strng$)
     ToSysop = (INSTR(WhoFind$,Strng$) > 0 OR _
        INSTR(WhoFind$,ZSysopFullName$) > 0)
     CALL OpenUser (ZHighestUserRecord)
     FIELD 5, 128 AS ZUserRecord$
     IF ToSysop THEN
        WasX$ = ZSysopFullName$
        ZMenuNewSysop = ZMenuNewSysop + 1
     ELSE
        WasX$ = WhoFind$
     END IF
     ZWasDF = INSTR(WasX$+"@","@")
     WasX$ = LEFT$(WasX$,ZWasDF)
     IF LEN(WasX$) > 1 THEN _
        CALL FindUser (WasX$,"",ZStartHash,ZLenHash,_
                       0,0,ZHighestUserRecord,WhoFound,_
                       UserNumFound,ZWasSL)
     LSET ZUserRecord$ = Work128$
     IF NOT WhoFound THEN
        IF ToSysop THEN
           WhoFound = ZTrue
        END IF
        UserNumFound = 0
     END IF
     END SUB
2618 ' $SUBTITLE: 'EditALine - Edits a line in a message'
' $PAGE
'
'  NAME    -- EditALine
'
'  INPUTS  --     PARAMETER                    MEANING
'                 WasL                        Line # to edit
'
'  OUTPUTS --  ZOutTxtAra$(WasL)                 Edited line
'
'  PURPOSE --  Edit a line in a message.
'
     SUB EditALine (WasL) STATIC
2620 '* "Line #"
     CALL FormatString (303,ZFalse,ZFalse,0,ZFalse,0,Strng1$)
     '* "{SPis:"
     CALL FormatString (304,ZFalse,ZFalse,0,ZFalse,0,Strng2$)
     ZOutTxt$ = Strng1$ + STR$(WasL) + _
                Strng2$ + ZReturnLineFeed$ + ZOutTxtAra$(WasL)
     ZSubParm = 3
     CALL TPut
     GOSUB 2695
     '* "Search for What String{EX"
     CALL FormatString (305,ZFalse,ZFalse,0,ZFalse,0,ZOutTxt$)
     ZMacroMin = 99
     ZParseOff = ZTrue
     ZSubParm = 1
     GOSUB 2694
     IF ZWasQ = 0 THEN _
        EXIT SUB
     ZWasY$ = LEFT$(ZUserIn$,1)
     IF ZWasY$ = RIGHT$(ZUserIn$,1) THEN _
        IF LEN(ZUserIn$) > 2 THEN _
           WasX = INSTR(2,ZUserIn$,ZWasY$) : _
           IF WasX < LEN(ZUserIn$) THEN _
              IF ZWasY$ < "0" OR (ZWasY$ > "9" AND ZWasY$ < "A") THEN _
                 ZUserIn$ = MID$(ZUserIn$,2,LEN(ZUserIn$)-2) : _
                 WasX = WasX - 1 : _
                 GOTO 2622
     WasX = INSTR(ZUserIn$,";")
2622 IF WasX > 0 THEN _
        WasX$ = LEFT$(ZUserIn$,WasX-1) : _
        ZWasY$ = RIGHT$(ZUserIn$,LEN(ZUserIn$)-WasX) : _
        GOTO 2660
     WasX$ = ZUserIn$
     '* "And Replace With What"
     CALL FormatString (306,ZFalse,ZFalse,0,ZFalse,0,ZOutTxt$)
     ZParseOff = ZTrue
     ZSubParm = 1
     ZMacroMin = 99
     GOSUB 2694
     ZWasY$ = ZUserIn$
2660 WasX = INSTR(1,ZOutTxtAra$(WasL),WasX$)
     IF WasX = 0 THEN
        '* "String Not Found in Line"
        CALL FormatString (307,ZFalse,ZFalse,0,ZFalse,0,Strng$)
        CALL QuickTPut1 (Strng$ + STR$(WasL))
        GOTO 2620
     END IF
2670 ZFF = LEN(WasX$)
     WasJJ = LEN(ZWasY$)
     IF ZFF = WasJJ THEN _
        MID$(ZOutTxtAra$(WasL),WasX) = ZWasY$ : _
        GOTO 2620
2690 ZWasDFF$ = LEFT$(ZOutTxtAra$(WasL),WasX - 1)
     ZOutTxtAra$(WasL) = ZWasDFF$ + _
             ZWasY$ + _
             MID$(ZOutTxtAra$(WasL),WasX + ZFF)
     IF LEN(ZOutTxtAra$(WasL)) > ZRightMargin THEN _
        CALL WordWrap (ZRightMargin, ZLinesInMsg, ZOutTxtAra$())
     GOTO 2620
2694 CALL TGet
2695 IF ZSubParm > -1 THEN _
        RETURN
     END SUB
3700 ' $SUBTITLE: 'LineEdit  - subroutine to produce edited line'
' $PAGE
'
'  NAME    -- LineEdit
'
'  INPUTS  -- PARAMETER             MEANING
'             ZBackArrow$
'             ZBackSpace$
'             ZCarriageReturn$
'             ZLineFeed$
'             ZLineMes$          BUFFER SPACE TO USE FOR HOLDING LINE
'             ZLocalUser
'             MaxLen             MAXIMUM LENGTH OF STRING TO INPUT
'             MsgLine            WHERE IN ZOutTxtAra$() TO PUT THE EDITED LINE
'             ZRightMargin
'             ZSnoop
'             ZStopInterrupts
'             ZWaitExpired
'
'  OUTPUTS -- ZOutTxtAra$(MsgLine)  EDITED LINE
'
'  PURPOSE -- Subroutine to edit a line quickly using a minimum of
'             string space.
'
     SUB LineEdit (MsgLine,MaxLen) STATIC
     TabToSpace = 0
     LSET ZLineMes$ = ZOutTxtAra$(MsgLine)
     Col = LEN(ZOutTxtAra$(MsgLine))
     ZStopInterrupts = ZTrue
     WasXXX = MaxLen - 3
     ZWaitExpired = ZFalse
     GOTO 3782
3720 Col = Col + 1
     CALL GiveBack
     ZAutoLogoff! = TIMER + ZWaitBeforeDisconnect
3730 IF TabToSpace > 0 THEN _
        WasX$ = SPACE$(1) : _
        TabToSpace = TabToSpace - 1 : _
        GOTO 3750
     CALL FindFKey
     IF ZSubParm < 0 THEN _
        EXIT SUB
     WasX$ = ZKeyPressed$
     IF WasX$ = "" THEN
        IF ZLocalUser THEN
           GOTO 3733
        ELSE
           GOTO 3732
        END IF
     END IF
     IF WasX$ = ZEscape$ THEN _
        ZKeyPressed$ = WasX$ : _
        EXIT SUB
     SendRemote = ZTrue
     WasZ = INSTR(ZLineEditChk$,WasX$)
     IF WasZ < 1 THEN _
        GOTO 3750 _
     ELSE IF WasZ > 4 THEN _
             GOTO 3870 _
     ELSE IF WasZ = 1 THEN _
             GOTO 3810
     IF ZLocalUser THEN _
        GOTO 3730
3732 IF ZCommPortStack$ <> "" THEN _
        WasX$ = LEFT$(ZCommPortStack$,1) : _
        ZCommPortStack$ = RIGHT$(ZCommPortStack$,LEN(ZCommPortStack$)-1) : _
        GOTO 3738
     IF NOT ZLocalUser THEN _
        CALL EofComm (Char) : _
        IF Char <> -1 THEN _
           GOTO 3736
3733 CALL CheckTime(ZAutoLogoff!, TempElapsed!, 1)
     IF TempElapsed! <=0 THEN _
        ZWaitExpired = ZTrue : _
        Col = Col - 1 : _
        GOTO 3850
     CALL CheckCarrier
     IF ZSubParm THEN _
        EXIT SUB
     GOTO 3730
3736 ZAutoLogoff! = TIMER + ZWaitBeforeDisconnect
3737 CALL GetCom (WasX$)
3738 SendRemote = ZRemoteEcho
3740 ON INSTR(ZLineEditChk$,WasX$) GOTO 3810,3730,3730,3730, _
                                   3870,3870,3870,3870,3870
3750 IF SendRemote THEN _
        CALL PutCom(WasX$)
     IF WasX$ = ZCarriageReturn$ THEN _
        CALL LPrnt (ZCrLf$,0) : _
        Col = Col - 1 : _
        GOTO 3850 _
     ELSE _
        CALL LPrnt (WasX$, 0)
3770 IF Col > WasXXX THEN _
        IF WasX$ = SPACE$(1) THEN _
           CALL SkipLine (1) : _
           GOTO 3860
3780 MID$(ZLineMes$,Col) = WasX$
3782 IF Col < MaxLen THEN _
        GOTO 3720
     WasZ = Col
3800 IF WasZ < 1 THEN _
        WasZ = Col-1 : _
        GOTO 3820
     IF MID$(ZLineMes$,WasZ,1) = SPACE$(1) THEN _
        GOTO 3820
     WasZ = WasZ - 1
     GOTO 3800
3810 TabToSpace = 5 - (Col MOD 5)
     GOTO 3730
3820 IF (NOT ZRemoteEcho) AND (NOT ZLocalUser) THEN _
        CALL SkipLine (1) : _
        GOTO 3860
     Col = MaxLen - WasZ
     IF ZSnoop THEN _
        IF (POS(0) > Col) AND (Col > 0) THEN _
           LOCATE ,POS(0)-Col: _
           CALL LPrnt(STRING$(Col,32),0)
3830 IF ZRemoteEcho THEN _
        CALL PutCom (STRING$(Col,8) + STRING$(Col,32))
3840 ZOutTxtAra$(MsgLine) = LEFT$(ZLineMes$,WasZ)
     ZOutTxtAra$(MsgLine + 1) = MID$(ZLineMes$,WasZ + 1,Col)
     CALL SkipLine (1)
     GOTO 3891
3850 IF SendRemote AND ZLineFeeds THEN _
        CALL PutCom(ZLineFeed$)
3860 ZOutTxtAra$(MsgLine) = LEFT$(ZLineMes$,Col)
     GOTO 3891
3870 IF Col = 1 THEN _
        GOTO 3730
     Col = Col-2
3880 CALL LPrnt(ZLocalBksp$,0)
3885 IF SendRemote THEN _
        CALL PutCom (ZBackSpace$)
3890 GOTO 3720
3891 CALL CheckCarrier
     END SUB
3952 ' $SUBTITLE: 'KillMsg - subroutine to delete messages'
' $PAGE
'
'  NAME    -- KillMsg
'
'  INPUTS  --     PARAMETER                    MEANING
'              MsgToKill                   MESSAGE NUMBER TO KILL
'              ZActiveMessages              NUMBER ACTIVE MESSAGES
'
'  OUTPUTS --  NONE
'
'  PURPOSE --  To kill/delete old or unnecessary messages
'
     SUB KillMsg (MsgToKill,ZActiveMessages,ZconfName$,FileAttachName$) STATIC
     FIELD #1,128 AS ZMsgRec$
     WasQX = 1
     NumHeaders = 0
3955 IF WasQX > ZActiveMessages THEN
        '* "Message to Kill Not Found!  Message Number:"
        CALL FormatString (308,ZFalse,ZFalse,0,ZFalse,0,ZOutTxt$)
        ZOutTxt$ = ZOutTxt$ + STR$(MsgToKill)
        GOTO 4031
     END IF
     IF ZMsgPtr(WasQX,2) = MsgToKill AND MsgToKill => 1 THEN _
        GOTO 3970
     WasQX = WasQX + 1
     GOTO 3955
3970 MsgRec = ZMsgPtr(WasQX,1)
     GET 1, MsgRec
     NumHeaders = ASC(MID$(ZMsgRec$,67,1))
     OrigNumHeaders = NumHeaders
3972 CALL ChkIfMsgHeader
     IF NOT ZOK THEN _
        NumHeaders = 0 : _
        GOTO 4032
     IF MID$(ZMsgRec$,116,1) = ZDeletedMsg$ THEN _
        GOTO 4032
     IF ZUserSecLevel >= ZSecKillAny THEN _
        GOTO 4020
3980 ZWasZ$ = MID$(ZMsgRec$,101,15)
     CALL Trim (ZWasZ$)
     IF LEN(ZWasZ$) = 0 THEN _
        GOTO 4030
3990 IF ZWasZ$ = "^READ^" OR ZWasZ$ = "^KILL^" THEN
        CALL ChkMsgName (MsgFromCaller,MsgToCaller)
        IF (MsgFromCaller OR MsgToCaller) THEN
           GOTO 4020
        ELSEIF NumHeaders > 1 THEN
           GOTO 4032
        ELSE
           ZMsgPswd = ZTrue
           ZAttemptsAllowed = 0
           '* "Only sender & receiver can kill"
           CALL FormatString (309,ZFalse,ZFalse,0,ZFalse,0,ZOutTxt$)
           GOTO 4031
        END IF
     END IF
4000 IF LEFT$(ZWasZ$,1) = "!" THEN _
        ZWasZ$ = MID$(ZWasZ$,2)
4010 ZPswdSave$ = ZWasZ$ + _
                      SPACE$(15 - LEN(ZWasZ$))
     ZAttemptsAllowed = 1
     ZMsgPswd = ZTrue
     CALL PassWrd
     IF ZPswdFailed THEN _
        GOTO 4031
4020 ZWasZ$ = MID$(ZMsgRec$,37,22)
     CALL Trim (ZWasZ$)
     IF OrigNumHeaders < 2 AND ZExpertUser THEN _
        GOTO 4030
     '* "{RCReally kill msg to {ZZ ([Y],N)"
     CALL FormatString (310,ZFalse,ZFalse,0,ZFalse,0,ZOutTxt$)
     ZSubParm = 1
     ZTurboKey = -ZTurboKeyUser
     CALL TGet
     IF ZSubParm < 0 THEN _
        EXIT SUB
     IF ZNo THEN _
        GOTO 4032
4030 IF FileAttachName$ <> "" THEN
        CALL FindFile (ZFileAttachPath$ + FileAttachName$,Found)
        IF Found THEN
           SaveIt = ZTrue
           IF ZSysop THEN
              CALL BreakFileName (ZFileAttachPath$ + FileAttachName$,Drive$,Body$,Ext$,ZTrue)
              ZFileNameHold$ = Body$ + Ext$
              '* "{RCSave File Attach {FH ([Y],N)"
              CALL FormatString (1164,ZFalse,ZFalse,0,ZFalse,0,ZOutTxt$)
              ZSubParm = 1
              ZTurboKey = -ZTurboKeyUser
              CALL TGet
              IF ZSubParm < 0 THEN
                 EXIT SUB
              END IF
              IF ZNo THEN
                 SaveIt = ZFalse
              ELSE
                 '* "Moving {FH to File Attach Holding Directory"
                 CALL FormatString (1165,ZFalse,ZFalse,0,ZTrue,1,"")
              END IF
           END IF
           IF SaveIt THEN
              CALL CopyFile (ZFileAttachPath$+FileAttachName$,ZFileAttachHoldPath$+FileAttachName$,ECODE)
           END IF
           CALL KillWork (ZFileAttachPath$+FileAttachName$)
           FileAttachName$ = ""
        END IF
        ZWasZ$ = MID$(ZMsgRec$,37,22)
     END IF
     ZSubParm = 3
     CALL FileLock
     GET 1, MsgRec
     MID$(ZMsgRec$,116,1) = ZDeletedMsg$
     PUT 1, MsgRec
     ZSubParm = 4
     CALL FileLock
     '* "Killed Msg #"
     CALL FormatString (311,ZFalse,ZFalse,0,ZFalse,0,Strng1$)
     '* "{SPto {ZZ"
     CALL FormatString (312,ZFalse,ZFalse,0,ZFalse,0,Strng2$)
     ZOutTxt$ = Strng1$ + STR$(MsgToKill) + Strng2$
     CALL UpdtCalr (ZOutTxt$,1)
     IF ((ZUserSecLevel < ZSecKillAny) AND NOT MsgFromCaller) THEN _
        NumHeaders = 0
4031 ZOutTxt$ = ZEmphasizeOff$ + ZOutTxt$
     ZSubParm = 5
     CALL TPut
4032 NumHeaders = NumHeaders - 1
     IF NumHeaders > 0 THEN _
        MsgRec = MsgRec + 1 : _
        GET 1, MsgRec : _
        GOTO 3972
     END SUB
4554 ' $SUBTITLE: 'SetThread - Sets up the interface for threading'
' $PAGE
'
'  NAME    -- SetThread
'
'  INPUTS  --     PARAMETER                    MEANING
'                 CurMsgNum                 Current message number
'                 CurSubj$                  Current message subject
'
'  OUTPUTS --  ZUserInAra$()                   Search msg by string
'              ZWasQ                        0 if thread cancelled
'
'  PURPOSE --  Find out how the caller wants to thread -
'              i.e. search messages by matching subject -
'              forward from current, back from current,
'              or forward from top of messages
'
     SUB SetThread (CurMsgNum,CurSubj$) STATIC
     IF ZWasQ > 1 THEN _
        ZWasZ$ = ZUserInAra$(2) : _
        GOTO 4657
4656 '* "THREAD: +)forward, -)back, 1)from origin{EX"
     CALL FormatString (313,ZFalse,ZFalse,0,ZFalse,0,ZOutTxt$)
     ZTurboKey = -ZTurboKeyUser
     ZSubParm = 1
     CALL TGet
     IF ZWasQ = 0 OR ZSubParm = -1 THEN _
        EXIT SUB
     ZWasZ$ = ZUserInAra$(1)
4657 ZWasZ$ = LEFT$(ZWasZ$,1)
     WasX = INSTR("+-1",ZWasZ$)
     IF WasX = 0 THEN _
        GOTO 4656
     ZUserInAra$(1) = "R"
     IF WasX = 1 THEN _
        CurMsgNum = CurMsgNum + 1 _
     ELSE IF WasX = 2 THEN _
             CurMsgNum = CurMsgNum - 1 _
          ELSE CurMsgNum = 1 : _
               ZWasZ$ = "+"
     ZUserInAra$(3) = MID$(STR$(CurMsgNum),2) + ZWasZ$
     '* "(R)"
     CALL FormatString (128,ZFalse,ZFalse,0,ZFalse,0,Strng$)
     IF LEN(CurSubj$) < 4 OR LEFT$(CurSubj$,3) <> Strng$ THEN _
        ZUserInAra$(2) = CurSubj$ _
     ELSE ZUserInAra$(2) = MID$(CurSubj$,4)
     ZUserInAra$(2) = LEFT$(ZUserInAra$(2) + SPACE$(2),22)
     ZLastIndex = 3
     ZAnsIndex = 1
     ZWasQ = 3
     END SUB
4773 ' $SUBTITLE: 'SysopChat - chat with sysop'
' $PAGE
'
'  NAME    -- SysopChat
'
'  INPUTS  --     PARAMETER                    MEANING
'  OUTPUTS --  ZWasCM                     True if chat active
'
'  PURPOSE --  Lets sysop chat interactively with caller
'
     SUB SysopChat STATIC
     ZWasCM = ZTrue
     TimeChatStarted! = TIMER
     ZSubParm = 1
     CALL Line25
     ZOutTxtAra$(2) = ""
4775 CALL LineEdit (1,72)
     IF ZKeyPressed$ = ZEscape$ OR _
        ZSubParm < 0 THEN _
        GOTO 4777
     ZOutTxtAra$(1) = ""
     IF ZOutTxtAra$(2) <> "" THEN _
        ZOutTxt$ = ZOutTxtAra$(2) : _
        ZOutTxtAra$(1) = ZOutTxtAra$(2) : _
        ZOutTxtAra$(2) = "" _
     ELSE ZOutTxt$ = ""
     ZSubParm = 4
     CALL TPut
     IF ZSubParm > -1 THEN _
        GOTO 4775
4777 ZWasCM = 0
     CALL CheckTime(TimeChatStarted!,Elapsed!, 2)
     ZSecsPerSession! = ZSecsPerSession! + Elapsed!
     IF NOT ZLocalUser THEN _
        ZAutoLogoff! = TIMER + ZWaitBeforeDisconnect
     '* "{SP{SPChat over.  BBS resuming"
     CALL FormatString (314,ZFalse,ZFalse,0,ZTrue,2,"")
     END SUB
5100 ' $SUBTITLE: 'RemNonAlf - removes non-alpha chars from a string'
' $PAGE
'
'  NAME    -- RemNonAlf
'
'  INPUTS  --     PARAMETER                    MEANING
'                 Strng$                   String to check
'                 MinChar                  Remove chars with this
'                                          ASCII value or lower
'                 MaxChar                  Remove chars with this
'                                          ASCII value or higher
'
'  OUTPUTS --       Strng$                 String returned
'  PURPOSE --  CALCULATE THE ELASPED TIME A USER HAS BEEN ON
'
     SUB RemNonAlf (Strng$,MinChar,MaxChar) STATIC
     Last = LEN(Strng$)
     WasJ = 1
     WHILE WasJ <= Last
        WasK = ASC(MID$(Strng$,WasJ))
        IF WasK > MinChar AND WasK < MaxChar THEN _
           WasJ = WasJ + 1 _
        ELSE Strng$ = LEFT$(Strng$,WasJ - 1) + _
                      RIGHT$(Strng$,Last - WasJ) : _
             Last = Last - 1
     WEND
     END SUB
5500 ' $SUBTITLE: 'BankTime - Allows User to Bank Session Time'
' $PAGE
'  NAME    -- BankTime
'
'  INPUTS  -- PARAMETER             MEANING
'             ZBankTimeVal       Time in bank can use
'
'  OUTPUTS -- ZBankTimeVal
'
'  PURPOSE -- Allow Users to use Bank session time
'
     SUB BankTime STATIC
     GOSUB 5507
5501 CALL TimeRemain(MinsRemaining)
     '* "{CD{TR {C2minutes left.{RC{CRD)eposit, W)ithdraw, H)elp, [Q]uit"
     CALL FormatString (315,ZFalse,ZFalse,0,ZFalse,0,ZOutTxt$)
     ZTurboKey = -ZTurboKeyUser
     CALL PopCmdStack
     IF ZSubParm = -1 THEN _
        EXIT SUB
     ZWasZ$ = UCASE$(LEFT$(ZUserInAra$(ZAnsIndex),1))
     '* "QDW?H"
     CALL FormatString (316,ZFalse,ZFalse,0,ZFalse,0,Strng$)
     ON INSTR(Strng$,ZWasZ$) GOTO 5509,5505,5502,5508,5508
     GOTO 5501
5502 SignTime = 1        ' withdraw time
     MaxTime = ZGlobalBankTime
5503 IF SignTime = 1 THEN
        '* "{CEWithdraw {CBhow many minutes?{RC"
        '* "Withdrew"
        LineNum = 317
     ELSE
        '* "{CEDeposit {CBhow many minutes?{RC"
        '* "Deposited"
        LineNum = 319
     END IF
     CALL FormatString (LineNum,ZFalse,ZFalse,0,ZFalse,0,ZOutTxt$)
     CALL FormatString (LineNum + 1,ZFalse,ZFalse,0,ZFalse,0,Action$)
     CALL ChangeInt (ZFalse,ZOutTxt$,Temp,0,Maxtime)
     IF ZWasQ = 0 OR ZTestedIntValue = 0 THEN _
        GOTO 5501
     ZTestedIntValue = SignTime * ZTestedIntValue
     CALL ChkAddedTime (ZTestedIntValue)
     IF ZTestedIntValue = 0 THEN _
        GOTO 5501
     CALL FormatString (321,ZFalse,ZFalse,0,ZFalse,0,Strng$)
     CALL UpdtCalr (Action$ + STR$(SignTime*ZTestedIntValue) + Strng$,1)
     ZSecsPerSession! = ZSecsPerSession! + (ZTestedIntValue * 60)
     IF ZMaxPerDay = 0 THEN _
        ZTimeCredits! = ZTimeCredits! + ZTestedIntValue * 60
     ZElapsedTimeVal = ZElapsedTimeVal - ZTestedIntValue
     ZGlobalBankTime = ZGlobalBankTime - ZTestedIntValue
     ZBankTimeVal = ZGlobalBankTime
     GOSUB 5507
     GOTO 5501
5505 SignTime = -1            ' deposit
     MaxTime = ZMaxBank - ZGlobalBankTime
     IF MaxTime <= 0 THEN
        '* "{CF{G5 Already deposited max of {BM minutes!{RC"
        CALL FormatString (322,ZFalse,ZFalse,0,ZTrue,1,"")
        ZLastIndex = 0
        GOTO 5501
     END IF
     IF MaxTime > MinsRemaining THEN _
        MaxTime = MinsRemaining
     GOTO 5503
5507 IF ZAnsIndex < ZLastIndex THEN _
        RETURN
     CALL SkipLine (1)
     '* "{C9Current Bank Balance: {CB{BB{RC"
     CALL FormatString (323,ZFalse,ZFalse,0,ZTrue,1,ZOutTxt$)
     RETURN
5508 ZFileName$ = ZHelpPath$ + _
                  "UB" + _
                  ZHelpExtension$
     CALL BufFile (ZFileName$,WasX)
     GOTO 5501
5509 GOSUB 5507
     END SUB
9140 ' $SUBTITLE: 'GetTime - subroutine to calculate elapsed time'
' $PAGE
'
'  NAME    -- GetTime
'
'  INPUTS  --     PARAMETER                    MEANING
'                ZTimeLoggedOn$
'
'  OUTPUTS --  ZSessionHour               NUMBER OF HOURS ON
'              ZSessionMin                NUMBER OF MINUTES ON
'              ZSessionSec                NUMBER OF SECONDS ON
'
'  PURPOSE --  Calculate the elapsed time a user has been on
'
     SUB GetTime STATIC
     CALL CheckTime(ZUserLogonTime!, TempElapsed!, 2)
     ZSessionHour = TempElapsed! / 3600
     ZSessionMin = (TempElapsed! - ZSessionHour * 3600!) / 60
     ZSessionSec = TempElapsed! - (ZSessionHour * 3600! + ZSessionMin * 60!)
     IF ZSessionSec < 0 THEN _
        ZSessionSec = ZSessionSec + 60 : _
        ZSessionMin = ZSessionMin - 1
     IF ZSessionMin < 0 THEN _
        ZSessionMin = ZSessionMin + 60 : _
        ZSessionHour = ZSessionHour - 1
     END SUB
9600 ' $SUBTITLE: 'DefaultU - subroutine to update user defauts'
' $PAGE
'
'  NAME    -- DefaultU
'
'  INPUTS  --     PARAMETER                    MEANING
'             ZFullScreenEditor
'             ZBoldText$              Ansi bold (0 no, 1 yes)
'             ZCheckBulletLogon
'             ZExpertUser
'             ZWasGR
'             ZLastMsgRead
'             ZLineFeeds
'             ZNulls
'             ZPageLength
'             ZPromptBell
'             ZRegDate$
'             ZReqQuesAnswered
'             ZRightMargin
'             ZSkipFilesLogon
'             ZTimesLoggedOn
'             ZUpperCase
'             ZUserOption$
'             ZUserTextColor          Ansi of color (31-37)
'             ZUserXferDefault$
'
'  OUTPUTS--  USER.OPTONS$
'
'  PURPOSE --  To update the user's record with their options.
'  Meaning of graphics preference stored is as follows: where # is
'  value stored for the color.  E.g. if graphics perference for text
'  files is color, and preference for normal text is light yellow,
'  graphics preference stored is 38.  Colors are Red, Green, Yellow,
'  Blue, Purple, Cyan, and White.
'
'  Colors (normal or Bold) are not used for AutoDetect and are foced
'  to bold white
'
'             normal                  bold
' Graphics R  G  Y  B  P  C  W    R  G  Y  B  P  C  W
'   none  30 35 40 45 50 55 60 | 65 70 75 80 85 90 95
'   mono  31 36 41 46 51 56 61 | 66 71 76 81 86 91 96
'   ansi  32 37 42 47 52 57 62 | 67 72 77 82 87 92 97
'   auto  33 38 43 48 53 58 63 | 68 73 78 83 88 93 98
'   RIP   34 39 44 49 54 59 64 | 69 74 79 84 89 94 99
'
     SUB DefaultU STATIC
     ZWasA =    -ZPromptBell          -2 * ZExpertUserHold _
            -4 * ZNulls               -8 * ZUpperCase _
           -16 * ZLineFeeds          -32 * ZCheckBulletLogon _
           -64 * ZSkipFilesLogon    -128 * ZFullScreenEditor _
          -256 * ZReqQuesAnswered   -512 * ZMailWaiting _
         -1024 * (NOT ZHiLiteOffHold)  -2048 * ZTurboKeyUserHold _
         -4096 * ZFileWaiting      -8192 * ZAvailableForChat _
        -16384 * ZExtendedOff
'
     WasAA =    -ZReadNewMail         -2 * ZReselectAll _
            -4 * ZMorePromptLF        -8 * ZReselectGraphics _
           -16 * ZANSIMusic          -32 * ZNeverCanPage _
           -64 * ZReselectProto     -128 * ZChangePswd
'
     WasX = 5*ZUserTextColor - 125 + 35*VAL(ZBoldTextHold$) + ZWasGRHold
     IF WasX < 30 OR WasX > 99 THEN _
        WasX = 60
     LSET ZUserOption$ = _
        MKI$(ZTimesLoggedOn) + _
        MKI$(ZLastMsgRead) + _
        ZUserXferDefault$ + _
        CHR$(WasX) + _
        CHR$(ZRightMargin) + _
        CHR$(WasAA) + _
        MKI$(ZWasA) + _
        ZRegDate$ + _
        CHR$(ZPageLengthHold) + _
        ZEchoer$
     END SUB
9801 ' $SUBTITLE: 'WhosOn - subroutine to display who is on'
' $PAGE
'
'  NAME    -- WhosOn
'
'  INPUTS  --     PARAMETER                    MEANING
'                NumNodes                   # of nodes to check
'                ZActiveMessageFile$        Current message file
'                ZOrigMsgFile$              Main msg file
'
'  OUTPUTS --  None
'
'  PURPOSE --  To display who is on each node.
'
     SUB WhosOn STATIC
     '* ANSIMChat
     IF ZAvailableForChat AND ZDoANSIMChat THEN
        StartRow = 6
        StartCol = 2
        CALL ANSIBox(StartRow,StartCol,12,78,ZFGA$,"","Who's On")
     END IF
     WasA1$ = ZActiveMessageFile$
     ZActiveMessageFile$ = ZOrigMsgFile$
     CALL OpenMsg
     FIELD 1, 128 AS ZMsgRec$
     GET 1,1
     NumNodes = VAL(MID$(ZMsgRec$,127))
     FOR NodeIndex = 2 TO NumNodes + 1
        GET 1,NodeIndex
        '* "Node{SP"
        LineNum = 1021
        GOSUB 9810
        ZOutTxt$ = ZFGA$ + Strng$ + _
             STR$(NodeIndex - 1) + ZFGE$
        RecIndex = -VAL(MID$(ZMsgRec$,44,2))
        IF RecIndex >= 0 THEN _
           RecIndex = -1
        WasAX$ = MID$(ZMsgRec$,79,5)
        CALL Trim (WasAX$)
        IF WasAX$ = "" THEN
           '* "9600"
           LineNum = 1002
           GOSUB 9810
           WasAX$ = Strng$
        END IF
        '* "{SPbaud{SP"
        LineNum = 1022
        GOSUB 9810
        WasAX$ = RIGHT$(SPACE$(5) + WasAX$,5) + Strng$
        IF MID$(ZMsgRec$,55,2) = "-1" AND NOT ZSysop THEN
           '* "SYSOP"
           LineNum = 131
           GOSUB 9810
           ZWasY$ = Strng$ + SPACE$(21)
        ELSE
           ZWasY$ = MID$(ZMsgRec$,1,26)
        END IF
        WasAX$ = WasAX$ + ZFGC$ + ZWasY$
        IF MID$(ZMsgRec$,40,2) <> "-1" THEN
           CALL SaveUserActivity(WhatTheyDoin$, NodeIndex, ZTrue,Avail)
           IF Avail = ZFalse THEN
              '* "{CD[Not Available]"
              LineNum = 1154
              GOSUB 9810
              WasAX$ = WasAX$ + Strng$
           ELSEIF WhatTheyDoin$ = "C" THEN
              '* "{CD[In Chat System]"
              LineNum = 324
              GOSUB 9810
              WasAX$ = WasAX$ + Strng$
           ELSEIF WhatTheyDoin$ = "F" THEN
              '* "{CD[In File System]"
              LineNum = 325
              GOSUB 9810
              WasAX$ = WasAX$ + Strng$
           ELSEIF WhatTheyDoin$ = "M" THEN
              '* "{CD[In Message System]"
              LineNum = 326
              GOSUB 9810
              WasAX$ = WasAX$ + Strng$
           ELSEIF WhatTheyDoin$ = "D" THEN
              '* "{CD[Has Opened a Door]"
              LineNum = 327
              GOSUB 9810
              WasAX$ = WasAX$ + Strng$
           ELSEIF WhatTheyDoin$ = "L" THEN
              '* "{CD[Is Logging On]"
              LineNum = 328
              GOSUB 9810
              WasAX$ = WasAX$ + Strng$
           ELSE
              WasAX$ = WasAX$ + ZFGD$ + MID$(ZMsgRec$,93,22)
           END IF
        ELSE
           '* "{CD[Has Opened a Door]"
           LineNum = 327
           GOSUB 9810
           WasAX$ = WasAX$ + Strng$
        END IF
        IF MID$(ZMsgRec$,57,1) = "A" THEN
           '* "{SP{SPOnLine at{SP"
           LineNum = 329
           GOSUB 9810
           ZOutTxt$ = ZOutTxt$ + Strng$ + WasAX$
        ELSEIF NOT ZSysop AND NOT ZShowAllWhosOn THEN
           '* "{SPWaiting for next caller"
           LineNum = 330
           GOSUB 9810
           ZOutTxt$ = ZOutTxt$ + Strng$
        ELSE
           '* "{SPOffline at{SP"
           LineNum = 331
           GOSUB 9810
           ZOutTxt$ = ZOutTxt$ + Strng$ + WasAX$
        END IF

        '* ANSI MChat
        CALL Trim(ZOutTxt$)
        IF ZAvailableForChat AND ZDoANSIMChat THEN
           StartRow = StartRow + 1
           CALL ANSILocate (StartRow,StartCol)
        END IF

        CALL QuickTPut1 (ZOutTxt$)
        CALL AskMore ("",ZTrue,ZTrue,ZAnsIndex,ZFalse)
        IF ZNo THEN _
           NodeIndex = NumNodes + 2
     NEXT
     ZActiveMessageFile$ = WasA1$
     CALL QuickTPut (ZEmphasizeOff$,0)
     IF NOT ZDoANSIMChat THEN
        CALL SmartPause (ZFalse)
     END IF
     EXIT SUB
9810 CALL FormatString (LineNum,ZFalse,ZFalse,0,ZFalse,0,Strng$)
     RETURN
     END SUB
10410 ' $SUBTITLE: 'RecoverMsg - sub to recover deleted messages'
' $PAGE
'
'  NAME    -- RecoverMsg
'
'  INPUTS  --     PARAMETER                    MEANING
'               MsgToRecover          MESSAGE NUMBER TO RECOVER
'               FirstMsgRecord        RECORD # FOR First MSG
'
'  OUTPUTS --  ActionFlag                 SET TO 0 IF ERROR
'                                         SET TO -1 IF No ERROR
'
'  PURPOSE --  To recover deleted messages.  Note that this is only
'              possible if you have not compressed your message file
'              using config.
'
      SUB RecoverMsg (MsgToRecover,FirstMsgRecord,ActionFlag,ZConfName$) STATIC
      FIELD #1,128 AS ZMsgRec$
      MsgRec = FirstMsgRecord
10420 GET 1,MsgRec
      NumRecsInMsg = VAL(MID$(ZMsgRec$,117,4))
      IF NumRecsInMsg < 1 OR MsgRec => ZNextMsgRec THEN
         '* "No Msg #"
         LineNum = 332
         GOSUB 10490
         ZWasY$ = Strng$ + STR$(MsgToRecover)
         GOTO 10485
      END IF
10440 IF VAL(MID$(ZMsgRec$,2,4)) <> MsgToRecover THEN
         MsgRec = MsgRec + NumRecsInMsg
         GOTO 10420
      END IF
10450 IF INSTR(ZMsgRec$,ZDeletedMsg$) <> 0 THEN
         LSET ZMsgRec$ = LEFT$(ZMsgRec$,115) + _
                                ZActiveMessage$ + _
                                MID$(ZMsgRec$,117)
         PUT 1,LOC(1)
         '* "Restored Msg #"
         LineNum = 333
         GOSUB 10490
         ZWasY$ = Strng$ + STR$(MsgToRecover)
         ActionFlag = ZTrue
         GOTO 10485
      END IF
10480 '* "Msg #"
      LineNum = 334
      GOSUB 10490
      Strng1$ = Strng$
      '* "{SPnot Dead"
      LineNum = 335
      GOSUB 10490
      ZWasY$ = Strng1$ + STR$(MsgToRecover) + Strng$
10485 CALL QuickTPut1 (ZWasY$)
      EXIT SUB
10490 CALL FormatString (LineNum,ZFalse,ZFalse,0,ZFalse,0,Strng$)
      RETURN
      END SUB
10600 ' $SUBTITLE: 'UpdateU -- Update the users record at logoff'
' $PAGE
'  NAME    -- UpdateU
'
'  INPUTS  -- PARAMETER             MEANING
'             ZAdjustedSecurity
'             ZCurDate$
'             ZDnlds
'             ZElapsedTimeVal
'             ZListDir
'             ZMainUserFileIndex
'             ZSecsPerSession!
'             ZUplds
'             ZUserSecLevel
'
'  OUTPUTS -- ZElapsedTime$
'             ZListNewDate$
'             ZSecLevel$
'             ZUserDnlds$
'             ZUserUplds$
'
'  PURPOSE -- Update the user record for the user when the user
'             exits RBBS-PC.
'
      SUB UpdateU (LoggingOff) STATIC
      IF ZActiveUserName$ = "" OR ZFirstName$ = "" OR _
         ZPswdFailed = ZTrue THEN _
         EXIT SUB
      IF ZUserFileIndex < 1 THEN _
         GOTO 10607
      UpdateDefaults = ZTrue
10602 ZSubParm = 6
      ZWasY$ = ZLastDateTimeOn$
      CALL FileLock
      CALL OpenUser (ZHighestUserRecord)
      FIELD 5,31 AS ZUserName$, _
              15 AS ZPswd$, _
               2 AS ZSecLevel$, _
              14 AS ZUserOption$,  _
              24 AS ZCityState$, _
               1 AS MachineType$, _
               1 AS ZDropTimes$, _
               1 AS ZBankTime$,_
               4 AS ZTodayDl$, _
               4 AS ZTodayBytes$, _
               4 AS ZDlBytes$, _
               4 AS ZULBytes$, _
              14 AS ZLastDateTimeOn$, _
               3 AS ZListNewDate$, _
               2 AS ZUserDnlds$, _
               2 AS ZUserUplds$, _
               2 AS ZElapsedTime$
10604 GET 5,ZUserFileIndex
      IF ZActiveUserFile$ = ZOrigUserFile$ THEN _
         ZUplds = ZGlobalUplds : _
         ZDnlds = ZGlobalDnlds : _
         ZDLToday! = ZGlobalDLToday! : _
         ZBytesToday! = ZGlobalBytesToday! : _
         ZDLBytesVal! = ZGlobalDLBytes! : _
         ZULBytesVal! = ZGlobalULBytes! : _
         ZDropTimesVal = ZGlobalDropTimes : _
         ZBankTimeVal = ZGlobalBankTime _
      ELSE ZBankTimeVal = 0
      LSET ZBankTime$ = CHR$(ZBankTimeVal)
      LSET ZDropTimes$ = CHR$(ZDropTimesVal)
      LSET ZLastDateTimeOn$ = ZWasY$
      LSET ZCityState$ = ZWasCI$
      IF UpdateDefaults THEN _
         CALL DefaultU
      IF ZListDir THEN _
         LSET ZListNewDate$ = CHR$(VAL(MID$(ZCurDate$,7,2))) + _
                              CHR$(VAL(MID$(ZCurDate$,1,2))) + _
                              CHR$(VAL(MID$(ZCurDate$,4,2)))
10605 LSET ZUserDnlds$ = MKI$(ZDnlds)
      LSET ZUserUplds$ = MKI$(ZUplds)
      IF ZEnforceRatios THEN _
         LSET ZTodayDl$ = MKS$(ZDLToday!) : _
         LSET ZTodayBytes$ = MKS$(ZBytesToday!) : _
         LSET ZDlBytes$ = MKS$(ZDLBytesVal!) : _
         LSET ZULBytes$ = MKS$(ZULBytesVal!)
      CALL CheckTime (ZUserLogonTime!, ZSecsUsedSession!, 2)
      IF (NOT ZExitToDoors) AND LoggingOff THEN _
         TempElapsed! = ZElapsedTimeVal + _
                       (ZSecsUsedSession! - ZTimeCredits!) / 60 : _
         ZTimeCredits! = 0 _
      ELSE TempElapsed! = ZElapsedTimeVal - ZExitToDoors*ZMinsInDoors
      IF TempElapsed! < -32767 THEN _
         TempElapsed! = -32767 _
      ELSE IF TempElapsed! > 32767 THEN _
         TempElapsed! = 32767
      LSET ZElapsedTime$ = MKI$(TempElapsed!)
      IF ZAdjustedSecurity THEN _
         LSET ZSecLevel$ = MKI$(ZUserSecLevel)
      PUT 5,ZUserFileIndex
      ZSubParm = 8
      CALL FileLock
      IF ZActiveUserFile$ <> ZOrigUserFile$ AND LoggingOff THEN _
         ZActiveUserFile$ = ZOrigUserFile$ : _
         ZUserFileIndex = ZOrigUserFileIndex : _
         UpdateDefaults = ZFalse : _
         ZAdjustedSecurity = ZFalse : _
         LSET ZLastDateTimeOn$ = ZOrigDateTimeOn$ : _
         GOTO 10602
10607 IF ZExitToDoors OR NOT LoggingOff THEN _
         EXIT SUB
      CALL CheckCarrier
      IF ZSubParm = -1 THEN
         GOTO 10609
      END IF
      IF NOT ZDontShowLogoff THEN
         Temp = ZMinsPerSession
         IF ZMaxPerDay > 0 THEN
            Temp = ZMaxPerDay - TempElapsed!
            IF Temp > ZMinsPerSession THEN
               Temp = ZMinsPerSession
            END IF
         END IF
         Temp = -(Temp > 0) * Temp
         ZOutTxt$ = STR$(Temp)
         CALL Trim (ZOutTxt$)
         '* "{CR{CB"
         CALL FormatString (336,ZFalse,ZFalse,0,ZFalse,0,Strng1$)
         '* "{C6 minutes left Today"
         CALL FormatString (337,ZFalse,ZFalse,0,ZFalse,0,Strng2$)
         CALL QuickTPut1 (Strng1$ + ZOutTxt$ + Strng2$)
         IF ZTempMaxBank > 0 THEN
            '* "{CCBanked Time: {CE{BB"
            CALL FormatString (338,ZFalse,ZFalse,0,ZTrue,1,"")
         END IF
         '* "{C9Thanks for calling {CB{BN {C9and please call again!"
         CALL FormatString (339,ZFalse,ZFalse,0,ZTrue,1,"")
         CALL DelayTime (1)
      END IF
      IF NOT ZHiLiteOff THEN _
         CALL QuickTPut1 (ZColorReset$)
      IF NOT ZLocalUser THEN
         CALL DelayTime (8 + ZCBPS)
      END IF
10609 CALL PutMenu0Info
      CALL SingleNodeDoorClear
      IF ZSysopNext THEN
         '* "O4T200MBMLA64L32C64D64E64"
         CALL FormatString (340,ZFalse,ZFalse,0,ZFalse,0,SoundStr$)
         FOR Count = 1 TO 15
            CALL RBBSPlay (SoundStr$)
         NEXT Count
      END IF
      END SUB
10935 ' $SUBTITLE: 'DosExit -- Setup to exit to DOS for ZSysop'
' $PAGE
'  NAME    -- DosExit
'
'  INPUTS  -- PARAMETER             MEANING
'             ZComPort$
'             ZDoorsTermType
'             ZMultiLinkPresent
'             ZRBBSBat$
'             ZRedirectIOMethod
'             ZUseDeviceDriver$
'
'  OUTPUTS -- ZWasQ                    NUMBER OF LINES TO WRITE OUT TO
'                                      ZRCTTYBat$
'             ZUserInAra$()               LINES TO WRITE OUT TO ZRCTTYBat$
'
'  PURPOSE -- Set up ZUserInAra$() and ZWasQ in order to call "RBBSExit" and
'             exit to DOS for the remote RBBS-PC sysop
'
      SUB DosExit STATIC
10940 '* "Exit To DOS Using a DOOR or use a DOS Command? (Y,[N])"
      CALL FormatString (341,ZFalse,ZFalse,0,ZFalse,0,ZOutTxt$)
      ZTurboKey = -ZTurboKeyUser
      CALL TGet
      ZUserIn$ = UCASE$(ZUserIn$)
      UseDOOR = ZYes
      '* "@ECHO OFF"
      CALL FormatString (1023,ZFalse,ZFalse,0,ZFalse,0,ZOutTxtAra$(1))
      IF ZUseDeviceDriver$ <> "" THEN _
         Port$ = ZUseDeviceDriver$ _
      ELSE Port$ = "COM" + RIGHT$(ZComPort$,1)
      IF ZRedirectIOMethod THEN
         ZOutTxtAra$(2) = ""
         ZOutTxtAra$(4) = ""
         ZFF = 5
         IF NOT ZLocalUser THEN
            ZOutTxtAra$(2) = "CTTY " + Port$
            ZOutTxtAra$(4) = "CTTY CON"
         END IF
         ZOutTxtAra$(3) = ZComSpec$
         ZOutTxtAra$(5) = ZRBBSBat$
      ELSE
         ZFF = 3
         ZOutTxtAra$(2) = ZComSpec$
         IF NOT ZLocalUser THEN
            ZOutTxtAra$(2) = ZOutTxtAra$(2) + _
                             " >" + _
                             Port$ + _
                             " <" + _
                             Port$
         END IF
         ZOutTxtAra$(3) = ZRBBSBat$
      END IF
      IF UseDOOR THEN
         GOTO 10955
      END IF
10950 '* "Exited to DOS at {TM"
      CALL FormatString (342,ZFalse,ZTrue,2,ZFalse,0,"")
      '* "RBBS-PC {ZV{CRRemote Exit To DOS{CRType EXIT to Return.{CRSysop in Remote Console mode"
      CALL FormatString (343,ZFalse,ZFalse,0,ZTrue,1,"")
      CALL RBBSExit (ZOutTxtAra$(),ZFF)
10955 '* "Enter Name of DOOR to use including Extension or DOS Command{EX"
      CALL FormatString (344,ZFalse,ZFalse,0,ZFalse,0,ZOutTxt$)
      CALL TGet
      ZUserIn$ = UCASE$(ZUserIn$)
      IF ZUserIn$ = "" or ZWasQ = 0 THEN _
         GOTO 10940
      CALL FindFile (ZUserIn$,Found)
      IF Found THEN
         ZWasZ$ = ZUserIn$
         ZWasP$ = ZWasZ$
         CALL DoorExit (ZFalse)
      ELSE
         SELECT CASE ZFF
            CASE 5
               ZOutTxtAra$(3) = ZUserIn$
            CASE 3
               ZOutTxtAra$(2) = ZUserIn$
               IF NOT ZLocalUser THEN
                  ZOutTxtAra$(2) = ZOutTxtAra$(2) + " >" + Port$ + " <" + Port$
               END IF
         END SELECT
         CALL RBBSExit (ZOutTxtAra$(),ZFF)
      END IF
      END SUB
10976 ' $SUBTITLE: 'WordInFile -- Searches a file to find a word'
' $PAGE
'  NAME    -- WordInFile
'
'  INPUTS  -- PARAMETER             MEANING
'             FilName$              FILE TO SEARCH IN
'             Strng$                STRING TO SEARCH FOR
'             CheckSmart            PROCESS SMARTTEXT CHARACTERS
'
'  OUTPUTS -- InFile                WHETHER STRING Found IN FILE
'
'  PURPOSE -- Searches for "Strng$" in file "FILNAME$."  Used to
'             limit doors and questionnaires to those specified
'             in their menu files.  The "Strng$" is capitalized
'             but not the lines in the file, so must be exact
'             case-sensitive match to be found.  The only character
'             that can immediately proceed or end a name to be
'             found must be a blank.
'
      SUB WordInFile (FilName$,Strng$,InFile,CheckSmart) STATIC
      InFile = ZFalse
      CALL FindIt (FilName$)
      IF NOT ZOK THEN _
         EXIT SUB
      WasX = 0
      Strng$ = UCASE$(Strng$)
      WHILE NOT EOF(2) AND WasX < 1
         LINE INPUT #2,ZOutTxt$
         IF CheckSmart THEN
            CALL SmartText (ZOutTxt$,ZTrue,ZFalse,ZFalse)
         END IF
         ZOutTxt$ = UCASE$(ZOutTxt$)
         WasY = 1
10978    WasX = INSTR(WasY,ZOutTxt$,Strng$)
         IF WasX < 1 THEN _
            GOTO 10980
10980 WEND
      CLOSE 2
      InFile = (WasX > 0)
      END SUB
10983 ' $SUBTITLE: 'DoorExit -- Setup to exit to a "door"'
' $PAGE
'  NAME    -- DoorExit
'
'  INPUTS  -- PARAMETER             MEANING
'             ZMultiLinkPresent
'             ZNodeID$
'             ZRBBSBat$
'             ZWasZ$
'
'  OUTPUTS -- ZWasQ                    NUMBER OF LINES TO WRITE OUT TO
'                                      ZRCTTYBat$
'             ZUserInAra$()               LINES TO WRITE OUT TO ZRCTTYBat$
'
'  PURPOSE -- Set up ZOutTxtAra$() in order to call "EXITRBBS" and exit
'             RBBS-PC to invoke another program
'
      SUB DoorExit (ReqDoorsDef) STATIC
      IF ZWasZ$ = "" OR _
         ZWasZ$ = "NONE" THEN _
         EXIT SUB
      CALL FindIt (ZWasP$)
      IF NOT ZOK THEN _
         GOTO 10986
      CALL BreakFileName (ZWasZ$,WasX$,ExitTo$,ExitMethod$,ZFalse)
      ExitMethod$ = ""
      ZDooredTo$ = ExitTo$
      CALL FindIt (ZDoorsDef$)
      IF NOT ZOK THEN _
         IF ReqDoorsDef THEN _
            EXIT SUB _
         ELSE ExitTo$ = ExitTo$ + SPACE$(1) + ZNodeID$ : _
              GOTO 10989
10985 CALL ReadParms (ZOutTxtAra$(),14,1)
      IF ZErrCode THEN _
         IF ReqDoorsDef THEN _
            EXIT SUB _
         ELSE ExitTo$ = ExitTo$ + SPACE$(1) + ZNodeID$ : _
              GOTO 10989
      IF ExitTo$ <> ZOutTxtAra$(2) THEN _
         GOTO 10985
      CALL CheckInt (ZOutTxtAra$(3))
      IF ZErrCode THEN _
         ZErrCode = 0 : _
         GOTO 10985
      IF ZUserSecLevel < ZTestedIntValue THEN
         '* "Insufficient security for door"
         CALL FormatString (345,ZFalse,ZFalse,0,ZTrue,1,"")
         EXIT SUB
      END IF
      WasX$ = LEFT$(ZOutTxtAra$(6),INSTR(ZOutTxtAra$(6)+SPACE$(1),SPACE$(1))-1)
      CALL FindIt (WasX$)
      IF NOT ZOK THEN _
         GOTO 10986
      ZFileName$ = ZOutTxtAra$(4)
      ExitMethod$ = ZOutTxtAra$(5)
      ExitTemplate$ = ZOutTxtAra$(6)
      ZDoorSkipsPswd = (ZOutTxtAra$(7) <> "Y")
      ZDoorDisplay$ = ZOutTxtAra$(8)
      ZDoorTime$ = ZOutTxtAra$(9)
      ZDoorDropFile$ = ZOutTxtAra$(10)
      ZDoorCarrierDropOK$ = ZOutTxtAra$(11)
      MultiNode$ = ZOutTxtAra$(12)
      ZUseSysopName$ = ZOutTxtAra$(13)
      ZMaxDoorSec = VAL(ZOutTxtAra$(14))
      IF MultiNode$ <> "M" THEN
         CALL SingleNodeDoorCheck (ZOutTxtAra$(2))
         IF NOT ZOK THEN
            '* "{CR{CESorry, {DN door in use on another node!  Try again later."
            CALL FormatString (346,ZFalse,ZFalse,0,ZTrue,1,"")
            CALL SmartPause (ZTrue)
            EXIT SUB
         END IF
      END IF
      CALL BreakFileName (ZFileName$,Drive$,Body$,Ext$,ZTrue)
      CALL FindFile (ZQuesPath$+Body$+Ext$,Found)
      IF Found THEN
         CALL AskUsers
      ELSE
         CALL GraphicDisplayFile (ZFileName$)
      END IF
      CALL SmartText (ExitTemplate$,ZFalse,ZFalse,ZFalse)
      CALL MetaGSR (ExitTemplate$,ZFalse)
      ExitTo$ = ExitTemplate$
      GOTO 10989
10986 '* "Missing door program {ZZ"
      CALL FormatString (347,ZFalse,ZTrue,1,ZFalse,0,ZOutTxt$)
      ZSnoop = ZTrue
      CALL LPrnt (ZOutTxt$,1)
      EXIT SUB
10989 IF ZTransferFunction = 3 THEN
         '* "{C2Swapping {CB{BN {C2out and the {CBRegistration {C2door in!{RC"
         LineNum = 348
         '* "Registration"
         CALL FormatString (1024,ZFalse,ZFalse,0,ZFalse,0,ZWasY$)
      ELSE
         '* {C2Swapping {CB{BN {C2out and the {CB{DN {C2door in!{RC"
         LineNum = 349
         ZWasY$ = ZDooredTo$
      END IF
      CALL FormatString (LineNum,ZFalse,ZFalse,0,ZFalse,0,ZOutTxt$)
      CALL SaveUserActivity("D", ZNodeRecIndex, ZFalse,WasAV)
      ZSubParm = 5
      CALL TPut
      '* "{DN door opened!"
      CALL FormatString (350,ZFalse,ZTrue,2,ZFalse,0,"")
      CALL DoorInfo
      IF ExitMethod$ = "S" THEN
         CALL UpdateU (ZFalse)
         CALL SaveProf (1)
         CLOSE 4,5,16
         CALL ShellExit (ExitTemplate$)
         CALL ReadProf
         IF MultiNode$ <> "M" THEN
            CALL SingleNodeDoorClear
         END IF
         ZPrevCaller$ = ""
         CALL SetCall
         ZExitToDoors = ZTrue
         CALL DoorReturn
         ZExitToDoors = ZFalse
         IF NOT ZDoorSkipsPswd THEN
            ZSubParm = 4
            CALL Passwrd
            IF ZPswdFailed THEN
               ZSubParm = -6
            END IF
         END IF
      ELSE
         ZOutTxtAra$(1) = ZComSpec$ + _
                     " /C " + _
                     ExitTo$
         ZOutTxtAra$(2) = ZRBBSBat$
         CALL RBBSExit (ZOutTxtAra$(),2)
      END IF
      END SUB
10991 ' $SUBTITLE: 'DoorInfo -- Write info for doors to file'
      SUB DoorInfo STATIC
      CLOSE 2
      IF ZDoorDropFile$ = "R" OR ZDoorDropFile$ = "S" OR ZDoorDropFile$ = "U" THEN
         CALL DoorSys
         IF ZDoorDropFile$ = "U" THEN
            CALL UserInfo
         END IF
         EXIT SUB
      END IF
      IF ZDoorDropFile$ = "P" THEN _
         CALL PCBoardSys : _
         EXIT SUB
      OPEN "O",2,"DORINFO" + _
                 ZNodeFileID$ + _
                 ".DEF"
      PRINT #2,ZRBBSName$
      PRINT #2,ZSysopFirstName$
      PRINT #2,ZSysopLastName$
      IF ZLocalUser THEN _
         PRINT #2,"COM0" _
      ELSE PRINT #2,ZComPort$
      ZUserIn$ = ZTalkToModemAt$ + " BAUD" + _
                 MID$("-R",1,-(ZReliableMode * 2)) + _
                 MID$(ZBaudParity$, INSTR(ZBaudParity$, ","))
      PRINT #2,ZUserIn$
      PRINT #2,ZNetworkType
      IF ZGlobalSysop THEN
         IF ZUseSysopName$ = "N" OR ZFileSysParm THEN
            PRINT #2,"SYSOP"
            PRINT #2,""
         ELSE
            PRINT #2,ZSysopFirstName$
            PRINT #2,ZSysopLastName$
         END IF
      ELSE
         IF ZOrigUserName$ <> ZActiveUserName$ THEN
            FirstNameEnd = INSTR(ZActiveUserName$,SPACE$(1))
            IF FirstNameEnd > 0 THEN
               PRINT #2,MID$(ZActiveUserName$,1,FirstNameEnd-1)
               PRINT #2,MID$(ZActiveUserName$,FirstNameEnd+1)
            ELSE
               PRINT #2,ZActiveUserName$
               PRINT #2,""
            END IF
         ELSE
            PRINT #2,ZFirstName$
            PRINT #2,ZLastName$
         END IF
      END IF
      PRINT #2,ZWasCI$
      IF ZWasGR > 2 OR ZCanANSIChat OR ZRIPGraphics THEN PRINT #2, 2 _
      ELSE PRINT #2,ZWasGR
      PRINT #2,ZUserSecLevel
      CALL TimeRemain (MinsRemaining)
      CALL CheckInt (ZDoorTime$)
      IF ZErrCode = 0 AND ZTestedIntValue > 0 THEN _
         IF MinsRemaining > ZTestedIntValue THEN _
            MinsRemaining = ZTestedIntValue
      PRINT #2,STR$(INT(MinsRemaining))
      PRINT #2,ZFossil
      CLOSE 2
      END SUB
10992 ' $SUBTITLE: 'RBBSExit -- Setup to exit RBBS'
' $PAGE
'  NAME    -- RBBSExit
'
'  INPUTS  -- PARAMETER             MEANING
'             LINE.ARA        Array of lines to write to batch file
'             NumLines        How many lines in array
'
'  OUTPUTS -- ZRCTTYBat$
'
'  PURPOSE -- To create a batch file that control can be passed to
'             and to exit RBBS-PC while still keeping carrier up
'
      SUB RBBSExit (LineAra$(1),NumLines) STATIC
      CLOSE 2
      IF NumLines = 0 THEN _
         GOTO 10994
      OPEN "O",2,ZRCTTYBat$
      FOR WasI = 1 TO NumLines
         IF LineAra$(WasI) <> "" THEN _
            PRINT #2,LineAra$(WasI)
      NEXT
      CLOSE 2
10994 CLOSE 3
      ZExitToDoors = ZTrue
      IF NOT ZFossil THEN _
         OUT ZModemCntlReg,INP(ZModemCntlReg) OR 1
10996 CALL UpdateU (ZTrue)
      CALL GetTime
      CALL SaveProf (1)
      IF NumLines = 0 THEN _
         EXIT SUB
      CALL DelayTime (9 + ZBPS)
      IF ZFossil THEN _
         CALL FOSExit(ZComPortNum)
      END ZExitCode
      END SUB
12000 ' $SUBTITLE: 'SetSection -- Setup section prompts'
' $PAGE
'  NAME    -- SetSection         Doug Azzarito
'
'  INPUTS  -- PARAMETER             MEANING
'             ZMenuIndex      2 = user is in MAIN section
'                             3 = user is in FILE section
'                             4 = user is in UTIL section
'                             6 = user is in LIBR section
'
'  OUTPUTS -- ZSection$       4 character section name
'             ZActiveMenu$    1 character section name
'             ZSectionPrompt$ Section name (if ZShowSection config)
'             ZCmdPrompt$     Command input prompt string
'             ZSectionOpts$   List of options valid in this sect
'             ZInvalidOpts$   List of options invalid in this sect
'             ZSubSection     Index into security array for section
'
'  PURPOSE -- To build the prompt strings for the current section
'
      SUB SetSection STATIC
      IF ZMenuIndex <> 6 THEN _
         ZCurDirPath$ = ZDirPath$
      ON ZMenuIndex GOTO 12001, 12010,12005,12020,12001
12001 EXIT SUB
12005 '* "FILE"
      LineNum = 351
      GOSUB 12030
      LSET ZSection$ = Strng$
      ZSectionOpts$ = ZFileOpts$
      ZInvalidOpts$ = ZInvalidFileOpts$
      ZSubSection = ZBegFile
      GOTO 12025
12010 '* "MAIN"
      LineNum = 352
      GOSUB 12030
      LSET ZSection$ = Strng$
      ZSectionOpts$ = ZMainOpts$
      ZInvalidOpts$ = ZInvalidMainOpts$
      ZSubSection = ZBegMain
      GOTO 12025
12020 '* "UTIL"
      LineNum = 353
      GOSUB 12030
      LSET ZSection$ = Strng$
      ZSectionOpts$ = ZUtilOpts$
      ZInvalidOpts$ = ZInvalidUtilOpts$
      ZSubSection = ZBegUtil
12025 ZActiveMenu$ = LEFT$(ZSection$,1)
      LSET ZLastCommand$ = ZActiveMenu$ + SPACE$(1)
      IF ZShowSection THEN
         ZSectionPrompt$ = ZSection$
      ELSE
         '* "Your"
         LineNum = 354
         GOSUB 12030
         ZSectionPrompt$ = Strng$
      END IF
      IF ZCmndsInPrompt=0 THEN _
          ZSectionOpts$ = ""
      '* "{C2{SPcommand"
      LineNum = 355
      GOSUB 12030
      ZCmdPrompt$ = ZSectionPrompt$ + Strng$ + ZSectionOpts$
      EXIT SUB
12030 CALL FormatString (LineNum,ZFalse,ZFalse,0,ZFalse,0,Strng$)
      RETURN
      END SUB
12878 ' $SUBTITLE: 'UntilRight - asks question until answer okay'
' $PAGE
'
'  NAME    -- UntilRight
'
'  INPUTS  -- PARAMETER             MEANING
'             Ques$         QUESTION TO BE ASKED THE USER
'             Ans$          LOCATION TO STORE THE ANSWER
'             MinLen        MINIMUM LENGTH OF ANSWER
'             MaxLen        MAX LENGTH OF ANSWER
'
'  OUTPUTS -- Ans$          RESPONSE TO THE QUESTION WHICH THE
'                                      CALLERS SAYS IS CORRECT
'
'  PURPOSE -- Subroutine to ask a user a question until the caller
'             responds that the answer is correct
'
      SUB UntilRight (Ques$,Ans$,MinLen,MaxLen) STATIC
12880 ZParseOff = ZTrue
      ZOutTxt$ = Ques$
      CALL PopCmdStack
      IF ZSubParm = -1 THEN _
         GOTO 12882
      IF ZWasQ = 0 THEN _
         GOTO 12880
      IF LEN(ZUserInAra$(ZAnsIndex)) > MaxLen THEN
         ZLastIndex = 0
         '* "{SPchars max"
         LineNum = 356
         GOSUB 12890
         CALL QuickTPut1 (STR$(MaxLen) + Strng$)
         GOTO 12880
      ELSEIF LEN(ZUserInAra$(ZAnsIndex)) < MinLen THEN
         ZLastIndex = 0
         '* "{SPchars min"
         LineNum = 357
         GOSUB 12890
         CALL QuickTPut1 (STR$(MinLen) + Strng$)
         GOTO 12880
      END IF
      Ans$ = ZUserInAra$(ZAnsIndex)
      IF ZAnsIndex < ZLastIndex THEN _
         GOTO 12881
      '* ", right? ([Y],N)"
      LineNum = 358
      GOSUB 12890
      ZOutTxt$ = ZUserInAra$(ZAnsIndex) + Strng$
      ZTurboKey = -ZTurboKeyUser
      ZSubParm = 1
      CALL TGet
      IF ZSubParm = -1 THEN _
         GOTO 12882
      IF ZNo THEN _
         GOTO 12880
12881 Ans$ = UCASE$(Ans$)
      EXIT SUB
12882 '* "GUEST"
      LineNum = 359
      GOSUB 12890
      Ans$ = Strng$
      EXIT SUB
12890 CALL FormatString (LineNum,ZFalse,ZFalse,0,ZFalse,0,Strng$)
      RETURN
      END SUB
13660 ' $SUBTITLE: 'LogError - sub to log errors to CALLERS file'
' $PAGE
'
'  NAME    -- LogError
'
'  INPUTS  --     PARAMETER                    MEANING
'                    ERR           ERROR NUMBER DETECTED BY BASIC
'                    ERL           Last LINE NUMBER ENCOUNTERED
'                                  PRIOR TO ENCOUNTERNING ERROR
'
'  OUTPUTS -- NONE
'
'  PURPOSE -- To set up a string to write to the callers log
'             indicating the date, time, error, and error line
'
      SUB LogError STATIC
      WasIX = ERR
      IF ERR < 1 THEN _
         WasIX = ZErrCode
      CALL UpdtCalr(STRING$(3,43) + SPACE$(1) + "Error " + _
           STR$(WasIX) + _
           " line " + _
           STR$(ERL) + _
           " at " + _
           TIME$ + _
           " on " + _
           DATE$,2)
      END SUB
'
20235 ' $SUBTITLE: 'BadName - subroutine to find bad file names'
' $PAGE
'
'  NAME    -- BadName
'
'  INPUTS  --     PARAMETER                    MEANING
'               ZActiveMessageFile$
'               ZActiveUserFile$
'               ZCallersFile$
'               ZCmntsFile$
'               ZConfigFileName$
'               ZMainMsgBackup$
'               ZMainMsgFile$
'               ZMaxViolations
'               ZPswdFile$
'               ZRBBSBat$
'               ZRCTTYBat$
'               ZSubDir$()
'               ZSubDirIndex
'               ZViolation$
'               ZViolationsThisSession
'               ZWasZ$                          NAME OF FILE
'               ProtectExt              -1 if check for extension
'                                        0 to allow any extension
'
'  OUTPUTS  -- BadFileNameIndex         1 = FILE NAME IS OK
'                                       2 = SECURITY BREACH TRIED
'
'  PURPOSE -- To protect RBBS-PC against the use of bad file names
'             to either crash the system or to breach RBBS-PC's security
'
      SUB BadName (BadFileNameIndex,ProtectExt) STATIC
'
'
' *  TEST FOR SYSTEM FILE ATTEMPT
'
      BadFileNameIndex = 2
      ZWasZ$ = ZFileName$
      CALL BreakFileName (ZFileName$,DR$,Prefix$,Extension$,ZFalse)
      IF LEN(Extension$) = 3 AND ProtectExt THEN
         '* "DEF,MNU,OLD,PUI,BAK"
         CALL FormatString (379,ZFalse,ZFalse,0,ZFalse,0,Strng$)
         IF INSTR(Strng$,Extension$+",") > 0 THEN
            EXIT SUB
         END IF
      END IF
      ZOK = 0
      IF ProtectExt THEN _
         CALL FileNameCheck (ZActiveMessageFile$,Prefix$,Extension$)
      CALL FileNameCheck (ZActiveUserFile$,Prefix$,Extension$)
      CALL FileNameCheck (ZCallersFile$,Prefix$,Extension$)
      CALL FileNameCheck (ZCmntsFile$,Prefix$,Extension$)
      CALL FileNameCheck (ZFileSecFile$,Prefix$,Extension$)
      CALL FileNameCheck (ZMainMsgBackup$,Prefix$,Extension$)
      CALL FileNameCheck (ZOrigMsgFile$,Prefix$,Extension$)
      CALL FileNameCheck (ZOrigUserFile$,Prefix$,Extension$)
      CALL FileNameCheck (ZPswdFile$,Prefix$,Extension$)
      CALL FileNameCheck (ZRBBSBat$,Prefix$,Extension$)
      CALL FileNameCheck (ZRCTTYBat$,Prefix$,Extension$)
      CALL FileNameCheck (ZConfigFileName$,Prefix$,Extension$)
      IF ZOK = 0 THEN _
         BadFileNameIndex = 1
      END SUB
20240 ' $SUBTITLE: 'FileNameCheck - checks file match except for drive'
' $PAGE
'
'  NAME    -- FileNameCheck
'
'  INPUTS  --     PARAMETER                    MEANING
'               CheckThis$           Name of file to check
'               Pref2$               Prefix to match against
'               Ext2$                Extension to match against
'
'  OUTPUTS  -- ZOK                    1 if got match
'
'  PURPOSE -- Checks for match on both prefix and extension of a file
'             name.   Used to catch match on system files not to be
'             downloaded.
'
      SUB FileNameCheck (CheckThis$,Pref2$,Ext2$) STATIC
      IF ZOK > 0 THEN _
         EXIT SUB
      CALL BreakFileName (CheckThis$,DR$,Pref1$,Ext1$,ZFalse)
      IF Pref1$ = Pref2$ THEN _
         IF Ext1$ = Ext2$ THEN _
            ZOK = 1
      END SUB
20245 SUB SetBPS (BaudTest!,BPS) STATIC
      IF BaudTest! > 0 AND BaudTest! < 100 THEN _
         BaudTest! = BaudTest! * 100  ' Support 14.4 for 14,400
      IF BaudTest! = 2400 THEN _
         BPS = -4 _
      ELSE IF BaudTest! = 1200 OR BaudTest! = 1275 THEN _
         BPS = -3 _
      ELSE IF BaudTest! >= 7200 AND BaudTest! < 19200 THEN _
         GOTO 20246 _
      ELSE IF BaudTest! = 0 OR BaudTest! = 300 THEN _
         BaudTest! = 300 : _
         BPS = -1 _
      ELSE IF BaudTest! = 19200 THEN _
         BPS = -11 _
      ELSE IF BaudTest! = 21600 THEN _
         BPS = -12 _
      ELSE IF BaudTest! = 24000 THEN _
         BPS = -13 _
      ELSE IF BaudTest! = 26400 THEN _
         BPS = -14 _
      ELSE IF BaudTest! = 28800 THEN _
         BPS = -15 _
      ELSE IF BaudTest! = 31200 THEN _
         BPS = -16 _
      ELSE IF BaudTest! = 33600 THEN _
         BPS = -17 _
      ELSE IF BaudTest! = 38400 THEN _
         BPS = -18 _
      ELSE IF BaudTest! = 57600 THEN _
         BPS = -19 _
      ELSE IF BaudTest! = 64000 THEN _
         BPS = -20 _
      ELSE IF BaudTest! = 76800 THEN _
         BPS = -21 _
      ELSE IF BaudTest! = 115200 THEN _
         BPS = -22 _
      ELSE IF BaudTest! = 4800 THEN _
         BPS = -5 _
      ELSE BPS = 0
      EXIT SUB
20246 IF BaudTest! = 14400 THEN _
         BPS = -9 _
      ELSE IF BaudTest! = 16800 THEN _
         BPS = -10 _
      ELSE IF BaudTest! = 7200 THEN _
         BPS = -6 _
      ELSE IF BaudTest! = 12000 THEN _
         BPS = -8 _
      ELSE BPS = -7       ' 9600
      END SUB
'
20340 ' $SUBTITLE: 'QuickPeek - Easy find user to send message to'
' $PAGE
'  NAME    -- QuickPeek - A Dan & Howard Mod - Dan Drinnon 1992
'
'  INPUTS  --     PARAMETER                    MEANING
'
'  OUTPUTS --     ZUserIn$                Search String User Input
'                 MsgTo$                  Who Message is To
'  PURPOSE -- Save User keystrokes when looking for message addressee
'
      SUB QuickPeek (ZUserIn$,MsgTo$,Found,FromUsers)  Static
      IF Found = ZTrue THEN EXIT SUB
      IF FromUsers THEN
         '* "{CR{CEChange: {C2"
         LineNum = 1029
      ELSEIF ZFileSysParm > 1 THEN
         '* "{CR{CEUpload To: {C2"
         LineNum = 1027
      ELSE
         '* "{CR{CESend To: {C2"
         LineNum = 1026
      END IF
      CALL FormatString (LineNum,ZFalse,ZFalse,0,ZFalse,0,Action$)
      ZLastDateTimeOnSave$ = ZLastDateTimeOn$
      HoldRecordPosition$ = ZUserRecord$
      UserInName$ = ZUserIn$
      WhichUser = 1
      GOSUB 20355
      NumDots = 0
      CALL OpenUser (ZHighestUserRecord)
      WHILE NOT EOF(5)
         GET #5, WhichUser
         TempMsgTo$ = ZUserName$
         CALL TRIM (TempMsgTo$)
         IF UserInName$ = TempMsgTo$ THEN
            EXIT SUB
         END IF
         IF INSTR(TempMsgTo$,UserInName$) > 0 THEN
            ZSubParm = 1
            CALL QuickTPut (ZBackSpace$,0)
            CALL QuickTPut (Action$ + TempMsgTo$ + SPACE$(1) + ZEmphasizeOff$,0)
            '* "(Y)es,[N]o,A)bort)"
            CALL FormatString (571,ZFalse,ZFalse,0,ZFalse,0,ZOutTxt$)
            ZTurboKey = -ZTurboKeyUser
            CALL PopCmdStack
            IF ZSubParm = -1 THEN
               LSET ZUserRecord$ = HoldRecordPosition$
               EXIT SUB
            END IF
            ZWasZ$ = UCASE$(ZUserInAra$(1))
            IF ZWasZ$ = "A" THEN
               MsgTo$ = ""
               Found = ZTrue
               LSET ZUserRecord$ = HoldRecordPosition$
               EXIT SUB
            END IF
            IF ZWasZ$ = "Y" THEN
               MsgTo$ = TempMsgTo$
               ZUserIn$ = TempMsgTo$
               Found = ZTrue
               LSET ZUserRecord$ = HoldRecordPosition$
               ZLastDateTimeOn$ = ZLastDateTimeOnSave$
               EXIT SUB
            ELSE
               WhichUser = WhichUser + 1
               NumDots = 0
               GOSUB 20355
            END IF
         ELSE
20350       WhichUser=WhichUser + 1
         END IF
         CALL MarkTime (NumDots)
      WEND
      CALL SkipLine (1)
      Found = ZFalse
      LSET ZUserRecord$ = HoldRecordPosition$
      ZLastDateTimeOn$ = ZLastDateTimeOnSave$
      EXIT SUB
20355 '* "{C5Searching For {CB"
      CALL FormatString (1028,ZFalse,ZFalse,0,ZFalse,0,Strng$)
      CALL QuickTPut (Strng$ + MsgTo$ + ZEmphasizeOff$,0)
      RETURN
      END SUB

