' $segment
' $linesize:132
' $title: 'RBBSSUB4.BAS 17.4, Copyright 1986 - 92 by D. Thomas Mack'
'  Copyright 1992 by D. Thomas Mack, all rights reserved.
'  Name ...............: RBBSSUB4.BAS
'  First Released .....: June 21, 1992
'  Subsequent Releases.: 
'  Copyright ..........: 1986 - 1992
'  Purpose.............: The Remote Bulletin Board System for the IBM PC,
'     RBBS-PC.BAS utilizes a lot of common subroutines.  Those that do not
'     require error trapping are incorporated within RBBSSUB 2-5 as
'     separately callable subroutines in order to free up as much
'     code as possible within the 64K code segment used by RBBS-PC.BAS.
'  Parameters..........: Most parameters are passed via a COMMON statement.
'
' Subroutine  Line               Function of Subroutine
'   Name     Number
'  AnyBut         59760  Determine where a "word" begins
'  AskUsers       64003  Ask users questions based on a script and save answers
'  AskMore        59858  Check whether screen full
'  AutoPage       60300  Check whether to notify sysop caller is on
'  BadFileChar    59800  Check file name for bad character
'  Bracket        59960  Puts strings around a substring
'  BufFile        58400  Write a file to the user quickly
'  BufString      58350  Write a string with imbedded CR/LF to the user quickly ' Mpl090202
'  CheckColor     59930  Highlighting based on search string
'  CmndToggle     64635  Processes user command to T)oggle preferences
'  CmndSysopXfer  64640  Sysop function to change Xfer counts
'  ColorDir       59920  Adds colorization to FMS directory entry
'  ColorPrompt    59940  Colorizes prompts
'  CompDate       59880+ Produces a computational data from YY, MM, DD
'  ConfMail       59850  Check conference mail waiting
'  ConvertDir     58950  Checks for U & A (shorthand) and converts appropriately
'  PackDate       59201  Compress date in string format to 2 characters
'  EofComm        60000  Determine whether any chars in comm port buffer
'  ExpireDate     59890  Calculate registration expiration date
'  FakeXRpt       62650  Write out file transfer report for protocols that don't
'  FindEnd        58770  Find where a "word" ends
'  FindFile       58790  Determine whether a file exists without opening it
'  FindLast       58600  Find last occurence of a string
'  FMS            58200  Search the upload management system for entries
'  GetAll         59780  Get list of all directories to display
'  GetDirs        58895  Prompts for directories for file list/new/search cmds
'  GetMsgAttr     62530  Restore attributes of original message
'  GetYMD         59204  Pulls YY, MM, or DD from a 2 byte stored date
'  GlobalSrchRepl 60100  Global search and replace
'  LogPDown       59400  Records download in private directory
'  MarkTime       60200  Give visual feedback during lengthy process
'  MetaGSR        60130  Meta statement global search and replace
'  MsgImport      59698  Allow local user to import a text file to a message
'  Muzak          59100  Play musical themes for different RBBS functions
'  NewPassword    60668  Get a new password
'  Protocol       62600  Determine if external protocols are available
'  PutMsgAttr     62520  Save attributes of original message
'  Remove         58210  Remove characters from within strings
'  RotorsDir      58700  Searches for a file using list of subdirs
'  RptTime        62540  Reports user's time used on system
'  SearchArray    58190  Check for the occurrence of a string in an array
'  SetEcho        59600  Set RBBS properly for who is to echo
'  SetHiLite      59934  Set user preference on highlighting
'  SetGraphic     59980  Sets graphic preference for text file display
'  SetNewUserDef  64645  Sets new user defaults
'  SmartText      58250  Process SMART TEXT control strings
'  SubMenu        59500  Processes options that have sub-menus
'  TimedOut       63000  Write timed exit semaphore file
'  TimeLock       60180  Check for TIME LOCK on certain features
'  Transfer       62624  RBBS-PC support for external protocols for file transfer
'  Toggle         57000  Toggles or views user options
'  TwoByteDate    59200  Reduces a date to 2 byte string for space compression
'  UnPackDate     59902  Uncompresses a 2 byte date
'  UserColor      59965  Lets user set color for text and whether bold
'  UserFace       59450  Processes programmable user interface
'  ViewArc        64600  Display .ARC file contents to user
'  PrivDoorRtn    62629  Private door exit routine
'  WipeLine       58800  Wipes away a line so next prints in its place
'  WordWrap       59710  Adjust a msg -- wrap lines and preserve paragraphs
'
'  $INCLUDE: 'RBBS-VAR.BAS'
'
57000 ' $SUBTITLE: 'Toggle - Toggle User Preferences'
' $PAGE
'
'  NAME    -- Toggle
'
'  INPUTS  -- ToggleOption      Option to toggle or view
'                               according to the following:
'    ToggleOption         PREFERENCE
'   Toggle   VIEW
'     1       -1           AnsiEd Toggle
'     2       -2           Bulletin review on logon
'     3       -3           Case change
'     4       -4           File review on logon
'     5       -5           Highlight
'     6       -6           Line feeds
'     7       -7           Nulls
'     8       -8           TurboKey
'     9       -9           Expert
'    10      -10           Bell
'    11      -11           Chat Availability
'
'  OUTPUTS -- ZSubParm   passed from TPut
'
'  PURPOSE -- Sets or views any single user preference value
'
      SUB Toggle (ToggleOption) STATIC
      ZSubParm = 0
      IF ToggleOption < 0 THEN _
         GOTO 57005
      ON ToggleOption GOSUB _
         57010, _         'AnsiEd toggle
         57120, _         'Bulletin review on logon
         57260, _         'Case change
         57150, _         'File review on logon
         57040, _         'Highlight
         57100, _         'Line feeds
         57210, _         'Nulls
         57230, _         'TurboKey
         57190, _         'Expert
         57170, _         'Bell
         57300, _         'Internode chat availability
         57320, _         'Extended DIR listing
         57340, _         'More Prompt LF
         57660, _         'Read All new mail
         57680            'ANSI Music
      EXIT SUB
57005 CALL AskMore ("",ZTrue,ZTrue,WasX,ZTrue)
      ON -ToggleOption GOSUB _
         57030, _         'AnsiEd Toggle
         57130, _         'Bulletin review on logon
         57270, _         'Case change
         57160, _         'File review on logon
         57050, _         'Highlight
         57110, _         'Line feeds
         57220, _         'Nulls
         57240, _         'TurboKey
         57200, _         'Expert
         57180, _         'Bell
         57310, _         'Internode chat availability
         57330, _         'Extended DIR listing
         57350, _         'More Prompt LF
         57670, _         'Read All new mail
         57690            'ANSI Music
      EXIT SUB
57010 ZFullScreenEditor = NOT ZFullScreenEditor
57030 '* "{CBFull Screen Editor"
      LineNum = 459
      GOSUB 57700
      ZOutTxt$ = Strng$ + FNOffOn$(ZFullScreenEditor) + ZEmphasizeOff$
      GOSUB 57710
     RETURN
57040 IF ZEmphasizeOnDef$ = "" THEN
        '* "Highlighting unavailable"
        CALL FormatString (460,ZFalse,ZFalse,0,ZTrue,1,"")
        RETURN
     END IF
     IF NOT ZHiLiteOff THEN
        CALL QuickTPut (ZColorReset$,0)
     END IF
     CALL SetHiLite (NOT ZHiLiteOff)
     ZHiLiteOffHold = ZHiLiteOff
     GOSUB 57050
     CALL UserColor
     RETURN
57050 IF ZEmphasizeOn$ <> "" THEN
        ZEmphasizeOff$ = ZEscape$ + "[" + ZBoldText$ + _
        ";40;" + MID$(STR$(ZUserTextColor),2) + "m"
     END IF
     '* "{COHighlighting{RC{SP"
     LineNum = 461
     GOSUB 57700
     ZOutTxt$ = Strng$ + FNOffOn$(NOT ZHiLiteOff)
     GOSUB 57710
     RETURN
57100 ZLineFeeds = NOT ZLineFeeds
      IF ZLocalUser THEN
         ZLineFeeds = ZTrue
      END IF
57110 '* "{CBLine Feeds{SP"
      LineNum = 462
      GOSUB 57700
      ZOutTxt$ = Strng$ + FNOffOn$(ZLineFeeds) + ZEmphasizeOff$
      GOSUB 57710
      CALL SetCrLf
      RETURN
57120 ZCheckBulletLogon = NOT ZCheckBulletLogon
57130 IF ZCheckBulletLogon THEN
         '* "{CBCheck all Bulletins at logon{RC"
         LineNum = 463
      ELSE
         '* "{CBSkip all Bulletins at logon{RC"
         LineNum = 464
      END IF
      GOSUB 57720
      RETURN
57150 ZSkipFilesLogon = NOT ZSkipFilesLogon
57160 IF ZSkipFilesLogon THEN
         '* "{CBSkip new files at logon{RC"
         LineNum = 465
      ELSE
         '* "{CBSkip new files at logon{RC"
         LineNum = 466
      END IF
      GOSUB 57720
      RETURN
57170 ZPromptBell = NOT ZPromptBell
57180 IF ZPromptBell THEN
         '* "{CBPrompt Bell On{RC"
         LineNum = 467
      ELSE
         '* "{CBPrompt Bell Off{RC"
         LineNum = 468
      END IF
      GOSUB 57720
      RETURN
57190 ZExpertUser = NOT ZExpertUser
      ZExpertUserHold = ZExpertUser
      CALL SetExpert
57200 IF ZExpertUser THEN
         '* "{CBExpert{RC"
         LineNum = 469
      ELSE
         '* "{CBNovice{RC"
         LineNum = 470
      END IF
      GOSUB 57720
      RETURN
57210 ZNulls = NOT ZNulls
      ZNul$ = MID$(STRING$(5,0),1, - 5 * ZNulls)
      CALL SetCrLf
57220 IF ZNulls THEN
         '* "{CBNulls On{RC"
         LineNum = 471
      ELSE
         '* "{CBNulls Off{RC"
         LineNum = 472
      END IF
      GOSUB 57720
      IF ZNulls AND NOT ZMorePromptLF THEN
         '* "{C9Turning {CBMore Prompt Erasing {C9off{RC"
         CALL FormatString (473,ZFalse,ZFalse,0,ZTrue,1,"")
         ZMorePromptLF = ZTrue
      END IF
      RETURN
57230 ZTurboKeyUser = NOT ZTurboKeyUser
      ZTurboKeyUserHold = ZTurboKeyUser
57240 IF ZTurboKeyUser THEN
         '* "{CBTurboKeys On{RC"
         LineNum = 474
      ELSE
         '* "{CBTurboKeys Off{RC"
         LineNum = 475
      END IF
      GOSUB 57720
      RETURN
57260 IF NOT ZUpperCase THEN
         IF (NOT ZHiLiteOff) OR ZUserGraphicDefault$ = "C" THEN
            '* "Graphics & HiLite must be OFF to use Upper Case!"
            CALL FormatString (476,ZFalse,ZFalse,0,ZTrue,1,"")
            RETURN
         END IF
      END IF
      ZUpperCase = NOT ZUpperCase
57270 IF ZUpperCase THEN
         '* "{CBUPPER CASE ONLY{RC"
         LineNum = 477
      ELSE
         '* "{CBUPPER CASE and lower{RC"
         LineNum = 478
      END IF
      GOSUB 57720
57280 ZUseTPut = (ZUpperCase OR ZXOnXOff)
      RETURN
57300 ZAvailableForChat = NOT ZAvailableForChat
57310 IF ZAvailableForChat THEN
         '* "{CBAvailable for internode chat{RC"
         LineNum = 479
      ELSE
         '* "{CBNOT Available for internode chat{RC"
         LineNum = 480
      END IF
      GOSUB 57720
      RETURN
57320 ZExtendedOff = NOT ZExtendedOff
57330 IF NOT ZExtendedOff THEN
         '* "{CBExtended Directory Lists On{RC"
         LineNum = 481
      ELSE
         '* "{CBExtended Directory Lists Off{RC"
         LineNum = 482
      END IF
      GOSUB 57720
      RETURN
57340 ZMorePromptLF = NOT ZMorePromptLF
57350 IF ZMorePromptLF THEN
         '* "{CBDon't Erase More Prompts{RC"
         LineNum = 483
      ELSE
         '* "{CBErase More Prompts{RC"
         LineNum = 484
      END IF
      GOSUB 57720
      IF NOT ZMorePromptLF AND ZNulls THEN
         '* "{C9Turning {CBNulls {C9off{RC"
         CALL FormatString (485,ZFalse,ZFalse,0,ZTrue,1,"")
         ZNulls = ZFalse
      END IF
      RETURN
57660 ZReadNewMail = NOT ZReadNewMail
57670 IF ZReadNewMail THEN
         '* "{CBRead new mail at logon{RC"
         LineNum = 486
      ELSE
         '* "{CBSkip new mail at logon{RC"
         LineNum = 487
      END IF
      GOSUB 57720
      RETURN
57680 ZANSIMusic = NOT ZANSIMusic
57690 IF ZANSIMusic THEN
         '* "{CBANSI Music On{RC"
         LineNum = 488
      ELSE
         '* "{CBANSI Music Off{RC"
         LineNum = 489
      END IF
      CALL SetANSIMusic
      GOSUB 57720
      RETURN
57700 CALL FormatString (LineNum,ZFalse,ZFalse,0,ZFalse,0,Strng$)
      RETURN
57710 CALL QuickTPut1 (ZOutTxt$)
      RETURN
57720 CALL FormatString (LineNum,ZFalse,ZFalse,0,ZTrue,1,ZOutTxt$)
      RETURN
      END SUB
'
58190 ' $SUBTITLE: 'SearchArray - subroutine to check for a string in an array'
' $PAGE
'
'  NAME    -- SearchArray
'
'  INPUTS  -- PARAMETER                      MEANING
'             Element$                THE STRING TO CHECK FOR
'             Array$()                THE ARRAY TO BE SEARCHED
'             NumEntriesToSearch      NUMBER OF ENTRIES WITHIN IN
'                                     THE ARRAY TO BE SEARCHED
'
'  OUTPUTS -- IsInAra                 0 = STRING NOT Found IN THE
'                                         ARRAY SPECIFIED
'                                     OTHERWISE IT IS THE NUMBER sOF
'                                     ELEMENT WITHIN THE ARRAY THAT
'                                     WAS Found TO MATCH
'
'  PURPOSE -- Search an array for a specified string and, if found,
'             return the number of the element that matched.
'
      SUB SearchArray (Element$,LookArray$(1),NumEntriesToSearch,IsInAra) STATIC
      IsInAra = 1
      CALL AllCaps (Element$)
      MaxTries = NumEntriesToSearch + 1
      LookArray$(MaxTries) = Element$
      WHILE LookArray$(IsInAra) <> Element$
         IsInAra = IsInAra + 1
      WEND
      IF IsInAra = MaxTries THEN _
         IsInAra = 0
      END SUB
'
58210 ' $SUBTITLE: 'Remove - subroutine to delete a string from within a string'
' $PAGE
'
'  NAME    -- Remove
'
'  INPUTS  -- PARAMETER                      MEANING
'             BADSTRING$              STRING CONTAINING CHARACTERS
'                                     TO BE DELETED FROM "WasL$"
'             WasL$                      STRING TO BE ALTERED
'
'  OUTPUTS -- WasL$                      WITH THE CHARACTERS IN
'                                     "BADSTRING#" DELETED FROM IT
'
'  PURPOSE -- To remove all instances of the characters in
'                        "BADSTRING$" from "WasL$"
'
      SUB Remove (WasL$,BadString$) STATIC
      WasJ = 0
      FOR WasI=1 TO LEN(WasL$)
         IF INSTR(BadString$,MID$(WasL$,WasI,1)) = 0 THEN _
            WasJ = WasJ + 1 : _
            MID$(WasL$,WasJ,1) = MID$(WasL$,WasI,1)
      NEXT WasI
      WasL$ = LEFT$(WasL$,WasJ)
      END SUB
'
58250 ' $SUBTITLE: 'SmartText - smart text substitution'
' $PAGE
'
'  NAME    -- SmartText   (WRITTEN BY DOUG AZZARITO)
'
'                         (Revised 081893/081802 - DAN DRINNON)
'
'
'  INPUTS  -- StringWork$        string to scan for Smart Text
'             CRFound            Does this line contain a CR?
'             ZSmartTextCode     Smart Text control code
'             ReadMsgs           Message Read flag
'
'  OUTPUTS -- StringWork$        Input string with Smart Text replaced
'
'  PURPOSE -- Smart Text allows control strings in text files
'             to be replaced at runtime with user info or other
'             data.  The Smart Text control code is a 1-byte
'             code (configurable) with a 2-byte action code.
'
      SUB SmartText (StringWork$, CRFound, OverStrike, ReadMsgs)

      STATIC SmartCarry$
      STATIC Overlay

      NA$ = "(n/a)"
      NONE$ = "(none)"

      IF SmartCarry$ <> "" THEN
         StringWork$ = SmartCarry$ + StringWork$
      END IF

      Index = INSTR(StringWork$, ZSmartTextChar$)

58252 WHILE Index > 0 AND Index < LEN(StringWork$) - 1

         IF INSTR(MID$(StringWork$, Index + 1,2), SPACE$(1)) THEN
            SmartAct = 0
         ELSE
            SmartAct = INSTR(ZSmartTable$, MID$(StringWork$, Index + 1, 2))
         END IF

         IF SmartAct = 0 THEN
            WasI = 1
         ELSE
            SmartHold$ = ""

            SaveSmart = ZFalse

            SmartAct = (SmartAct+2)/3

58254       SELECT CASE SmartAct

               CASE 1                           ' CS Reset ZLinesPrinted
                  IF NOT ReadMsgs THEN
                     ZLinesPrinted = 0
                  END IF

               CASE 2                           ' PB Page Break
                  ZLinesPrinted = ZPageLength
                  IF ZNonStop THEN              ' force a 1-time pause
                     ZOneStop = ZTrue           ' if NON STOP is on
                     ZNonStop = ZFalse
                  END IF
                  ZForceKeyboard = ZTrue

               CASE 3                           ' NS Non-stop
                  IF NOT ReadMsgs THEN
                     ZNonStop = ZTrue
                  END IF

               CASE 4                           ' FN First Name
                  IF ZGlobalSysop THEN
                     SmartHold$ = ZOrigSysopFN$
                  ELSE
                     SmartHold$ = ZFirstName$
                  END IF
                  CALL NameCaps(SmartHold$)

               CASE 5                           ' LN Last Name
                  IF ZGlobalSysop THEN          
                     SmartHold$ = ZOrigSysopLN$
                  ELSE
                     SmartHold$ = ZLastName$
                  END IF
                  CALL NameCaps(SmartHold$)

               CASE 6                           ' SL Security level
                  SmartHold$ = STR$(ZUserSecLevel)
                  TrimSmart = ZTrue

               CASE 7                           ' DT Date
                  SmartHold$ = DATE$

               CASE 8                           ' TM Time
                  CALL AMorPM
                  SmartHold$ = ZTime$

               CASE 9                           ' TR Time Remaining
                  CALL TimeRemain(MinsRemaining)
                  SmartHold$ = MID$(STR$(INT(MinsRemaining)),2)

               CASE 10                          ' TE Time elapsed (mm:ss)
                  CALL TimeRemain(MinsRemaining)
                  SmartHold$ = MID$(STR$(INT(ZSecsUsedSession!/60)),2) + _
                               ":" + _
                               MID$(STR$((ZSecsUsedSession! MOD 60)+100),3)

               CASE 11                          ' TL - Time Lock period
                   SmartHold$ = MID$(STR$(INT((ZTimeLockSet + 0.5) / 60)),2)
                   SmartHold$ = SmartHold$ + ":" + _
                                MID$(STR$((ZTimeLockSet MOD 60) + 100),3)

               CASE 12                          ' RP Registration Length
                   IF ZDaysInRegPeriod > 0 THEN
                      SmartHold$ = MID$(STR$(ZDaysInRegPeriod),2)
                   ELSE
                      SmartHold$ = NA$
                   END IF

               CASE 13                         ' RR Registration Remaining
                  IF ZDaysInRegPeriod > 0 THEN
                     SmartHold$ = MID$(STR$(ZRegDaysRemaining),2)
                  ELSE
                     SmartHold$ = NA$
                  END IF

               CASE 14                         ' CT Users CITY & STATE
                  SmartHold$ = ZCityState$
                  TrimSmart = ZTrue

               CASE 15                         ' C1 Color 1
                  SmartHold$ = ZFG1$
                  SaveSmart = ZTrue

               CASE 16                         ' C2 Color 2
                  SmartHold$ = ZFG2$
                  SaveSmart = ZTrue

               CASE 17                         ' C3 Color 3
                  SmartHold$ = ZFG3$
                  SaveSmart = ZTrue

               CASE 18                         ' C4 Color 4
                  SmartHold$ = ZFG4$
                  SaveSmart = ZTrue

               CASE 19                         ' C0 Color 1
                  SmartHold$ = ZFG0$
                  SaveSmart = ZTrue

58255          CASE 20                         ' DD files Dnlded TODAY
                  SmartHold$ = MID$(STR$(INT(ZDLToday! + ZDownFiles)),2)

               CASE 21                         ' BD Bytes Dnlded TODAY
                  SmartHold$ = MID$(STR$(INT(ZBytesToday! + ZNumDnldBytes!)),2)

               CASE 22                         ' DB Download Bytes
                  SmartHold$ = MID$(STR$(INT(ZDLBytesVal! + ZNumDnldBytes!)),2)

               CASE 23                         ' UB Upload Bytes
                  SmartHold$ = MID$(STR$(INT(ZULBytesVal!)),2)

               CASE 24                         ' DL Number of Dnlds
                  SmartHold$ = MID$(STR$(ZDnlds + ZDownFiles),2)

               CASE 25                         ' UL Number of Uplds
                  SmartHold$ = MID$(STR$(ZUplds),2)

               CASE 26                         ' FI  File Name
                  IF NOT ReadMsgs THEN
                     SmartHold$ = ZFileName$
                  END IF

               CASE 27                         ' VY Overlay ON
                  IF NOT ReadMsgs THEN
                     Overlay = ZTrue
                  END IF

               CASE 28                         ' VN Overlay OFF
                  IF NOT ReadMsgs THEN
                     Overlay = ZFalse
                  END IF

               CASE 29                         ' TY Trim Yes
                  IF NOT ReadMsgs THEN
                     TrimSmart = ZTrue
                  END IF

               CASE 30                         ' TN Trim No
                  IF NOT ReadMsgs THEN
                     TrimSmart = ZFalse
                  END IF

               CASE 31                         ' BN Board Name
                  SmartHold$ = ZOrigRBBSName$

               CASE 32                         ' ND Node Number
                  SmartHold$ = ZNodeID$

               CASE 33                         ' FS Sysops First Name
                  SmartHold$ = ZSysopFirstName$
                  CALL NameCaps(SmartHold$)

               CASE 34                         ' LS Sysops First Name
                  SmartHold$ = ZSysopLastName$
                  CALL NameCaps(SmartHold$)

               CASE 35                         ' CN Conference Name
                  SmartHold$ = ZConfName$

               CASE 36
                  SmartHold$ = ZFG5$           ' C5 Color 5
                  SaveSmart = ZTrue

               CASE 37
                  SmartHold$ = ZFG6$           ' C6 Color 6
                  SaveSmart = ZTrue

               CASE 38
                  SmartHold$ = ZFG7$           ' C7 Color 7
                  SaveSmart = ZTrue

               CASE 39
                  SmartHold$ = ZFG8$           ' C8 Color 8
                  SaveSmart = ZTrue

58256          CASE 40
                  SmartHold$ = ZFG9$           ' C9 Color 9
                  SaveSmart = ZTrue

               CASE 41
                  SmartHold$ = ZFGA$           ' CA Color 10
                  SaveSmart = ZTrue

               CASE 42
                  SmartHold$ = ZFGB$           ' CB Color 11
                  SaveSmart = ZTrue

               CASE 43
                  SmartHold$ = ZFGC$           ' CC Color 12
                  SaveSmart = ZTrue

               CASE 44
                  SmartHold$ = ZFGD$           ' CD Color 13
                  SaveSmart = ZTrue

               CASE 45
                  SmartHold$ = ZFGE$           ' CE Color 14
                  SaveSmart = ZTrue

               CASE 46
                  SmartHold$ = ZFGF$           ' CF Color 15
                  SaveSmart = ZTrue

               CASE 47                         ' G0 Background Color 0
                  SmartHold$ = ZBG0$
                  SaveSmart = ZTrue

               CASE 48                         ' G1 Background Color 1
                  SmartHold$ = ZBG1$
                  SaveSmart = ZTrue

               CASE 49                         ' G2 Background Color 2
                  SmartHold$ = ZBG2$
                  SaveSmart = ZTrue

               CASE 50                         ' G3 Background Color 3
                  SmartHold$ = ZBG3$
                  SaveSmart = ZTrue

               CASE 51                         ' G4 Background Color 4
                  SmartHold$ = ZBG4$
                  SaveSmart = ZTrue

               CASE 52                         ' G5 Background Color 5
                  SmartHold$ = ZBG5$
                  SaveSmart = ZTrue

               CASE 53                         ' G6 Background Color 6
                  SmartHold$ = ZBG6$
                  SaveSmart = ZTrue

               CASE 54                         ' G7 Background Color 7
                  SmartHold$ = ZBG7$
                  SaveSmart = ZTrue

               CASE 55                         ' SN Snoop ON
                  IF NOT ReadMsgs THEN
                     ZSnoop = ZTrue
                     PRINT "SmartText Activated SNOOP ON"
                  END IF

               CASE 56                         ' SO Snoop OFF
                  IF NOT ReadMsgs THEN
                     ZSnoop = ZFalse
                     PRINT "SmartText Activated SNOOP OFF"
                  END IF

               CASE 57                         ' MS Modem Speed
                  SmartHold$ = STR$(ZBaudTest!)
                  TrimSmart = ZTrue

               CASE 58                         ' CR Carriage Return/Line Feed
                  IF NOT ReadMsgs THEN
                     SmartHold$ = ZCrLf$
                  END IF

               CASE 59                         ' LT Long Time Format
                  SmartHold$ = TIME$

58257          CASE 60                         ' SD Short Date Format
                  SmartHold$ = ZCurDate$

               CASE 61                         ' TD Time to Disconnect
                  SmartHold$ = STR$(ZWaitBeforeDisconnect)
                  TrimSmart = ZTrue

               CASE 62                         ' HB Hard Break
                  CALL SmartPause (ZTrue)

               CASE 63                         ' DC Dropped Carriers
                  SmartHold$ = STR$(ZDropTimesVal)
                  TrimSmart = ZTrue

               CASE 64                         ' ZV Version ID Number
                  SmartHold$ = ZVersionID$

               CASE 65                         ' LD Last Date on
                  SmartHold$ = ZLastDateTimeOnSave$

               CASE 66                         ' TO Times On
                  SmartHold$ = STR$(ZTimesLoggedOn)
                  TrimSmart = ZTrue

               CASE 67                         ' TC Total Calls to BBS
                  SmartHold$ = STR$(ZCallsToDate!)
                  TrimSmart = ZTrue

               CASE 68                         ' MA Active Messages
                  IF ZActiveMessages = 0 THEN
                     SmartHold$ = "(not loaded)"
                  ELSE
                     SmartHold$ = STR$(ZActiveMessages)
                     TrimSmart = ZTrue
                  END IF

               CASE 69                         ' MH High Message number
                  SmartHold$ = STR$(ZHighMsgNumber + 1)
                  TrimSmart = ZTrue

               CASE 70                         ' ML Last Message Read
                  IF ZLastMsgRead > 0 THEN
                     SmartHold$ = STR$(ZLastMsgRead)
                     TrimSmart = ZTrue
                  ELSE
                     SmartHold$ = NONE$
                  END IF

               CASE 71                         ' BP Baud and Parity
                  SmartHold$ = ZCBaud$
                  IF ZReliableMode THEN
                     SmartHold$ = SmartHold$ + "-R"
                  END IF
                  SmartHold$ = SmartHold$ + _
                  SPACE$(1) + RIGHT$(ZBaudParity$,5)
                  TrimSmart = ZTrue

               CASE 72                         ' BB Time Bank Balance
                  IF ZGlobalBankTime > 0 THEN
                     SmartHold$ = STR$(ZGlobalBankTime) + " Mins"
                     TrimSmart = ZTrue
                  ELSE
                     SmartHold$ = NONE$
                  END IF

               CASE 73                         ' CL New Callers Today
                  SmartHold$ = STR$(ZMenuNewCalls)
                  TrimSmart = ZTrue

               CASE 74                         ' FB Free UL DriveSpace in Bytes
                  ZWasZ$ = ZUpldDriveFile$
                  CALL FindFree
                  SmartHold$ = ZFreeSpace$
                  TrimSmart = ZTrue

               CASE 75                         ' FK Free UL DriveSpace in KBytes
                  ZWasZ$ = ZUpldDriveFile$
                  CALL FindFree
                  SmartHold$ = ZFreeSpaceK$
                  TrimSmart = ZTrue

               CASE 76                         ' FM Free UL DriveSpace in MBytes
                  ZWasZ$ = ZUpldDriveFile$
                  CALL FindFree
                  SmartHold$ = ZFreeSpaceM$
                  TrimSmart = ZTrue

               CASE 77                         ' DR Dropped Carriers Allowed
                  IF ZDropCarSecChng > 0 AND ZDropIncrement > 0 THEN
                     SmartHold$ = STR$(ZDropCarSecChng)
                     TrimSmart = ZTrue
                  ELSE
                     SmartHold$ = NA$
                  END IF

               CASE 78                         ' PW Password
                  SMartHold$ = ZPswdSave$

               CASE 79                         ' UM User Mode
                  SmartHold$ = MID$("NoviceExpert",1 -6 * ZExpertUser,6)

58258          CASE 80                         ' PR Default Protocol
                  IF ZUserXferDefault$ = "N" THEN
                     SmartHold$ = "NONE"
                  ELSE
                     SmartHold$ = ZProtoPrompt$
                  END IF

               CASE 81                         ' UC Upper Case Off or On
                  SmartHold$ = FNOffOn$(ZUpperCase)

               CASE 82                         ' LF Line Feeds Off or On
                  SmartHold$ = FNOffOn$(ZLineFeeds)

               CASE 83                         ' NL Nulls Off or On
                  SmartHold$ = FNOffOn$(ZNulls)

               CASE 84                         ' TK TurboKeys Off or On
                  SmartHold$ = FNOffOn$(ZTurboKeyUser)

               CASE 85                         ' GR Graphics Mode
                  SmartHold$ = MID$(RIGHT$("RIP       " + _
                                           "AutoDetect" + _
                                           "Color     " + _
                                           "Mono      " + _
                                           "None      ", _
                                           (ZWasGRHold+1)*10),1,10)
                  IF ZwasGRHold = 3 THEN
                     SmartHold$ = SmartHold$ + SPACE$(1) + "(" + _
                                  MID$(RIGHT$("RIP       " + _
                                              "AutoDetect" + _
                                              "Color     " + _
                                              "Mono      " + _
                                              "None      ", _
                                              (ZWasGR+1)*10),1,10)
                     CALL Trim (SmartHold$)
                     SmartHold$ = SmartHold$ + ")"
                  END IF
                  TrimSmart = ZTrue

               CASE 86                         ' HL HiLite Off or On
                  SmartHold$ = FNOffOn$(NOT ZHiLiteOff)

               CASE 87                         ' RB Prompt Bell Off or On
                  SmartHold$ = FNOffOn$(ZPromptBell)

               CASE 88                         ' Check New Bulletins Yes or No
                  SmartHold$ = FNYesNo$(-(ZCheckBulletLogon))

               CASE 89                         ' NU Check New Uploads Yes or No
                  SmartHold$ = FNYesNo$(-(NOT ZSkipFilesLogon))

               CASE 90                         ' AE ANSI Editor Yes or No
                  SmartHold$ = FNYesNo$(-(ZFullScreenEditor))

               CASE 91                         ' IC Internode Chat Yes or No
                  SmartHold$ = FNYesNo$(-(ZAvailableForChat))

               CASE 92                         ' RG Reset RIP Graphics
                  IF ZWasGR = 4 AND NOT ReadMsgs THEN
                     SmartHold$ = ZRIPGraphicsReset$
                  END IF

               CASE 93                         ' NF New Files Date
                  CALL UnPackDIRDate (ZListNewDate$, SmartHold$, "-")

               CASE 94                         ' 2J Clear ANSI Screen
                  IF ZWasGR > 1 AND NOT ReadMsgs THEN
                     IF ZForceKeyboard THEN
                        CALL AskMore ("",ZTrue,ZFalse,WasX,ZStopInterrupts)
                     END IF
                     SmartHold$ = ZEscape$ + "[2J"
                  END IF

               CASE 95                         ' RI Ring Caller
                  CALL PutCom (ZBellRinger$)

               CASE 96                         ' AM ANSIMusic Off or On
                  SmartHold$ = FNOffOn$(ZANSIMusic)

               CASE 97                         ' EF Extended Files Off or On
                  SmartHold$ = FNOffOn$(NOT ZExtendedOff)

               CASE 98                         ' NM New Mail Check Off or On
                  SmartHold$ = FNYesNo$(-(ZReadNewMail))

               CASE 99                         ' EM Erase More Prompt Yes or No
                  SmartHold$ = FNYesNo$(-(NOT ZMorePromptLF))

58259          CASE 100                        ' TU Total Users
                  SmartHold$ = STR$(ZCurUserCount-1)
                  TrimSmart = ZTrue

               CASE 101                        ' LC Last Caller
                  SmartHold$ = ZLastCaller$

               CASE 102                        ' F3 Printer Logging Off or On
                  IF NOT ReadMsgs THEN
                     SmartHold$ = FNOffOn$(ZPrinter)
                  END IF

               CASE 103                        ' F4 Sysop Annoy Status Off or On
                  IF NOT ReadMsgs THEN
                     SmartHold$ = FNOffOn$(ZSysopAnnoy)
                  END IF

               CASE 104                        ' F6 Sysop Available Yes or No
                  IF NOT ReadMsgs THEN
                     SmartHold$ = FNYesNo$(-(ZSysopAvail))
                  END IF

               CASE 105                        ' F7 Sysop Next
                  IF NOT ReadMsgs THEN
                     SmartHold$ = FNYesNo$(-(ZSysopNext))
                  END IF

               CASE 106                        ' F9 Snoop Off or On
                  IF NOT ReadMsgs THEN
                     SmartHold$ = FNOffOn$(ZSnoop)
                  END IF

               CASE 107                        ' D1 Delay 1 sec
                  IF NOT ReadMsgs THEN
                     CALL DelayTime (1)
                     SmartHold$ = ""
                  END IF

               CASE 108                        ' FR File Ratio
                  ULWork# = ZUplds
                  DLWork# = ZDnlds + ZDownFiles
                  IF ULWork# < ZInitialCredit# THEN
                     ULWork# = ZInitialCredit#
                  END IF
                  IF ZByteMethod = 2 THEN
                     Today# = ZRatioRestrict# - ZDLToday! - ZDownFiles
                  END IF
                  IF ZByteMethod = 3 THEN
                     Today# = ZRatioRestrict# - ZBytesToday! - ZNumDnldBytes!
                  END IF
                  GOSUB 58260

               CASE 109                        ' BR Byte Ratio
                  ULWork# = ZULBytesVal!
                  DLWork# = ZDLBytesVal! + ZNumDnldBytes!
                  IF ULWork# < ZInitialCredit# THEN
                     ULWork# = ZInitialCredit#
                  END IF
                  IF ZByteMethod = 3 THEN
                     Today# = ZRatioRestrict# - ZBytesToday! - ZNumDnldBytes!
                  END IF
                  GOSUB 58260

               CASE 110                        ' ID Caller ID
                  SmartHold$ = ZCallerIDNumber$

               CASE 111                        ' PA Parity
                  SmartHold$ = RIGHT$(ZBaudParity$,5)

               CASE 112                        ' SP SPACE
                  SmartHold$ = SPACE$(1)

               CASE 113                        ' AN Active User Name
                  SmartHold$ = ZActiveUserName$

               CASE 114                        ' TF Total New Files
                  SmartHold$ = STR$(ZTotalNewFiles)  
                  TrimSmart = ZTrue

               CASE 115                        ' BC Baud Carrier
                  SmartHold$ = ZCBaud$         
                  IF ZReliableMode THEN
                     SmartHold$ = SmartHold$ + "-R"
                  END IF

               CASE 116                        ' CP Command Prompt
                  SmartHold$ = ZCmdPrompt$     

               CASE 117                        ' ZZ ZWasZ$ internal variable
                  IF NOT ReadMsgs THEN
                     SmartHold$ = ZWasZ$
                  END IF

               CASE 118                        ' MH Message Header
                  SmartHold$ = ZMsgHeader$

               CASE 119                        ' EX Expert ENTER prompt
                  SmartHold$ = ZPressEnterExpert$

               CASE 120                        ' LM Max Message Lines
                  SmartHold$ = STR$(ZMaxMsgLines)
                  TrimSmart = ZTrue

               CASE 121                        ' MT Message To
                  SmartHold$ = ZMsgTo$

               CASE 122                        ' SM Message Subject
                  SmartHold$ = ZSubject$

               CASE 123                        ' MB Low Message Number
                  SmartHold$ = STR$(ZLowMsgNumber)
                  TrimSmart = ZTrue

               CASE 124                        ' SS ZSearchString$
                  SmartHold$ = ZSearchString$

               CASE 125                        ' CO Emphasize On
                  SmartHold$ = ZEmphasizeOn$

               CASE 126                        ' MF Message From
                  SmartHold$ = ZMsgFrom$
                  TrimSmart = ZTrue

               CASE 127                        ' CM Current Message Number
                  SmartHold$ = STR$(ZCurMsg)
                  TrimSmart = ZTrue

               CASE 128                        ' ZU ZUserIn$
                  SmartHold$ = ZUserIn$

               CASE 129                        ' ER ZErrCode
                  SmartHold$ = STR$(ZErrCode)
                  TrimSmart = ZTrue

               CASE 130                        ' Z1 ZUserInAra$(1)
                  SmartHold$ = ZUserInAra$(1)

               CASE 131                        ' BM Max Banked Time Allowed
                  SmartHold$ = STR$(ZMaxBank)
                  TrimSmart = ZTrue

               CASE 132                        ' DN Door Name
                  IF NOT ReadMsgs THEN
                     SmartHold$ = ZDooredTo$
                  END IF

               CASE 133                        ' DE Default Extension
                  SmartHold$ = ZDefaultExtension$

               CASE 134                        ' FH FileNameHold
                  SmartHold$ = ZFileNameHold$

               CASE 135                        ' HC Home Conference
                  SmartHold$ = ZHomeConf$

               CASE 136                        ' TS Time left in Session
                  SmartHold$ = STR$(ZMinsPerSession)
                  TrimSmart = ZTrue

               CASE 137                        ' RV RIPScript version of caller
                  SmartHold$ = ZRIPVersion$

               CASE 138                        ' SF Free STACK Space bytes
                  IF NOT ReadMsgs THEN
                     SmartHold$ = STR$(CINT(FRE(-2)))
                     TrimSmart = ZTrue
                  END IF

               CASE 139                        ' DF Free Data Segment Space K
                  IF NOT ReadMsgs THEN
                     SmartHold$ = STR$(CINT(FRE("A")/1024))
                     TrimSmart = ZTrue
                  END IF

               CASE 140                        ' UA User Records Available
                  IF NOT ReadMsgs THEN
                     UserWork = (ZHighestUserRecord * .95) + 1
                     SmartHold$ = STR$(UserWork - ZCurUserCount)
                     TrimSmart = ZTrue
                  END IF
                     
               CASE 141                         ' MR Unused Messages Remaining
                  IF ZActiveMessages = 0 THEN
                     SmartHold$ = "(not loaded)"
                  ELSE
                     SmartHold$ = STR$(ZMaxMsgs - ZActiveMessages)
                     TrimSmart = ZTrue
                  END IF

               CASE 142                         ' MU Message Records Used
                  IF NOT ReadMsgs THEN
                     SmartHold$ = STR$(ZNextMsgRec-1)
                     TrimSmart = ZTrue
                  END IF

               CASE 143                         ' NR Message Records Remaining
                  IF NOT ReadMsgs THEN
                     IF ZMsgsCanGrow THEN
                        SmartHold$ = "open"
                     ELSE
                        SmartHold$ = STR$(ZHighestMsgRecord + 1 - ZNextMsgRec)
                        TrimSmart = ZTrue
                     END IF
                  END IF
                  
               CASE 144                         ' NO Original Logon Name
                  SmartHold$ = ZOrigUserName$

               CASE 145                         ' SH Start SYSOP Page Hours
                  SmartHold$ = MID$(STR$(ZStartOfficeHours),2,2) + _
                               ":" + MID$(STR$(ZStartOfficeHours),4,2)

               CASE 146                         ' EH End SYSOP Page Hours
                  SmartHold$ = MID$(STR$(ZEndOfficeHours),2,2) + _
                               ":" + MID$(STR$(ZEndOfficeHours),4,2)

               CASE 147                         ' IV Interger Value
                  SmartHold$ = STR$(ZTestedIntValue)
                  TrimSmart = Ztrue

               CASE 148                         ' NC Name Caps
                  SmartHold$ = ZActiveUserName$
                  CALL NameCaps (SmartHold$)

               CASE 149                         ' RC Reset color
                  SmartHold$ = ZEmphasizeOff$
                  ZLastSmartColor$ = ""

               CASE 150                         ' UN User's Name
                  SmartHold$ = ZUserName$
                  TrimSmart = ZTrue

               CASE 151                         ' TG Time Greeting
                  TestTime = VAL(MID$(TIME$,1,2))
                  SELECT CASE TestTime
                     CASE 0 TO 11
                        '* "Good Morning"
                        CALL FormatString (1150,ZFalse,ZFalse,0,ZFalse,0,SmartHold$)
                     CASE 12 TO 17
                        '* "Good Afternoon"
                        CALL FormatString (1151,ZFalse,ZFalse,0,ZFalse,0,SmartHold$)
                     CASE 18 TO 23
                        '* "Good Evening"
                        CALL FormatString (1152,ZFalse,ZFalse,0,ZFalse,0,SmartHold$)
                     CASE ELSE
                        SmartHold$ = ""
                  END SELECT

               CASE 152                         ' SE Section Name
                  SmartHold$ = ZSection$

               CASE 153
                  SmartHold$ = ZLongDoorName$   ' LG Long Door Name

               CASE 154
                  SmartHold$ = ZCallerIDName$   ' IN Caller ID Name

               CASE ELSE

            END SELECT

            IF TrimSmart THEN
               CALL Trim (SmartHold$)
            END IF

            IF SaveSmart THEN
               ZLastSmartColor$ = SmartHold$
            END IF

            WasI = LEN(SmartHold$)

            ReplaceLen = 3

            IF OverStrike OR Overlay THEN
               IF WasI > 2 THEN
                  ReplaceLen = WasI
               ELSEIF SmartAct <> 112 THEN
                  SmartHold$ = SmartHold$ + SPACE$(3 - WasI)
               END IF
            END IF

            StringWork$ = LEFT$(StringWork$, Index-1) + SmartHold$ + _
                          MID$(StringWork$, Index + ReplaceLen)

         END IF

         Index = INSTR(Index + WasI, StringWork$, ZSmartTextChar$)

      WEND

      IF Index AND (Index > LEN(StringWork$)-2) AND NOT CRFound THEN
         SmartCarry$ = MID$(StringWork$, Index)
         StringWork$ = LEFT$(StringWork$, Index-1)
      ELSE
         SmartCarry$ = ""
      END IF
      EXIT SUB
' *
' * Calculate Ratios For {FR and {BR
' *
58260 Ratio# = 0
      RatioSuffix$ = ":0"
      IF ULWork# > 0 THEN
         Ratio# = (DLWork# / ULWork#)
         RatioSuffix$ = ":1"
      END IF
      WasX$ = STR$(Ratio#)
      X = INSTR(WasX$,".")
      IF X > 0 THEN
         WasX$ = LEFT$(WasX$,X+1)
      END IF
      SmartHold$ = WasX$ + RatioSuffix$
      RETURN
'
      END SUB
'
58390 ' $SUBTITLE: 'BufString - write a string with imbedded ZCR/LF'
' $PAGE
'
'  NAME    -- BufString
'
'  INPUTS  -- PARAMETER                      MEANING
'             Strng$                 STRING TO BE WRITTEN OUT
'             DataSize               LENGTH OF STRING - # LEFT
'                                        CHARS TO OUTPUT
'
'  OUTPUTS -- Strng$                 IS WRITTEN TO THE USER
'
'  PURPOSE -- To search the string, Strng$, for embedded carriage
'             returns and line feeds and write out each line with
'             the appropriate substitution (cr/lf if to the local
'             screen or cr/nulls/lf if to the communications port).
'
      SUB BufString (Strng$,PassedDataSize,AbortIndex) STATIC
      WasL = LEN(Strng$)
      IF PassedDataSize < WasL THEN _
         WasL = PassedDataSize
      IF WasL < 1 THEN _
         EXIT SUB
      ZFF = ZPageLength - 1
      StartByte = 1
      ZRet = ZFalse
      IF CarryOver THEN _
         IF ASC(Strng$) = 10 THEN _
            StartByte = 2 : _
            CALL SkipLine (1+ZJumpSearching)
      CarryOver = (MID$(Strng$,WasL,1) = ZCarriageReturn$)
      WasL = WasL + CarryOver
58391 CRat = INSTR(StartByte,Strng$,ZCarriageReturn$)
      IF CRat > 0 AND CRat < WasL THEN _
         CRFound = (MID$(Strng$,CRat + 1,1) = ZLineFeed$) _
      ELSE CRFound = ZFalse
      EOLlen = -2 * CRFound
      IF CRFound THEN _
         EOD = CRat _
      ELSE EOD = WasL + 1
      NumBytes = EOD - StartByte
      StringWork$ = MID$(Strng$,StartByte,NumBytes)
      IF NOT ZDeleteInvalid THEN _
         GOTO 58392
      IF LastChar$ = "[" OR LastChar$ = "m" THEN
         StringWork$ = LastChar$ + StringWork$
         ShiftOne = ZTrue
      ELSE
         ShiftOne = ZFalse
      END IF
      IF ShiftOne THEN
         StringWork$ = MID$(StringWork$,2)
      END IF
      LastChar$ = RIGHT$(StringWork$,1)
58392 IF ZJumpSearching THEN _
         Temp$ = StringWork$ : _
         CALL AllCaps (Temp$) : _
         HiLitePos = INSTR (Temp$,ZJumpTo$) : _
         IF HiLitePos = 0 THEN _
            GOTO 58397 _
         ELSE CALL Bracket (StringWork$,HiLitePos,HiLitePos+LEN(ZJumpTo$)-1,ZEmphasizeOn$,ZEmphasizeOff$) : _
              ZJumpSearching = ZFalse
      IF ZSmartTextCode THEN _
         CALL SmartText (StringWork$, CRFound, ZFalse,ZFalse)
      Index = INSTR(StringWork$,"[")
      WasJ = LEN(StringWork$) - 1
      WHILE Index > 0 AND Index < WasJ
         IF MID$(StringWork$,Index + 2,1) = "]" THEN _
            IF INSTR (ZInvalidOpts$,MID$(StringWork$,Index + 1,1)) THEN _
               MID$(StringWork$,Index + 1,1) = "*"
         Index = INSTR(Index + 1,StringWork$,"[")
      WEND
      Index = INSTR(StringWork$,"m")
      WasJ = LEN(StringWork$) - 1
      WHILE Index > 0 AND Index < WasJ
         IF MID$(StringWork$,Index + 2,1) = CHR$(27) THEN _
            IF INSTR (ZInvalidOpts$,MID$(StringWork$,Index + 1,1)) THEN _
               MID$(StringWork$,Index + 1,1) = "*"
         Index = INSTR(Index + 1,StringWork$,"m")
      WEND
      IF NOT ZLocalUser THEN _
         CALL EofComm (Char) : _
         IF Char <> -1 THEN _
            GOTO 58393            ' comm port input
      ZKeyboardStack$ = INKEY$ : _
      IF ZKeyboardStack$ <> "" THEN _  ' keyboard input
         GOTO 58393
      CALL QuickTPut (StringWork$, - (CRFound))
      GOTO 58394
58393 ZOutTxt$ = StringWork$
      ZSubParm = 4
      IF CRFound THEN ZSubParm = 5
      CALL TPut
58394 IF ZRet THEN _
         EXIT SUB
      IF ZLinesPrinted < ZFF THEN _
         GOTO 58397
58395 CALL CheckTimeRemain (MinsRemaining)
      CALL CheckCarrier
      IF ZSubParm = -1 THEN _
         EXIT SUB
      IF ZNonStop THEN _
         GOTO 58397
      IF NOT CRFound THEN _
         GOTO 58397
      ZForceKeyboard = ZTrue
      CALL AskMore ("",ZTrue,ZFalse,AbortIndex,ZStopInterrupts)
      IF ZNo THEN _
         ZRet = ZTrue : _
         EXIT SUB
58397 StartByte = EOD + EOLlen
      IF StartByte <= WasL THEN _
         GOTO 58391
      END SUB
58400 ' $SUBTITLE: 'BufFile - subroutine to write a sequential file to the user'
' $PAGE
'
'  NAME    -- BufFile
'
'  INPUTS  -- PARAMETER                      MEANING
'             FileSpec$               NAME OF THE FILE TO WRITE TO
'                                                OUT TO THE USER
'
'  OUTPUTS -- NONE                    FILE IS WRITTEN TO THE USER
'
'  PURPOSE -- To display a sequential file to the user
'
      SUB BufFile (FilName$,AbortIndex) STATIC
      CALL FindIt (FilName$)
      IF NOT ZOK THEN _
         GOTO 58418
      ZNo = ZFalse
      ZToggleOnly = ZTrue
      CALL OpenRSeq (2,FilName$,NumRecs&,LenLastRec,ZBufferSize)
      IF ZErrCode > 0 THEN _
         GOTO 58418
      DataSize = ZBufferSize
      FIELD 2, DataSize AS SeqRec$
      ZNonStop = ZNonStop OR (ZPageLength < 1)
      ZJumpLast$ = ""
      ZJumpSearching = ZFalse
      ZJumpSupported = ZTrue
      IF NOT ZStopInterrupts THEN _
         IF NOT ZConcatFIles THEN _
            IF NOT ZNonStop THEN _
               ZOutTxt$ = "" : _
               ZSubParm = 5 : _
               CALL TPut
      IF ZSubParm = -1 THEN _
         GOTO 58420
      IF (ZBBSOptions AND 2) > 0 AND ZWasGR > 1 THEN
         CALL QuickTPut (ZEscape$ + "[2J",0)
         CALL Line25
      END IF
      WasTU& = 0
58405 WasTU& = WasTU& + 1
      IF WasTU& < NumRecs& THEN _
         GET 2,WasTU& _
      ELSE IF WasTU& = NumRecs& THEN _
              GET 2,WasTU& : _
              WasX = INSTR(SeqRec$,CHR$(26)) : _
              IF WasX = 0 OR WasX > LenLastRec THEN _
                 DataSize = LenLastRec _
              ELSE DataSize = WasX - 1 _
           ELSE GOTO 58418
      CALL BufString (SeqRec$,DataSize,AbortIndex)
58408 IF ZSubParm <> -1 AND NOT ZRet THEN _
         GOTO 58405
58418 CLOSE 2
58419 ZBypassTimeCheck = ZFalse
      ZStopInterrupts = ZFalse
      CALL QuickTPut (ZEmphasizeOff$,0)
      ZJumpSupported = ZFalse
      ZLastSmartColor$ = ""
      CALL Line25
58420 ZToggleOnly = ZFalse
      END SUB
58600 ' $SUBTITLE: 'FindLast - find last occurence of a string'
' $PAGE
'
'  NAME    -- FindLast
'
'  INPUTS  -- PARAMETER             MEANING
'              LookIn$           STRING TO LOOK INTO
'              LookFor$          STRING TO SEARCH FOR
'
'  OUTPUTS -- WhereFound        POSITION IN LookIn$ THAT
'                                   LookFor$ Found
'             NumFinds          HOW MANY OCCURENCES IN LookIn$
'
'  PURPOSE -- Finds last occurence of LookFor$ in LookIn$ and
'             returns count of # of occurences.  If none found,
'             both returned parameters are set to 0.
'
      SUB FindLast (LookIn$,LookFor$,WhereFound,NumFinds) STATIC
      WhereFound = INSTR(LookIn$,LookFor$)
      NumFinds = -(WhereFound > 0)
      NextFound = INSTR(WhereFound + 1,LookIn$,LookFor$)
      WHILE NextFound > 0
         NumFinds = NumFinds + 1
         WhereFound = NextFound
         NextFound = INSTR(WhereFound + 1,LookIn$,LookFor$)
      WEND
      END SUB
'
58800 ' $SUBTITLE: 'WipeLine - Wipe away a line so next overprints'
' $PAGE
'
'  NAME    -- WipeLine
'
'  INPUTS  --     PARAMETER                    MEANING
'                 ZCarriageReturn$
'                 CharsToWipe            # OF CHARACTERS TO BLANK
'                 ZNulls
'
'  OUTPUTS -- NONE
'
'  PURPOSE -- Wipe away a line and leave cursor at beginning of the
'             same line so that the next line will print in its place
'
      SUB WipeLine (CharsToWipe) STATIC
      IF ZNulls OR CharsToWipe > 79 THEN _
         CALL SkipLine (1) : _
         EXIT SUB
      IF ZWasGR > 1 THEN _
         Strng$ = ZCarriageReturn$ + ZEscape$ + "[K" _
      ELSE _
         Strng$ = ZCarriageReturn$ + SPACE$(CharsToWipe) + _
         ZCarriageReturn$
      Strng$ = Strng$ + ZLastSmartColor$
      IF NOT ZLocalUser THEN _
         CALL PutCom (Strng$)
      IF ZSnoop THEN _
         LOCATE ,1 :  _
         CALL LPrnt(SPACE$(CharsToWipe),0) : _
         LOCATE ,1
      END SUB
'
59200 ' $SUBTITLE: 'TwoByteDate -- subroutine to put date in 2 bytes'
' $PAGE
'
'  NAME    -- TwoByteDate
'
'  INPUTS  --   PARAMETER     MEANING
'                  Year       FOUR DIGIT YEAR (I.E. 1987)
'                  WasMM      MONTH
'                  WasDD      DAY
'                Result$      LOCATION TO PLACE THE Result
'
'  OUTPUTS -- Result$       TWO BYTE COMPRESSED DATE FOR USE IN
'                           A RANDOM RECORD
'
'  PURPOSE -- Compress a WasY,ZMsgPtr,WasD date into two characters
'
      SUB TwoByteDate (YearX,WasMM,WasDD,Result$) STATIC
      Result$ = CHR$(((YearX - 1980) * 2) OR - ((WasMM AND 8) <> 0)) + _
                CHR$((WasMM AND NOT 8) * 32 + WasDD)
      END SUB
59201 ' $SUBTITLE: 'PackDate -- subroutine to Compress STRING DATE'
' $PAGE
'
'  NAME    -- PackDate
'
'  INPUTS  --   PARAMETER     MEANING
'                 Strng$    String Date (mm-dd-yyyy)
'
'  OUTPUTS --    Result$    TWO BYTE COMPRESSED DATE FOR USE IN
'                                      A RANDOM RECORD
'
'  PURPOSE -- Compress an 8-character date into two characters
'
      SUB PackDate (Strng$,Result$) STATIC
      IF LEN(Strng$) < 8 THEN _
         EXIT SUB
      YearX = VAL(MID$(Strng$,7))
      WasMM = VAL(Strng$)
      WasDD = VAL(MID$(Strng$,4))
      CALL TwoByteDate (YearX,WasMM,WasDD,Result$)
      END SUB
59202 ' $SUBTITLE: 'UnPackDate -- subroutine to UNCompress DATE'
' $PAGE
'
'  NAME    -- UnPackDate
'
'  INPUTS  --   PARAMETER      MEANING
'             CompressedDate$ Date in 2 byte compressed form
'
'  OUTPUTS --     Year           Year of compressed date
'                 WasMM          Month of compressed date
'                 WasDD          Day of compressed date
'             DisplayDate$       8 char display date (mm-dd-yyyy)
'
'  PURPOSE -- Uncompress a 2 char date to get Y,M,D & display
'
      SUB UnPackDate (CompressedDate$,YearX,WasMM,WasDD,DisplayDate$) STATIC
      CALL GetYMD (CompressedDate$,1,YearX)
      CALL GetYMD (CompressedDate$,2,WasMM)
      CALL GetYMD (CompressedDate$,3,WasDD)
      DisplayDate$ = RIGHT$(STRING$(2,48) + MID$(STR$(WasMM),2),2) + _
                      "-" + _
                      RIGHT$(STRING$(2,48) + MID$(STR$(WasDD),2),2) + _
                      "-" + _
                      RIGHT$(STR$(YearX),2)
      END SUB
59204 ' $SUBTITLE: 'GetYMD -- subroutine to unpack a two-byte date'
' $PAGE
'
'  NAME    -- GetYMD
'
'  INPUTS  --   PARAMETER     MEANING
'                 TwoByte$    PACKED TWO-BYTE DATE FIELD
'                   YMD       1 = YEAR
'                             2 = MONTH
'                             3 = DAY
'                 Result      LOCATION TO PLACE THE Result
'
'  OUTPUTS -- Result        FOUR DIGIT Result OF UNPAKING THE DATE
'
'  PURPOSE -- Unpack a compressed two-byte date field
'
      SUB GetYMD (TwoByte$,YMD,Result) STATIC
      ON YMD GOTO 59206,59210,59215
      EXIT SUB
59206 Result = (ASC(TwoByte$)AND NOT 1) / 2 + 1980
      EXIT SUB
59210 Result = FIX((ASC(MID$(TwoByte$,2)) / 32)) OR ((ASC(TwoByte$) AND 1) * 8)
      EXIT SUB
59215 Result = ASC(MID$(TwoByte$,2)) AND NOT 224
      END SUB
'
59450 ' $SUBTITLE: 'UserFace - handles programmable user interface'
' $PAGE
'
'  NAME    --  UserFace
'
'  INPUTS  --  PARAMETER                   MEANING
'              ZCurPUI$             PUI TO USE
'              ZExpertUser          WHETHER CALL IN EXPERT MODE
'
'  OUTPUTS --  ZWasQ
'              ZUserInAra$()
'              ZWasZ$
'
'  PURPOSE --  When sysop overrides RBBS-PC's default user
'              interface (provides a MAIN.PUT), this routine
'              reads in the table of specifications, presents
'              the sysop menu, presents the prompt, verifies
'              that a valid option has been picked, determines
'              whether the option is another PUI, and passes
'              back choices to be processed.
'
      SUB UserFace STATIC
59455 IF ZPrevPUI$ = ZCurPUI$ THEN _
         GOTO 59458
59456 ZFileName$ = ZCurPUI$
      CALL Graphic (ZFileName$)
      IF NOT ZOK THEN
         '* "Missing menu{SP"
         CALL FormatString (492,ZFalse,ZFalse,0,ZFalse,0,Strng$)
         CALL UpdtCalr (Strng$ + ZCurPUI$,2)
         ZCurPUI$ = ZPrevPUI$
         GOTO 59456
      END IF
      CALL BreakFileName(ZFileName$,ZWasZ$,ZActiveMenu$,ZWasZ$,ZTrue)
      ZActiveMenu$ = LEFT$(ZActiveMenu$,1)
      LSET ZLastCommand$ = ZActiveMenu$ + SPACE$(1)
      ZPrevPUI$ = ZCurPUI$
      LINE INPUT #2,ZFileName$
      INPUT #2,Prompt$
      INPUT #2,ValidChoice$,ActualCommands$
      LINE INPUT #2,MenuChoice$
      LINE INPUT #2,MenuName$
      LINE INPUT #2,QuitCmd$
      INPUT #2,QuitPrompt$
      LINE INPUT #2,QuitSubCmds$
      LINE INPUT #2,QuitMenuOpt$
      LINE INPUT #2,QuitMenus$
      CALL Graphic (ZFileName$)
      CALL BreakFileName (ZFileName$,MenuDrvPath$,WasX$,ZWasY$,ZTrue)
      MenuToDisplay$ = ZFileName$
      WasJ = INSTR(ZOrigCommands$,"?")
      IF WasJ < 1 THEN _
         WasX$ = "" _
      ELSE WasX$ = MID$(ZAllOpts$,WasJ,1)
59458 IF ZExpertUser THEN
         GOSUB 59493
         GOTO 59461
      END IF
59460 ZNonStop = (ZPageLength < 1)
      ZDeleteInvalid = ZTrue
      CALL BufFile (MenuToDisplay$,WasX)
      ZDeleteInvalid = ZFalse
      CALL Line25
      GOSUB 59493
59461 MID$(ZLastCommand$,2,1) = SPACE$(1)
      ZOutTxt$ = Prompt$
      ZTurboKey = -ZTurboKeyUser
      CALL PopCmdStack
      IF ZSubParm = -1 OR ZFunctionKey <> 0 THEN _
         EXIT SUB
      IF ZWasQ = 0 THEN _
         GOTO 59461
59462 ZWasZ$ = ZUserInAra$(ZAnsIndex)
      CALL AllCaps (ZWasZ$)
      WasJ = INSTR(ValidChoice$,ZWasZ$)
      IF WasJ < 1 THEN _
         GOTO 59492
      ZWasZ$ = MID$(ActualCommands$,WasJ,1)
      ZUserInAra$(ZAnsIndex) = ZWasZ$
      WasJ = INSTR(MenuChoice$,ZWasZ$)
      IF WasJ > 0 THEN _
         ZCurPUI$ = MID$(MenuName$,1 + (WasJ - 1) * 7,7) : _
         GOTO 59490
      IF ZWasZ$ = WasX$ THEN _
         GOTO 59460
      IF ZWasZ$ <> QuitCmd$ THEN _
         EXIT SUB
59470 MID$(ZLastCommand$,2,1) = ZWasZ$
      ZOutTxt$ = QuitPrompt$
      ZTurboKey = -ZTurboKeyUser
      CALL PopCmdStack
      IF ZSubParm = -1 OR ZFunctionKey <> 0 THEN _
         EXIT SUB
      IF ZWasQ = 0 THEN _
         ZUserInAra$(1) = LEFT$(QuitSubCmds$,1) : _
         ZWasQ = 1
59480 ZWasZ$ = ZUserInAra$(ZAnsIndex)
      CALL AllCaps (ZWasZ$)
      WasJ = INSTR(QuitSubCmds$,ZWasZ$)
      IF WasJ < 1 THEN _
         GOTO 59470
      WasJ = INSTR(QuitMenuOpt$,ZWasZ$)
      IF WasJ > 0 THEN _ 'quit to submenu
         ZCurPUI$ = MID$(QuitMenus$,1 + (WasJ - 1) * 7,7) : _
         GOTO 59490
      ZUserInAra$(ZAnsIndex) = QuitCmd$ 'valid but not menu-send to RBBS
      EXIT SUB
59490 CALL Remove (ZCurPUI$,SPACE$(1))
      ZCurPUI$ = MenuDrvPath$ + _
                     ZCurPUI$ + _
                     ".PUI"
      GOTO 59455
59492 CALL Putcom (ZBellRinger$)
      '* "No such option <{ZZ>"
      CALL FormatString (1060,ZFalse,ZFalse,0,ZTrue,1,"")
      CALL SmartPause (ZFalse)
      Call FlushKeys
      GOTO 59460
59493 CALL DispSectionAndTime
      RETURN
      END SUB
59500 ' $SUBTITLE: 'SubMenu -- subroutine to process menus'
' $PAGE
'
'  NAME    -- SubMenu
'
'  INPUTS  --   PARAMETER     MEANING
'             PassedPrompt$   PROMPT TO DISPLAY
'             CurMenu$        NOVICE MENU TO DISPLAY
'             FrontOpt$       DRIVE/PATH/PREFIX OF FILE
'                             NEEDED FOR TYPED OPTION
'             BackOpt$        SUFFIX/EXTENSION OF FILE
'                             NEEDED WITH TYPED OPTION
'             ReturnOn$       LETTERS CALLING PROGRAM WANTS
'                             CONTROL ON
'             GRDefault$      GRAPHICS DEFAULT TO USE
'             VerifyInMenu    WHETHER VERIFY OPTION IS IN MENU
'             AllMenuOK       WHETHER CONTROL SHOULD RETURN
'                             WHEN IN MENU
'             ZAnsIndex       # OF COMMANDS IN TYPE AHEAD
'             RequireInMenu   WHETHER OPTION MUST BE IN MENU
'
'  OUTPUTS -- ZWasZ$              OPTION PICKED
'             ZFileName$      NAME OF FILE SUPPORTING OPTION
'
'
'  PURPOSE -- Handles menus - including conference, bulletins,
'             doors, questionnaires.  Supports sub-menus (i.e.
'             an option on the menu that invokes another menu)
'
      SUB SubMenu (PassedPrompt$,CurMenu$,FrontOpt$, _
         BackOpt$,ReturnOn$,PassedVerifyInMenu, _
         AllMenuOK,RequireInMenu,BackOpt2$,InMenu,ChkGraphic) STATIC
59510 ZFileName$ = CurMenu$
      InMenu = ZTrue
      CALL BreakFileName (FrontOpt$,WasX$,FrontPre$,ZWasDFF$,ZTrue)
      CALL BreakFileName (CurMenu$,MenuDrv$,WasX$,ZWasDFF$,ZTrue)
      MenuFront$ = MenuDrv$ + LEFT$(WasX$,LEN(WasX$)-LEN(PreSuf$))
      IF CurMenu$ = LastSubMenu$ THEN _
         MenuFront$ = LEFT$(MenuFront$,LEN(MenuFront$)-1)
      CALL Graphic (ZFileName$)
      CurMenuVer$ = ZFileName$
      ZStopInterrupts = ZFalse
59514 IF ZAnsIndex < ZLastIndex OR ZExpertUser THEN _
         GOTO 59520
59515 CALL BufFile (CurMenuVer$,ZAnsIndex) 'show menu
      CALL DispSectionAndTime
59520 ZOutTxt$ = PassedPrompt$            'get response
      CALL PopCmdStack
      IF ZWasQ = 0 OR ZSubParm = -1 THEN _
         EXIT SUB
59530 ZWasZ$ = ZUserInAra$(ZAnsIndex)
      CALL AllCaps (ZWasZ$)
      ZWasP$ = ZWasZ$
      IF CurMenu$ = ZMenu$(5) THEN
         CALL FindFile (ZDoorsDef$,Found)
         IF Found THEN
            CALL OpenWork (2,ZDoorsDef$)
            WHILE NOT EOF(2) AND (NOT FoundIt)
               CALL ReadParms (ZWorkAra$(),14,1)
               IF ZErrCode > 0 THEN
                  CLOSE 2
                  GOTO 59531
               END IF
               IF ZWasZ$ = ZWorkAra$(1) OR ZWasZ$ = ZWorkAra$(2) THEN
                  ZWasZ$ = ZWorkAra$(2)
                  ZWasP$ = ZWorkAra$(6)
                  IF INSTR(ZWasP$," ") THEN
                     ZWasP$ = LEFT$(ZWasP$,INSTR(ZWasP$," ")-1)
                  END IF
                  ZLongDoorName$ = ZWorkAra$(1)
                  FoundIt = ZTrue
               END IF
            WEND
            CLOSE 2
         END IF
         FoundIt = ZFalse
      END IF
      IF CurMenu$ = ZConfMenu$ THEN
         IF ZExtendedConfMail THEN
            CALL OpenWork (2,ZConfMailList$)
            WHILE NOT EOF(2) AND (NOT FoundIt)
               CALL ReadParms (ZWorkAra$(),10,1)
               IF ZErrCode > 0 THEN
                  CLOSE 2
                  GOTO 59531
               END IF
               IF ZWasZ$ = ZWorkAra$(1) OR ZWasZ$ = ZWorkAra$(2) THEN
                  ZConfNum$ = ZWorkAra$(1)
                  ConfName$ = ZWorkAra$(2)
                  CALL BreakFileName (ZWorkAra$(8),pre$,body$,ext$,ZFalse)
                  ZWasZ$ = MID$(body$,1,LEN(body$)-1)
                  FoundIt = ZTrue
               END IF
            WEND
            CLOSE 2
            FoundIt = ZFalse
         END IF
      END IF
59531 IF INSTR(ReturnOn$,","+ZWasZ$+",") THEN _  'check if calling pgm wants
         EXIT SUB
      IF INSTR("LH?",ZWasZ$) THEN _       'check whether caller wants help
         GOTO 59515
      IF INSTR(ZWasZ$,".") > 0 THEN _
         GOTO 59532
      CALL BadFile (ZWasZ$,WasBF)
      IF WasBF > 1 THEN _
         GOTO 59532
      FPre$ = MenuFront$   ' check for sub-option
      PreSuf$ = "-"
      CALL BadFile (FPRE$ + ZWasZ$ + "-",WasBF)
      ZOK = ZFalse
      IF WasBF < 2 THEN _
         VerifyInMenu = ZFalse : _
         GOSUB 59538
      PreSuf$ = ""
      VerifyInMenu = PassedVerifyInMenu
      IF NOT ZOK THEN _
         FPre$ = FrontOpt$ : _    ' check standard option
         GOSUB 59538 : _
         IF NOT ZOK THEN _    ' check option where menu is
            FPre$ = MenuDrv$ + FrontPre$ : _
            IF FrontOpt$ <> FPre$ THEN _
               GOSUB 59538
      IF NewMenu THEN _
         NewMenu = ZFalse : _
         GOTO 59515
      IF ZOK THEN _
         EXIT SUB
59532 GOSUB 59547
      GOTO 59514
59538 FilName$ = FPre$ + ZWasZ$ + PreSuf$
      ZFileName$ = FilName$ + BackOpt$
      GOSUB 59543
      IF WasBF > 1 THEN _
         ZOK = ZFalse : _
         RETURN
      GOSUB 59542
      IF NOT ZOK THEN _
         IF BackOpt2$ <> "" THEN _
            ZFileName$ = FilName$ + _
                         BackOpt2$ : _
         GOSUB 59543 : _
         IF WasBF > 1 THEN _
            ZOK = ZFalse : _
            RETURN _
         ELSE GOSUB 59542
      IF ZOK THEN _
         CALL WordInFile (CurMenu$,ZWasZ$,InMenu,ZFalse) : _
         IF ZSysop OR InMenu OR (NOT RequireInMenu) THEN _
            RETURN _
         ELSE GOTO 59540
      IF (NOT VerifyInMenu) THEN _
         GOTO 59540
      CALL WordInFile (CurMenu$,ZWasZ$,InMenu,ZFalse)  'verify against menu itself
      IF InMenu THEN _
         IF AllMenuOK THEN _
            RETURN
59540 WasX$ = FPre$ + _
           ZWasZ$ + PreSuf$ + _
           ".MNU" 'check whether option is a menu
      ZFileName$ = WasX$
      CALL Graphic (ZFileName$)
      IF ZOK THEN _
         NewMenu = ZTrue : _
         CurMenuVer$ = ZFileName$ : _
         CurMenu$ = WasX$ : _
         CALL BreakFileName (FPre$ + ZWasZ$,MenuDrv$,WasX$,ZWasDFF$,ZTrue) : _
         MenuFront$ = MenuDrv$ + WasX$ : _
         IF PreSuf$ = "-" THEN _
            LastSubMenu$ = CurMenu$
      RETURN
59542 IF ChkGraphic THEN _
         CALL Graphic (ZFileName$) _
      ELSE CALL FindIt (ZFileName$)
      IF NOT ZOK AND ZWasP$ <> "" THEN
         CALL FindIt (ZWasP$)
         IF ZOK THEN
            ZFileName$ = ZWasZ$
         END IF
      END IF
      RETURN
59543 WasZ$ = ZWasZ$
      CALL BadName (WasBF,ZFalse)
      ZWasZ$ = WasZ$
      RETURN
59547 '* "No such option <{ZZ>"
      CALL FormatString (1060,ZFalse,ZFalse,0,ZTrue,1,"")
      CALL SmartPause (ZFalse)
      ZLastIndex = 0
      IF VerifyInMenu AND InMenu AND NOT RequireInMenu THEN
         '* "Option {ZZ on menu but not found.  MENU:{SP"
         CALL FormatString (493,ZFalse,ZFalse,0,ZFalse,0,Strng$)
         CALL UpdtCalr (Strng$ + CurMenu$,1)
      END IF
      RETURN
59548 END SUB
59600 ' $SUBTITLE: 'SetEcho -- subroutine to reset who echoes'
' $PAGE
'
'  NAME    -- SetEcho
'
'  INPUTS  --   PARAMETER     MEANING
'               NewEcho$   The new echo option
'               ZLocalUser
'
'  OUTPUTS -- ZRemoteEcho   Whether RBBS is to echo what a
'                           remote caller types
'
'  PURPOSE -- Resets who echos.  "R" is for RBBS to echo.
'             "I" is for intermediate host to echo.
'             "C" is for caller's communication pgm to echo.
'
      SUB SetEcho (NewEcho$) STATIC
      IF NewEcho$ = PrevEcho$ THEN _
         EXIT SUB
      IF NewEcho$ = "R" THEN _
         ZRemoteEcho = (NOT ZLocalUser) _
      ELSE ZRemoteEcho = ZFalse
      IF ZLocalUser THEN _
         GOTO 59602
      IF NewEcho$ = "I" THEN _
          IF ZFossil THEN _
             Bytes = LEN(ZHostEchoOn$) : _
             CALL FosWrite(ZComPortNum,Bytes,ZHostEchoOn$) : _
             GOTO 59602 _
          ELSE PRINT #3,ZHostEchoOn$; : _
               GOTO 59602
      IF PrevEcho$ = "I" THEN _
          IF ZFossil THEN _
             Bytes = LEN(ZHostEchoOff$) : _
             CALL FosWrite(ZComPortNum,Bytes,ZHostEchoOff$) _
          ELSE PRINT #3,ZHostEchoOff$;
59602 PrevEcho$ = NewEcho$
      END SUB
59698 ' $SUBTITLE: 'MsgImport -- subroutine to import a message'
' $PAGE
'
'  NAME    -- MsgImport
'
'  INPUTS  --   PARAMETER     MEANING
'               MaxLines     MAXIMUM # OF LINES
'               MaxLen       MAXIMUM LENGTH OF A LINE
'               NumLines     NUMBER OF LINES ALREADY IN MESSAGE
'               LineAra$     ARRAY OF LINES IN MESSAGE
'
'  OUTPUTS --   NumLines
'               LineAra$
'
'  PURPOSE -- Allows local user to append a text file to
'             a message.   Will word wrap if needed.
'
      SUB MsgImport (MaxLines,MaxLen,NumLines,LineAra$(1)) STATIC
      IF ZNewUser THEN
         FileName$ = ZWelcomeFileDrvPath$ + "NEWUSER.TXT"
         GOTO 59702
      END IF
      IF NOT (ZLocalUser OR ZSysop) THEN
         EXIT SUB
      END IF
59700 '* "Import what file? {EX"
      CALL FormatString (494,ZFalse,ZFalse,0,ZFalse,0,ZOutTxt$)
      CALL PopCmdStack
      IF ZSubParm = -1 OR ZWasQ = 0 THEN
         EXIT SUB
      END IF
      FileName$ = UCASE$(ZUserInAra$(ZAnsIndex))
59702 CALL FindIt (FileName$)
      IF NOT ZOK THEN
         IF ZNewUser THEN
            EXIT SUB
         END IF
         '* "{Z1 not found"
         CALL FormatString (495,ZFalse,ZFalse,0,ZTrue,1,"")
         GOTO 59700
      END IF
      IF ZNewUser THEN
         CALL ReadDir (2,1)
         ZMsgFrom$ = ZOutTxt$
         CALL ReadDir (2,1)
         ZSubject$ = ZOutTxt$
      END IF
      WHILE NOT EOF(2) AND NumLines < MaxLines
         NumLines = NumLines + 1
         CALL ReadDir (2,1)
         LineAra$(NumLines) = ZOutTxt$
         IF ZNewUser THEN
            CALL SmartText (LineAra$(NumLines),ZTrue,ZFalse,ZFalse)
         END IF
      WEND
      CLOSE 2
      CALL WordWrap (MaxLen,NumLines,LineAra$())
      IF ZNewUser THEN
         EXIT SUB
      END IF
      CALL WipeLine(79)
      '* "{Z1 imported.  Delete {Z1 (Y,[N])"
      CALL FormatString (496,ZFalse,ZFalse,0,ZFalse,0,ZOutTxt$)
      ZTurboKey = -ZTurboKeyUser
      ZSubparm = 1
      CALL TGet
      IF ZSubParm < 0 THEN
         EXIT SUB
      END IF
      IF ZYes THEN
         CALL KillWork (FileName$)
      END IF
      END SUB
59703 ' $SUBTITLE: 'WordWrap -- subroutine to wrap lines in a message'
' $PAGE
'
'  NAME    -- WordWrap
'
'  INPUTS  --   PARAMETER     MEANING
'               MaxLen       MAXIMUM LENGTH OF A SINGLE LINE
'               NumLines     NUMBER OF LINES IN A MESSAGE
'               LineAra$     ALL THE LINES IN THE MESSAGE
'
'  OUTPUTS --   NumLines
'               LineAra$
'
'  PURPOSE -- Batch adjusts a message, wrapping lines if
'             needed.  Preserves paragraph structure.
'
      SUB WordWrap (MaxLen,NumLines,LineAra$(1)) STATIC
      WasJ = 1
      SplitOn = 1 + .4 * MaxLen
      WHILE WasJ <= NumLines and NumLines < ZMaxMsgLines
         ReFormatted = ZFalse
59704    LineAra$(WasJ) = RTRIM$(LineAra$(WasJ))
         WasK = LEN(LineAra$(WasJ))
         IF WasK <= MaxLen THEN _
            GOTO 59705
         CALL FindLast (LineAra$(WasJ),SPACE$(1),LastPos,HowMany)
         IF MID$(LineAra$(WasJ), 3, 1) = ">" THEN _
            CALL AnyBut (LineAra$(WasJ),3,">",WasX) _
         ELSE _
            CALL AnyBut (LineAra$(WasJ),1,">",WasX)
         IF WasX = 0 THEN WasX = 2
         IF MID$(LineAra$(WasJ + 1),3,1) = ">" THEN _
            CALL AnyBut (LineAra$(WasJ + 1),3,">",Temp) _
         ELSE _
            CALL AnyBut (LineAra$(WasJ+1),1,">",Temp)
         IF LEFT$(LineAra$(WasJ + 1),2) = SPACE$(2) OR ((Temp > 0) AND WasX <> Temp) THEN _
            FOR WasK = NumLines TO WasJ + 1 STEP -1 : _
               LineAra$(WasK + 1) = LineAra$(WasK) : _
            NEXT : _
            NumLines = NumLines + 1 : _
            LineAra$(WasJ + 1) = ""
         IF WasX > 1 THEN _
            IF MID$(LineAra$(WasJ),WasX,1) = SPACE$(1) THEN _
               WasX = WasX + 1
         WasX$ = LEFT$(LineAra$(WasJ),WasX-1)
         IF LastPos < SplitOn THEN _
            LineAra$(WasJ + 1) = WasX$ + MID$(LineAra$(WasJ),MaxLen) + MID$(LineAra$(WasJ + 1),WasX) : _
            LineAra$(WasJ) = LEFT$(LineAra$(WasJ),MaxLen - 1) + "-" _
         ELSE ZUserIn$ = LEFT$(SPACE$(1), - (LEN(LineAra$(WasJ + 1)) > 0)) : _
              LineAra$(WasJ + 1) = WasX$ + MID$(LineAra$(WasJ),LastPos + 1) + ZUserIn$ + MID$(LineAra$(WasJ + 1),WasX) : _
              LineAra$(WasJ) = LEFT$(LineAra$(WasJ),LastPos - 1)
         ReFormatted = ZTrue
         GOTO 59704
59705    IF ReFormatted THEN _
            IF WasJ = NumLines THEN _
               NumLines = NumLines + 1
         WasJ = WasJ + 1
      WEND
      END SUB
59760 ' $SUBTITLE: 'AnyBut -- subroutine to find where a word begins'
' $PAGE
'
'  NAME    -- AnyBut
'
'  INPUTS  --   PARAMETER     MEANING
'               Strng$        STRING TO SEARCH FOR WORDS
'               Beg           BYTE POSITION IN Strng$ TO
'                             BEGIN SEARCHING
'               SkipChars$    CHARACTERS TO SKIP OVER WHEN
'                                SEARCHING
'
'  OUTPUTS --   WhereIs      BYTES POSITION IN Strng$ WHERE
'                             WORD BEGINS
'
'  PURPOSE -- Parser.   Finds where a "word" begins, where
'             any character will be accepted as the beginning of a
'             word except those listed in SKIP.CHAR$
'
      SUB AnyBut (Strng$, Beg, SkipChars$, WhereIs) STATIC
      WasX$ = Strng$ + _
           CHR$(0)
      WhereIs = Beg
      IF WhereIs < 1 THEN _
         WhereIs = 1
      WHILE INSTR(SkipChars$, MID$(WasX$, WhereIs, 1)) > 0
         WhereIs = WhereIs + 1
      WEND
      IF WhereIs > LEN(Strng$) THEN _
         WhereIs = 0
      END SUB
59770 ' $SUBTITLE: 'FindEnd -- subroutine to find where a word ends'
' $PAGE
'
'  NAME    -- FindEnd
'
'  INPUTS  --   PARAMETER     MEANING
'               Strng$        STRING TO SEARCH FOR WORDS
'               Beg          POSITION IN Strng$ TO BEGIN SEARCH
'               StopWith$    CHARACTERS THAT TERMINATE A WORD
'
'  OUTPUTS      WhereIs      POSITION IN Strng$ WHERE WORD ENDS
'                             (I.E. THE Last CHARACTER OF THE WORD)
'
'  PURPOSE -- Parser.   Finds where a "word" ends, where
'             any character will be counted as in a word
'             except for those in StopWith$ or when the end of
'             the string is found.
'
      SUB FindEnd (Strng$, Beg, StopWith$, WhereIs) STATIC
      ZWasB = Beg
      IF ZWasB < 1 THEN _
         ZWasB = 1
      IF ZWasB > LEN(Strng$) THEN _
         WasX$ = StopWith$ _
      ELSE WasX$ = MID$(Strng$, ZWasB) + _
                StopWith$
      WasI = 1
      WasX = INSTR(StopWith$, MID$(WasX$, WasI, 1))
      WHILE WasX = 0
         WasI = WasI + 1
         WasX = INSTR(StopWith$, MID$(WasX$, WasI, 1))
      WEND
      WhereIs = WasI - 1 + ZWasB - 1
      END SUB
'
59800 ' $SUBTITLE: 'BadFileChar -- checks file for illegal char'
' $PAGE
'
'  NAME    --  BadFileChar
'
'  INPUTS  --  PARAMETER         MEANING
'               FilName$         NAME OF FILE TO CHECK
'
'  OUTPUTS --  IsOK            WHETHER NAME OK
'
'  PURPOSE --  Part of test for file's existence.  If bad
'              character in name, can't exist.
'
      SUB BadFileChar (FilName$,IsOK) STATIC
      WasL = LEN(FilName$)
      IF WasL > 2 THEN _
         IF INSTR(3,FilName$,":") > 0 THEN _
            IsOK = ZFalse : _
            EXIT SUB
      WasX$ = FilName$ + "="
      WasI = 1
      WHILE INSTR("/[]|<>+=;, ?*",MID$(WasX$,WasI,1)) = 0 AND ASC(MID$(WasX$,WasI)) < 128
         WasI = WasI + 1
      WEND
      IsOK = WasI > WasL
      END SUB
'
59850 ' $SUBTITLE: 'ConfMail -- quickly checks mail waiting'
' $PAGE
'
'  NAME    -- ConfMail
'
'  INPUTS  -- PARAMETER        MEANING
'         SKIP.CONFIRM         Whether to skip confirm of option
'         ZConfMailList$       File of user/message pairs to check
'         ZActiveUserFile$     Active user file (restored on exit)
'         ZActiveMessageFile$  Active msg file (restored)
'  OUTPUTS -- None
'
'  PURPOSE -- Quicking scans message header record to get
'             last msg # and user record to get whether any
'             new mail and last msg read, reports both, using
'             highlighting if new mail to caller.
'
      SUB ConfMail (MailCheckConfirm,LinkNew,LinkPers) STATIC
      IF NOT MailCheckConfirm AND ZWasGR = 4 THEN
         CALL BufFile (ZWelcomeFileDrvPath$ + "RIPWINC.RIP",WasX)
      END IF
      SkipJoinUnjoin = ZNonStop OR LinkNew OR LinkPers
      IF ZStartHash = 1 AND ZUserFileIndex > 0 THEN
         CALL FindIt (ZConfMailList$)
      ELSE
         ZOK = ZFalse
      END IF
      IF NOT ZOK THEN
         EXIT SUB
      END IF
      IF PrevMailList$ <> ZConfMailList$ THEN
         SkipParms = 0
      END IF
      PrevMailList$ = ZConfMailList$
      IF MailCheckConfirm THEN
         '* "{CR{CBCheck conferences for mail/uploads?{RC ([Y],N)"
         LineNum = 498
         GOSUB 59856
         ZOutTxt$ = Strng$
         ZTurboKey = -ZTurboKeyUser
         CALL PopCmdStack
         IF ZNo OR ZSubParm < 0 THEN
            EXIT SUB
         END IF
      END IF
      PrevTi! = TIMER
      CALL BreakFileName (ZActiveUserFile$,WasX$,NowInPre$,NowInExt$,ZFalse)
      CALL BreakFileName (ZOrigUserFile$,WasX$,OrigPre$,OrigExt$,ZFalse)
      '* "{CR{CBChecking message bases you have joined  {CF{G1(* = linked){RC{CR"
      LineNum = 499
      CRCount = 1
      GOSUB 59857
      '* {CAName                Message Status                 Personal Info
      '* {CANumber      Name           Message Status                 Personal Info
      LineNum = 1142 + (-1*(ZExtendedConfMail AND (ZShowConfName=3)))
      CRCount = 1
      GOSUB 59857
      '* {C9----------------------------------------------------------------{RC
      '* {C9-----------------------------------------------------------------------{RC
      LineNum = 1144 + (-1*(ZExtendedConfMail AND (ZShowConfName=3)))
      GOSUB 59856
      IF ZWasGR > 0 THEN
         CALL GlobalSrchRepl (Strng$,"-",CHR$(196),ZTrue)
      END IF
      CALL QuickTPut1 (Strng$)
      IF LinkNew OR LinkPers THEN
         ZLinkedConf$ = ""
      END IF
      AnyMail = ZFalse
      ZStopInterrupts = ZFalse
      WasA1$ = ZActiveUserFile$
      MsgFileSave$ = ZActiveMessageFile$
      TempIndivValue$ = ""
      UserFileIndexSave = ZUserFileIndex
      UserRecordHold$ = ZUserRecord$
      ZOK = ZTrue
      IF ZExtendedConfMail THEN
         Parms = 10
      ELSE
         Parms = 1
      END IF
      CALL ReadParms (ZWorkAra$(),Parms,SkipParms)
      IF SkipParms = 0 THEN
         LogicalEOF$ = ""
      ELSE
         IF ZExtendedConfMail THEN
            LogicalEOF$ = ZWorkAra$(9)
         ELSE
            LogicalEOF$ = ZWorkAra$(1)
         END IF
      END IF
59851 IF NOT ZOK THEN
         GOTO 59854
      ELSEIF EOF(2) THEN
         IF LogicalEOF$ = "" OR SkipParms = 0 THEN
            GOTO 59854
         ELSE
            CALL FindIt (ZConfMailList$)
            SkipParms = 0
            GOTO 59851
         END IF
      END IF
      TimeNow! = TIMER
      IF TimeNow! - PrevTi! > 3.0 THEN
         IF NOT AlreadyPrinted THEN
            CALL WipeLine (79)
            '* "{CESearching Conferences{RC"
            LineNum = 977
            GOSUB 59856
            CALL QuickTPut (Strng$,0)
            NumDots = 0
            AlreadyPrinted = ZTrue
         END IF
         PrevTi! = TimeNow!
      END IF

      IF AlreadyPrinted THEN
         CALL MarkTime (NumDots)
      END IF

      IF ZExtendedConfMail THEN
         CALL ReadParms (ZWorkAra$(),10,1)
         ZActiveUserFile$ = ZWorkAra$(8)
      ELSE
         CALL ReadAny
         ZActiveUserFile$ = ZOutTxt$
         CALL ReadAny
         IF ZErrCode > 0 THEN
            GOTO 59854
         END IF
      END IF
      IF ZExtendedConfMail THEN
         SkipParms = SkipParms + 1
      ELSE
         SkipParms = SkipParms + 2
      END IF
      IF ZExtendedConfMail THEN
         ZActiveMessageFile$ = ZWorkAra$(9)
      ELSE
         ZActiveMessageFile$ = ZOutTxt$
      END IF
      CALL FindFile (ZActiveUserFile$,ZOK)
      IF NOT ZOK THEN
         GOTO 59854
      END IF
      CALL OpenUser (ZHighestUserRecord)
      FIELD 5, 128 AS ZUserRecord$
      CALL FindFile (ZActiveMessageFile$,ZOK)
      IF NOT ZOK THEN
         GOTO 59854
      END IF
      CALL FindUser (ZOrigUserName$,"",ZStartHash,ZLenHash,_
                     0,0,ZHighestUserRecord,_
                     Found,HoldUserFileIndex,ZWasSL)
      IF NOT Found THEN
         GOTO 59853
      END IF
      CALL WipeLine (79)
      AlreadyPrinted = ZFalse
      CALL OpenMsg
      FIELD 1, 128 AS ZMsgRec$
      GET 1,1
      AnyMail = ZTrue
      WasX = CVI(MID$(ZUserRecord$,57,2))
      FileWait = (WasX AND 4096) > 0
      WasX = (WasX AND 512) > 0
      CALL BreakFileName (ZActiveUserFile$,WasX$,CurPre$,CurExt$,ZFalse)
      InCur = (CurPre$ = NowInPre$ AND CurExt$ = NowInExt$)
59852 IF InCur THEN
         FileWait = ZFileWaiting
         WasX = ZMailWaiting
         ZWasA = ZLastMsgRead
      ELSE
         ZWasA = CVI(MID$(ZUserRecord$,51,2))
      END IF
      ZWasB = VAL(LEFT$(ZMsgRec$,8))
      WasZ = (ZWasB - ZWasA)
      IF WasZ < 0 THEN
         ZWasA = 0
         WasZ = ZWasB
      ELSEIF WasZ = 0 THEN
         WasX = ZFalse
      END IF
      ZWasSL = LEN(CurPre$)
      IF CurPre$ = "USERS" AND CurExt$ = "" THEN
         '* "MAIN"
         LineNum = 166
         GOSUB 59856
         Conf$ = Strng$
      ELSE
         Conf$ = LEFT$(CurPre$,ZWasSL-1)
      END IF
      ZOutTxt$ = MID$(STR$((ZWasB > ZWasA) * WasZ),2)
      IF ZOutTxt$ = "0" THEN
         '* "{C7"
         LineNum = 500
         GOSUB 59856
         MsgColor1$ = Strng$
         '* "{C2"
         LineNum = 501
         GOSUB 59856
         MsgColor2$ = Strng$
      ELSE
         '* "{CF"
         LineNum = 502
         GOSUB 59856
         MsgColor1$ = Strng$
         '* "{CA"
         LineNum = 503
         GOSUB 59856
         MsgColor2$ = Strng$
      END IF
      Temp = LEN(ZOutTxt$)
      ZOutTxt$ = SPACE$(-(Temp<4) * (4-Temp)) + ZOutTxt$
      IF (WasZ > 0 AND LinkNew) OR (WasX AND LinkPers) THEN
         IF (NOT InCur) THEN
            CALL AddLink (Conf$)
         END IF
      END IF
      Temp = (INSTR(ZCarriageReturn$ + ZLinkedConf$,ZCarriageReturn$ + Conf$ + ZCarriageReturn$) > 0)
      ZWasY$ = ZFGA$ + MID$(" *",1-Temp,1) + ZFGE$ + SPACE$(1)
      IF ZShowConfName > 1 THEN
         ZWasY$ = ZWasY$ + Conf$ + SPACE$(-(ZWasSL<8) * (8-ZWasSL))
      END IF
      IF ZExtendedConfMail THEN
         IF ZWorkAra$(1) <> "" THEN
            ConfNum$ = ZFGF$ + ZWorkAra$(1) + SPACE$(10-LEN(ZWorkAra$(1)))
         ELSE
            ConfNum$ = SPACE$(10)
         END IF
         IF ZShowConfName = 1 OR ZShowConfName = 3 THEN
            ZwasY$ = ConfNum$ + ZWasY$
         ELSE
            ZWasY$ = ZWasY$ + SPACE$(3)
         END IF
      END IF
      IF WasX THEN
         '* "{SP{SP{CD* {CO Some to you! {RC"
         LineNum = 504
         GOSUB 59856
         WasX$ = Strng$
      ELSE
         WasX$ = ""
      END IF
      IF FileWait THEN
         '* "{SP{SP{CD* {CO Personal Upload for you! {RC"
         LineNum = 505
         GOSUB 59856
         IF WasX THEN
            Temp$ = ZCrLf$ + SPACE$(41+7*(ZShowConfName<2)) + Strng$
         ELSE
            Temp$ = Strng$
         END IF
      ELSE
         Temp$ = ""
      END IF
      '* "{C6 :{SP"
      LineNum = 506
      GOSUB 59856
      Strng1$ = Strng$
      '* "{SPnew message(s){RC"
      LineNum = 507
      GOSUB 59856
      Strng2$ = Strng$
      ZOutTxt$ = ZWasY$ + Strng1$ + MsgColor1$ + _
                 ZOutTxt$ + MsgColor2$ + Strng2$ + WasX$ + Temp$
      ZSubParm = 5
      CALL TPut
      ZJumpSupported = ZFalse
      IF SkipJoinUnjoin THEN
         CALL AskMore ("",ZTrue,ZTrue,WasX,ZTrue)
         GOTO 59853
      END IF
      ZTurboKey = -ZTurboKeyUser
      '* ",J)oin,U)njoin,L)ink,D)elink"
      LineNum = 508
      GOSUB 59856
      CALL AskMore (Strng$,ZTrue,ZFalse,WasX,ZFalse)
      IF ZNo THEN
         GOTO 59854
      END IF
      WasX$ = LEFT$(ZUserInAra$(1),1)
      CALL AllCaps (WasX$)
      PauseFlag$ = WasX$
      IF WasX$ = "J" THEN
         ZLastIndex = ZWasQ
         ZHomeConf$ = Conf$
         GOTO 59854
      END IF
      IF WasX$ = "D" THEN
         CALL DeLink (Conf$)
         GOTO 59852
      END IF
      IF WasX$ = "L" THEN
         CALL AddLink (Conf$)
         GOTO 59852
      END IF
      IF WasX$ = "U" THEN
         IF InCur OR (OrigPre$ = CurPre$ AND OrigExt$ = CurExt$) THEN
            '* "{CR{CE{G5Cannot omit yourself from the subboard or conference you are in{RC"
            LineNum = 509
            CRCount = 1
            GOSUB 59857
         ELSEIF (ZBBSOptions AND  16384) = 0 AND _
                 ZSubBoard AND NOT ZSysop THEN
            '* "{C${CE{G4Cannot omit you from this subboard - ask the sysop to manually delete you{RC"
            LineNum = 510
            CRCount = 1
            GOSUB 59857
         ELSE
            '* "deleted user"
            LineNum = 511
            GOSUB 59856
            LSET ZUserRecord$ = CHR$(0) + Strng$
            ZUserFileIndex = HoldUserFileIndex
            ZSubParm = 6
            CALL FileLock
            PUT 5, HoldUserFileIndex
            ZSubParm = 8
            CALL FileLock
            '* "{CR{CE{G5Omitted you from {CF"
            LineNum = 512
            GOSUB 59856
            CALL QuickTPut (Strng$ + Conf$ + ZEmphasizeOff$,2)
         END IF
      END IF
59853 IF ZActiveMessageFile$ = LogicalEOF$ THEN
         GOTO 59854
      END IF
      IF NOT ZRet THEN
         GOTO 59851
      END IF
59854 IF NOT ZOK THEN
         '* "Error in Conference System"
         LineNum = 1166
         GOSUB 59856
         CALL UpdtCalr (Strng$,1)
         Strng1$ = Strng$
         '* ". Please tell sysop."
         LineNum = 563
         GOSUB 59856
         CALL QuickTPut1 (ZCrLf$ + Strng1$ + Strng$)
      END IF
ZActiveUserFile$ = WasA1$
      CALL OpenUser (ZHighestUserRecord)
      FIELD 5, 128 AS ZUserRecord$
      IF (NOT ZRet) AND NOT AnyMail THEN
         '* "{CF{G2You have not joined any conferences!{RC"
         LineNum = 513
         CRCount = 1
         GOSUB 59857
      END IF
      ZUserFileIndex = UserFileIndexSave
      LSET ZUserRecord$ = UserRecordHold$
      ZActiveMessageFile$ = MsgFileSave$
      CALL OpenMsg
      FIELD 1, 128 AS ZMsgRec$
      GET 1,1
      ZNonStop = (ZPageLength < 1)
      WasX$ = ZUserInAra$(ZAnsIndex+1)
      CALL AllCaps (WasX$)
      ZAnsIndex = ZAnsIndex - (WasX$ = "C")
      SkipParms = -(NOT EOF(2))*SkipParms
      LinkNew = ZFalse
      LinkPers = ZFalse
      CLOSE 2
      IF PauseFlag$ <> "J" THEN
         CALL SmartPause (ZFalse)
      END IF
      EXIT SUB
59856 CALL FormatString (LineNum,ZFalse,ZFalse,0,ZFalse,0,Strng$)
      RETURN
59857 CALL FormatString (LineNum,ZFalse,ZFalse,0,ZTrue,CRCount,"")
      RETURN
      END SUB
59858 ' $SUBTITLE: 'AskMore -- pauses when possible screen full'
' $PAGE
'
'  NAME    -- AskMore
'
'  INPUTS  --   PARAMETER     MEANING
'               ExtraPrompt$  STRING TO ADD TO MORE PROMPT AT END
'               OverWrite     WHETHER TO WIPE AWAY PROMPT
'
'  OUTPUTS --   ZUserInAra$()
'               ZNo
'
'  PURPOSE -- Determines whether need to pause if screen full.
'             And, if so, asks the appropriate question.  If non-
'             stop, at least check for carrier present.
'
      SUB AskMore (ExtraPrompt$, OverWrite, CheckLines,AbortIndex,CantInterrupt) STATIC
      ZNo = ZFalse
      IF CheckLines THEN _
         WasX = -ZDisplayAsUnit*ZUnitCount -(NOT ZDisplayAsUnit)*ZLinesPrinted : _
         IF WasX < ZPageLength OR (ZPageLength = 0) THEN _
            ZWasQ = 0 : _
            EXIT SUB
      IF ZOneStop THEN _
         ZOneStop = ZFalse : _
         ZNonStop = ZTrue : _
         GOTO 59860
      IF ZNonStop THEN _
         ZLinesPrinted = 0 : _
         CALL CheckCarrier : _
         IF ZKeyboardStack$ = "" AND ZCommPortStack$ = "" THEN _
            EXIT SUB _
         ELSE ZNonStop = ZFalse
59860 CALL QuickTPut (ZEmphasizeOff$,0)
      IF CantInterrupt THEN
         ZTurboKey = 2
         ZForceKeyboard = ZTrue
         '* "Press any key to continue"
         CALL FormatString (514,ZFalse,ZFalse,0,ZFalse,0,ZOutTxt$)
         ZOutTxt$ = ZEmphasizeOn$ + ZOutTxt$ + ZEmphasizeOff$
      ELSE
         GOSUB 59870
         ZOutTxt$ = ZMorePrompt$ + Temp$ + ExtraPrompt$ + LEFT$(")",-ZExpertUser)
      END IF
      WasX = LEN(ZOutTxt$) + 2
      ZNoAdvance = OverWrite
      ZSubParm = 1
      IF ExtraPrompt$ = "" AND ZTurboKey = 0 THEN _
         ZTurboKey = -ZTurboKeyUser
      ZMacroMin = 2
      CALL TGet
      IF ZSubParm = -1 THEN _
        EXIT SUB
      ZTurboKey = ZFalse
      ZWasDFF$ = ZUserInAra$(1)
      CALL AllCaps (ZWasDFF$)
      WasI = INSTR(";C;A;",";"+ZWasDFF$+";")
      IF WasI = 1 THEN _
         ZNonStop = ZTrue : _
         ZWasQ = 0
      IF ZMorePromptLF THEN
         CALL SkipLine (1)
      ELSE
         CALL WipeLine (WasX + LEN(ZUserIn$))
      END IF
      IF NOT ZHiLiteOff THEN _
         CALL QuickTPut (ZLastSmartColor$,0)
      IF CantInterrupt THEN _
         ZNo = ZFalse : _
         EXIT SUB
      IF WasI = 3 THEN _
         ZLastIndex = 0 : _
         AbortIndex = 32000
      IF ZNo THEN _
         ZKeyboardStack$ = "" : _
         ZCommPortStack$ = "" : _
         ZLastSmartColor$ = ""
      IF NOT ZJumpSupported THEN _
         EXIT SUB
      IF ZWasDFF$ = "J" THEN
         IF ZWasQ > 1 THEN
            ZUserIn$ = ZUserInAra$(2)
            GOTO 59866
         ELSE
            '* "{RCJump to what text? {EX{RC"
            CALL FormatString (515,ZFalse,ZFalse,0,ZFalse,0,ZOutTxt$)
            CALL PopCmdStack
            IF ZWasQ = 0 THEN
               EXIT SUB
            ELSE
               GOTO 59866
            END IF
         END IF
      END IF
      IF ZWasDFF$ <> "R" THEN _
         EXIT SUB
      ZUserIn$ = ZJumpLast$
59866 ZJumpTo$ = ZUserIn$
      CALL AllCaps (ZJumpTo$)
      ZJumpSearching = ZTrue
      ZJumpLast$ = ZJumpTo$
      EXIT SUB
59870 Temp$ = ""
      IF NOT ZJumpSupported THEN _
         RETURN
      IF ZJumpLast$ = "" THEN
         '* ",J)ump"
         LineNum = 1062
         GOSUB 59872
         Temp$ = LEFT$(Strng$,2+4*(ZExpertUser+1))
      ELSEIF ZExpertUser THEN
         '* ",J,R="
         LineNum = 1063
         GOSUB 59872
         Temp$ = Strng$ + ZJumpLast$
      ELSE
         '* ",J)ump,R)ejump="
         LineNum = 1064
         GOSUB 59872
         Temp$ = Strng$ + ZJumpLast$
      END IF
      RETURN
59872 CALL FormatString (LineNum,ZFalse,ZFalse,0,ZFalse,0,Strng$)
      RETURN
      END SUB
59880 ' $SUBTITLE: 'CompDate -- subroutine to compute elased days'
' $PAGE
'
'  NAME    -- CompDate
'
'  INPUTS  --   PARAMETER     MEANING
'                   Year        YEAR
'                   WasMM       MONTH
'                   WasDD       DAY
'                 Result!    LOCATION TO PLACE THE Result
'
'  OUTPUTS -- Result!        COMPUTE COMPUTATIONAL DATE
'
'  PURPOSE -- Computes a computational date from YEAR, MONTH, DAY.
'             Results may be used to compute the number of elapsed
'             days between two dates.  You may pass a 2 or 4 digit
'             year, but for meaningful results, be consistent
'
      SUB CompDate (YearX,WasMM,WasDD,Result!) STATIC
      IF WasMM < 1 OR WasMM > 12 THEN _
         WasMM = 1
      '* "000303060811131619212426"
      CALL FormatString (1065,ZFalse,ZFalse,0,ZFalse,0,Strng$)
      Result! = YearX * 365.0 + _
                INT((YearX - 1) / 4) + _
                (WasMM - 1) * 28 + _
                VAL(MID$(Strng$,(WasMM - 1) * 2 + 1,2)) - _
                ((WasMM > 2) AND ((YearX MOD 4) = 0)) + _
                WasDD
      END SUB
59890 ' $SUBTITLE: 'ExpireDate -- subroutine to display expiration date'
' $PAGE
'
'  NAME    -- ExpireDate
'
'  INPUTS  --   PARAMETER           MEANING
'             RegDate!    COMPUTATIONAL REGISTRATION DATE
'             RegPeriod   DAYS IN REGISTRATION PERIOD
'
'  OUTPUTS -- ExpDate$             DISPLAYABLE EXPIRATION DATE
'
'  PURPOSE -- Computes/creates a displayable registration
'             expiration date using registration date and days in
'             registration period.
'
      SUB ExpireDate (RegDate!,RegPeriod,ExpDate$) STATIC
      ExpDate! = RegDate! + RegPeriod
      ExpireYear = INT((ExpDate! - ExpDate! / 1461) / 365)
      ExpireDay = ExpDate! - (ExpireYear * 365.0 + INT((ExpireYear -1)/4))
      ExpireMonth = -((ExpireYear MOD 4)<>0) * _
                      (1 - (ExpireDay > 31) - (ExpireDay > 59) - _
                      (ExpireDay > 90) - (ExpireDay >120) - _
                      (ExpireDay > 151) - (ExpireDay > 181) - _
                      (ExpireDay > 212) - (ExpireDay > 243) - _
                      (ExpireDay > 273) - (ExpireDay > 304) - _
                      (ExpireDay > 334)) - ((ExpireYear MOD 4) = 0) * _
                      (1 - (ExpireDay > 31) - (ExpireDay > 60) - _
                      (ExpireDay > 91) - (ExpireDay >121) - _
                      (ExpireDay > 152) - (ExpireDay > 182) - _
                      (ExpireDay > 213) - (ExpireDay > 243) - _
                      (ExpireDay > 274) - (ExpireDay > 305) - _
                      (ExpireDay > 335))
      '* "000303060811131619212426"
      CALL FormatString (1065,ZFalse,ZFalse,0,ZFalse,0,Strng$)
      ExpireDay = (ExpireDay - ((ExpireMonth - 1) * 28 + _
                   VAL(MID$(Strng$,(ExpireMonth -1) * 2 + 1,2)))) + _
                   ((ExpireMonth > 2) AND ((ExpireYear MOD 4) = 0))
      ExpDate$ = RIGHT$("0" + MID$(STR$(ExpireMonth),2),2) + _
                  "/" + _
                  RIGHT$("0" + MID$(STR$(ExpireDay),2),2) + _
                  "/" + _
                  RIGHT$(STR$(ExpireYear),2)
      END SUB
'
59930 ' $SUBTITLE: 'CheckColor - highlights based on search string'
' $PAGE
'
'  NAME    --  CheckColor
'
'  INPUTS  --  PARAMETER                   MEANING
'              LookFor$           String that triggers highlight
'              LookIn$            String being searched
'              EndColor$          Terminating color
'
'  OUTPUTS --  Strng$              Revised string
'
'  PURPOSE --  Adds highlighting to a string within a string.
'              Respects previous colorization.
      SUB CheckColor (LookIn$,LookFor$,PassedEndColor$) STATIC
      IF LookFor$ = "" THEN _
         EXIT SUB
      WasX$ = LookIn$
      CALL AllCaps (WasX$)
      StartColor = INSTR(WasX$,LookFor$)
      IF StartColor < 1 THEN _
         EXIT SUB
      IF StartColor > 2 THEN
         IF INSTR(MID$(WasX$,StartColor-2,2),";") OR _
            INSTR(MID$(WasX$,StartColor-2,2),"[") OR _
            INSTR(MID$(WasX$,StartColor-2,2),CHR$(27)) THEN
            EXIT SUB
         END IF
      END IF
      EndColor$ = PassedEndColor$
      IF EndColor$ = "" THEN
         EndColor$ = ZEmphasizeOff$
         CALL FindLast (LEFT$(LookIn$,StartColor-1),ZEscape$,WhereFound,WasJ)
         IF WhereFound > 0 THEN
            WasJ = INSTR(WhereFound,LookIn$,"m")
            IF WasJ > 0 THEN
               EndColor$ = MID$(LookIn$,WhereFound,WasJ-WhereFound+1)
            END IF
         END IF
      END IF
      CALL Bracket (LookIn$,StartColor,StartColor + _
           LEN(LookFor$)-1,ZEmphasizeOn$,EndColor$ + ZBG0$)
      END SUB
59934 ' $SUBTITLE: 'SetHiLite - subroutine to reset highlight preference'
' $PAGE
'
'  NAME    --  SetHiLite
'
'  INPUTS  --  PARAMETER                   MEANING
'              SetTo              New value (True or False)
'              ZEmphasizeOnDef$   String turns emphasize on
'              ZEmphasizeOffDef$  String turns emphasize off
'
'  OUTPUTS --  ZHiLiteOff       Callers preference on Hilite
'              ZEmphasizeOn$       String to use for emphasis
'              ZEmphasizeOff$      String to use after emphasis
'
      SUB SetHiLite (SetTo) STATIC
      ZHiLiteOff = (ZEmphasizeOnDef$ <> "" AND SetTo)
      ZHiLiteOffHold = ZHiLiteOff
      IF ZHiLiteOff THEN _
         ZEmphasizeOn$ = "" : _
         ZEmphasizeOff$ = "" : _
         ZDR1$ = "" : _
         ZDR2$ = "" : _
         ZDR3$ = "" : _
         ZDR4$ = "" : _
         ZDR5$ = "" : _
         ZFG0$ = "" : _
         ZFG1$ = "" : _
         ZFG2$ = "" : _
         ZFG3$ = "" : _
         ZFG4$ = "" : _
         ZFG5$ = "" : _
         ZFG6$ = "" : _
         ZFG7$ = "" : _
         ZFG8$ = "" : _
         ZFG9$ = "" : _
         ZFGA$ = "" : _
         ZFGB$ = "" : _
         ZFGC$ = "" : _
         ZFGD$ = "" : _
         ZFGE$ = "" : _
         ZFGF$ = "" : _
         ZBG0$ = "" : _
         ZBG1$ = "" : _
         ZBG2$ = "" : _
         ZBG3$ = "" : _
         ZBG4$ = "" : _
         ZBG5$ = "" : _
         ZBG6$ = "" : _
         ZBG7$ = "" _
      ELSE ZEmphasizeOn$ = ZEmphasizeOnDef$ : _
         ZEmphasizeOff$ = ZEscape$ + "[" + ZBoldText$ + _
              ";40;" + MID$(STR$(ZUserTextColor),2) + "m" : _
         CALL SetANSIColors
      CALL SetSection
      END SUB
59940 ' $SUBTITLE: 'ColorPrompt - subroutine to colorize prompts'
' $PAGE
'
'  NAME    --  ColorPrompt
'
'  INPUTS  --  PARAMETER                   MEANING
'              Strng$              String to colorize
'              ZHiLiteOff          Whether highlighting is off
'              ZEmphasizeOn$       String to use for emphasis
'              ZEmphasizeOff$      String to use after emphasis
'
'  OUTPUTS --  Strng$              Colorized string
'
'  PURPOSE -- colorizes a string based on sysop settings
'             and the string.
'                        [...] is the default - put in emphasis
'                        <...> options to type - put in ZFGB$
'                        and first two preceeding words use ZFGA$
'                        and ZFGE$ options identified on right
'                        by ) and on left by space or comma - put
'                        in ZFGB$
'
      SUB ColorPrompt (Strng$) STATIC
      CALL SmartText(Strng$,ZTrue,ZFalse,ZFalse)
      IF ZHiLiteOff THEN _
         EXIT SUB
      AlreadyColorized = (INSTR(Strng$,ZEscape$) > 0)
      WasX = INSTR(Strng$,"<")
      IF WasX > 0 THEN _
         GOTO 59943
      WasX = INSTR(Strng$,"[")   ' highlight default
      IF WasX > 0 THEN _
         WasY = INSTR(WasX,Strng$,"]") : _
         IF WasY > 0 THEN _
            CALL FindLast (LEFT$(Strng$,WasY),"[",WasX,Temp) : _
            CALL Bracket (Strng$,WasX,WasY,ZEmphasizeOn$,ZEmphasizeOff$)
      WasX = INSTR(Strng$,"<")
      IF WasX < 1 THEN _
         GOTO 59945
59943 WasY = INSTR(WasX,Strng$,">")
      IF WasY < 1 THEN _
         GOTO 59945
      CALL Bracket (Strng$,WasX,WasY,ZFGB$,ZEmphasizeOff$)
      WasY = INSTR(Strng$,SPACE$(1))
      IF WasY > 1 AND WasY < WasX THEN _
         Strng$ = ZFGA$ + Strng$ : _
         WasZ = INSTR(WasY+1,Strng$,SPACE$(1)) : _
         IF WasZ > 1 AND WasZ < WasX+LEN(ZFGA$) THEN _
            Strng$ = LEFT$(Strng$,WasZ) + ZFG2Def$ + MID$(Strng$,WasZ+1)
      EXIT SUB
59945 WasX = 1
      DidInsert = ZFalse
      WasL = LEN(ZFGB$)
59950 WasY = INSTR (WasX,Strng$,")") ' x: where command begins, y: terminating pos
      WasZ = INSTR (WasX,Strng$,",")
      IF WasY = 0 OR (WasZ > 0 AND WasZ < WasY) THEN _
         WasY = WasZ
      WasK = LEN(Strng$)
      IF WasX > WasK THEN _
         EXIT SUB
      IF WasY < 1 THEN _
         IF NOT DidInsert THEN _
            EXIT SUB _
         ELSE WasY = WasK+1
      WasZ = WasY - 1
      WHILE WasZ > 0    ' got terminating pos: find beginning
         IF INSTR(ZOptionEnd$,MID$(Strng$,WasZ,1)) > 0 THEN _
            WasX = WasZ + 1 : _
            WasZ = 0
         WasZ = WasZ - 1
      WEND
      IF WasY-WasX < 3 THEN _     ' exclude commands too long
         CmndString$ = MID$(Strng$,WasX,WasY-WasX) : _
         WasX$ = CmndString$ : _
         CALL AllCaps (CmndString$) : _
         IF WasX$ = CmndString$ THEN _  ' exclude lower case
            DidInsert = ZTrue : _
            CALL Bracket (Strng$,WasX,WasY-1,ZFGB$,ZEmphasizeOff$) : _  ' colorize
            WasY = WasY + WasL
      WasX = WasY + 1
      GOTO 59950
      END SUB
59960 ' $SUBTITLE: 'Bracket - Inserts strings around a string'
' $PAGE
'
'  NAME    --  Bracket
'
'  INPUTS  --  PARAMETER                   MEANING
'              Strng$              Insert in this string
'              B4Here              Insert 1st before this pos
'              AfterHere           Insert 2nd after this pos
'              B4String$           String to insert before
'              AfterString$        String to insert after
'
'  OUTPUTS --  Strng$
'
'  PURPOSE -- Primarily for colorization
'
      SUB Bracket (Strng$,B4Here,AfterHere,B4String$,AfterString$) STATIC
      Strng$ = LEFT$(Strng$,B4Here-1) + _
               B4String$ + _
               MID$(Strng$,B4Here,AfterHere-B4Here+1) + _
               AfterString$ + _
               RIGHT$(Strng$,LEN(Strng$) - AfterHere)
      END SUB
59965 ' $SUBTITLE: 'UserColor - lets user set color for normal text'
' $PAGE
'
'  NAME    --  UserColor
'
'  INPUTS  --  PARAMETER                   MEANING
'              ZEmphasizeOff$            Normal text color
'
'  OUTPUTS --  ZEmphasizeOff$            New text color
'              ZBoldText$                Whether bold (0 not, 1 bold)
'              ZUserTextColor            ANSI Color selected
'
'  PURPOSE --  Lets caller select desired color and whether bold.
'
      SUB UserColor STATIC
      IF ZHiLiteOff THEN _
         EXIT SUB _
      ELSE _
         CALL SetANSIColors
59970 '* "{RCMake text R)ed,G)reen,Y)ellow,B)lue,P)urple,C)yan,W)hite{EX"
      LineNum = 516
      GOSUB 59975
      GOSUB 59973
      IF ZWasQ = 0 THEN _
         ZEmphasizeOff$ = ZEscape$ + "[" + ZBoldText$ + _
             ";40;" + MID$(STR$(ZUserTextColor),2) + "m" : _
         EXIT SUB
      CALL AllCaps (ZUserIn$)
      WasX = INSTR("RGYBPCW",ZUserIn$)
      IF WasX = 0 THEN _
         GOTO 59970
      ZUserTextColor = 30 + WasX
      '* "{RCMake text Bright? (Y,[N])"
      LineNum = 1066
      GOSUB 59975
      GOSUB 59973
      ZBoldText$ = CHR$(48 - ZYes)
      ZBoldTextHold$ = ZBoldText$
      ZEmphasizeOff$ = ZEscape$ + "[" + ZBoldText$ + ";40;" + MID$(STR$(ZUserTextColor),2) + "m"
      GOTO 59970
59973 ZSubParm = 1
      ZTurboKey = -ZTurboKeyUser
      CALL TGet
      IF ZSubParm = -1 THEN _
         EXIT SUB
      RETURN
59975 CALL FormatString (LineNum,ZFalse,ZFalse,0,ZFalse,0,ZOutTxt$)
      RETURN
      END SUB
59980 ' $SUBTITLE: 'SetGraphic - Sets user graphic preference'
' $PAGE
'
'  NAME    --  SetGraphic
'
'  INPUTS  --  PARAMETER                   MEANING
'              GraphicsNumber        0=None, 1=Ascii, 2=color
'
'  OUTPUTS --  ZWasGR                Shared var - set to
'                                    graphics.number
'              ZUserGraphicDefault$ What add to file name to
'                                    see if got graphics file ver
'
'  PURPOSE --  Sets file graphics preference
'
      SUB SetGraphic (GraphicsNumber) STATIC
      ZWasGR = GraphicsNumber
      ZUserGraphicDefault$ = MID$(" GC R",ZWasGR+1, - (ZWasGR > 0))
      IF ZWasGR = 4 THEN
         ZTurboKeyUser = ZFalse
         ZPageLength = 28
         ZExpertUser = ZFalse
         CALL SetExpert
      END IF
      END SUB
60000 ' $SUBTITLE: 'EofComm - Determines whether input in comm port buffer'
' $PAGE
'
'  NAME    --  EofComm
'
'  INPUTS  --  PARAMETER                   MEANING
'               ZFossil              Whether fossil driver used
'               ZComPortNum         Comm port # in use
'
'  OUTPUTS --  NoChars           -1 (True) if no chars in buffer.
'                                   Anything else means has char.
'
'  PURPOSE -- Query comm port to see if input waiting
'
      SUB EofComm (NoChars) STATIC
      IF ZFossil THEN _
         CALL FosReadAhead(ZComPortNum,NoChars) _
      ELSE NoChars = EOF(3)
      END SUB
60100 ' $SUBTITLE: 'GlobalSrchRepl - Global search and replace'
' $PAGE
'
'  NAME    --  GlobalSrchRepl
'
'  INPUTS  --  PARAMETER                   MEANING
'              Strng$              String to edit
'              LookFor$           String to look for
'              ReplaceBy$         String to replace by
'
'  OUTPUTS --  Strng$              Edited string
'
'  PURPOSE --  Replaces every occurence of LookFor$ that
'                         is in Strng$ by ReplaceBy$
'
      SUB GlobalSrchRepl (Strng$,LookFor$,ReplaceBy$,OverStrike) STATIC
      IF LookFor$ = "" THEN _
         EXIT SUB
      WasX = 1
      WasL = LEN(ReplaceBy$)
      ZMsgPtr = LEN(LookFor$)
60102 WasY = INSTR(WasX,Strng$,LookFor$)
      IF WasY < 1 THEN _
         EXIT SUB
      IF OverStrike THEN _
         MID$(Strng$,WasY) = ReplaceBy$ + SPACE$((WasL-ZMsgPtr)*(WasL < ZMsgPtr)) _
      ELSE Strng$ = LEFT$(Strng$,WasY-1) + _
                    ReplaceBy$ + _
                    RIGHT$(Strng$,LEN(Strng$)-WasY+1-ZMsgPtr)
      WasX = WasY + WasL
      IF WasX > LEN(Strng$) THEN _
         EXIT SUB
      GOTO 60102
      END SUB
60130 ' $SUBTITLE: 'MetaGSR -- Meta Global search and replace'
' $PAGE
'
'  NAME    --  MetaGSR
'
'  INPUTS  --  PARAMETER               MEANING
'              Strng$              String to edit
'
'  OUTPUTS --  Strng$              Edited string
'
'  PURPOSE --  Global search and replace for meta variables
'
      SUB MetaGSR (Strng$,OverStrike) STATIC
      WasY = 1
60131 IF WasY > LEN(Strng$) THEN _
         EXIT SUB
      WasX = INSTR(WasY,Strng$,"[")
      IF WasX = 0 THEN _
         EXIT SUB
      WasY = INSTR(WasX,Strng$,"]")
      IF WasY = 0 THEN _
         EXIT SUB
      ZMsgPtr = WasY-WasX+1
      Temp = WasY-WasX-1
      CALL CheckInt(MID$(Strng$,WasX+1,Temp))
      IF (ZErrCode > 0) OR (ZTestedIntValue < 1) OR (ZTestedIntValue > ZMaxWorkVar) THEN _
            GOTO 60135
      IF ((ZTestedIntValue < 10) AND (Temp = 1)) OR ((ZTestedIntValue > 9) AND (Temp = 2)) THEN _
            GOTO 60132
      WasY = WasX + 1
      GOTO 60131
60132 WorkHold$ = ZGSRAra$(ZTestedIntValue)
      IF WasY = LEN(Strng$) THEN _
         GOTO 60151
      IF MID$(Strng$,WasY+1,1) <> "(" THEN _
         GOTO 60151
      WasI = INSTR(WasY+1,Strng$,")")
      IF WasI = 0 THEN _
         GOTO 60151
      WasJ = INSTR(WasY+1,Strng$,":")
      IF WasJ > WasI THEN _
         GOTO 60151
      CALL CheckInt (MID$(Strng$,WasY+2))
      IF (ZErrCode > 0) OR (ZTestedIntValue < 1) OR _
         (ZTestedIntValue > LEN(WorkHold$)) THEN _
            GOTO 60151
      WasY = WasI
      ZMsgPtr = WasI-WasX+1
      StartSub = ZTestedIntValue
      CALL CheckInt (MID$(Strng$,WasJ+1))
      IF ZErrCode > 0 OR ZTestedIntValue < 1 OR _
         (ZTestedIntValue > LEN(WorkHold$)) THEN _
            GOTO 60151
      LenSub = ZTestedIntValue
      WorkHold$ = MID$(WorkHold$,StartSub,LenSub)
      GOTO 60151
60135 MetaVal$ = MID$(Strng$,WasX+1,WasY-WasX-1)
      '* "{SP{SP{SP{SP{SP{SPBAUD  CBAUD PORT  PORT# PARITYPROTO NODE  FILE  PATH{SP{SP"
      CALL FormatString (517,ZFalse,ZFalse,0,ZFalse,0,Strng1$)
      WasI = INSTR(Strng1$,MetaVal$)
      IF WasI = 0 OR LEN(MetaVal$) < 4 THEN _
         WasY = WasX + 1 : _
         GOTO 60131
      WasJ = (WasI-1)\6 + 1
      WasK = (WasI+4)\6 + 1
      IF WasK > WasJ THEN _
         EXIT SUB
      ON WasJ GOTO 60155, _
                60137, _
                60138, _
                60139, _
                60141, _
                60143, _
                60145, _
                60147, _
                60149, _
                60150, _
                60151
60137 WorkHold$ = ZTalkToModemAt$
      GOTO 60151
60138 WorkHold$ = ZCBaud$
      GOTO 60151
60139 WorkHold$ = ZComPort$
      GOTO 60151
60141 WorkHold$ = MID$(ZComPort$,4)
      GOTO 60151
60143 WorkHold$ = MID$(ZBaudParity$,INSTR(ZBaudParity$,",")+1,1)
      GOTO 60151
60145 WorkHold$ = ZWasFT$
      GOTO 60151
60147 WorkHold$ = ZNodeID$
      GOTO 60151
60149 IF ZWasBatchTransfer THEN _
         WorkHold$ = ZUpldSubDir$ + "\" _
      ELSE _
         IF ZBatchTransfer THEN _
            WorkHold$ = "@" + ZNodeWorkFile$ _
         ELSE WorkHold$ = ZFileName$
      GOTO 60151
60150 IF ZWasBatchTransfer THEN
         WorkHold$ = ZUpldSubDir$ + "\"
      ELSE
         CALL BreakFileName (ZFileName$,WorkHold$,Body$,Ext$,ZTrue)
      END IF
60151 WasL = LEN(WorkHold$)
      IF OverStrike THEN _
         MID$(Strng$,WasX) = WorkHold$ + SPACE$((WasL-ZMsgPtr)*(WasL < ZMsgPtr)) _
      ELSE Strng$ = LEFT$(Strng$,WasX-1) + WorkHold$ + RIGHT$(Strng$,LEN(Strng$)-WasY)
      WasY = 1
      GOTO 60131
60155 WasY = WasY + 1
      GOTO 60131
      END SUB
60180 ' $SUBTITLE: 'TimeLock - Test TIME LOCK for premium features'
' $PAGE
'
'  NAME    --  TimeLock  (written by Doug Azzarito)
'
'  INPUTS  --  PARAMETER                   MEANING
'              ZTimeLockSet               SECONDS/SESSION TO LOCK
'
'  OUTPUTS --  ZSubParm     -1 if feature is LOCKED
'
'  PURPOSE -- Check elapsed time for lock duration
'
      SUB TimeLock STATIC
      IF ZSysop THEN
         ZOK = ZTrue
         EXIT SUB
      END IF
      CALL TimeRemain(MinsRemaining)
      IF ZSecsUsedSession! >= ZTimeLockSet THEN _
         ZOK = ZTrue : _
         EXIT SUB
      CALL BufFile(ZHelpPath$+"TIMELOCK"+ZHelpExtension$,WasX)
      ZOK = ZFalse
      ZLastIndex = 0
      END SUB
60200 ' $SUBTITLE: 'MarkTime - Give feedback for lengthy processes'
' $PAGE
'
'  NAME    --  MarkTime
'
'  INPUTS  --  PARAMETER                   MEANING
'              DotNumber          How many dots printed
'
'  OUTPUTS --  DotNumber
'
'  PURPOSE --  Marks time by putting colorized dots out
'              to 4, then erasing
'
      SUB MarkTime (DotNumber) STATIC
      IF DotNumber = 0 THEN
         Style = Style + 1
         IF Style > 7 OR Style < 1 THEN Style = 1
         ON Style GOSUB 60230,60240,60250,60260,60270,60280,60290
         CALL QuickTPut (SPACE$(2),0)
      END IF
      TimeNow! = TIMER
      IF TimeNow! < PrevTI! THEN
         PrevTI! = TIMER
         EXIT SUB
      END IF
      IF TimeNow! - PrevTI! < 0.15 THEN _
         EXIT SUB
      PrevTI! = TimeNow!
      DotNumber = DotNumber + 1
      IF DotNumber > 4 THEN DotNumber = 1
      WasX$ = CHR$(8) + " " + CHR$(8)
      ON DotNumber GOTO 60201,60202,60203,60204
60201 WasX$ = WasX$ + ZFGA$ + char1$
      GOTO 60205
60202 WasX$ = WasX$ + ZFGE$ + char2$
      GOTO 60205
60203 WasX$ = WasX$ + ZFGC$ + char3$
      GOTO 60205
60204 WasX$ = WasX$ + ZFGB$ + char4$
60205 CALL QuickTPut (WasX$ + ZEmphasizeOff$,0)
      EXIT SUB
60230 IF ZWasGR = 0 THEN GOTO 60270
      char1$ = CHR$(221)
      char2$ = CHR$(220)
      char3$ = CHR$(222)
      char4$ = CHR$(223)
      RETURN
60240 IF ZWasGR = 0 THEN GOTO 60280
      char1$ = CHR$(45)
      char2$ = CHR$(61)
      char3$ = CHR$(247)
      char4$ = CHR$(240)
      RETURN
60250 IF ZWasGR = 0 THEN GOTO 60290
      char1$ = CHR$(92)
      char2$ = CHR$(124)
      char3$ = CHR$(47)
      char4$ = CHR$(196)
      RETURN
60260 IF ZWasGR = 0 THEN GOTO 60270
      char1$ = CHR$(250)
      char2$ = CHR$(249)
      char3$ = CHR$(254)
      char4$ = CHR$(219)
      RETURN
60270 char1$ = CHR$(43)
      char2$ = CHR$(42)
      char3$ = CHR$(45)
      char4$ = CHR$(42)
      RETURN
60280 char1$ = CHR$(46)
      char2$ = CHR$(111)
      char3$ = CHR$(79)
      char4$ = CHR$(111)
      RETURN
60290 char1$ = CHR$(92)
      char2$ = CHR$(124)
      char3$ = CHR$(47)
      char4$ = CHR$(45)
      RETURN
      END SUB
60300 ' $SUBTITLE: 'AutoPage - NOTIFIES ZSysop WHEN SPECIFIC USER CALLS'
' $PAGE
'
'  NAME    --  AutoPage   'Contributed  by Gregg and Bob Snyder
'                        'and RoseMarie Siddiqui
'
'  INPUTS  --  ZAutoPageDef$  List of conditions that trigger
'                                       notification and how
'
'  OUTPUTS -- NONE
'
'  PURPOSE -- Search ZAutoPageDef$ for match on whether
'             on name, security level, whether new user.
'             Also controls whether caller notified and
'             number of times sysop has bell rung.
'             And what tune to play (if any).
'
      SUB AutoPage STATIC
      CALL FindIt (ZAutoPageDef$)
      IF NOT ZOK THEN _
         EXIT SUB
      ZErrCode = 0
      ZOK = ZFalse
      WHILE NOT EOF(2) AND ZOK = ZFalse AND ZErrCode = 0
         CALL ReadParms (ZWorkAra$(),4,1)
         IF ZErrCode = 0 THEN _
            ZOK = (ZWorkAra$(1) = ZActiveUserName$) : _
            IF NOT ZOK THEN _
               IF ZNewUser AND ZWorkAra$(1) = "NEWUSER" THEN _
                  ZOK = ZTrue _
               ELSE IF LEFT$(ZWorkAra$(1),1) = "/" AND LEN(ZWorkAra$(1)) > 2 THEN _
                       ZWasB = INSTR (2,ZWorkAra$(1),"/") : _
                       IF ZWasB > 0 AND LEN(ZWorkAra$(1)) > ZWasB THEN _
                          IF ZUserSecLevel <= VAL(MID$(ZWorkAra$(1),ZWasB+1)) AND _
                             ZUserSecLevel >= VAL(MID$(ZWorkAra$(1),2)) THEN _
                                ZOK = ZTrue
      WEND
      CLOSE 2
      IF ZErrCode > 0 OR NOT ZOK THEN _
         ZErrCode = 0 : _
         EXIT SUB
      ZPageStatus$ = "AP!"
      IF ZWorkAra$(2) = "N" THEN
         '* "Telling sysop you're on..."
         CALL FormatString (518,ZFalse,ZFalse,0,ZFalse,0,ZoutTxt$)
         CALL RingCaller
      ELSEIF NOT ZConfMode THEN
         CALL FindFile (ZWorkAra$(2),Found)
         IF Found THEN
            CALL GraphicDisplayFile (ZWorkAra$(2))
         END IF
      END IF
      ZWasB = (ZWorkAra$(4) = "")
      ZWorkAra$(5) = ""
     TempSnoop = ZSnoop
     ZSnoop = ZTrue
     CALL Line25
      FOR WasI = 1 TO VAL(ZWorkAra$(3))
         IF ZWasB THEN _
            CALL LPrnt (ZBellRinger$,0) : _
         ELSE ZWorkAra$(5) = ZWorkAra$(5) + "O4 X" + VARPTR$(ZWorkAra$(4))
      NEXT
      IF NOT ZWasB THEN _
         CALL RBBSPlay (ZWorkAra$(5))
      ZSnoop = TempSnoop
      END SUB
62520 ' $SUBTITLE: 'PutMsgAttr - subroutine to save msg. attributes'
' $PAGE
'
'  NAME    --  PutMsgAttr
'
'  INPUTS  --  PARAMETER                   MEANING
'              ZWasQ
'              ZUserIn$
'              ZLinesInMsg
'              ZWasS
'              ZNonStop
'              ZMsgDimIndex
'
'  OUTPUTS --  ZWasSQ
'              ZWasLG$(10)
'              ZLinesInMsgSave
'              ZWasSL
'              ZNonStopSave
'              ZMsgDimIndexSave
'
'  PURPOSE --  WHEN REPLYING TO A MESSAGE THIS ROUTINE SAVES
'              THE ATTRIBUTES OF THE ORGINAL MESSAGE
'
      SUB PutMsgAttr STATIC
      ZWasSQ = ZWasQ
      ZWasLG$(10) = ZUserIn$
      ZLinesInMsgSave = ZLinesInMsg
      ZWasSL = ZWasS
      ZNonStopSave = ZNonStop
      ZMsgDimIndexSave = ZMsgDimIndex
      END SUB
62530 ' $SUBTITLE: 'GetMsgAttr - subroutine to get msg. attributes'
' $PAGE
'
'  NAME    --  GetMsgAttr
'
'  INPUTS  --  PARAMETER                   MEANING
'              ZWasSQ
'              ZWasLG$(10)
'              ZLinesInMsgSave
'              ZWasSL
'              ZNonStopSave
'              ZMsgDimIndexSave
'
'  OUTPUTS --  ZWasQ
'              ZUserIn$
'              LINES.IN.MESSAGESAVE
'              ZWasS
'              ZNonStop
'              ZMsgDimIndex
'              ZKillMessage
'
'  PURPOSE --  After replying to a message this routine restores
'              the attributes of the orginal message
'
      SUB GetMsgAttr STATIC
      ZWasQ = ZWasSQ
      ZUserIn$ = ZWasLG$(10)
      ZLinesInMsg = ZLinesInMsgSave
      ZWasS = ZWasSL
      ZNonStop = ZNonStopSave
      ZMsgDimIndex = ZMsgDimIndexSave
      ZKillMessage = ZFalse
      END SUB
62540 ' $SUBTITLE: 'RptTime -- Reports time on system'
' $PAGE
'
'  NAME    --  RptTime
'
'  INPUTS  --  PARAMETER                   MEANING
'
'  OUTPUTS --
'
'  PURPOSE --  Tells user time used on system
'
      SUB RptTime STATIC
      IF ZActiveUserName$ = "" OR ZFirstName$ = "" THEN _
         EXIT SUB
      CALL SkipLine (1)
      CALL GetTime
      CALL AMorPM
      Mins = (ZSessionHour * 60) + ZSessionMin
      CALL CheckCarrier
      IF ZSubParm = -1 THEN
         EXIT SUB
      END IF
      '* "{C5Now: {CB{DT {C5at {CB{LT"
      CALL FormatString (519,ZFalse,ZFalse,0,ZTrue,1,"")
      '* "{C2On for{CE"
      LineNum = 520
      GOSUB 62550
      Strng1$ = Strng$
      '* "{C2 mins,{CE"
      LineNum = 521
      GOSUB 62550
      Strng2$ = Strng$
      '* "{C2 secs{RC"
      LineNum = 522
      GOSUB 62550
      Strng3$ = Strng$
      CALL QuickTPut1 (Strng1$ + STR$(Mins) + _
                       Strng2$ + STR$(ZSessionSec) + _
                       Strng3$)
      EXIT SUB
62550 CALL FormatString (LineNum,ZFalse,ZFalse,0,ZFalse,0,Strng$)
      RETURN
      END SUB
'
62660 ' $SUBTITLE: 'SetExpert - subroutine to adjust for expert change'
' $PAGE
'
'  NAME    --  SetExpert
'
'  INPUTS  --  PARAMETER                   MEANING
'              ZExpertUser          WHETHER IS AN EXPERT
'
'  OUTPUTS --  ZMorePrompt$         Pause prompt
'              ZPressEnter$         Prompt to press enter
'
'  PURPOSE --  Make more helpful prompt for novices and shorter
'              one for experts
'
      SUB SetExpert STATIC
      IF ZExpertUser THEN
         '* "{RCMore <[Y],N,C,A"
         LineNum = 537
         ZPressEnter$ = ZPressEnterExpert$
      ELSE
         '* "More [Y]es,N)o,C)ont,A)bort"
         LineNum = 723
      END IF
         CALL FormatString (LineNum,ZFalse,ZFalse,0,ZFalse,0,ZMorePrompt$)
      END SUB
62668 ' $SUBTITLE: 'NewPassword - subroutine to get new password'
' $PAGE
'
'  NAME    --  NewPassword
'
'  INPUTS  --  PARAMETER                   MEANING
'              Prompt$               Prompt to display
'              DisallowSpaces        Whether answer can have all spaces
'
'  OUTPUTS --  ZWasZ$                   Password
'
'  PURPOSE --  To get a new password.
'
      SUB NewPassword (Prompt$,DisallowSpaces) STATIC
62670 ZOutTxt$ = Prompt$
      ZLastIndex = 0
      ZHidden = ZTrue
      CALL PopCmdStack
      ZHidden = ZFalse
      IF ZSubParm = -1 OR ZWasQ = 0 THEN _
         EXIT SUB
      IF LEN(ZUserIn$) > 15 OR LEN(ZUserIn$) < 3 THEN
         '* "{C2Password must be at least {CE3 {C2characters and no more than {CE15 {C2characters long!{RC"
         LineNum = 538
         GOSUB 62680
         GOTO 62670
      END IF
      IF INSTR(ZUserIn$,";") > 0 THEN
         '* "{C2Cannot use {CE';' {C2in Password!{RC"
         LineNum = 539
         GOSUB 62680
         GOTO 62670
      END IF
      IF NOT ZSysop THEN
         IF INSTR(ZUserIn$,SPACE$(1)) > 0 THEN
            '* "{C2Cannot use {CESPACES {C2in Password!{RC"
            LineNum = 540
            GOSUB 62680
            GOTO 62670
         END IF
      END IF
      IF DisallowSpaces THEN
         IF ZUserIn$ = SPACE$(LEN(ZUserIn$)) THEN
            '* "{C2Cannot use all {C2SPACES {C2for Password!{RC"
            LineNum = 541
            GOSUB 62680
            GOTO 62670
         END IF
      END IF
      CALL AllCaps (ZUserIn$)
      CALL BreakFileName (ZPswdFile$,Drive$,Body$,Ext$,ZTrue)
      FileName$ = Drive$ + Body$ + ".CTL"
      Found = ZFalse
      CALL WordInFile (FileName$,ZUserIn$,Found,ZTrue)
      IF NOT ZSysop AND Found THEN
         '* "{C2Sorry, that password is not allowed here!{RC"
         LineNum = 976
         GOSUB 62680
         GOTO 62670
      END IF
      ZWasZ$ = ZUserIn$
      EXIT SUB
62680 CALL FormatString (LineNum,ZFalse,ZFalse,0,ZTrue,1,"")
      RETURN
      END SUB
63000 ' $SUBTITLE: 'TimedOut - exits based on time of day'
' $PAGE
'
'  NAME    --  TimedOut
'
'  INPUTS  --  PARAMETER                   MEANING
'              ZRCTTYBat$
'              ZNodeRecIndex
'              ZMsgRec$
'              ZModemInitBaud$
'              ZModemGoOffHookCmnd$
'
'  OUTPUTS --  NONE
'
'  PURPOSE --  When RBBS-PC is to exit to DOS at a specific time of
'              day, this routine writes out to the file specified
'              in "RCTTY.BAT" the one-line entry:
'                          RBBSxTM.BAT
'               WHERE "x" is the node id.
'
      SUB TimedOut STATIC
      FIELD #1,128 AS ZMsgRec$
      ZSubParm = 3
      CALL FileLock
      GET 1,ZNodeRecIndex
      WasX$ = DATE$
      CALL PackDate (WasX$,ZWasY$)
      MID$(ZMsgRec$,77,2) = ZWasY$
      'MID$(ZMsgRec$,86,5) = LEFT$(TIME$,5)
      PUT 1,ZNodeRecIndex
      ZSubParm = 2
      CALL FileLock
      CLOSE 2
      ZFileName$ = ZNodeWorkDrvPath$ + "RBTM" + ZNodeFileID$ + ".DEF"
      OPEN "O",2,ZFileName$
      PRINT #2,MID$(ZFileName$,3,7)
      CLOSE 2
      IF ZLocalUserMode THEN _
         EXIT SUB
      IF ZSubParm <> 7 THEN _
         ZSubParm = 4 : _
         CALL FileLock : _
         CALL OpenCom(ZModemInitBaud$,",N,8,1")
      CALL TakeOffHook
      END SUB
64003 ' $SUBTITLE: 'AskUsers - subroutine to get registration information'
' $PAGE
'
'  NAME    --  AskUsers  (WRITTEN BY JON MARTIN)
'
'  INPUTS  --  PARAMETER                   MEANING
'              ZFileName$           NAME OF THE FILE CONTAINING THE
'                                   SCRIPT TO BE USED WHEN ASKING
'                                   THE USER QUESTIONS.
'              ZActiveUserName$     NAME OF THE CURRENT USER
'              ZUserSecLevel        USER'S SECURITY
'              ZUpperCase           SET IF USER NEEDS UPPERCASE
'
'  OUTPUTS --  WRITE THE USER'S RESPONSES TO THE QUESTIONS TO THE
'              FILE NAME SPECIFIED AS THE First PARAMETER IN THE
'              First RECORD OF THE FILE CONTAINING THE SCRIPT TO
'              BE USED.
'              ZUserSecLevel  CAN BE RAISED OR LOWERED
'
'  PURPOSE --  Provides a sophisticated, script driven mechanism by
'              which a sysop can control the interaction with the
'              user.  Special function questionnaires include the
'              registration questionnaire and the epilog.
'
      SUB AskUsers STATIC
      ZQuestAborted = ZFalse
      ZQuestChainStarted = ZFalse
      REDIM ZOutTxtAra$(256)
      REDIM ZWorkAra$(ZMaxWorkVar),ZGSRAra$(ZMaxWorkVar)
      PrevAppend$ = ""
      AppendFileName$ = ""
'
'
' *  LOAD SCRIPT CONTAINING THE QUESTIONS INTO THE ZOutTxt$ DIMENSION  *
'
'
64005 ZChatAvail = ZFalse
      QestChain = ZFalse
      LastQues = 0
' *
' * for the NewUser Questionaire, if the new user cannot support
' * cursor positioning (as tested with AnsiTest), then DON'T run
' * an ANSI NewUser Questionaire!  This was added in because some
' * questionaires may have ANSI Cursor positioning commands that
' * the NewUser cannot support causing problems when going thru
' * the questionaire
      IF ZFileName$ = ZNewUserQuestionnaire$ AND ZCanANSIChat = ZTrue THEN
         CALL Graphic (ZFileName$)
         CALL ResetGraphics
      ELSE
         CALL FindIt (ZFileName$)
      END IF
      IF NOT ZOK THEN _
         EXIT SUB
      CALL ReadParms (ZOutTxtAra$(),2,1)
      IF ZErrCode > 0 THEN _
         EXIT SUB
      PrevAppend$ = AppendFileName$
      AppendFileName$ = ZOutTxtAra$(1)
      MaxSecLevel = VAL(ZOutTxtAra$(2))
      WasX = INSTR(ZOutTxtAra$(2),SPACE$(1))
      IF WasX > 0 THEN
         IF ZUserSecLevel < VAL(MID$(ZOutTxtAra$(2),WasX)) THEN
            '* "Higher security needed for questionnaire"
            CALL FormatString (542,ZFalse,ZFalse,0,ZTrue,1,"")
            EXIT SUB
         END IF
      END IF
'
'
' *  THE First RECORD OF THE SCRIPT FILE CONTAINS THREE PARAMETERS:
' *   1.  THE NAME OF THE FILE TO APPEND THE ANSWERS TO.
' *   2.  THE MAXIMUM SECURITY LEVEL THE + COMMAND CAN RAISE A USER SECURITY
' *   3.  THE MINIMUM SECURITY TO USE THIS QUESTIONNAIRE
' * e.g. 'C:XXX.DAT,6 5' writes answers to C:XXX.DAT, can raise to 6,
' *      and requires security 5 or more to access
      ScriptIndex = 1
      '* "{AN {DT {LT"
      CALL FormatString (543,ZFalse,ZFalse,0,ZFalse,0,ZOutTxtAra$(ScriptIndex))
64010 IF EOF(2) OR ScriptIndex > 255 THEN _
         GOTO 64100
      ScriptIndex = ScriptIndex + 1
      LINE INPUT #2,ZOutTxtAra$(ScriptIndex)
      IF LEFT$(ZOutTxtAra$(ScriptIndex),1) = ":" THEN _
         Temp$ = ZOutTxtAra$(ScriptIndex) : _
         CALL AllCaps (Temp$) : _
         CALL Trim (Temp$) : _
         ZOutTxtAra$(ScriptIndex) = Temp$
      IF ZUpperCase THEN _
         CALL AllCaps (ZOutTxtAra$(ScriptIndex))
      IF LEFT$(ZOutTxtAra$(ScriptIndex),1) = "?" THEN _
         ScriptIndex = ScriptIndex + 1 : _
         ZOutTxtAra$(ScriptIndex) = "!"
      GOTO 64010
'
'
' *  PROCESS QUESTIONS IN THE SCRIPT AS FOLLOWS:
' *
' * First COLUMN     MEANING
' *      :        THIS LINE IS A LABEL THAT MAY BE BRANCHED TO
' *      !        THIS MEANS THIS IS AN ANSWER
' *      >        THIS IS A "GOTO" COMMAND TO ONE OF THE LABELS
' *      *        THIS MEANS THE LINE IS A MESSAGE TO BE WRITTEN TO THE USER
' *      ?        THIS MEANS THIS IS A QUESTION FOR THE USER
' *      =        THIS MEANS THAT THIS LINE CONTAINS DECISION CRITERIA
' *      -        THIS MEANS TO LOWER THE USER'S SECURITY LEVEL
' *      +        THIS MEANS TO RAISE THE USER'S SECURITY LEVEL
' *      @        THIS MEANS TO ABORT THE QUESTIONNAIRE DO NOT WRITE OUT
' *      &        THIS MEANS TO CHAIN TO ANOTHER QUESTIONNAIRE
' *      M        Execute specified macro
' *      T        Turbo Key
' *      <        Assign value to work variable
'
64100 ScriptMax = ScriptIndex
      ScriptIndex = 1
64110 CALL CheckCarrier
      IF ZSubParm = -1 THEN _
         GOTO 64510
      ScriptIndex = ScriptIndex + 1
      IF ScriptIndex > ScriptMax THEN _
         GOTO 64400
      ZOutTxt$ = MID$(ZOutTxtAra$(ScriptIndex),2)
      WasX = ZFalse
      IF LEFT$(ZOutTxt$,3) = "/FL" THEN _
         ZOutTxt$ = RIGHT$(ZOutTxt$,LEN(ZOutTxt$)-3) : _
         WasX = ZTrue
      CALL MetaGSR (ZOutTxt$,WasX)
      CALL SmartText (ZOutTxt$,ZFalse,WasX,ZFalse)
      WasX$ = ZOutTxt$
      '* "{SP:!@MT><*?=-+&"
      LineNum = 544
      GOSUB 64520
      ON INSTR(Strng$,LEFT$(ZOutTxtAra$(ScriptIndex),1)) GOTO _
         64111, _       ' catch invalid lines
         64110, _       ' : label
         64110, _       ' ! stored answer
         64420, _       ' @ abort
         64120, _       ' M macro execute
         64430, _       ' T turbo key
         64440, _       ' > goto label
         64190, _       ' < assign value
         64450, _       ' * display line
         64113, _       ' ? prompt for answer
         64114, _       ' = conditional branch
         64460, _       ' - decrease security level
         64465, _       ' + increase security level
         64470          ' & chain
64111 '* "Invalid line.  Column 1 is <"
      LineNum = 545
      GOSUB 64520
      Strng1$ = Strng$
      '* ">.  Must be: * ? = + - > @ & M T <"
      LineNum = 546
      GOSUB 64520
      Strng2$ = Strng$
      ZOutTxt$ = Strng1$ + LEFT$(ZOutTxtAra$(ScriptIndex),1) + Strng2$
      ZSubParm = 5
      CALL TPut
      GOTO 64510
64113 LastQues = ScriptIndex  ' process ?
      GOSUB 64180
      ZSubParm = 1
      CALL TGet
      IF ZSubParm = -1 THEN _
         GOTO 64510 _
      ELSE IF ZWasQ = 0 THEN _
              ZOutTxt$ = WasX$ : _
              GOTO 64113 _
           ELSE ZOutTxtAra$(ScriptIndex + 1) = "!" + _
                                       ZUserIn$ : _
                ZGSRAra$(ZTestedIntValue) = ZUserIn$
      GOTO 64110
64114 IF LEFT$(ZOutTxtAra$(ScriptIndex),2) = "=#" THEN _        ' Numeric
         GOSUB 64350 : _
         GOTO 64110
      GOSUB 64300             ' process =
      GOTO 64445
64120 ZWasZ$ = MID$(ZOutTxtAra$(ScriptIndex),2)   ' Execute macro
      CALL Trim (ZWasZ$)
      CALL Macro (ZWasZ$,Found)
      IF Found THEN _
          CALL FDMACEXE
      GOTO 64110
64180 CALL CheckInt (ZOutTxt$)
      IF (ZErrCode > 0) OR (ZTestedIntValue < 1) OR _
          (ZTestedIntValue > ZMaxWorkVar) OR _
          (INSTR("123456789",LEFT$(ZOutTxt$,1)) = 0) THEN _
             ZTestedIntValue = 0 _
      ELSE ZOutTxt$ = RIGHT$(ZOutTxt$,LEN(ZOutTxt$)-1+(ZTestedIntValue > 9))
      RETURN
64190 GOSUB 64180
      IF ZTestedIntValue > 0 THEN _
         ZGSRAra$(ZTestedIntValue) = MID$(ZOutTxt$,2)
      GOTO 64110
'
'
' *  SEARCH FOR GOTO LABEL
'
'
64200 ScriptIndex = 1
      CALL MetaGSR (BranchLabel$,ZFalse)
      CALL SmartText (BranchLabel$,ZFalse,ZFalse,ZFalse)
      CALL AllCaps (BranchLabel$)
      CALL Trim (BranchLabel$)
64210 ScriptIndex = ScriptIndex + 1
      IF ScriptIndex > ScriptMax THEN
         '* "{SPnot found!"
         LineNum = 374
         GOSUB 64520
         ZOutTxt$ = BranchLabel$ + Strng$
         ZSubParm = 5
         CALL TPut
         IF ZSubParm = -1 THEN
            RETURN
         ELSEIF LastQues > 0 THEN
            ScriptIndex = LastQues - 1
            RETURN
         ELSE
            GOTO 64510
         END IF
      END IF
      IF LEFT$(ZOutTxtAra$(ScriptIndex),1) <> ":" THEN _
         GOTO 64210
      IF MID$(ZOutTxtAra$(ScriptIndex),2) <> BranchLabel$ THEN _
         GOTO 64210
      RETURN
'
'
' *  DETERMINE BRANCH LOGIC
'
'
64300 CurEquals = 1
      ZWasZ$ = RIGHT$(ZOutTxtAra$(LastQues + 1),1)
      CALL AllCaps (ZWasZ$)
64310 NextEquals = INSTR(CurEquals + 1, ZOutTxtAra$(ScriptIndex),"=")
      IF NextEquals = 0 THEN _
         BranchLabel$ = MID$(ZOutTxtAra$(ScriptIndex),CurEquals + 2) : _
         GOTO 64320
      IF ZWasZ$ <> _
         MID$(ZOutTxtAra$(ScriptIndex),CurEquals + 1,1) THEN  _
         CurEquals = NextEquals : _
         GOTO 64310
      BranchLabel$ = MID$(ZOutTxtAra$(ScriptIndex),CurEquals + 2,NextEquals-(CurEquals + 2))
64320 GOSUB 64200
      RETURN
'
'
' *  DETERMINE Numeric BRANCH LOGIC
'
'
64350 CurEquals = 1
64360 NextEquals = INSTR(CurEquals + 1, ZOutTxtAra$(ScriptIndex),"=")
      IF NextEquals = 0 THEN _
         BranchLabel$ = MID$(ZOutTxtAra$(ScriptIndex),CurEquals + 2) : _
         GOTO 64380
      Numeric = ZTrue
      LoopIndex = 2
      '* "()1234567890-{SP"
      LineNum = 547
      GOSUB 64520
      WHILE LoopIndex < LEN(ZOutTxtAra$(ScriptIndex - 1)) +1
         IF INSTR(Strng$,MID$(ZOutTxtAra$(ScriptIndex - 1),LoopIndex,1)) THEN _
            GOTO 64370
         Numeric = ZFalse
64370    LoopIndex = LoopIndex + 1
      WEND
      IF NOT Numeric THEN _
         CurEquals = NextEquals : _
         GOTO 64360
      BranchLabel$ = MID$(ZOutTxtAra$(ScriptIndex),CurEquals + 2,NextEquals-(CurEquals + 2))
64380 GOSUB 64200
      RETURN
'
'
' *  WRITE RESPONSES TO DESIGNATED FILE
'
'
64400 ScriptIndex = 0
      ZWasEN$ = AppendFileName$
      CALL LockAppend
      IF ZErrCode <> 0 THEN
         '* "Fatal Error in script!"
         LineNum = 548
         GOSUB 64520
         ZOutTxt$ = Strng$
         ZSubParm = 5
         CALL TPut
         GOTO 64500
      END IF
64410 ScriptIndex = ScriptIndex + 1
      IF ScriptIndex > ScriptMax THEN _
         GOTO 64500
      IF LEFT$(ZOutTxtAra$(ScriptIndex),1) = ":" THEN _
         QuestionSave$ = MID$(ZOutTxtAra$(ScriptIndex),2) : _
         GOTO 64410
      IF LEFT$(ZOutTxtAra$(ScriptIndex),1) = "!" AND _
         LEN(ZOutTxtAra$(ScriptIndex)) < 2 THEN _
         GOTO 64410
      IF LEFT$(ZOutTxtAra$(ScriptIndex),1) = "!" THEN _
         CALL PrintWorkA (2,QuestionSave$) : _
         CALL PrintWorkA (2,MID$(ZOutTxtAra$(ScriptIndex),2))
      IF ScriptIndex = 1 AND _
         AppendFileName$ <> PrevAppend$ THEN _
         CALL PrintWorkA (2,ZOutTxtAra$(ScriptIndex))
      IF ZErrCode <> 0 THEN
         '* "Unrecoverable failure in script!"
         LineNum = 549
         GOSUB 64520
         ZOutTxt$ = Strng$
         ZSubParm = 5
         CALL TPut
         GOTO 64500
      END IF
      GOTO 64410
64420 ZQuestAborted = ZTrue  ' @ abort
      GOTO 64510
64430 ZTurboKey = -ZTurboKeyUser   ' T turbo key
      GOTO 64110
64440 BranchLabel$ = ZOutTxt$            ' = branch
      GOSUB 64200
64445 IF ZSubParm = -1 THEN _
         GOTO 64510 _
      ELSE GOTO 64110
64450 CALL AskMore ("",ZTrue,ZTrue,WasX,ZTrue)  ' * display
      ZSubParm = 5
      CALL TPut
      GOTO 64445
64460 WasX = -1        ' - lower security
64462 CALL CheckInt (ZOutTxt$)
      IF ZErrCode = 0 THEN _
         Temp = ZUserSecLevel + _
            WasX * ZTestedIntValue : _
         IF Temp <= MaxSecLevel THEN _
            ZUserSecLevel = Temp : _
            ZUserSecSave = ZUserSecLevel : _
            ZAdjustedSecurity = ZTrue
            IF ZOrigMsgFile$ = ZActiveMessageFile$ THEN _
               ZOrigSec = ZUserSecLevel
      GOTO 64110
64465 WasX = 1               ' + raise security
      GOTO 64462
64470 QestChain = ZTrue  ' & chain questionnaires
      ZFileNameHold$ = ZOutTxt$
      GOTO 64110
64500 CALL UnLockAppend
      CALL CheckCarrier
      IF QestChain THEN _
         ZQuestChainStarted = ZTrue : _
         ZFileName$ = ZFileNameHold$ : _
         GOTO 64005
64510 ZChatAvail = (INSTR("MUF",ZActiveMenu$) > 0)
      ZOK = ZTrue
      ZLastIndex = 0
      EXIT SUB
64520 CALL FormatString (LineNum,ZFalse,ZFalse,0,ZFalse,0,Strng$)
      RETURN
      END SUB
'
      SUB CmndToggle STATIC
64636 IF ZAnsIndex < ZLastIndex THEN _
         GOTO 64638
      ZFileName$ = ZWelcomeFileDrvPath$ + "TOGGLES.MNU"
      CALL GraphicDisplayFile (ZFileName$)
      '* "{CFTOGGLE {C2command{RC"
      CALL FormatString (550,ZFalse,ZFalse,0,ZFalse,0,ZOutTxt$)
      IF ZCmndsInPrompt THEN
         '* "{SP(A,B,C,E,F,H,I,K,L,M,N,S,T,X,!,[Q])"
         CALL FormatString (551,ZFalse,ZFalse,0,ZFalse,0,Strng$)
         ZOutTxt$ = ZOutTxt$ + Strng$
      END IF
64638 ZStackC = ZTrue
      ZTurboKey = -ZTurboKeyUser
      CALL PopCmdStack
      IF ZWasQ=0 OR ZSubParm < 0 THEN _
         EXIT SUB
      ZWasZ$ = ZUserInAra$(ZAnsIndex)
      CALL AllCaps (ZWasZ$)
      IF ZWasZ$ = "Q" THEN
         ZLastIndex = 0
         EXIT SUB
      END IF
      '* "ABCFHLNTX!IEKMS"
      CALL FormatString (552,ZFalse,ZFalse,0,ZFalse,0,Strng$)
      ZFF = INSTR(Strng$,ZWasZ$)
      IF ZFF < 1 THEN _
         GOTO 64636
      CALL Toggle (ZFF)
      CALL SmartPause (ZTrue)
      GOTO 64636
      END SUB
      SUB TopPrompt STATIC
      CALL ColorPrompt (ZOutTxt$)
      CALL QuickTPut1 (ZOutTxt$)
      END SUB
64640 ' * SysOp function 5 - change xfer stats
      SUB CmndSysOpXfer STATIC
      '* "[ENTER] leaves unchanged"
      CALL FormatString (553,ZFalse,ZFalse,0,ZTrue,1,"")
      '* "Upload file total"
      LineNum = 554
      GOSUB 64642
      IF LEN(ZUserInAra$(1)) > 0 THEN _
         LSET ZUserUplds$ = MKI$(VAL(ZUserInAra$(1)))
      '* "Upload byte total"
      LineNum = 555
      GOSUB 64642
      IF LEN(ZUserInAra$(1)) > 0 THEN _
         LSET ZULBytes$ = MKS$(VAL(ZUserInAra$(1)))
      '* "Download file total"
      LineNum = 556
      GOSUB 64642
      IF LEN(ZUserInAra$(1)) > 0 THEN _
         LSET ZUserDnlds$ = MKI$(VAL(ZUserInAra$(1)))
      '* "Download byte total"
      LineNum = 557
      GOSUB 64642
      IF LEN(ZUserInAra$(1)) > 0 THEN _
         LSET ZDlBytes$ = MKS$(VAL(ZUserInAra$(1)))
      '* "Files downloaded TODAY"
      LineNum = 558
      GOSUB 64642
      IF LEN(ZUserInAra$(1)) > 0 THEN _
         LSET ZTodayDl$ = MKS$(VAL(ZUserInAra$(1)))
      '* "Bytes downloaded TODAY"
      LineNum = 559
      GOSUB 64642
      IF LEN(ZUserInAra$(1)) > 0 THEN _
         LSET ZTodayBytes$ = MKS$(VAL(ZUserInAra$(1)))
      EXIT SUB
64642 CALL FormatString (LineNum,ZFalse,ZFalse,0,ZFalse,0,ZOutTxt$)
      ZSubParm = 1
      CALL TGet
      IF ZSubParm >= 0 THEN _
         RETURN
      END SUB
64645 ' * sets new user defaults
      ' * formerly 12900 of rbbs-pc.bas
      SUB SetNewUserDef STATIC
      IF ZNewUserSetsDefaults THEN
         WasX = 5*ZUserTextColor - 125 + 35*VAL(ZBoldText$) + ZWasGR
         IF WasX < 30 OR WasX > 99 THEN _
            WasX = 60
      ELSE
         WasX = 60
      END IF
      IF ZReqQues$ = ZNewUserQuestionnaire$ THEN
         ZReqQuesAnswered = ZTrue
      END IF
      WasA =    -ZPromptBell          -2 * ZExpertUserHold _
            -4 * ZNulls               -8 * ZUpperCase _
           -16 * ZLineFeeds          -32 * ZCheckBulletLogon _
           -64 * ZSkipFilesLogon    -128 * ZFullScreenEditor _
          -256 * ZReqQuesAnswered   -512 * ZMailWaiting _
         -1024 * (NOT ZHiLiteOffHold)  -2048 * ZTurboKeyUserHold _
         -4096 * ZFileWaiting      -8192 * ZAvailableForChat _
        -16384 * ZExtendedOff
'
      WasAA =   -ZReadNewMail         -2 * ZReselectALL _
            -4 * ZMorePromptLF        -8 * ZReselectGraphics _
           -16 * ZANSIMusic          -32 * ZNeverCanPage _
           -64 * ZReselectProto     -128 * ZChangePswd
'
      LSET ZUserName$ = ZActiveUserName$
      LSET ZUserOption$ = MKI$(0) + _
                           MKI$(0) + _
                           ZUserXferDefault$ + _
                           MKI$(WasX) + _
                           CHR$(ZRightMargin) + _
                           CHR$(WasAA) + _
                           MKI$(WasA) + _
                           CHR$(ZPageLengthHold) + _
                           ZRegDate$ + _
                           ZDefaultEchoer$
      LSET ZUserDnlds$ = MKI$(0)
      LSET ZUserUplds$ = MKI$(0)
      IF ZEnforceRatios THEN _
         LSET ZTodayDl$ = MKS$(0) : _
         LSET ZTodayBytes$ = MKS$(0) : _
         LSET ZDlBytes$ = MKS$(0) : _
         LSET ZULBytes$ = MKS$(0)
      LSET ZSecLevel$ = MKI$(ZTempSecLevel)
      LSET ZElapsedTime$ = MKI$(0)
      LSET ZDropTimes$ = CHR$(0)
      LSET ZBankTime$ = CHR$(0)
      END SUB
64650 ' Checks/stacks keyboard input while running long process
      SUB CheckKBStop STATIC
      ZOutTxt$ = ""
      ZSubParm = 4
      CALL TPut
      END SUB
