' $segment
' $linesize:132
' $title: 'RBBSSUB5.BAS 17.4, Copyright 1986 - 92 by D. Thomas Mack'
'  Copyright 1991 by D. Thomas Mack, all rights reserved.
'  Name ...............: RBBSSUB5.BAS
'  First Released .....: June 21, 1992
'  Subsequent Releases.: 
'  Copyright ..........: 1986 - 1992
'  Purpose.............: The Remote Bulletin Board System for the IBM PC,
'     RBBS-PC.BAS utilizes a lot of common subroutines.  Those that do not
'     require error trapping are incorporated within RBBSSUB 2-5 as
'     separately callable subroutines in order to free up as much
'     code as possible within the 64K code segment used by RBBS-PC.BAS.
'  Parameters..........: Most parameters are passed via a COMMON statement.
'
' Subroutine  Line               Function of Subroutine
'   Name     Number
'  AddLink        63620  Adds a conference link
'  AraAllCaps     63720  Capitalize an element of an array
'  AskItems       63610  Get a list of items
'  BinSearch      63520  Binary searches sorted file for a key value
'  BreakFileName  63300  Break file name into component parts
'  BufAsUnit      63500  Buffer out a string with CR's
'  ChangeInit     63590  Get an integer value
'  ChkAddedTime   63056  Check whether ok to extend time remaining
'  ChkIfMsgHeader 63550  Checks whether record is a msg header
'  DeLink         63620  Removes conference from linked ones
'  DoorReturn     63100  Process door requests
'  ExcludeCount   63715  Counts # of words in a string
'  FdMacExe       63462  Executes a found macro
'  FileSystem     20117  File System for RBBS-PC
'  FindIt         63490  Check whether file exists and if so open as #2
'  FormRead       63420  Read from file into a form
'  LockAppend     63400  Prepare for a file append
'  MacroExe       63460  Execute internal macro rather than user
'  MarkItems      63600  Convert list of items into a "mark"
'  MsgNameMatch   63540  Match name to one in msg header
'  NextConf       63615  Sets up join to next conference link
'  NoPath         63480  Detects whether string has a path in it
'  RestoreCom     63310  Restore comm port after external program
'  ReadMacro      63330  Read and process macro
'  ReadParms      63490  Read certain number of parameters from file 2
'  ReportEcho     63635  Reports echo preference of caller
'  SayWelcome     63640  Welcomes callers on logon
'  SetPrivileges  63650  Sets user privileges based on PASSWRDS
'  SetPrompt      63470  Set prompts based on the user's security
'  SetSessionTime 63645  Sets the session time
'  SetSysOp       63625  Determines whether remote or global SysOp
'  SetUserFlag    63560  Sets specified user flag
'  SetUserPref    63630  Sets user preferences based on user record
'  ShellExit      63320  Exit RBBS via shell
'  SrchPasswrds   63652  Searches the PASSWRDS file
'  TakeOffHook    63530  Take modem off hook
'  TestANSI       63700  Tests caller for ANSI compatibility
'  TStats         69600  Display transfer stats from XFER-? file
'  UnLockAppend   63410  Clean up after file append
'  UnMarkItems    63610  Convert marked items into an input list
'  VerifyAns      63510  Verify that string passes edits
'  WildCard       63200  Match string to a pattern
'
' * For EMS/XMS/DISK Shell Swapping
'
   DECLARE FUNCTION SWAPBAS% (SEG SwapPack AS ANY)
'
   TYPE SwapPackTYPE
      StatEXEC AS INTEGER
      ProgName AS STRING * 128
      CmdLine AS STRING * 126
      SaveFile AS STRING * 128
   END TYPE
'
' * For BLINKER EMS/XMS/DISK Shell Swapping
'
'  DECLARE FUNCTION SWPRUNCMDBAS% CDECL (Program AS STRING, BYVAL FreeMem AS INTEGER, RunPath AS STRING, TmpPath AS STRING)
'  DECLARE FUNCTION SWPUSEEMS%    CDECL (BYVAL Flag AS INTEGER)
'  DECLARE FUNCTION SWPUSEXMS%    CDECL (BYVAL Flag AS INTEGER)
'  DECLARE FUNCTION SWPUSEUMB%    CDECL (BYVAL Flag AS INTEGER)
'
'  $INCLUDE: 'RBBS-VAR.BAS'
'
63100 ' $SUBTITLE: 'DoorReturn - Subroutine to process requests from a door'
' $PAGE
'
'  NAME    -- DoorReturn
'
'  INPUTS  -- PARAMETER                      MEANING
'             DOUTx.DEF               File of requests
'
'  OUTPUTS -- ZUserSecLevel     Revised Security Level
'
'  PURPOSE -- To give Doors a stable way to make requests
'             to the host.
'
      SUB DoorReturn STATIC
      IF NOT ZExitToDoors THEN _
         EXIT SUB
      CALL OpenUser (ZHighestUserRecord)
      FIELD 5, 128 AS ZUserRecord$
      FIELD 5,31 AS ZUserName$, _
              15 AS ZPswd$, _
               2 AS ZSecLevel$, _
              14 AS ZUserOption$,  _
              24 AS ZCityState$, _
               1 AS MachineType$, _
               1 AS ZDropTimes$, _
               1 AS ZBankTime$,_
               4 AS ZTodayDl$, _
               4 AS ZTodayBytes$, _
               4 AS ZDlBytes$, _
               4 AS ZULBytes$, _
              14 AS ZLastDateTimeOn$, _
               3 AS ZListNewDate$, _
               2 AS ZUserDnlds$, _
               2 AS ZUserUplds$, _
               2 AS ZElapsedTime$
      ZSubParm = 6
      CALL FileLock
      GET 5,ZUserFileIndex
      ZTimesLoggedOn = CVI(MID$(ZUserOption$,1,2))
      IF ZDoorDropFile$ = "R" THEN _
         CALL ReadDoorSys
      IF ZDoorDropFile$ = "U" THEN _
         CALL ReadUserInfo
      GOSUB 63198
      ZElapsedTimeVal = CVI(MID$(ZUserRecord$,127,2))
      IF ZDoorDropFile$ = "R" OR ZDoorDropFile$ = "U" THEN _
         ZErrCode = 0 : _
         PUT 5,ZUserFileIndex
      ZFileName$ = "DOUT" + ZNodeID$ + ".DEF"
      CALL FindIt (ZFileName$)
      IF NOT ZOK THEN _
         GOTO 63197
63105 IF EOF(2) THEN _
         GOTO 63195
      CALL ReadParms (ZOutTxtAra$(),2,1)
      IF ZErrCode > 0 THEN _
         GOTO 63115
      IF LEN(ZOutTxtAra$(1)) < 2 THEN _
         GOTO 63105
      ZUserIn$ = LEFT$(ZOutTxtAra$(1),2) + ","
      WasX = INSTR("SL,UR,",ZUserIn$)
      IF WasX = 0 THEN _
         GOTO 63105
      WasX = WasX\3 + 1
      ON WasX GOTO 63110,63115
      GOTO 63105
63110 WasX$ = LEFT$(ZOutTxtAra$(2),1)         ' ZWasSL = Security Level
      CALL CheckInt (ZOutTxtAra$(2))
      IF ZErrCode > 0 THEN _
         GOTO 63105
      IF WasX$ = "+" OR WasX$ = "-" THEN _
         ZWasA = ZUserSecLevel + ZTestedIntValue _
      ELSE ZWasA = ZTestedIntValue
      IF ZWasA > ZMaxDoorSec AND ZMaxDoorSec <> 0 THEN
         ZWasA = ZMaxDoorSec
      END IF
      IF ZWasA < ZSysopSecLevel THEN
         ZAdjustedSecurity = (ZWasA <> ZUserSecLevel)
         IF ZAdjustedSecurity THEN
            ZUserSecLevel = ZWasA
            MID$(ZUserRecord$,47,2) = MKI$(ZWasA)
            '* "Door changed Security to {SL"
            CALL FormatString (630,ZFalse,ZTrue,2,ZTrue,1,"")
         END IF
      END IF
      GOTO 63105
63115 IF LEN(ZOutTxtAra$(1)) < 7 THEN _
         GOTO 63105
      IF MID$(ZOutTxtAra$(1),3,1) <> "(" THEN _
         GOTO 63105
      WasX = INSTR(4,ZOutTxtAra$(1),":")
      IF WasX < 1 THEN _
         GOTO 63105
      CALL CheckInt (MID$(ZOutTxtAra$(1),4,WasX-4))
      IF ZErrCode > 0 THEN _
         GOTO 63105
      IF ZTestedIntValue > 128 OR ZTestedIntValue < 1 THEN _
         GOTO 63105
      ZWasA = ZTestedIntValue
      CALL CheckInt (MID$(ZOutTxtAra$(1),WasX+1))
      IF ZErrCode > 0 OR ZTestedIntValue < 1 OR ZTestedIntValue > 128 THEN _
         GOTO 63105
      MID$(ZUserRecord$,ZWasA,ZTestedIntValue) = LEFT$(ZOutTxtAra$(2) + _
         SPACE$(ZTestedIntValue),ZTestedIntValue)
      CALL UpdtCalr ("Door set UR"+STR$(ZWasA)+":"+STR$(ZTestedIntValue)+" to <"+ZOutTxtAra$(2)+">",2)
      GOTO 63105
63195 CALL KillWork (ZFileName$)
      GOSUB 63198
      ZErrCode = 0
      PUT 5,ZUserFileIndex
63197 ZSubParm = 8
      CALL FileLock
      EXIT SUB
63198 CALL SetSysOp
      CALL SetUserPref
      CALL SetUserUpDn
      ZGlobalsSet = ZFalse
      CALL SetGlobalUpDn
      CALL SetPrivileges
      CALL SetPrompt
      RETURN
      END SUB
'
63300 ' $SUBTITLE: 'BreakFileName - sub to split file name into components'
' $PAGE
'
'  NAME    -- BreakFileName
'
'  INPUTS  -- PARAMETER                    MEANING
'             FileSpec$        FULL NAME OF FILE
'             ForJoining       True IF WANT PARTS FORMATTED FOR
'                                           FORMING FILE NAMES
'  OUTPUTS -- DrvPath$         DRIVE AND PATH
'             Prefix$          PREFIX OF FILE NAME
'             Extension$       EXTENSION OF FILE NAME
'
' (E.G. "C:\RBBS\ARCE.COM" HAS "C:\RBBS" AS DRIVE AND PATH,
'                              "ARCE"    AS PREFIX OF THE FILE NAME, AND
'                              "COM"     AS THE EXTENSION OF THE FILE NAME.
'
' JOINED FORMAT IS C:\RBBS\,ARCE,.COM
'
'  PURPOSE -- To break a file name into its component parts
'             of drive/path, prefix, and extension
'
'
      SUB BreakFileName (PassedFileSpec$,DrvPath$,Prefix$,Extension$,ForJoining) STATIC
      FileSpec$ = PassedFileSpec$
      CALL AllCaps (FileSpec$)
      DrvPath$ = ""
      Prefix$ = ""
      Extension$ = ""
      WasL = LEN(FileSpec$)
      IF WasL < 1 THEN _
         EXIT SUB
      CALL FindLast (FileSpec$,"\",WasX,WasY)
      IF WasX < 1 THEN _
         IF MID$(FileSpec$,2,1) = ":" THEN _
            DrvPath$ = LEFT$(FileSpec$,2) : _
            ZWasS = 3 _
         ELSE ZWasS = 1 _
      ELSE DrvPath$ = LEFT$(FileSpec$,WasX) : _
           ZWasS = WasX + 1
      WasX = INSTR(ZWasS,FileSpec$ + ".",".")
      IF WasX < WasL THEN _
         Extension$ = MID$(FileSpec$,WasX)
      IF ZWasS <= WasL THEN _
         IF WasX >= ZWasS THEN _
            Prefix$ = MID$(FileSpec$,ZWasS,WasX - ZWasS)
      IF ForJoining THEN _
         EXIT SUB
      IF WasY > 1 THEN _
         DrvPath$ = LEFT$(DrvPath$, LEN(DrvPath$) - 1)
      IF LEN(Extension$) > 0 THEN _
         Extension$ = MID$(Extension$, 2)
      END SUB
63310 ' $SUBTITLE: 'RestoreCom - sub to restore comm port'
' $PAGE
'
'  NAME    -- RestoreCom
'
'  INPUTS  -- none
'
'  OUTPUTS -- none
'
'  PURPOSE -- To restore communications port after an external
'             program may have left it in altered state
'
      SUB RestoreCom STATIC
      Parity$ = MID$(",N,8,1,E,7,1",7 + 6 * ZEightBit,6)
      IF ZLocalUser THEN _
         EXIT SUB
      CALL SetBaud
      IF NOT ZFossil THEN _
         CALL OpenCom(ZTalkToModemAt$,Parity$)
      END SUB
63320 ' $SUBTITLE: 'ShellExit - sub to shell out from RBBS'
' $PAGE
'
'  NAME    -- ShellExit
'
'  INPUTS  -- ShellTem$     String to invoke shell with
'
'  OUTPUTS -- none
'
'  PURPOSE -- Delay so that strings can finish printing.  Restore comm
'             port on return
'
      SUB ShellExit (ShellTem$) STATIC

      DIM SWAPIT AS SwapPackTYPE

      CALL DelayTime (4 + ZBPS)
      IF NOT ZLocalUser THEN _
         IF ZFossil THEN _
            CALL FOSExit(ZComPortNum) _
         ELSE CLOSE 3 : _
              OUT ZModemCntlReg,INP(ZModemCntlReg) OR 1
      IF ZFunctionKey <> 2 THEN
         CLOSE 2
      END IF
      CALL MetaGSR (ShellTem$,ZFalse)

      IF CSRLIN = ZLocalPageLength - 1 THEN
         LOCATE ZLocalPageLength,1
         CALL WipeLine(79)
         LOCATE ZLocalPageLength - 1,1
      END IF

'-------------------------------------------
' * Blinker EMS/XMS swapping
'
' UnComment these lines to link with Blinker
'-------------------------------------------
'     IF ZNoSwap THEN
'        i = SWPUSEEMS(ZFalse)
'        i = SWPUSEXMS(ZFalse)
'        i = SWPUSEUMB(ZFalse)
'     END IF
'     i = SWPRUNCMDBAS (ShellTem$,0,"","")
'-------------------------------------------
'
' UnComment these lines for MS LINK
'-------------------------------------------
      Path$ = CURDIR$
      IF ZNoSwap THEN
         SHELL ShellTem$
      ELSE
         IF INSTR(ShellTem$," ") THEN
            PrgName$ = MID$(ShellTem$,1,INSTR(ShellTem$," ")-1)
            PrgLine$ = MID$(ShellTem$,INSTR(ShellTem$," ")+1)
         ELSE
            PrgName$ = ShellTem$
            PrgLine$ = ""
         END IF
         CALL BreakFileName (PrgName$,Drive$,Body$,Ext$,ZTrue)
         IF UCASE$(Ext$) = UCASE$(ZDefaultBatchExt$) THEN
             PrgLine$ = "/C" + " " + PrgName$ + " " + PrgLine$
             PrgName$ = ZComspec$
         END IF
         SWAPIT.statEXEC = 0
         SWAPIT.ProgName = PrgName$ + CHR$(0)
         SWAPIT.CmdLine = PrgLine$ + CHR$(0)
         SWAPIT.SaveFile = ZArkViewPath$ + "RBBS-PC.SWP" + CHR$(0)
         i = SWAPBAS(SWAPIT)
      END IF
      CHDRIVE Path$
      CHDIR Path$
'-------------------------------------------
      IF ZFossil THEN
         IF NOT ZLocalUser THEN
            CALL FOSinit(ZComPortNum,Result)
            IF Result = -1 THEN
               '* "ERROR INIT FOSSIL AFTER SHELL"
               CALL FormatString (631,ZTrue,ZFalse,0,ZFalse,0,"")
               ZExitCode = 14
               END ZExitCode
            END IF
         END IF
      END IF
      CALL DelayTime (2)
      CALL RestoreCom
      END SUB
63330 ' $SUBTITLE: 'ReadMacro - sub to read macro'
' $PAGE
'
'  NAME    -- ReadMacro
'
'  INPUTS  -- PARAMETER             MEANING
'
'  OUTPUTS -- ZOutTxt$               LINE TO PROCESS IN MACRO
'             ZMacroActive           FLAG WHETHER IN A MACRO
'
'  PURPOSE -- Reads in a line from macro file (#6) and processes
'             macro commands, which are:
'             *0 - display what follows, no carriage return
'             *1 - display what follows with carriage return
'             *B - display block that follows
'             *F - display File
'             GF - display Graphics version of a file
'             WT - wait specified # of seconds
'             >> - append following block to specified file
'             ST - stack following (with carriage return)
'             ON - define case
'             == - case value that applies to following block
'             M! - execute following macro
'             M@ - abort macro processing
'             EY - Echo on (yes)
'             EN - Echo off (no)
'             /* - comment line skipped in processing
'             TK - Turbo key on (if user preference)
'             << - Read from file into a form
'             := - Assign value to work variable
'             LO - Set the location of a file
'
      SUB ReadMacro STATIC
      IF ZMacroTemplate$ <> "" THEN _
         GOTO 63392
      IF ZDistantTGet = 2 THEN _
         GOTO 63349
63336 GOSUB 63395
      IF NOT ZMacroActive THEN _
         ZMacroEcho = ZTrue : _
         EXIT SUB
      IF CompareVar > 0 THEN
         IF NOT CaseExecute THEN
            IF LEFT$(ZOutTxt$,3) = ZSmartTextChar$+STRING$(2,61) THEN
               WasX$ = RIGHT$(ZOutTxt$,LEN(ZOutTxt$)-3)
               GOTO 63370
            ELSEIF LEFT$(ZOutTxt$,7) = ZSmartTextChar$ + "END ON" THEN
               CompareVar = 0
               GOTO 63336
            ELSE
               GOTO 63336
            END IF
         END IF
      END IF
      IF LEN(ZOutTxt$) < 3 THEN _
         GOTO 63398
      WasX$ = RIGHT$(ZOutTxt$,LEN(ZOutTxt$)-3)
      IF LEFT$(ZOutTxt$,1) <> ZSmartTextChar$ THEN _
         GOTO 63398
      CALL CheckInt (MID$(ZOutTxt$,2))
      IF ZErrCode > 0 THEN _
         GOTO 63398
      IF ZTestedIntValue > 0 AND ZTestedIntValue <= ZMaxWorkVar THEN _
         ZOutTxt$ = WasX$ : _  ' Macro command ask
         ZForceKeyboard = ZTrue : _
         ZMacroSave = ZTestedIntValue : _
         ZLinesPrinted = 1 : _
         ZNonStop = (ZPageLength < 1) : _
         EXIT SUB
      ON (1+INSTR("*0*1*B*FGFWT>>STON==M!M@EYEN/*TK<<:=LVNVCVLO",MID$(ZOutTxt$,2,2)))\2 GOTO _
         63345, _  ' Display with no Carriage Return
         63347, _  ' Display with Carriage Return
         63340, _  ' Display Block
         63348, _  ' Display File
         63361, _  ' Display Graphics File
         63343, _  ' Wait # of seconds
         63350, _  ' Append to file
         63355, _  ' Stack
         63360, _  ' Case
         63370, _  ' Case Comparison
         63375, _  ' Macro execute
         63380, _  ' Macro Abort
         63383, _  ' Macro Echo on
         63385, _  ' Macro Echo off
         63336, _  ' Macro Comment
         63387, _  ' Turbo Key allowed
         63390, _  ' Form read
         63362, _  ' Assign value to work var
         63363, _  ' LV list verify
         63364, _  ' NV number verify
         63364, _  ' CV character verify
         63367     ' LO assign file location
      GOTO 63398
63338 ZOutTxt$ = WasX$
63339 ZSubParm = 4
      CALL TPut
      RETURN
63340 WasX$ = ZSmartTextChar$ + "END"  ' Print Block
      GOSUB 63395
      WHILE ZMacroActive AND LEFT$(ZOutTxt$,4) <> WasX$
         GOSUB 63339
         CALL SkipLine (1)
         GOSUB 63395
      WEND
      GOTO 63336
63343 CALL CheckInt (WasX$)      ' Delay
      IF ZErrCode = 0 THEN _
         CALL DelayTime (ZTestedIntValue)
      GOTO 63336
63345 GOSUB 63338               ' Print Line
      GOTO 63336
63347 CALL AskMore ("",ZTrue,ZTrue,WasX,ZTrue)
      GOSUB 63338
      CALL SkipLine (1)
      GOTO 63336
63348 CALL Trim (WasX$)            ' Print File
      CALL FindItX (WasX$,2)
      IF NOT ZOK THEN _
         GOTO 63336
      ZLinesPrinted = 1
      ZNo = ZFalse
      ZNonStop = (ZNonStop OR ZPageLength < 1)
63349 WHILE (NOT EOF(2) AND (NOT ZNo) AND (ZNonStop OR (ZLinesPrinted < ZPageLength)) AND (ZSubParm > -1))
         CALL ReadDir (2,1)
         GOSUB 63396
         ZSubParm = 5
         CALL TPut
      WEND
      ZDistantTGet = 0
      IF ZSubParm < 0 THEN _
         EXIT SUB
      IF EOF(2) OR ZNo THEN _
         CLOSE 2 : _
         ZNo = ZFalse : _
         GOTO 63336
      ZDistantTGet = 2
      CALL PauseExit
      EXIT SUB
63350 ZWasEN$ = WasX$            ' Append to file
      WasX = INSTR(ZWasEN$," /FL")
      OverStrike = (WasX > 0)
      IF OverStrike THEN _
         ZWasEN$ = LEFT$(ZWasEN$,WasX-1) + RIGHT$(ZWasEN$,LEN(ZWasEN$)-WasX-3)
      CALL Trim (ZWasEN$)
      CALL LockAppend
      IF ZErrCode > 0 THEN _
         GOTO 63352
      GOSUB 63395
      WasX$ = ZSmartTextChar$ + "END"
      WHILE ZMacroActive AND LEFT$(ZOutTxt$,4) <> WasX$
         CALL PrintWorkA (2,ZOutTxt$)
         GOSUB 63395
      WEND
63352 CALL UnLockAppend
      OverStrike = ZFalse
      GOTO 63336
63355 CALL GlobalSrchRepl (WasX$,"|",ZCarriageReturn$,ZTrue)
      ZCommPortStack$ = ZCommPortStack$ + WasX$ + ZCarriageReturn$   ' STack
      GOTO 63336
63360 CompareVar = VAL(WasX$)
      CALL AllCaps (WasX$)
      IF CompareVar < 1 OR CompareVar > ZMaxWorkVar THEN _
         CompareVar = 0
      GOTO 63336
63361  CALL Trim (WasX$)
       CALL GraphicDisplayFile (WasX$)
       GOTO 63336
63362 CALL Trim (WasX$)
      CALL CheckInt (WasX$)
      WasX = INSTR(WasX$,SPACE$(1))
      IF WasX > 0 AND ZTestedIntValue > 0 AND ZTestedIntValue <= ZMaxWorkVar THEN _
         ZGSRAra$(ZTestedIntValue) = RIGHT$(WasX$,LEN(WasX$)-WasX)
      GOTO 63336
63363 ZVerifyList$ = WasX$
      CALL Trim (ZVerifyList$)
      GOTO 63365
63364 CALL Trim (WasX$)
      WasX = INSTR(WasX$,SPACE$(1))
      IF WasX = 0 THEN _
         GOTO 63336
      ZVerifyLow$ = LEFT$(WasX$,WasX-1)
      ZVerifyHigh$ = RIGHT$(WasX$,LEN(WasX$)-WasX)
      CALL Trim (ZVerifyLow$)
      CALL Trim (ZVerifyHigh$)
      ZVerifyNumeric = (MID$(ZOutTxt$,2,1) = "N")
63365 ZVerifying = ZTrue
      GOTO 63336
63367 CALL TRIM (WasX$)
      ZFileLocation$ = WasX$
      GOTO 63336
63370 IF CompareVar = 0 THEN _     ' Compare Case
         GOTO 63336
      ZWasDFF$ = ZGSRAra$(CompareVar)
      CALL AllCaps (ZWasDFF$)
      CaseExecute = (WasX$ = ZWasDFF$)
      GOTO 63336
63375 CALL Trim (WasX$)           ' Execute Macro
      CALL Macro (WasX$,WasX)
      GOTO 63336
63380 ZMacroActive = ZFalse     ' Abort Macro
      GOTO 63398
63383 ZMacroEcho = ZTrue
      GOTO 63336
63385 ZMacroEcho = ZFalse
      GOTO 63336
63387 ZTurboKey = -ZTurboKeyUser   'TK Turbo Key
      GOTO 63336
63390 ZUserIn$ = ZOutTxt$
      ZUserInAra$(5) = ""
      ZUserInAra$(6) = ""
      ZWasQ = 1
      ZStoreParseAt = 1
      CALL ParseIt
      IF ZWasQ < 4 THEN _
         GOTO 63336
      WasX$ = ZSmartTextChar$ + "END"
      GOSUB 63397
      ZMacroTemplate$ = ""
      WHILE ZMacroActive AND LEFT$(ZOutTxt$,4) <> WasX$
         ZMacroTemplate$ = ZMacroTemplate$ + ZOutTxt$ + ZCrLf$
         GOSUB 63397
      WEND
      WasX = VAL(ZUserInAra$(4))
      VarLen = (ZUserInAra$(3) <> "/F")
      CALL FindIt (ZUserInAra$(2))
      IF (WasX < 1) OR (NOT ZOK) OR (VarLen AND WasX > ZMaxWorkVar) THEN _
         ZMacroTemplate$ = "" : _
         GOTO 63336
      PauseEachRec = (ZUserInAra$(6) = "/1")
63392 CALL FormRead (ZMacroTemplate$,ZUserInAra$(2),NOT VarLen,WasX,(ZUserInAra$(5) = "/FL"),PauseEachRec)
      IF ZMacroTemplate$ <> "" THEN
         EXIT SUB
      ELSE
         GOTO 63336
      END IF
63395 GOSUB 63397
      GOSUB 63396
      RETURN
63396 CALL SmartText (ZOutTxt$,ZFalse, OverStrike,ZFalse)
      CALL MetaGSR (ZOutTxt$,OverStrike)
      RETURN
63397 IF EOF(18) THEN           ' Read next line in macro
         ZMacroActive = ZFalse
         CLOSE 18
      ELSE
         CALL ReadDir (18,1)
         ZMacroActive = (ZErrCode = 0)
      END IF
      RETURN
63398 END SUB    ' Not Macro command - pass to normal processing
63400 ' $SUBTITLE: 'LockAppend - prepares for file append'
' $PAGE
'
'  NAME    -- LockAppend
'
'  INPUTS  -- ZWasEN$            Name of file to append to
'
'  OUTPUTS -- none
'
'  PURPOSE -- Locks and opens file to append to
'
      SUB LockAppend STATIC
      IF ZNetWorkType <> 0 THEN _
      WasBX = &H4 : _
      ZSubParm = 9 : _
      CALL FileLock
      ZErrCode = 0
      CALL OpenWorkA (2,ZWasEN$)
      END SUB
63410 ' $SUBTITLE: 'UnLockAppend - cleans up after file append'
' $PAGE
'
'  NAME    -- UnLockAppend
'
'  INPUTS  -- none
'
'  OUTPUTS -- none
'
'  PURPOSE -- Unlocks and close file appending to
'
      SUB UnLockAppend STATIC
      IF ZNetWorkType <> 0 THEN _
      WasBX = &H4 : _
      ZSubParm = 10 : _
      CALL FileLock
      CLOSE 2
      END SUB
63420 ' $SUBTITLE: 'FormRead - Reads from a file into a form'
' $PAGE
'
'  NAME    -- FormRead
'
'  INPUTS  -- Template$      Display formvoke shell with
'             FilName$       Data file to get values from
'             FixedLength    Whether file is fixed length
'             DataVar       # bytes data if fixed length; # fields
'                              if variable length
'             OverStrike     Whether typeover into form or insert
'             RecPause      Whether pause after every record displayed
'                               otherwise when screen fills
'  OUTPUTS -- (displays data base records)
'
'  PURPOSE -- Allows field oriented data base data to be displayed
'               in a human readable format by substituting field
'               data into template or form
'
      SUB FormRead (Template$,FilName$,FixedLength,DataVar,OverStrike,RecPause) STATIC
63422 IF EOF(2) OR ZNo OR (ZErrCode > 0) OR (ZSubParm < 0) THEN _
         Template$ = "" : _
         EXIT SUB
      IF FixedLength THEN _
         CALL ReadDir (2,1) : _
         ZGSRAra$(1) = ZOutTxt$ _
      ELSE CALL ReadParms (ZGSRAra$(),DataVar,1)
      WasX$ = Template$
      CALL SmartText (WasX$,ZTrue,OverStrike,ZFalse)
      CALL MetaGSR (WasX$,OverStrike)
      CALL BufAsUnit (WasX$)
      IF RecPause OR (ZPageLength > 0 AND (ZLinesPrinted >= ZPageLength-1)) THEN _
         CALL PauseExit : _
         EXIT SUB
      GOTO 63422
      END SUB
63440 ' $SUBTITLE: 'BufAsUnit - prints string with no pauses'
' $PAGE
'
'  NAME    -- BufAsUnit
'
'  INPUTS  -- Strng$     String to print
'
'  OUTPUTS -- none
'
'  PURPOSE -- Prints string with embedded carriage returns.
'             Will never pause.  Used to print when can't call TGet
'
      SUB BufAsUnit (Strng$) STATIC
      WasL = LEN(Strng$)
      IF WasL < 1 THEN _
         EXIT SUB
      StartByte = 1
63450 CRat = INSTR(StartByte,Strng$,ZCarriageReturn$)
      IF CRat > 0 AND CRat < WasL THEN _
         CRFound = (MID$(Strng$,CRat + 1,1) = ZLineFeed$) _
      ELSE CRFound = ZFalse
      EOLlen = -2 * CRFound
      IF CRFound THEN _
         EOD = CRat _
      ELSE EOD = WasL + 1
      NumBytes = EOD - StartByte
      ZOutTxt$ = MID$(Strng$,StartByte,NumBytes)
      ZSubParm = 4
      CALL TPut
      CALL SkipLine (-(CRFound))
      IF ZRet THEN _
         EXIT SUB
      StartByte = EOD + EOLlen
      IF StartByte <= WasL THEN _
         GOTO 63450
      END SUB
      ' Check if macro exists and execute if does
63460 SUB MacroExe (Strng$) STATIC
      CALL Trim (Strng$)
      CALL Macro (Strng$,Found)
      IF NOT Found THEN _
         EXIT SUB
      CALL FdMacExe
      END SUB
63462 ' Unconditionally executes a macro
      SUB FdMaCExe STATIC
      ZOutTxt$ = ""
      ZMacroEcho = ZFalse
      ZSubParm = 1
      CALL TGet
      END SUB
63465 ' Forces a keyboard pause inside a macro
      SUB PauseExit STATIC
      ZSubParm = 4
      ZTurboKey = -ZTurboKeyUser
      ZOutTxt$ = ZMorePrompt$ + LEFT$(">",-1*ZExpertUser) + MID$("? : ",2*ZTurboKey+1,2)
      ZForceKeyboard = ZTrue
      ZNoAdvance = ZTrue
      CALL TPut
      ZLinesPrinted = 0
      ZUserIn$ = ""
      END SUB
63470 ' $SUBTITLE: 'SetPrompt - sub to set prompts based on user security'
' $PAGE
'
'  NAME    -- SetPrompt
'
'  INPUTS  -- PARAMETER           MEANING
'             ZBegMain          POSITION START OF MAIN CMDS
'             ZBegFile          POSITION START OF FILE CMDS
'             ZBegUtil          POSITION START OF UTIL CMDS
'             ZBegLibrary       POSITION START OF Library CMDS
'
'  OUTPUTS -- PRESENT.OPTS$         DISPLAY WHAT USER CAN DO (1st)
'             CALLERS.OPTS$         DISPLAY WHAT USER CAN DO (2nd)
'             ZMainOpts$            MAIN OPTS USER CAN DO
'             ZFileOpts$            FILE OPTS USER CAN DO
'             ZUtilOpts$            UTIL OPTS USER CAN DO
'             ZLibOpts$         Library OPTS USER CAN DO
'
'  PURPOSE -- Sets command line display of what user can do by
'             section and display of what all user can do
'
      SUB SetPrompt STATIC
      First = ZBegMain
      Last = ZBegFile - 1
      CALL SetOpts (ZMainOpts$,ZInvalidMainOpts$,First,Last)
      First = ZBegFile
      Last = ZBegUtil - 1
      CALL SetOpts (ZFileOpts$,ZInvalidFileOpts$,First,Last)
      First = ZBegUtil
      Last = ZBegLibrary - 1
      CALL SetOpts (ZUtilOpts$,ZInvalidUtilOpts$,First,Last)
      IF ZTempMaxBank <= 0 THEN
         IF INSTR(ZUtilOpts$,MID$(ZUtilCmds$,1,1)) AND _
            NOT INSTR(ZInvalidUtilOpts$,MID$(ZUtilCmds$,1,1)) THEN
               ZInvalidUtilOpts$ = ZInvalidUtilOpts$ + _
                  MID$(ZUtilCmds$,1,1)
               CALL Remove (ZUtilOpts$,MID$(ZUtilCmds$,1,1))
         END IF
      END IF
      First = ZBegLibrary
      Last = ZBegLibrary + 6
      CALL SetOpts (ZLibOpts$,ZInvalidLibraryOpts$,First,Last)
      First = 50
      Last = 57
      CALL SetOpts (SysOpt$,ZInvalidSysOpts$,First,Last)
      First = 46
      Last = 49
      CALL SetOpts (GlobalOpts$,InvalidGlobalOpts$,First,Last)
      ZMainOpts$ = GlobalOpts$ + ZMainOpts$
      ZFileOpts$ = GlobalOpts$ + _
                   ZFileOpts$
      ZUtilOpts$ = GlobalOpts$ + _
                   ZUtilOpts$
      ZLibOpts$ = GlobalOpts$ + _
                      ZLibOpts$
      CALL SortString (SysOpt$)
      CALL SortString (ZMainOpts$)
      ZMainOpts$ = ZMainOpts$ + _
                   SysOpt$
      CALL SortString (ZFileOpts$)
      CALL SortString (ZUtilOpts$)
      CALL SortString (ZLibOpts$)
      CALL AddCommas (ZMainOpts$)
      CALL AddCommas (ZFileOpts$)
      CALL AddCommas (ZUtilOpts$)
      CALL AddCommas (ZLibOpts$)
      '* "U)pload,A)ll"
      LineNum = 1075
      GOSUB 63472
      Strng1$ = Strng$
      '* ",P)ers"
      LineNum = 1076
      GOSUB 63472
      Strng2$ = Strng$
      '* ",L)ist,E)xtended, [Q]uit)"
      LineNum = 1077
      GOSUB 63472
      Strng3$ = Strng$
      TempStr$ = Strng1$ + _
                 MID$(Strng2$,1,-(ZUserSecLevel > ZOptSec(23)) * 6) + _
                 Strng3$
      '* "{RCWhat directory(s) ("
      LineNum = 1078
      GOSUB 63472
      ZDirPrompt$ = Strng$ + _
                    MID$(TempStr$,8 * (ZUserSecLevel => ZMinSecToView) + 9)
      '* "QUIT [C],S, or to F,M,U"
      LineNum = 1079
      GOSUB 63472
      ZQuitPromptExpert$ = Strng$
      '* "QUIT [C]onference, S)ession or to section F)ile, M)ain, U)til"
      LineNum = 1080
      GOSUB 63472
      ZQuitPromptNovice$ = Strng$
      '* "FMUS@C"
      LineNum = 1081
      GOSUB 63472
      ZQuitList$ = Strng$
      IF ZUserSecLevel < ZOptSec(18) THEN _
         ZQuitPromptExpert$ = LEFT$(ZQuitPromptExpert$,25) : _
         ZQuitPromptNovice$ = LEFT$(ZQuitPromptNovice$,61) : _
         MID$(ZQuitList$,5) = SPACE$(1)
      IF ZUserSecLevel < ZOptSec(15) THEN _
         ZQuitPromptExpert$ = LEFT$(ZQuitPromptExpert$,24) + _
                               MID$(ZQuitPromptExpert$,27) : _
         ZQuitPromptNovice$ = LEFT$(ZQuitPromptNovice$,56) + _
                               MID$(ZQuitPromptNovice$,63) : _
         MID$(ZQuitList$,3,1) = SPACE$(1)
      IF ZUserSecLevel < ZOptSec(6) THEN _
         ZQuitPromptExpert$ = LEFT$(ZQuitPromptExpert$,18) + _
                               MID$(ZQuitPromptExpert$,21) : _
         ZQuitPromptNovice$ = LEFT$(ZQuitPromptNovice$,41) + _
                               MID$(ZQuitPromptNovice$,49) : _
         MID$(ZQuitList$,1,1) = SPACE$(1)

      CALL SetXPost
      CALL SetSection
      EXIT SUB
63472 CALL FormatString (LineNum,ZFalse,ZFalse,0,ZFalse,0,Strng$)
      RETURN
      END SUB
63480 ' $SUBTITLE: 'NoPath - detects whether string has path'
' $PAGE
'
'  NAME    -- NoPath
'
'  INPUTS  -- Strng$     String to check
'
'  OUTPUTS -- HAS.NONE   True if has no path
'
'  PURPOSE -- Detects whether have path.  Used when shouldn't
'             be any
'
      SUB NoPath (Strng$,HasPath) STATIC
      CALL BreakFileName (Strng$,DrvPath$,Prefix$,Ext$,ZFalse)
      HasPath = (DrvPath$ <> "")
      END SUB
63490 ' $SUBTITLE: 'FindIt - Determine whether file exists'
' $PAGE
'
'  NAME    -- FindIt
'
'  INPUTS  -- FilName$   File name to check
'
'  OUTPUTS -- ZOK         True if file exists.  Opened as #2 if does
'
'  PURPOSE -- Determine whether file exists and open as standard work
'             file if it does (#2)
'
      SUB FindIt (FilName$) STATIC
      CALL FindItX (FilName$,2)
      END SUB
      SUB ReadParms (AraToUse$(1),NumParms,WhichLine) STATIC
      CALL ReadParmsX (2,AraToUse$(),NumParms,WhichLine)
      END SUB
63495 ' $SUBTITLE: 'TimeBack - Give time back to the user'
' $PAGE
'
'  NAME    -- TimeBack
'
'  INPUTS  -- Index    = 1    Set start of time (begin give back)
'                      = 2    Give back time from defined start
'
'  OUTPUTS -- ZTimeCredits!         Number of seconds to credit with
'             ZSecsPerSession!  Number of seconds in current session
'
'  PURPOSE -- Give time back to the user (e.g. sysop initiated chat)
'
      SUB TimeBack (Index) STATIC
      IF Index = 1 THEN _
         CALL TimeRemain (MinsRemaining) : _
         ZWasQQ! = ZSecsUsedSession! : _
         EXIT SUB
      CALL TimeRemain (MinsRemaining)
      WasX! = (ZSecsUsedSession! - ZWasQQ!)
      ZTimeCredits! = ZTimeCredits! + WasX!
      END SUB
63500 ' $SUBTITLE: 'CmdStackPushPop - Save/restore command stack'
' $PAGE
'
'  NAME    -- CmdStackPushPop
'
'  INPUTS  -- Index    = 1    Save command stack
'                      = 2    Restore command stack
'             ZAnsIndex
'             ZLastIndex
'             ZUserInAra$()
'
'  OUTPUTS -- ZUserInAra$()                  Stacked commands
'             ZAnsIndex
'             ZLastIndex
'
'  PURPOSE -- Save restore a command stack list when need to input
'             another list in middle of previous list processing
'
      SUB CmdStackPushPop (Index) STATIC
      IF Index = 1 THEN
         OrigLastIndex = ZLastIndex   ' save
         OrigIndex = ZAnsIndex
         FOR WasI = 1 TO OrigLastIndex
             ZSaveTxtAra$(WasI) = ZUserInAra$(WasI)
         NEXT
         EXIT SUB
      END IF
      ZLastIndex = OrigLastIndex        ' restore
      ZAnsIndex = OrigIndex
      FOR WasI = 1 TO OrigLastIndex
         ZUserInAra$(WasI) = ZSaveTxtAra$(WasI)
      NEXT
      END SUB
63510 ' $SUBTITLE: 'VerifyAns - edits an answer'
' $PAGE
'
'  NAME    -- VerifyAns
'                                  MEANING
'  INPUTS  -- ZVerifying      Whether verifying
'             ZUserInAra$(1)     Response verifying
'             ZVerifyList$    List of appropriate answers.  1st
'                                char is what separates answers
'             ZVerifyNumeric     Verify that is a valid integer
'                                  if false, then verifying that
'                                  a string is between 2 values
'             ZVerifyLow$     Lowest ok value of string
'             ZVerifyHigh$    Highest ok value of string
'
'  OUTPUTS -- ZOK             Whether passes verification
'             ZVerifyList$    Empties if ok
'             ZVerifying      Sets false if ok
'             ZVerifyNumeric  Sets false if ok
'
'  PURPOSE -- Processes edits on a user input
'
      SUB VerifyAns STATIC
      ZOK = ZTrue
      IF NOT ZVerifying THEN _
         EXIT SUB
      Temp$ = ZUserInAra$(1)
      CALL AllCaps (Temp$)
      IF ZVerifyList$ <> "" THEN _
         WasX$ = LEFT$(ZVerifyList$,1) : _
         ZOK = (INSTR (ZVerifyList$, WasX$+Temp$+WasX$) > 0) _
      ELSE IF ZVerifyNumeric THEN _
              CALL CheckInt (ZUserIn$) : _
              ZOK = (ZErrCode = 0 AND _
                    ZTestedIntValue >= VAL(ZVerifyLow$) AND _
                    ZTestedIntValue <= VAL(ZVerifyHigh$)) _
           ELSE ZOK = (Temp$ >= ZVerifyLow$ AND Temp$ <= ZVerifyHigh$)
      IF ZOK THEN _
         ZVerifyList$ = "" : _
         ZVerifying = ZFalse : _
         ZVerifyNumeric = ZFalse
      END SUB
63530 ' Take modem offhook
      SUB TakeOffHook STATIC
      IF (ZBBSOptions AND 8) > 0 THEN
         EXIT SUB
      END IF
      CALL ModemPut (ZModemGoOffHookCmd$)
      CALL DelayTime (3)
      END SUB
63540 ' Match Name to one in message file
      SUB ChkMsgName (MsgFromCaller,MsgToCaller) STATIC
      IF ZNewUserDGS THEN
         '* "NEWUSER"
         LineNum = 32
         GOSUB 63541
         CALL MsgNameMatch (Strng$,ZActiveUserName$,6,MsgFromCaller)
         CALL MsgNameMatch (Strng$,ZActiveUserName$,37,MsgToCaller)
         EXIT SUB
      END IF
      IF ZOrigUserName$ <> ZActiveUserName$ THEN
         WasY$ = ZActiveUserName$
      ELSE
         WasY$ = ZOrigUserName$
      END IF

      '* "SYSOP"
      LineNum = 131
      GOSUB 63541
      IF NOT ZRemoteSysop THEN
         WasX$ = LEFT$(Strng$,-5*ZSysop)
         CALL MsgNameMatch (WasY$,WasX$,6,MsgFromCaller)
         CALL MsgNameMatch (WasY$,WasX$,37,MsgToCaller)
         EXIT SUB
      END IF
      CALL MsgNameMatch (Strng$,LEFT$(ZSysopFullName$+SPACE$(2),22),6,MsgFromCaller)
      IF NOT MsgFromCaller THEN
         CALL MsgNameMatch (WasY$,"",6,MsgFromCaller)
      END IF
      CALL MsgNameMatch (Strng$,LEFT$(ZSysopFullName$+SPACE$(2),22),37,MsgToCaller)
      IF NOT MsgToCaller THEN
         CALL MsgNameMatch (WasY$,"",37,MsgToCaller)
      END IF
      EXIT SUB
63541 CALL FormatString (LineNum,ZFalse,ZFalse,0,ZFalse,0,Strng$)
      RETURN
      END SUB
'
      SUB MsgNameMatch (PrimeName$,AltName$,SearchPos,Found) STATIC
      WasX$ = LEFT$(PrimeName$+SPACE$(2),22-8*(SearchPos < 7))
      GOSUB 63542
      IF Found OR AltName$ = "" THEN _
         EXIT SUB
      WasX$ = LEFT$(AltName$ + SPACE$(2),22-8*(SearchPos < 7))
      GOSUB 63542
      EXIT SUB
63542 WasY$ = MID$(ZMsgRec$,SearchPos,LEN(WasX$))
      CALL SmartText(WasY$,ZFalse, OverStrike,ZFalse)
      CALL AllCaps(WasY$)
      WasY$ = LEFT$(WasY$,LEN(WasX$))
      ZWasDF = INSTR(WasY$,"@")
      IF ZWasDF > 0 THEN _
         MID$(WasY$,ZWasDF) = SPACE$(6)
      Found = (WasY$ = WasX$)
      RETURN
      END SUB
63550 ' Check whether message record is a msg header record
      SUB ChkIfMsgHeader STATIC
      ZOK = ZFalse
      IF MID$(ZMsgRec$,70,1) = "-" AND MID$(ZMsgRec$,73,1) = "-" THEN _
         WasY = ASC(MID$(ZMsgRec$,116,1)) : _
         IF WasY > 224 AND WasY < 227 THEN _
            ZOK = ZTrue
      END SUB
63560 ' Set specified user flag
      SUB SetUserFlag (RcvrRecNum, ChangeIndex, WhatGetting$) STATIC
      FIELD #5, 128 AS ZUserRecord$
      IF RcvrRecNum > 0 THEN
         ZUserFileIndex = RcvrRecNum
         ZSubParm = 6
         CALL FileLock
         GET 5, RcvrRecNum
         WasX = CVI(MID$(ZUserRecord$,57,2))
         MID$(ZUserRecord$,57,2) = MKI$(WasX OR ChangeIndex)
         PUT 5, RcvrRecNum
         ZSubParm = 8
         CALL FileLock
         '* "{SPwill be notified of new{SP"
         CALL FormatString (633,ZFalse,ZFalse,0,ZFalse,0,Strng$)
         CALL QuickTPut1 (ZEmphasizeOff$ + ZWorkAra$(1) + Strng$ + WhatGetting$)
         RcvrRecNum = 0
      END IF
      END SUB
63570 ' Check Proposed Change to Time Remaining
      SUB ChkAddedTime (TimeToAdd) STATIC
      IF TimeToAdd <= 0 THEN _
         EXIT SUB
      IF ZTimeToDropToDos! = 0 OR ZOldDate$ = DATE$ THEN _
         GOTO 63571
      CALL CheckTime (ZTimeToDropToDos!, HowMuchTimeLeft!, 1)
      IF HowMuchTimeLeft! < -60 THEN _
         HowMuchTimeLeft! = (HowMuchTimeLeft! * -1) + 43200
      IF 60!*TimeToAdd + (ZSecsPerSession! - ZSecsUsedSession!) > HowMuchTimeLeft! THEN
         TimeToAdd = (HowMuchTimeLeft! - ZSecsPerSession! + ZSecsUsedSession!) / 60
         '* "Scheduled"
         CALL FormatString (634,ZFalse,ZFalse,0,ZFalse,0,ZOutTxt$)
         GOSUB 63572
      END IF
63571 CheckTheTime = ZMinsPerSession + TimeToAdd
      IF ZLimitMinsPerSession THEN
         IF CheckTheTime > ZLimitMinsPerSession THEN
            TimeToAdd = ZLimitMinsPerSession - ZMinsPerSession
            '* "External"
            CALL FormatString (635,ZFalse,ZFalse,0,ZFalse,0,ZOutTxt$)
            GOSUB 63572
         END IF
      END IF
      EXIT SUB
63572 '* "Time Extension reduced to"
      CALL FormatString (636,ZFalse,ZFalse,0,ZFalse,0,Strng1$)
      '* "{SPdue to{SP"
      CALL FormatString (637,ZFalse,ZFalse,0,ZFalse,0,Strng2$)
      '* "{SPEvent"
      CALL FormatString (638,ZFalse,ZFalse,0,ZFalse,0,Strng3$)
      ZOutTxt$ = Strng1$ + STR$(TimeToAdd) + Strng2$ + ZOutTxt$ + Strng3$
      CALL RingCaller
      CALL SkipLine (1)
      END SUB
63580 ' Displays user record
      SUB DispUserRec (ToPrint) STATIC
      ZOK = ZFalse
      WasX$ = MID$(ZUserRecord$,ZStartHash,ZLenHash)
      IF ASC(WasX$) = 0 OR LEFT$(WasX$,3) = SPACE$(3) THEN _
         EXIT SUB
      WasOF = CVI(ZSecLevel$)
      IF WasOF > ZUserSecLevel THEN _
         IF NOT ZGlobalSysop THEN _
            EXIT SUB
      IF NOT ToPrint THEN
         CALL ANSISysop5
         EXIT SUB
      END IF
      IF ToPrint AND NOT ZPrinter THEN
         ZPrinterNumberSave = ZPrinterNumber
         ZPrinterNumber = 1
         ZPrinterSave = ZPrinter
         ZPrinter = ZTrue
         CALL Line25
      END IF
      '* "{CRRecord......"
      LineNum = 639
      GOSUB 63584
      ZOutTxt$ = Strng$ + STR$(LOC(5)) + ZCRLf$
      '* "Name........{SP"
      LineNum = 640
      GOSUB 63584
      ZOutTxt$ = ZOutTxt$ + Strng$ + ZUserName$ + ZCRLf$
      '* "From........{SP"
      LineNum = 641
      GOSUB 63584
      ZOutTxt$ = ZOutTxt$ + Strng$ + ZCityState$ + ZCRLf$
      '* "SL.........."
      LineNum = 642
      GOSUB 63584
      ZOutTxt$ = ZOutTxt$ + Strng$ + STR$(WasOF) + ZCRLf$
      ' * "Password....{SP"
      LineNum = 643
      GOSUB 63584
      ZOutTxt$ = ZOutTxt$ + Strng$ + ZPswd$ + ZCRLf$
      IF WasOF < ZOrigMainSec THEN
         '* "<Locked out>{CR"
         LineNum = 644
         GOSUB 63584
         ZOutTxt$ = ZOutTxt$ + Strng$
      ELSEIF WasOF >= ZSysopSecLevel THEN
         '* "(SysOp){CR"
         LineNum = 645
         GOSUB 63584
         ZOutTxt$ = ZOutTxt$ + Strng$
      END IF
      '* "Last On.....{SP"
      LineNum = 646
      GOSUB 63584
      ZOutTxt$ = ZOutTxt$ + Strng$ + ZLastDateTimeOn$ + ZCRLf$
      '* "Downloads..."
      LineNum = 647
      GOSUB 63584
      ZOutTxt$ = ZOutTxt$ + Strng$ + STR$(CVI(ZUserDnlds$)) + ZCRLf$
      '* "Uploads....."
      LineNum = 648
      GOSUB 63584
      ZOutTxt$ = ZOutTxt$ + Strng$ + STR$(CVI(ZUserUplds$)) + ZCRLf$
      '* "Times On...."
      LineNum = 649
      GOSUB 63584
      ZOutTxt$ = ZOutTxt$ + Strng$ + STR$(CVI(MID$(ZUserOption$,1,2))) + ZCRLf$
      '* "Mins Used..."
      LineNum = 650
      GOSUB 63584
      ZOutTxt$ = ZOutTxt$ + Strng$ + STR$(CVI(ZElapsedTime$)) + ZCRLf$
      '* "Time Banked."
      LineNum = 651
      GOSUB 63584
      ZOutTxt$ = ZOutTxt$ + Strng$ + STR$(ASC(ZBankTime$)) + ZCRLf$
      '* "Carriers...."
      LineNum = 652
      GOSUB 63584
      ZOutTxt$ = ZOutTxt$ + Strng$ + STR$(ASC(ZDropTimes$)) + ZCRLf$
      IF NOT ZEnforceRatios THEN _
         GOTO 63581
      '* "DL Bytes...."
      LineNum = 653
      GOSUB 63584
      ZOutTxt$ = ZOutTxt$ + Strng$ + STR$(CVS(ZDlBytes$)) + ZCRLf$
      '* "UL Bytes...."
      LineNum = 654
      GOSUB 63584
      ZOutTxt$ = ZOutTxt$ + Strng$ + STR$(CVS(ZULBytes$)) + ZCRLf$
      '* "DL Today...."
      LineNum = 655
      GOSUB 63584
      ZOutTxt$ = ZOutTxt$ + Strng$ + STR$(CVS(ZTodayDl$)) + ZCRLf$
      '* "Bytes Today."
      LineNum = 656
      GOSUB 63584
      ZOutTxt$ = ZOutTxt$ + Strng$ + STR$(CVS(ZTodayBytes$)) + ZCRLf$
      GOSUB 63583
63581 IF (ZStartIndiv = 0 OR ZLenIndiv = 0) AND _
         (ZStartHash = 0 OR ZLenHash = 0) AND _
         NOT ZRestrictByDate THEN _
            GOTO 63582
      IF (ZStartHash > 1 AND ZLenHash > 0) THEN
         '* "Hash:{SP"
         LineNum = 657
         GOSUB 63584
         ZOutTxt$ = Strng$ +  MID$(ZUserRecord$,ZStartHash,ZLenHash)
      ELSE
         ZOutTxt$ = ""
      END IF
      IF (ZStartIndiv > 1 AND ZLenIndiv > 0) THEN
         '* "{SPIndiv:{SP"
         LineNum = 658
         ZOutTxt$ = ZOutTxt$ + Strng$ + MID$(ZUserRecord$,ZStartIndiv,ZLenIndiv)
      END IF
      IF ZRestrictByDate THEN
          CALL SetRegDisplay
          '* "Registered..{SP"
          LineNum = 659
          GOSUB 63584
          ZOutTxt$ = ZOutTxt$ + Strng$ + ZRegDisplayDate$
      END IF
      GOSUB 63583
63582 ZOK = ZTrue
      ZPrinterNumber = ZPrinterNumberSave
      ZPrinter = ZPrinterSave
      CALL Line25
      EXIT SUB
63583 IF ToPrint THEN _
          CALL Printit (ZOutTxt$)
      RETURN
63584 CALL FormatString (LineNum,ZFalse,ZFalse,0,ZFalse,0,Strng$)
      RETURN
      END SUB
63585 '  *  CALCULATE REGISTRATION DATES
        ' checks proposed new registration date
        SUB ResetRegDate (WorkDate$) STATIC ' Formerly 11470
        'Y2K Correction
        IF LEN(WorkDate$) < 10 THEN
           YearVal = VAL(MID$(WorkDate$,6,2))
           IF YearVal < 60 THEN
              CentVal$ = "20"
           ELSE
              CentVal$ = "19"
           END IF

           WorkDate$ = LEFT$(WorkDate$,6) + CentVal$ + RIGHT$(WorkDate$,2)
        END IF
        ZTodayRegYY = VAL(MID$(WorkDate$,7))
        ZTodayRegMM = VAL(LEFT$(WorkDate$,2))
        ZTodayRegDD = VAL(MID$(WorkDate$,4,2))
        ZOK = ZTodayRegYY > 1979 AND ZTodayRegMM > 0 AND _
              ZTodayRegMM < 13 AND ZTodayRegDD > 0 AND _
              ZTodayRegDD < 32
        IF ZOK THEN _
           CALL TwoByteDate (ZTodayRegYY,ZTodayRegMM,ZTodayRegDD,ZRegDate$)
        END SUB
        ' Sets display of registration date
        SUB SetRegDisplay STATIC  ' Formerly 11480
        WasX$ = MID$(ZUserOption$,11,2)
        IF CVI(WasX$) <> 0 THEN _
           ZRegDate$ = WasX$ : _
        ELSE CALL RegToCurrent
        CALL UnPackDate (ZRegDate$,ZUserRegYY,ZUserRegMM,ZUserRegDD,ZRegDisplayDate$)
        IF CVI(WasX$) = 0 THEN _
           ZRegDisplayDate$ = STRING$(2,48) + "-" + _
                              STRING$(2,48) + "-" + _
                              STRING$(2,48)
        END SUB
        ' Sets registration date to current date
        SUB RegToCurrent STATIC    ' Formerly 11482
        WorkDate$ = DATE$
        CALL ResetRegDate (WorkDate$)
        END SUB
63590 ' ChangeInt - General routine to get an integer value.
      '             Calling program has option to show current
      '             value in prompt (ShowCur) when changing from
      '             an old value to a new one, passing current
      '             value in CurVal.   Txt$ is part of prompt that
      '             calling program contributes.  Is whole prompt
      '             if not showing old value, otherwise is just
      '             description of what value represents.
      '                 Pass the inclusive minimum values (MinVal)
      '             and maximum values (MaxVal).
      '                 Returns the value gotten in ZTestedIntValue.
      '
      SUB ChangeInt (ShowCur,Txt$,CurVal,MinVal,MaxVal) STATIC
      IF ZAnsIndex < ZLastIndex THEN _
         GOTO 63594
63592 IF Showcur THEN
         '* "{C9Change {CB"
         LineNum = 660
         GOSUB 63596
         Strng1$ = Strng$
         '* "{C9 from {CB"
         LineNum = 661
         GOSUB 63596
         Strng2$ = Strng$
         '* "{C9 to{SP"
         LineNum = 662
         GOSUB 63596
         Strng3$ = Strng$
         CALL QuickTPut (Strng1$ + Txt$ + Strng2$ + _
                         LTRIM$(STR$(CurVal)) + Strng3$ + _
                         ZEmphasizeOff$,0)
      ELSE
         '* "{CB"
         LineNum = 663
         GOSUB 63596
         CALL QuickTPut (Strng$ + Txt$ + ZEmphasizeOff$,0)
      END IF
      '* "({CB"
      LineNum = 664
      GOSUB 63596
      Strng1$ = Strng$
      '* "{RC - {CB"
      LineNum = 665
      GOSUB 63596
      Strng2$ = Strng$
      CALL QuickTPut (Strng1$ + LTRIM$(STR$(MinVal)) + Strng2$ + _
                      LTRIM$(STR$(MaxVal)) + ZEmphasizeOff$,0)
      '* ", [Q]uit)"
      LineNum = 666
      GOSUB 63596
      ZOutTxt$ = Strng$
63594 CALL PopCmdStack
      Temp$ = ZUserInAra$(ZAnsIndex)
      CALL AllCaps (Temp$)
      CALL Trim (Temp$)
      IF ZSubParm > -1 AND Temp$ <> "Q" AND ZWasQ <> 0 THEN _
         GOTO 63595
      ZWasQ = 0
      IF ShowCur THEN
         '* "{CB"
         LineNum = 663
         GOSUB 63596
         Strng1$ = Strng$
         '* "{C9 Unchanged{RC"
         LineNum = 667
         GOSUB 63596
         Strng2$ = Strng$
         CALL QuickTPut1 (Strng1$ + Txt$ + Strng2$)
      END IF
      EXIT SUB
63595 CALL CheckInt (Temp$)
      IF ZTestedIntValue < MinVal OR ZTestedIntValue > MaxVal THEN
         ZLastIndex = 0
         '* "{C9Min {CB"
         LineNum = 668
         GOSUB 63596
         Strng1$ = Strng$
         '* "{C9, Max {CB"
         LineNum = 669
         GOSUB 63596
         Strng2$ = Strng$
         CALL QuickTPut1 (Strng1$ + LTRIM$(STR$(MinVal)) + _
                          Strng2$ + LTRIM$(STR$(MaxVal)) + ZEmphasizeOff$)
         GOTO 63592
      END IF
      IF ShowCur THEN
         '* "{CB"
         LineNum = 663
         GOSUB 63596
         Strng1$ = Strng$
         '* "{C9 Set to {CB"
         LineNum = 670
         GOSUB 63596
         Strng2$ = Strng$
         CALL QuickTPut1 (Strng1$ + Txt$ + Strng2$ + _
                          LTRIM$(STR$(ZTestedIntValue)) + ZEmphasizeOff$)
      END IF
      EXIT SUB
63596 CALL FormatString (LineNum,ZFalse,ZFalse,0,ZFalse,0,Strng$)
      RETURN
      END SUB
63600 ' MarkItems - Converts a list of items ZUserInAra$(), items ZAnsIndex
      '             thru ZLastIndex, into a marked list MarkedList$.
      '
      '           - Verifies that marked items are available
      '
      SUB MarkItems (IsMarking,MarkedList$,MarkedDesc$) STATIC
      IF NOT IsMarking THEN _
         EXIT SUB
      IF ZFileSysParm < 1 THEN
         FOR Temp = ZAnsIndex to ZLastIndex
            MarkedList$ = MarkedList$ + ZUserInAra$(Temp) + ZCarriageReturn$
         NEXT
         GOTO 63602
      END IF
      BeginDir = ZAnsIndex
      EndDir = ZLastIndex
      LineToRead = 1
      FOR Temp = BeginDir to EndDir
         ZWorkAra$(Temp) = UCASE$(ZUserInAra$(Temp))
         CALL CheckInt (ZWorkAra$(Temp))
         IF ZTestedIntValue THEN
            IF INSTR(ZWorkAra$(Temp),".") = 0 THEN
               ZUserInAra$(Temp) = ZListFile$(ZTestedIntValue)
               ZWorkAra$(Temp) = ZListFile$(ZTestedIntValue)
            END IF
         END IF
      Next Temp
      FOR Temp = BeginDir to EndDir
         Dot = INSTR(ZWorkAra$(Temp),".")
63601    IF ZPersonalDnld THEN
            CALL FindFile (ZPersonalDrvPath$ + ZWorkAra$(Temp),ZOK)
         ELSE
            FOR Count = 1 TO ZSubDirCount
               CALL FindFile (ZSubDir$(Count) + ZWorkAra$(Temp),ZOK)
               IF ZOK THEN
                  EXIT FOR
               END IF
            NEXT Count
         END IF
         IF ZOK THEN
            MarkedList$ = MarkedList$ + ZWorkAra$(Temp) + ZCarriageReturn$
         END IF
         IF NOT ZOK AND ZFastFileSearch THEN
            CALL BreakFileName (ZFastFileList$,Drive$,Body$,Ext$,ZTrue)
            FIDXList$ = Drive$ + Body$ + ".LST"
            CALL FindFile (FIDXList$,UseList)
            IF UseList THEN
               CALL OpenWork (11,FIDXList$)
               IF ZErrCode = 0 THEN
                  DO
                     CALL ReadParmsX (11,ZOutTxtAra$(),4,LineToRead)
                     IF ZErrCode <> 0 AND ZOutTxtAra$(1) = "" THEN
                        EXIT DO
                     END IF
                     LineToRead = LineToRead + 1
                     TFastFileList$ = UCASE$(ZOutTxtAra$(1))
                     GOSUB 63603
                     IF ZOK THEN
                        CLOSE 11
                        EXIT DO
                     END IF
                     ZOutTxtAra$(1) = ""
                  LOOP WHILE NOT EOF(11)
                  CLOSE 11
               END IF
            ELSE
               TFastFileList$ = ZFastFileList$
               GOSUB 63603
            END IF
         END IF
         IF NOT ZOK AND NOT Dot THEN
            CALL BreakFileName (ZWorkAra$(Temp),Drive$,Body$,Ext$,ZTrue)
            IF Ext$ = "" THEN
               ZWorkAra$(Temp) = Drive$ + Body$ + "." + ZDefaultExtension$
            END IF
            Dot = ZTrue
            LineToRead = 1
            GOTO 63601
         END IF
         IF NOT ZOK THEN
            CALL WipeLine (79)
            '* "{SPnot found! Correct Name?{EX"
            CALL FormatString (671,ZFalse,ZFalse,0,ZFalse,0,Strng$)
            ZOutTxt$ = UCASE$(ZUserInAra$(Temp)) + Strng$
            ZSubParm = 1
            CALL TGet
            IF ZSubParm < 0 THEN
               ZFileSysParm = 2
               EXIT SUB
            END IF
            IF ZWasQ <> 0 THEN
               CALL CheckInt (ZUserInAra$(ZAnsIndex))
               IF ZTestedIntValue THEN
                  IF INSTR(ZUserInAra$(ZAnsIndex),".") = 0 THEN
                     ZUserInAra$(Temp) = ZListFile$(ZTestedIntValue)
                     ZWorkAra$(Temp) = ZListFile$(ZTestedIntValue)
                  END IF
               END IF
               ZWorkAra$(Temp) = UCASE$(ZUserInAra$(ZAnsIndex))
               LineToRead = 1
               GOTO 63601
            END IF
            CALL WipeLine (79)
         END IF
      NEXT Temp
63602 CALL ReportMarked (MarkedList$,MarkedDesc$)
      EXIT SUB
63603 CALL OpenRSeq (7,TFastFileList$,HighRec&,WasX,ZFIDXLEN)
      FIELD #7, 12 AS SearchFile$, _
                 4 AS SearchPath$, _
       ZFIDXRFMLEN AS SearchDate$, _
     ZFIDXCDROMLEN AS SearchOnCD$, _
                 2 AS SearchCrLf$
      IF ZErrCode <> 0 THEN
         ZOK = ZFalse
      END IF
      HoldFastTabs$ = ZFastTabs$
      IF TFastFileList$ <> ZFastFileList$ THEN
         CALL BreakFileName (TFastFileList$,Pre$,Body$,Ext$,ZTrue)
         FastTabFile$ = Pre$ + Body$ + "T" + Ext$
         CALL FindFile (FastTabFile$,UseTabs)
         IF UseTabs THEN
            CALL OpenRSeq (12,FastTabFile$,WasX&,WasY,72)
            FIELD 12, 72 AS TabRec$
            GET 12, 1
            ZFastTabs$ = TabRec$
            CLOSE 12
         ELSE
            ZFastTabs$ = ""
         END IF
      END IF
      CALL TrimTrail (ZWorkAra$(Temp),".")
      CALL BinSearch (7,ZWorkAra$(Temp),1,12,ZFIDXLEN,HighRec&,RecFoundAt&,RecFound$)
      ZOK = (RecFoundAt& > 0)
      IF ZOK THEN
         MarkedList$ = MarkedList$ + ZWorkAra$(Temp) + ZCarriageReturn$
      END IF
      ZFastTabs$ = HoldFastTabs$
      CLOSE 7
      RETURN
      END SUB
      SUB ReportMarked (MarkedList$,ListDesc$) STATIC
      CALL FindLast (MarkedList$,ZCarriageReturn$,Temp,ZLastIndex)
      '* "(s) now marked"
      CALL FormatString (672,ZFalse,ZFalse,0,ZFalse,0,Strng$)
      CALL QuickTPut1 (STR$(ZLastIndex) + SPACE$(1) + ListDesc$ + Strng$)
      CALL SmartPause (ZTrue)
      ZLastIndex = 0
      END SUB
63605 ' AskItems - general routine for asking for a list of items.
      '            Calling program instructs what the valid commands
      '            are (ValidCmnd$), what the actual user command is
      '            (UserCmnd$), and whether to Mark the items.  Returns
      '            list of items in ZUserInAra$().   Supports lists for viewing,
      '            downloading, and marking.   Gives option to operate
      '            on marked when items have been previously marked.
      '                Calling program tells what to mark (MarkedItems$)
      '            and how to describe the items gathering (ItemDesc$).
      '
      SUB AskItems (ValidCmnd$,UserCmnd$,DoMark,ItemDesc$,MarkedItems$) STATIC
      CALL AllCaps (UserCmnd$)
      Temp = INSTR(ValidCmnd$,UserCmnd$)
      IF Temp = 0 OR UserCmnd$ = "" THEN _
         EXIT SUB
      Temp = INSTR("VDM",UserCmnd$)
      '* "ViewDnldMark"
      LineNum = 1082
      GOSUB 63608
      Strng1$ = Strng$
      '* "{SPwhat{SP"
      LineNum = 673
      GOSUB 63608
      Strng2$ = Strng$
      '* "(s)"
      LineNum = 674
      GOSUB 63608
      Strng3$ = Strng$
      IF ZFileSysParm > 0 THEN
         '* "{SPor #(s)"
         LineNum = 968
         GOSUB 63608
         Strng4$ = Strng$
      END IF
      ZOutTxt$ = ZEmphasizeOff$ + _
                 MID$(Strng1$,4*Temp-3,4) + _
                 Strng2$ + ItemDesc$ + Strng3$ + Strng4$
      IF Temp = 2 AND ZWildDownOK AND NOT ZPersonalDnld THEN
         '* "{SP(WildCards OK)"
         LineNum = 675
         GOSUB 63608
         ZOutTxt$ = ZOutTxt$ + Strng$
      END IF
      IF Temp < 3 THEN
         IF MarkedItems$ <> "" THEN
            '* ", M)arked"
            LineNum = 676
            GOSUB 63608
            ZoutTxt$ = ZOutTxt$ + Strng$
         END IF
      END IF
      ZOutTxt$ = ZOutTxt$ + ZPressEnterExpert$
      ZStackC = ZTrue
      CALL PopCmdStack
      IF Temp <> 3 AND ZFileSysParm <> 0 THEN
         FOR count = ZAnsIndex to ZLastIndex
            CALL CheckInt (ZUserInAra$(count))
            IF ZTestedIntValue THEN
               IF INSTR(ZUserInAra$(count),".") = 0 AND _
                  ZListFile$(ZTestedIntValue) <> "" THEN
                  ZUserInAra$(count) = ZListFile$(ZTestedIntValue)
               END IF
            END IF
         Next count
      END IF
      IF ZWasQ > 0 AND DoMark AND Temp = 3 THEN _
         CALL MarkItems (ZTrue,MarkedItems$,ItemDesc$)
      EXIT SUB
63608 CALL FormatString (LineNum,ZFalse,ZFalse,0,ZFalse,0,Strng$)
      RETURN
      END SUB
63610 ' UnMarkItems - takes an input (ZWasZ$), on input item number
      '               "OnItem", where number of last of the inputs
      '               is "LastItem", determines whether the option
      '               is one for marked items, and inserts any marked
      '               items in MarkedList$ into the input stream (ZUserInAra$())
      '               at the item number (OnItem).  Reports
      '               whether found marked (FoundMarked),
      '               and if calling programs says to reinitialize
      '               the marked items (ReInit), empties the
      '               list of marked items (MarkedList$) when they
      '               are found.
      '
      SUB UnMarkItems (MarkedList$,OnItem, LastItem, FoundMarked,ReInit) STATIC
      FoundMarked = ZFalse
      CALL AllCaps (ZWasZ$)
      IF MarkedList$ <> "" THEN IF ZWasZ$ ="M" THEN _
         FoundMarked = ZTrue : _
         EndFile = LEN (MarkedList$) : _
         Temp = INSTR(MarkedList$,ZCarriageReturn$) : _
         ZUserInAra$(OnItem) = MID$(MarkedList$,1,Temp-1) : _
         StartFile = Temp + 1 : _
         InsertAt = OnItem + 1 : _
         WHILE StartFile < EndFile : _
            Temp = INSTR(StartFile,MarkedList$,ZCarriageReturn$) : _
            FOR X = LastItem TO InsertAt STEP -1 : _
               ZUserInAra$(X + 1) = ZUserInAra$(X) : _
            NEXT : _
            LastItem = LastItem + 1 : _
            ZUserInAra$(InsertAt) = MID$(MarkedList$,StartFile,Temp-StartFile) : _
            InsertAt = InsertAt + 1 : _
            StartFile = Temp + 1 : _
         WEND : _
         IF ReInit THEN _
            MarkedList$ = ""
      END SUB
63615 ' * Sets up next message base link *
      SUB NextConf (DoJoin) STATIC
      IF ZLinkedConf$ = "" OR (NOT DoJoin) THEN _
         EXIT SUB
63616 EndConf = INSTR(ZLinkedConf$,ZCarriageReturn$)
      LastConf = (EndConf = LEN(ZLinkedConf$))
      ZHomeConf$ = LEFT$(ZLinkedConf$,EndConf-1)
      IF ZNonStop THEN
         '* "Joining linked conference {HC"
         CALL FormatString (677,ZFalse,ZFalse,0,ZTrue,1,"")
      ELSE
         '* "Continue to linked conference {HC ([Y],S)kip,A)bort)"
         CALL FormatString (678,ZFalse,ZFalse,0,ZFalse,0,ZOutTxt$)
         CALL DeLink (ZHomeConf$)
         ZTurboKey = -ZTurboKeyUser
         ZSubParm = 1
         CALL TGet
         IF ZWasQ > 0 AND NOT ZYes THEN
            ZWasX$ = ZUserInAra$(1)
            CALL AllCaps (ZWasX$)
            ZLinkedConf$ = ZLinkedConf$ + ZHomeConf$ + ZCarriageReturn$
            IF LastConf OR ZWasX$ = "A" THEN
               ZHomeConf$ = ""
               ZGlobalRead = ZFalse
               EXIT SUB
            ELSE
               GOTO 63616
            END IF
         END IF
      END IF
      END SUB
63620 ' * Adds/Deletes a new link to conference link list *
      SUB AddLink (Conf$) STATIC
      IF INSTR(ZCarriageReturn$+ZLinkedConf$,ZCarriageReturn$+Conf$+ZCarriageReturn$) THEN _
         EXIT SUB
      ZLinkedConf$ = ZLinkedConf$ + Conf$ + ZCarriageReturn$
      END SUB
      SUB DeLink (Conf$) STATIC
      Temp = INSTR(ZCarriageReturn$+ZLinkedConf$,ZCarriageReturn$+Conf$+ZCarriageReturn$)
      IF Temp > 0 THEN _
         Temp = Temp - 1 : _
         ZLinkedConf$ = LEFT$(ZLinkedConf$,Temp) + RIGHT$(ZLinkedConf$,LEN(ZLinkedConf$)-Temp-LEN(Conf$)-1)
      END SUB
63625 ' * Sets SysOp security variables Formerly 5370 of rbbs-pc.bas
      ' * Returns ZWasA true when remote or global sysop
      SUB SetSysOp STATIC
      '* "SYSOP"
      CALL FormatString (131,ZFalse,ZFalse,0,ZFalse,0,Strng$)
      ZRemoteSysop = ((ZActiveUserName$ = ZSysopFullName$) OR _
                      (ZActiveUserName$ = Strng$))
      ZWasA = ZRemoteSysop
      ZGlobalSysop = (ZGlobalSysop OR (ZWasA AND ZOrigCnfg$ = ZConfigFileName$))
      IF ZGlobalSysop THEN _
         ZWasA = ZTrue
      END SUB
63630 ' * Sets the user preferences based on user record.
      ' * Formerly in RBBS-PC.BAS
      SUB SetUserPref STATIC
      IF ZWasA THEN _
         ZUserSecLevel = ZSysopSecLevel _
      ELSE ZUserSecLevel = CVI(ZSecLevel$)
      ZDropTimesVal = ASC(ZDropTimes$)
      ZBankTimeVal = ASC(ZBankTime$)
      ZLastMsgRead = CVI(MID$(ZUserOption$,3,2))
      ZUserXferDefault$ = MID$(ZUserOption$,5,1)
      IF ZUserXferDefault$ = SPACE$(1) THEN _
         ZUserXferDefault$ = "N"
      CALL XferType (2,ZTrue)
      WasX = ASC(MID$(ZUserOption$,6,1))
      IF WasX < 30 OR WasX > 99 THEN
         WasX = 60
      END IF
      IF ZConfMode AND ZWasGRHold = 3 THEN
         ZWasGR = ZWasGRHold
      ELSE
         ZWasGR = (WasX MOD 5)
      END IF
      ZBoldText$ = CHR$(48 - (WasX > 64))
      ZBoldTextHold$ = ZBoldText$
      IF WasX > 64 THEN
         ZUserTextColor = INT((WasX - ZWasGR)/5 + 18)
      ELSE
         ZUserTextColor = INT((WasX - ZWasGR)/5 + 25)
      END IF
      IF ZUserTextColor > 37 THEN _
         ZUserTextColor = 37
      IF NOT ZExitToDoors THEN
         ZWasGRHold = ZWasGR
      END IF
      IF ZWasGR = 3 THEN
         IF ZRIPGraphics THEN
            ZWasGR = 4
         ELSEIF ZCanANSIChat THEN
            ZWasGR = 2
         ELSE
            ZWasGR = 0
         END IF
      END IF
      IF ZEmphasizeOff$ <> "" THEN _
         CALL QuickTPut (ZColorReset$,0)
      IF ZEmphasizeOnDef$ <> "" THEN _
         ZEmphasizeOff$ = ZEscape$ + "[" + ZBoldText$ + ";40;" + MID$(STR$(ZUserTextColor),2) + "m" _
      ELSE ZEmphasizeOff$ = ""
      IF ZWasGR = 1 AND NOT ZEightBit THEN _
         ZWasGR = 0
      ZRightMargin = ASC(MID$(ZUserOption$,7,1))
      IF ZRightMargin > 72 THEN _
         ZRightMargin = 72
      IF NOT ZConfMode THEN _
         ZWasCI$ = ZCityState$ : _
         CALL Trim (ZWasCI$)
      UserOptions = CVI(MID$(ZUserOption$,9,2))
      ZPromptBell = (UserOptions AND 1) > 0
      ZExpertUserHold = (UserOptions AND 2) > 0
      ZExpertUser = ZExpertUserHold
      CALL SetExpert
      ZNulls = (UserOptions AND 4) > 0
      ZUpperCase = (UserOptions AND 8) > 0
      ZLineFeeds = (UserOptions AND 16) > 0
      ZCheckBulletLogon = (UserOptions AND 32) > 0
      ZSkipFilesLogon = (UserOptions AND 64) > 0
      ZFullScreenEditor = (UserOptions AND 128) > 0
      ZReqQuesAnswered = (UserOptions AND 256) > 0
      ZMailWaiting = (UserOptions AND 512) > 0
      WasX = (UserOptions AND 1024 ) > 0
      IF ZWasGRHold = 3 THEN
         IF ZRIPGraphics OR ZCanANSIChat THEN
            WasX = ZTrue
         ELSE
            WasX = ZFalse
         END IF
      END IF
      CALL SetHiLite (NOT WasX)
      IF NOT ZHiLiteOff THEN _
         CALL QuickTPut (ZEmphasizeOff$,0)
      ZTurboKeyUserHold = (UserOptions AND 2048) > 0
      ZTurboKeyUser = ZTurboKeyUserHold
      ZTurboKey = ZFalse
      ZFileWaiting = (UserOptions AND 4096) > 0
      IF NOT ZConfMode THEN
         ZAvailableForChat = (UserOptions AND 8192) > 0
      END IF
      ZExtendedOff = (UserOptions AND 16384) > 0
      ExtendedUserOptions = ASC(MID$(ZUserOption$,8,1))
      ZReadNewMail = (ExtendedUserOptions AND 1) > 0
      ZReselectALL = (ExtendedUserOptions AND 2) > 0
      ZMorePromptLF = (ExtendedUserOptions AND 4) > 0
      ZReselectGraphics = (ExtendedUserOptions AND 8) > 0
      ZANSIMusic = (ExtendedUserOptions AND 16) > 0
      CALL SetANSIMusic
      ZNeverCanPage = (ExtendedUserOptions AND 32) > 0
      ZReselectProto = (ExtendedUserOptions AND 64) > 0
      ZChangePswd = (ExtendedUserOptions AND 128) > 0
      CALL SetRegDisplay
      ZPageLengthHold = ASC(MID$(ZUserOption$,13,1))
      ZPageLength = ZPageLengthHold
      IF ZLocalUser THEN
         IF ZPageLength > ZLocalPageLength OR _
            ZPageLength < ZLocalPageLength - 2 THEN
            ZPageLength = ZLocalPageLength - 2
         END IF
      END IF
      CALL SetGraphic (ZWasGR)
      IF ZSubBoard THEN _
         GOTO 63632
      WasX$ = ZEchoer$
      ZEchoer$ = MID$(ZUserOption$,14,1)
      IF INSTR("ICR",ZEchoer$) = 0 THEN _
         ZEchoer$ = "R"
      IF WasX$ <> ZEchoer$ THEN _
         CALL ReportEcho
      CALL SetEcho (ZEchoer$)
63632 ZNul$ = MID$(STRING$(5,0),1, - 5 * ZNulls)
      CALL SetCrLf
      ZUseTPut = (ZUpperCase OR ZXOnXOff)
      ZPswdSave$ = ZPswd$
      END SUB
63635 ' * Reports who is doing echoing.  Formerly 9525 of rbbs-pc.bas
      SUB ReportEcho STATIC
      IF ZEchoer$ = "R" THEN
         '* "RBBS now set"
         LineNum = 679
         GOSUB 63637
         ZOutTxt$ =  Strng$
      ELSEIF ZEchoer$ = "C" THEN
         '* "Please set your communications package"
         LineNum = 680
         GOSUB 63637
         ZOutTxt$ = Strng$
      ELSE
         '* "Intermediate host now set"
         LineNum = 681
         GOSUB 63637
         ZOutTxt$ = Strng$
      END IF
      '* "{SPto echo what you type"
      LineNum = 682
      GOSUB 63637
      CALL QuickTPut1 (ZOutTxt$ + Strng$)
      EXIT SUB
63637 CALL FormatString (LineNum,ZFalse,ZFalse,0,ZFalse,0,Strng$)
      RETURN
      END SUB
63640 ' * Welcomes caller on
      SUB SayWelcome STATIC
      LOCATE ZLocalPageLength-1,1,1
      CALL AMorPM
      ZUserLogonTime! = TIMER
      ZTimeLoggedOn$ = TIME$
      ZLinesPrinted = 0
      ZExpertUser = ZFalse
      CALL SetExpert
      ZOutTxt$ = ""
      IF ZMaxNodes > 1 THEN
         '* "{SP- Node{SP"
         LineNum = 683
         GOSUB 63642
         ZOutTxt$ = Strng$ + ZNodeID$
      END IF
      IF ZReliableMode THEN
         '* "{SP(Reliable)"
         LineNum = 684
         GOSUB 63642
         ZOutTxt$ = ZOutTxt$ + Strng$
      END IF
      CALL TestANSI
      ZTestParity = ZTrue
      ZStopInterrupts = ZTrue
      CALL BreakFileName (ZPreLog$,Drive$,Body$,Ext$,ZFalse)
      ZFileName$ = Drive$ + Body$ + "." + MID$(TIME$,1,2)
      CALL FindFile (ZFileName$,Found)
      IF NOT Found THEN
         ZFileName$ = ZPreLog$
      END IF
      CALL FlushCom (WasX$)
      ZCommPortStack$ = ""
      EXIT SUB
63642 CALL FormatString (LineNum,ZFalse,ZFalse,0,ZFalse,0,Strng$)
      RETURN
      END SUB
63645 ' * computes the session time.  Formerly 825 in rbbs-pc.bas
      SUB SetSessionTime STATIC
      WasX = (ZMaxPerDay - ZMinsPerSession)
      WasX = -WasX * (WasX > 0)    ' extra from daily max
      ZWasQQ! = WasX + ZMinsPerSession + (ZMaxPerDay > 0) * ZElapsedTimeVal
      IF ZWasQQ! > ZMinsPerSession AND ZElapsedTimeVal >= 0 THEN _
         ZWasQQ! = ZMinsPerSession
      ZSecsPerSession! = ZWasQQ! * 60 + ZTimeCredits!
      END SUB
63650 ' * Sets privileges based on PASSWRDS file
      ' * Formerly 5135-5160 in RBBS-PC.BAS
      SUB SetPrivileges STATIC
      ZWasZ$ = ""
      CALL SrchPasswrds (Found)
      IF NOT Found THEN _
         ZTempTimeAllowed = ZMinsPerSessionDef : _
         ZTempMaxPerDay = ZMaxPerDayDef : _
         ZTempExpiredSec = ZExpiredSec : _
         ZMaxBank = ZMaxBankTimeDef _
      ELSE ZTimeLockSet = ZTempTimeLock : _
           ZDaysInRegPeriod = ZTempRegPeriod : _
           ZMaxBank = ZTempMaxBank
      ZMinsPerSession = ZTempTimeAllowed
      ZMaxPerDay = -(ZMaxPerDay * (ZTempMaxPerDay <= 0)) - _
                     (ZTempMaxPerDay * (ZTempMaxPerDay > 0))
      IF ZLimitMinsPerSession THEN
         IF ZMinsPerSession > ZLimitMinsPerSession THEN
            ZMinsPerSession = ZLimitMinsPerSession
          IF (NOT ZExitToDoors) AND (NOT ZSubBoard) AND _
             (NOT AlreadyShown) THEN
               '* "{CR{COAn External Event is coming up in {TS minutes.{RC"
               CALL FormatString (685,ZFalse,ZFalse,0,ZTrue,1,"")
               '* "Your time online has been shortened.{RC{CR"
               CALL FormatString (686,ZFalse,ZFalse,0,ZFalse,0,ZOutTxt$)
               CALL RingCaller
                AlreadyShown = ZTrue
            END IF
         END IF
      END IF
      CALL SetSessionTime
      END SUB

63652 ' * Searches file ZPswdFile$, looking for match to
      ' * ZWasZ$.  Returns whether found in "Found" and sets
      ' * varibles read in by GetPassword
      '
      SUB SrchPasswrds (Found) STATIC
      Found = ZFalse
      CALL OpenWork (2,ZPswdFile$)
      IF ZErrCode > 0 THEN _
         CALL UpdtCalr ("Err"+STR$(ZErrCode)+" opening " + ZPswdFile$,2) : _
         GOTO 63659
      MatchPass$ = ZWasZ$
      IF MatchPass$ <> "" THEN _
         MatchPass$ = LEFT$(MatchPass$ + SPACE$(15),15)
      MatchPass = (MatchPass$ <> "")
63654 IF EOF(2) THEN _
         GOTO 63659
63656 CALL GetPassword
      IF ZErrCode <> 0 THEN _
         CALL UpdtCalr (ZPswdFile$ + " bad format!",2) : _
         GOTO 63659
      IF MatchPass THEN
         ZTempPassword$ = LEFT$(ZTempPassword$ + SPACE$(15),15)
         IF MatchPass$ <> ZTempPassword$ THEN
            GOTO 63654
         ELSEIF ZUserSecLevel >= ZMinSecForTempPswd THEN
            GOTO 63658
         ELSE
            GOTO 63654
         END IF
      END IF
      IF ZUserSecLevel <> ZTempSecLevel OR ZTempPassword$ <> "" THEN _
         GOTO 63654
      IF ZStartTime = 0 THEN _
         GOTO 63658
      WorkTime$ = TIME$
      TestTime = VAL(LEFT$(WorkTime$,2) + MID$(WorkTime$,4,2))
      IF TestTime => ZStartTime AND TestTime <= ZEndTime THEN _
         GOTO 63658
      IF ZEndTime < ZStartTime THEN _
         IF TestTime => ZStartTime OR TestTime <= ZEndTime THEN _
            GOTO 63658
      GOTO 63654
63658 Found = ZTrue
63659 ZErrCode = 0
      END SUB
63675 SUB SetUserUpDn STATIC
      ZDnlds = CVI(ZUserDnlds$)
      ZUplds = CVI(ZUserUplds$)
      ZDropTimesVal = ASC(ZDropTimes$)
      ZBankTimeVal = ASC(ZBankTime$)
      IF ZEnforceRatios THEN _
         ZDLToday! = CVS(ZTodayDl$) : _
         ZBytesToday! = CVS(ZTodayBytes$) : _
         ZDLBytesVal! = CVS(ZDlBytes$) : _
         ZULBytesVal! = CVS(ZULBytes$)
      END SUB
      SUB SetGlobalUpDn STATIC
      IF NOT ZGlobalsSet THEN _
         ZGlobalsSet = ZTrue : _
         ZGlobalDnlds = ZDnlds : _
         ZGlobalUplds = ZUplds : _
         ZGlobalDLToday! = ZDLToday! : _
         ZGlobalBytesToday! = ZBytesToday! : _
         ZGlobalDLBytes! = ZDLBytesVal! : _
         ZGlobalULBytes! = ZULBytesVal! : _
         ZGlobalDropTimes = ZDropTimesVal : _
         ZGlobalBankTime = ZBankTimeVal
      END SUB
63700 ' $SUBTITLE: 'TestANSI - test caller for ANSI support'
' $PAGE
'
'  NAME    -- TestANSI
'                                  MEANING
'  INPUTS  -- ZTestANSITime   # of seconds to wait for ANSI response
'                             0 = do not test for ANSI
'
'  OUTPUTS -- ZCanANSIChat      = ZTrue if ANSIChat possible
'
'  PURPOSE -- Test callers' software for support of ANSI graphics
'
      SUB TestANSI STATIC
      IF ZTestANSITime < 1 THEN _
         GOTO 63705
      IF ZLocalUser THEN
         IF ZDOSAnsi THEN
            GOTO 63710
         ELSE
            GOTO 63705
         END IF
      END IF
      CALL FlushCom(Temp$)
      CALL PutCom (ZEscape$ + "[6n")
      CALL WipeLine (5)
      FOR Temp = 1 TO ZTestANSITime
         CALL DelayTime(1)
         CALL FlushCom(Temp$)
         IF LEN(Temp$) > 0 THEN
            GOTO 63702
         END IF
      NEXT Temp
63702 Temp = INSTR(Temp$,ZEscape$)
      IF Temp > 0 THEN _
         CALL FlushCom(Temp2$) : _
         Temp$ = Temp$ + Temp2$ : _
         Temp = INSTR(Temp,Temp$,"R") : _
         IF TEMP > 0 AND TEMP < 9 THEN _
            GOTO 63710
63705 ZHiLiteOff = ZTrue
      CALL SetHiLite(ZHiLiteOff)
      ZHiLiteOffHold = ZHiLiteOff
      CALL SetGraphic (0)
      ZWasGRHold = 0
      GOSUB 63712
      EXIT SUB
63710 CALL SetGraphic(2)
      ZWasGRHold = 2
      ZHiLiteOff = ZFalse
      CALL SetHiLite(ZHiLiteOff)
      ZHiLiteOffHold = ZHiLiteOff
      CALL QuickTPut (ZEscape$ + "[2J",0)
      CALL Line25
      GOSUB 63712
      '* "{CFANSI detected"
      CALL FormatString (687,ZFalse,ZFalse,0,ZTrue,1,"")
      IF ZDOSANSI THEN _
         ZCanANSIChat = ZTrue
      CALL FlushCom(Temp$)
      CALL PutCom (ZEscape$ + "[!")
      CALL WipeLine (5)
      FOR Temp = 1 TO ZTestANSITime
         CALL DelayTime (1)
         CALL FlushCom (Temp$)
         IF LEN(Temp$) > 0 THEN
            '* "RIPSCRIP"
            CALL FormatString (688,ZFalse,ZFalse,0,ZFalse,0,Strng$)
            Temp = INSTR(UCASE$(Temp$),Strng$)
            IF Temp THEN
               ZRIPVersion$ = MID$(Temp$,10,1) + "." + MID$(Temp$,11,2) + _
                              "." + MID$(Temp$,13,2)
               '* "RIPScript version {RV Detected"
               CALL FormatString (689,ZFalse,ZFalse,0,ZTrue,1,"")
               ZRIPGraphics = ZTrue
               CALL SetGraphic(4)
               ZWasGRHold = 4
               EXIT FOR
            END IF
         END IF
      NEXT Temp
      EXIT SUB
63712 '* "{CRRBBS-PC {ZV  The Remote Bulletin Board System"
      CALL FormatString (690,ZFalse,ZFalse,0,ZTrue,1,"")
      RETURN
      END SUB
63715 ' Counts the number of words NumFound in ParseThis, defined
      ' as strings separated by those in ExcludeThis$
      '
      SUB ExcludeCount (ExcludeThis$, ParseThis$, NumFound) STATIC
      NumFound = 0
      StartAt = 1
      FOR I = 1 TO LEN(ParseThis$)
         IF INSTR(ExcludeThis$, MID$(ParseThis$, I, 1)) > 0 THEN _
            ParseLen = I - StartAt : _
            IF ParseLen > 0 THEN _
               NumFound = NumFound + 1
      NEXT
      END SUB
63720 SUB AraAllCaps (Ara$(1),WhichElement) STATIC
      Temp$ = Ara$(WhichElement)
      CALL AllCaps (Temp$)
      Ara$(WhichElement) = Temp$
      END SUB
'
' $SUBTITLE: 'AutoLogOff - Subroutine to  to log off after transfer'
' $PAGE
'
      SUB AutoLogOff STATIC
      ZAutoEnd = 0
      ZAbort = ZFalse
      IF ZGetExtDesc = ZTrue or ZOK = ZFalse or ZAutoLogOffReq = ZTrue THEN _
         EXIT SUB
      ZSubParm = 1
      ZStackC = ZTrue    'Pe 12/21/91
64980 IF NOT ZExpertUser THEN _
         GOTO 64999
64981 CALL DispSectionAndTime
      '* "{CFAUTOLOGOFF {C2command{RC"
      LineNum = 691
      GOSUB 65010
      ZOutTxt$ = Strng$
      IF ZCmndsInPrompt THEN
         IF ZExpertUser THEN
            '* "{SP(?,A,[C],G,H)"
            LineNum = 692
         ELSE
            '* "{SP(?,A)bort,[C]ontinue,G)oodbye,H)elp)"
            LineNum = 693
         END IF
         GOSUB 65010
         ZOutTxt$ = ZOutTxt$ + Strng$
      END IF
64990 ZTurboKey = -ZTurboKeyUser
      ZSubParm = 1
      Call TGet
      CALL CheckCarrier
      IF ZSubParm = -1 THEN _
         ZFileSysParm = 7 : _
         EXIT SUB
      '* "CAGH?"
      LineNum = 694
      GOSUB 65010
      WasMplx = INSTR(Strng$,UCASE$(ZUserIn$))
      IF ZUserIn$ = "" THEN _
         GOTO 64995
      ON WasMplx GOTO 64995,64991,64998,64999,64999
      GOTO 64981
64991 ZAutoEnd = 2
      GOTO 65000
64995 ZAutoEnd = 3
      GOTO 65000
64998 ZAutoEnd = 1
      ZAutoLogoffReq = ZTrue
      GOTO 65000
64999 ZStopInterrupts = ZTrue
      AutoOffFile$ = ZWelcomeFileDrvPath$ + "AUTOOFF.MNU"
      CALL GraphicDisplayFile (AutoOffFile$)
      ZStopInterrupts = ZFalse
      GOTO 64981
65000 CALL SkipLine (1)
      EXIT SUB
65010 CALL FormatString (LineNum,ZFalse,ZFalse,0,ZFalse,0,Strng$)
      RETURN
      END SUB
